C
C    ***************************************************************
C    ***************************************************************
C    **                                                           **
C    **                         RIETAN                            **
C    **                                                           **
C    **     A FORTRAN 77 PROGRAM FOR THE RIETVELD ANALYSIS OF     **
C    **  ANGLE-DISPERSIVE X-RAY AND NEUTRON DIFFRACTION PATTERNS  **
C    **                                                           **
C    **             COPYLEFT (C) 1989, BY F. IZUMI                **
C    **                  ALL RIGHTS RELEASED                      **
C    **                                                           **
C    **  NATIONAL INSTITUTE FOR RESEARCH IN INORGANIC MATERIALS   **
C    **                                                           **
C    ***************************************************************
C    ***************************************************************
C
* FILES USED IN THIS PROGRAM
*    #1: SPGRI
*   #11: SPGRA
*    #2: ASFDC
*    #3: INTENSITY DATA OF THE SAMPLE
*    #5: INPUT DATA (RECORD LENGTH = 80)
*    #6: PRINTER OUTPUT
*    #9: OUTPUT FOR ORFFE (RECORD LENGTH = 150)
*   #20: OUTPUT FOR RIETVELD REFINEMENT PATTERNS (RECORD LENGTH = 140)
*   #21: FOURIER OUTPUT (RECORD LENGTH = 100)
 
      PROGRAM RIETAN
C     C**: ESSENTIAL LINES
C      C*: OPTIONAL LINES
C     NB:  MAXIMUM NUMBER OF PEAKS
C     NP:  MAXIMUM NUMBER OF INTENSITY DATA
C     NA:  MAXIMUM NUMBER OF CHEMICAL SPECIES INCLUDING VIRTUAL ONES
C     NT:  MAXIMUM NUMBER OF PARAMETERS
C     NR:  MAXIMUM NUMBER OF REFINABLE PARAMETERS
C     NSF: MAXIMUM NUMBER OF REFINABLE STRUCTURE-FACTOR PARAMETERS
C          (Q, G, X, Y, Z, THERMAL PARAMETER(S), MU, AND PHI)
C     NS:  MAXIMUM NUMBER OF SYMMETRY OPERATIONS (<=48)
C     NAP: MAXIMUM NUMBER OF ATOMS IN ASYMMETRIC UNIT
C     NCS: MAXIMUM NUMBER OF LINEAR CONSTRAINTS
C     NPH: MAXIMUM NUMBER OF PHASES
C     NGEN: MAXIMUM NUMBER OF REFLECTIONS GENERATED TEMPORARILY IN THE
C           PROGRAM (NGEN >= NB)
C
C     CHANGE THE FOLLOWING PARAMETER VALUES IF NECESSARY
      PARAMETER (NB=2000,NP=5050,NA=7,NT=220,NR=65,NSF=50,NS=48,NAP=36,
     &          NCS=50,NPH=2,NGEN=2000)
C
      PARAMETER (NOD=NR*(NR+1)/2)
 
      INTEGER H,HP,R,RX,RY,RZ,SECSET
*VAX
      INTEGER LIB\INIT_TIMER
      DOUBLE PRECISION G
      CHARACTER TNAME*2,XTARG(5)*2,CRYSYS(15)*36,
*FACOM, HITAC, ACOS, AND SUN
*    &  ANAME*5,YMD*8,SYM*10,SPGR*10,PARNAM*48,
*VAX
     &  ANAME*5,YMD*9,SYM*10,SPGR*10,COORD*20,PARNAM*48,
     &  TITLE*80,LINE*80,COL(80),FSSET*14,PHNAME*25,LINNSS(14)*40,
     &  REFTYP(NPH)*3,LCON(7,NPH)*80,ANAME2(NA)*5,VNS(NPH)*7
*SUN
*     CHARACTER*50 FILE5
      EQUIVALENCE (LINE,COL(1))
      DIMENSION DEG(NP),XINT(NP),YFIT(NP),YPEAK(NB),A(NT),ANAME(NA),
     &  X(100),Y(100),DC(2,5),IDREAL(NA),DEGEXC(2,50),SYM(3,NS,NPH),
     &  ISONUM(NAP,NPH),WL(4,5),NSPGR(NPH),COEF(NPH),AW(NA),INDIV(NPH),
     &  NSET(NPH),SIGMAA(NT)
      COMMON /A/ H(NB),K(NB),IL(NB),L12(NB),NOPH(NB)
      COMMON /ALP/ LALPHA
      COMMON /B/ U(NB),NREFL
      COMMON /C/ BG(NP)
      COMMON /CC/ APR(NT)
      COMMON /CNSTR/ C1(NCS),C2(10,NCS),IN(10,NCS),NCNPAR(NCS),
     &  NACNS(NCS),NCNSTR
      COMMON /CONHKL/ NHKL(NPH),ICH(5,3,7,NPH),NCON(7,NPH),NLINE(NPH)
      COMMON /DERPR/ POP2(NB),COMPO(NB),GAUSS(NB)
      COMMON /E/ AA(4,NA),BB(4,NA),C(NA)
      COMMON /EXC/ LSPSYM(NPH),NSSYM(14,NPH)
      COMMON /FLAG/ LFLAG(10)
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /FRDA/ NFR,NDA
      COMMON /FT/ FT1,FT2
      COMMON /G/ I
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /HALF/ IFAC(NAP,NPH)
      COMMON /I/ RDEG(2,NB)
      COMMON /INPT/ DUM1,DUM2,DUM3,DUM4,DUM5,DUM6,DUM7,ANGMAX,ANGMIN
      COMMON /IS/ ISET(44),SECSET
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /L/ DEG1,DEG2
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /MAGNE/ FMAG(NA,NB),SFRMAG(NB),SFIMAG(NB),Q2(NB)
      COMMON /MAGSC/ MAGATM(NA),RLV(20,NA),AMPMAG(20,NA),NPAIR(NA)
      COMMON /MC/ CTHM
      COMMON /MIX/ FRCTN(5,10),MFRAC(5,10),NOFRAC(10),NMIX
      COMMON /NONLIN/ NLESQ,NAUTO,IDCYCL,NCHNG,NPAR(10),IPAR(NR,10)
      COMMON /NUML/ NUPDT
      COMMON /O/ NMODE
      COMMON /OLD/ AOLD(NT),AOUT(NT)
      COMMON /ORDER/ IPOINT(NB)
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PHNO/ IPHASE
      COMMON /POW/ MITER,STEP2,ACC
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /PRLV/ NPRINT
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /RLS/ NRANGE
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      COMMON /S/ F(NA,NB),NATOM
      COMMON /SFRI/ SFR(NB),SFI(NB),OTF(NB)
      COMMON /SG/ SPGR(NPH)
      COMMON /SITE/ NOAT(NAP,NPH)
      COMMON /SGN/ NSG9,NSC9
      COMMON /T/ FF(NB)
      COMMON /TENS/ DUMG(6,NPH),GG(6,NPH)
      COMMON /TWO/ G(NOD),FIRST(NR)
      COMMON /U/ DELTF1(NA),DELTF2(NA)
      COMMON /UCC/ IDPEAK(NPH),IDSF(NPH),IDPRF(NPH),IDZP
      COMMON /V/ NPROR(NPH),HP(NPH),KP(NPH),LP(NPH)
*VAX
      COMMON /VAX/ IVX
      COMMON /WL/ NBEAM,XLMD,XLMDH,XLMD2H,R12
      COMMON /X/ STEP
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
 
      DATA (XTARG(I),I=1,5)/'CR','FE','CU','MO','AG'/
      DATA ((WL(J,I),J=1,4),I=1,5)/
     &  2.28970,   2.293606,  1.14485,   1.146803,
     &  1.936042,  1.939980,  0.968021,  0.96999,
C       COBALT
C    &  1.792850,  1.788965,  0.896425,  0.8944825,
     &  1.540562,  1.544390,  0.770281,  0.772195,
     &  0.7093,    0.713590,  0.35465,   0.356795,
     &  0.5594075, 0.563798,  0.2797038, 0.281899/
      DATA (CRYSYS(I),I=1,15)/'TRICLINIC, -1','MONOCLINIC, 2/M (A-AXIS)'
     &,'MONOCLINIC, 2/M (B-AXIS)','MONOCLINIC, 2/M (C-AXIS)',
     &'ORTHORHOMBIC, MMM','TETRAGONAL, 4/M','TETRAGONAL, 4/MMM',
     &'TRIGONAL, -3 (RHOMBOHEDRAL LATTICE)','TRIGONAL, -3 (HEXAGONAL LAT
     &TICE)','TRIGONAL, -3M (RHOMBOHEDRAL LATTICE)','TRIGONAL, -3M (HEXA
     &GONAL LATTICE)','HEXAGONAL,6/M','HEXAGONAL, 6/MMM',
     &'CUBIC, M3','CUBIC, M3M'/
      DATA RD,RD2/0.01745329,57.29578/
C
      LD(J)=ID(KPHB(L)+J)
      P(J)=A(KPHB(L)+J)
*HITAC
*     CALL CLOCK
*VAX
      I=LIB\INIT_TIMER(IVX)
*FACOM, HITAC, VAX, AND SUN
      CALL DATE(YMD)
*ACOS
*     CALL DATIM(YMD,HMS)
*FACOM, HITAC, ACOS, AND SUN
*     WRITE(6,110) YMD(1:2),YMD(4:5),YMD(7:8)
*FACOM, HITAC, ACOS, AND SUN
* 110 FORMAT(//' ',113X,'19',A2,'.',A2,'.',A2/)
*VAX
      WRITE(6,110) YMD
*VAX
  110 FORMAT(//' ',113X,A9)
      WRITE(6,'(54X,A///(20X,A))') 'WELCOME TO THE',
     &'RRRRRRRRRRR     IIIIIIII    EEEEEEEEEEEE  TTTTTTTTTTTT  '//
     &' AAAAAAAAAA    NN        NN',
     &'RRRRRRRRRRRR    IIIIIIII    EEEEEEEEEEEE  TTTTTTTTTTTT  '//
     &'AAAAAAAAAAAA   NNN       NN',
     &'RR        RR       II       EE                 TT       '//
     &'AA        AA   NNNN      NN',
     &'RR        RR       II       EE                 TT       '//
     &'AA        AA   NN NN     NN',
     &'RR        RR       II       EE                 TT       '//
     &'AA        AA   NN  NN    NN',
     &'RRRRRRRRRRRR       II       EEEEEEEEEEE        TT       '//
     &'AAAAAAAAAAAA   NN   NN   NN'
      WRITE(6,'(20X,A)')
     &'RRRRRRRRRRR        II       EEEEEEEEEEE        TT       '//
     &'AAAAAAAAAAAA   NN    NN  NN',
     &'RR    RRR          II       EE                 TT       '//
     &'AA        AA   NN     NN NN',
     &'RR     RRR         II       EE                 TT       '//
     &'AA        AA   NN      NNNN',
     &'RR      RRR        II       EE                 TT       '//
     &'AA        AA   NN       NNN',
     &'RR       RRR    IIIIIIII    EEEEEEEEEEEE       TT       '//
     &'AA        AA   NN        NN',
     &'RR        RR    IIIIIIII    EEEEEEEEEEEE       TT       '//
     &'AA        AA   NN        NN'
      WRITE(6,'(//17X,A///)')
     &'SYSTEM FOR THE RIETVELD ANALYSIS AND SIMULATION OF '//
     &'X-RAY AND NEUTRON DIFFRACTION PATTERNS'
C**   TITLE
*FACOM, HITAC, AND ACOS
*     OPEN(UNIT=5)
*SUN
*     CALL GETARG(1,FILE5)
*SUN
*     OPEN(UNIT=5,FILE=FILE5,STATUS='OLD')
*VAX
      OPEN(UNIT=5,FILE='RIETAN.INP',STATUS='OLD')
      READ(5,'(A80)') TITLE
      WRITE(6,'(7X,A///11X,A,A/)')
     &'*** DATA GIVEN BY USER AND SYSTEM ***','TITLE: ',TITLE
C
C**   CONTROL DATA #1
C     NBEAM=0: NEUTRON DIFFRACTION
C     NBEAM=1: X-RAY DIFFRACTION
C     NBEAM=2: SR
C
C     NMODE=0: RIETVELD ANALYSIS
C     NMODE=1: RIETVELD ANALYSIS AND OFF-LINE PLOT
C     NMODE=-1: RIETVELD ANALYSIS AND CREATION OF A FILE FOR TOP DRAWER
C     NMODE=2: CACLULATION OF INTENSITIES FROM STRUCTURE PARAMETERS
C     NMODE=3: SIMULATION OF POWDER PATTERNS AND OFF-LINE PLOT
      NBEAM=1
      NMODE=0
      READ(5,*) NBEAM,NMODE
      LOUTS=1
      IF (NMODE .EQ. -3) THEN
         NMODE=3
         LOUTS=-1
      END IF
      WRITE(6,'(/11X,A,I2,4X,A,I2)')
     &'NBEAM =',NBEAM,'  NMODE =',LOUTS*NMODE
      IF(NBEAM.LT.0 .OR. NBEAM.GT.2 .OR. NMODE.LT.-1 .OR. NMODE.GT.3)
     &   CALL JOBEND('CONTROL PARAMETER OUT OF RANGE')
C
*     LFLAG(1): 1 ==> USE ALL THE SYMMETRY OPERATIONS AS IN USUAL
*                     REFINEMENT PROGRAMS
*     LFLAG(2): 1 ==> WRITE PARNAM IN THE INPUT FILE ON UPDATING
*     LFLAG(3): 1 ==> WRITE SIGMAA IN THE INPUT FILE ON UPDATING
*     LFLAG(3): 2 ==> WRITE PARAMETER NUMBERS IN THE INPUT FILE
*                     ON UPDATING
*     LFLAG(4): 1 ==> PRINT OUT THE CORRELATION MATRIX (NPRINT = 0,1)
*     LFLAG(5): 1 ==> PRINT OUT OBSERVED AND CALCULATED INTENSITIES
*                     (NPRINT = 0,1)
*     LFLAG(6): 1 ==> PRINT OUT OBSERVED, CALCULATED, AND DIFFERENCE
*                     PATTERNS
      READ(5,'(A62,10I1)') LINE(1:62),(LFLAG(J),J=1,10)
      BACKSPACE 5
C*    CONTROL DATA #2 (NMODE<>2)
C     NMODE=0,1: READ NLESQ, NRANGE, NEXC, NUPDT, NPRINT, NFR, AND NDA
C     NMODE=3:   READ NPRINT
C
C     NLESQ=1: CONJUGATE DIRECTION METHOD (WITHOUT USING DERIVATIVES)
C     NLESQ=2: MARQUARDT'S METHOD (USING DERIVATIVES)
C     NLESQ=3: GAUSS-NEWTON METHOD (USING DERIVATIVES)
C
C     NRANGE=1: FIX THE BACKGROUND
C     NRANGE=2: REFINE THE BACKGROUND
C
C     NEXC=0: USE ALL THE INTENSITY DATA
C     NEXC=1: SKIP SOME INTENSITY DATA
C
C     NUPDT=0: DO'NT UPDATE PARAMETER VALUES IN THE INPUT FILE
C     NUPDT=1: UPDATE PARAMETER VALUES IN THE INPUT FILE
C
C     NPRINT=0: A MINIMUM PRINTOUT IS DESIRED
C     NPRINT=1: A STANDARD PRINTOUT IS DESIRED
C     NPRINT=2: A COMPLETE PRINTOUT IS DESIRED
C
C       NFR=0: A FOURIER FILE IS NOT MADE
C       NFR>0: OUTPUT H, K, L, SIN(THETA/LAMBDA), FO, FC, COS(PHI),
C              SIN(PHI), FO-FC FOR THE NFR'TH PHASE.
C
C       NDA=0: NEITHER BOND DISTANCES NOR ANGLES ARE CALCULATED
C       NDA>0: BOND DISTANCES AND/OR ANGLES FOR THE NDA'TH PHASE
C              ARE CALCULATED
C
      IF(NMODE.LE.1) THEN
         NLESQ=2
         NRANGE=2
         NEXC=0
         NUPDT=0
         NPRINT=1
         NFR=0
         NDA=0
         READ(5,*) NLESQ,NRANGE,NEXC,NUPDT,NPRINT,NFR,NDA
         WRITE(6,120) NLESQ,NRANGE,NEXC,NUPDT,NPRINT,NFR,NDA
  120    FORMAT(11X,'NLESQ =',I2,5X,'NRANGE =',I2,5X,
     &   '  NEXC =',I2,5X,' NUPDT =',I2,5X,'NPRINT =',I2,5X,
     &   '   NFR =',I2,5X,'   NDA =',I2)
         IF(NLESQ.LT.1 .OR. NLESQ.GT.3 .OR. NRANGE.LT.1 .OR.
     &   NRANGE.GT.2 .OR. NEXC.LT.0 .OR. NEXC.GT.1 .OR. NPRINT.LT.0 .OR.
     &   NPRINT.GT.2 .OR. NUPDT.LT.0 .OR. NUPDT.GT.1 .OR. NFR .LT. 0
     &   .OR. NFR .GT. NPH .OR. NDA .LT. 0 .OR. NDA .GT. NPH)
     &   CALL JOBEND('CONTROL PARAMETER OUT OF RANGE')
      ELSE
         NLESQ=-1
         NRANGE=2
         NEXC=-1
         NPRINT=1
         NFR=0
         NDA=0
         IF(NMODE.EQ.3) THEN
            READ(5,*) NPRINT
            WRITE(6,'(11X,A,I2)') 'NPRINT =',NPRINT
            IF(NPRINT.LT.0 .OR. NPRINT.GT.2)
     &      CALL JOBEND('CONTROL PARAMETER OUT OF RANGE')
         ENDIF
      ENDIF
      WRITE(6,'(11X,A,6I1)') 'LFLAG: ',(LFLAG(J),J=1,6)
 
      IF(NBEAM.EQ.0 .OR. NBEAM.EQ.2) THEN
C*       WAVELENGTH (FOR NEUTRON DIFFRACTION AND SOR)
         XLMD=1.08
         READ(5,*) XLMD
         WRITE(6,'(//11X,A,F8.5)') 'WAVELENGTH =',XLMD
         XLMDH=XLMD/2.0
         R12=0.0
      ELSEIF(NBEAM.EQ.1) THEN
C*       EQUIPMENT (FOR X-RAY DIFFRACTION)
C        TNAME: TARGET ELEMENT
C        R12: INTENSITY(ALPHA2)/INTENSITY(ALPHA1)
C        CTHM: COEFFICIENT IN FORMULA FOR POLARIZATION CORRECTION FOR
C              USE OF MONOCHROMATOR
C              (1+CTHM*(COS(2*THETA))**2)/((SIN(THETA))**2*COS(THETA))
C              CTHM = (COS(2*ALPHA))**2 (2*ALPHA IS THE DIFFRACTION
C              ANGLE IN THE MONOCHROMETER)
         TNAME='CU'
         R12=0.497
         CTHM=0.8049
         READ(5,'(A80)') LINE
         IF(LINE(1:1).NE.'''') CALL JOBEND('THE NAME OF TARGET ELEMENT'
     &   //' SHOULD BE ENCLOSED BY A PAIR OF APOSTOROPHES.')
         BACKSPACE 5
         READ(5,*) TNAME,R12,CTHM
         DO 10 J=1,5
            IF(TNAME.EQ.XTARG(J)) THEN
               NTARG=J
               XLMD=WL(1,J)
               XLMD2=WL(2,J)
               XLMDH=WL(3,J)
               XLMD2H=WL(4,J)
               GO TO 1
            ENDIF
   10    CONTINUE
         CALL JOBEND('BAD TARGET NAME: '//TNAME)
    1    WRITE(6,150) TNAME,XLMD,XLMD2,R12,CTHM
      ELSE
         CALL JOBEND('INVALID NBEAM VALUE')
      ENDIF
  150 FORMAT(//11X,'RADIATION: ',A2/11X,'WAVELENGTH(ALPHA1) =',
     &F9.6,5X,'WAVELENGTH(ALPHA2) =',F9.6,5X,'I(ALPHA2)/I(ALPHA1) =',
     &F9.6,5X,'CTHM =',F9.6)
C
C**   NUMBER OF SPECIES
C     NREAL: NUMBER OF PURE CHEMICAL SPECIES
C     NMIX:  NUMBER OF VIRTUAL SPECIES COMPOSED OF TWO OR MORE KINDS
C            OF ATOMS
      NREAL=1
      NMIX=0
      READ(5,*) NREAL,NMIX
C
C     NATOM: NUMBER OF ATOMIC SPECIES (INCLUDING VIRTUAL SPECIES)
      NATOM=NREAL+NMIX
      IF(NATOM.GT.NA)
     &CALL JOBEND('NUMBER OF ATOMIC SPECIES OUT OF RANGE')
C
C**   CHEMICAL SYMBOLS
C     ANAME(KATOM): CHEMICAL SYMBOL (+VALENCE)
C     '*' IS ADDED IMMEDIATELY AFTER THE CHEMICAL SYMBOL OF
C     THE MAGNETIC ATOM
C*    NEUTRON MAGNETIC SCATTERING CURVES
C     RLV: SIN(THETA)/LAMBDA
C     AMPMAG: MAGNETIC FORM FACTOR
C     IDREAL=0: THE DATA FOR THIS CHEMICAL SPECIES HAS NOT BEEN READ
C     IDREAL=1: THE DATA FOR THIS CHEMICAL SPECIES HAS BEEN READ
      DO 14 J=1,NREAL
         READ(5,'(A5)') ANAME(J)
         IF(NBEAM.EQ.0 .AND. (INDEX(ANAME(J),'+').NE.0 .OR.
     &   INDEX(ANAME(J),'-').NE.0)) CALL JOBEND
     &   ('IONIC SPECIES SHOULD NOT BE INPUT IN NEUTRON DIFFRACTION.')
         IDREAL(J)=0
C        MAGATM=0: NONMAGNETIC ATOM
C        MAGATM=1: MAGNETIC ATOM
         MAGATM(J)=0
         ANAME2(J)=ANAME(J)
         ISTAR=INDEX(ANAME(J),'*')
         IF (ISTAR .NE. 0) THEN
            ANAME2(J)(ISTAR:ISTAR)=' '
            MAGATM(J)=1
            DO 12 JJ=1,20
               RLV(JJ,J)=-1.0
   12       CONTINUE
            READ(5,*) (RLV(JJ,J),AMPMAG(JJ,J),JJ=1,20)
            DO 13 JJ=20,1,-1
               IF (RLV(JJ,J) .GT. 0) GO TO 2
   13       CONTINUE
    2       NPAIR(J)=JJ
         END IF
   14 CONTINUE
C
C*    DISPERSION CORRECTION (NBEAM=2)
C     READ DISPERSION TERMS FOR SOR
      IF(NBEAM.EQ.2) READ(5,*) (DELTF1(J),DELTF2(J),J=1,NREAL)
      CALL ASFDC(NREAL,IDREAL,ANAME,ANAME2,AW,NBEAM,AA,BB,C,DC,
     &  DELTF1,DELTF2,NTARG,NPRINT)
C
C*    CONSTITUENTS OF SITES
C     NOFRAC: NUMBER OF ATOMIC SPECIES OCCUPYING THE SITE
C     MFRAC:  NUMBER WHICH REPRESENTS THE KIND OF THE ATOM
C     FRCTN:  MOLE FRACTION OF THE MFRAC'TH ATOM
      IF(NMIX.NE.0) THEN
         IF(NPRINT.NE.0) THEN
            WRITE(6,'(10X,122A1)') ('-',J=1,122)
         ELSE
            WRITE(6,'(/)')
         ENDIF
         WRITE(6,247)
         IMIX=1
         DO 16 LL=NREAL+1,NATOM
            READ(5,'(A80)') LINE
            IF(LINE(1:1).NE.'''') CALL JOBEND('THE NAME OF VIRTUAL ATOM'
     &      //' SHOULD BE ENCLOSED BY APOSTROPHES.')
            BACKSPACE 5
            READ(5,*) ANAME(LL),KK,(MFRAC(J,IMIX),FRCTN(J,IMIX),J=1,KK)
            NOFRAC(IMIX)=KK
            MAGATM(LL)=0
            DELTF2(LL)=0.0
            AW(LL)=0.0
            DO 15 J=1,KK
               IF (NBEAM .GE.1) THEN
                  DELTF2(LL)=DELTF2(LL)+DELTF2(MFRAC(J,IMIX))*
     &            FRCTN(J,IMIX)
               ELSE IF (MAGATM(MFRAC(J,IMIX)) .EQ. 1) THEN
C                 ONE OF THE CONSTITUENTS OF THE SITE IS OF MAGNETIC
C                 MOMENT
                  MAGATM(LL)=1
               END IF
               AW(LL)=AW(LL)+AW(MFRAC(J,IMIX))*FRCTN(J,IMIX)
   15       CONTINUE
            IF(NPRINT.NE.0) THEN
               WRITE(6,255) LL,ANAME(LL),
     &         (ANAME(MFRAC(J,IMIX)),FRCTN(J,IMIX),J=1,KK)
            ELSE
               WRITE(6,260) ANAME(LL),
     &         (ANAME(MFRAC(J,IMIX)),FRCTN(J,IMIX),J=1,KK)
            ENDIF
            IMIX=IMIX+1
   16    CONTINUE
      ENDIF
  247 FORMAT(' ',10X,'VIRTUAL ATOM(S).  FIGURES DENOTE THE MOLE FRACTION
     &S OF SPECIFIED COMPONENTS.')
  255 FORMAT(10X,I2,1X,A5,5X,A5,F11.6,3(6X,A5,F11.6))
  260 FORMAT(' ',12X,A5,5X,A5,F11.6,3(6X,A5,F11.6))
C
      LL=0
      DO 17 J=1,NREAL
         IF (MAGATM(J) .EQ. 1) THEN
            IF (LL .EQ. 0)
     &      WRITE(6,'(//11X,A/)') 'NEUTRON MAGNETIC SCATTERING CURVE(S)'
            M=MIN(13,NPAIR(J))
            WRITE(6,262) ANAME(J),'RLV',(RLV(JJ,J),JJ=1,M)
            WRITE(6,262) ANAME(J),'AMP',(AMPMAG(JJ,J),JJ=1,M)
            IF (NPAIR(J) .GE. 14) THEN
               WRITE(6,262) ANAME(J),'RLV',(RLV(JJ,J),JJ=14,NPAIR(J))
               WRITE(6,262) ANAME(J),'AMP',(AMPMAG(JJ,J),JJ=14,NPAIR(J))
            END IF
            LL=1
         END IF
   17 CONTINUE
  262 FORMAT(13X,A,A,13(F8.4:))
 
C**   NUMBER OF PHASES
C     NPHASE: NUMBER OF PHASES
      NPHASE=1
      READ(5,*) NPHASE
      IF (NFR .GT. NPHASE) THEN
         CALL JOBEND('NPHASE IS NOT COMPATIBLE WITH NFR.')
      ELSE IF (NDA .GT. NPHASE .OR. NDA .GT. NPHASE) THEN
         CALL JOBEND('NPHASE IS NOT COMPATIBLE WITH NDA.')
      ELSE IF (NPHASE .GT. NPH) THEN
         CALL JOBEND('NUMBER OF PHASES IS TOO LARGE.')
      END IF
C**   INFORMATION ON EACH PHASE
C       PHNAME: NAME OF A PHASE
C          VNS: VOLUME NAME-SPACE GROUP #-SETTING # OF INTERNATIONAL
C               TABLES
C     LSPSYM=0: STANDARD SYMMETRY IS REQUIRED
C     LSPSYM=1: SOME SPECIAL SYMMETRY IS REQUIRED
C     LSPSYM=2: NON-STANDARD SYMMETRY IS REQUIRED
C      INDIV=0: INDIVIDUAL THERMAL PARAMETERS ARE NOT INPUT
C               (THE OVERALL THERMAL PARAMETER IS USED)
C      INDIV=1: INDIVIDUAL THERMAL PARAMETERS (ISOTROPIC OR ANISOTROPIC)
C               ARE INPUT
C         NOAT: TYPES OF ATOMS IN ONE ASYMMETRIC UNIT, REPRESENTED BY
C               CODE NUMBERS
C               NOAT < 0: ANISOTROPIC THERMAL PARAMETERS ARE INPUT.
C               NOAT > 0: AN ISOTROPIC THERMAL PARAMETER IS INPUT.
C
      DO 22 L=1,NPHASE
         DO 18 J=1,NAP
            NOAT(J,L)=0
   18    CONTINUE
         READ(5,*) PHNAME(L),VNS(L),LSPSYM(L),INDIV(L),
     &   (NOAT(J,L),J=1,NAP)
 
         CALL FLSITE(L,NOAT,INDIV,LISO,NPSITE,MAGATM,NSITE,LMAG,
     &   NATOM,ISONUM)
 
         IF (LSPSYM(L) .EQ. 1) THEN
C*          TYPE OF POSSIBLE REFLECTIONS
            REFTYP(L)='HKL'
            READ(5,'(A)') REFTYP(L)
            IF (REFTYP(L) .EQ. 'HKL') THEN
               NHKL(L)=1
            ELSE IF (REFTYP(L) .EQ. '0KL') THEN
               NHKL(L)=2
            ELSE IF (REFTYP(L) .EQ. 'H0L') THEN
               NHKL(L)=3
            ELSE IF (REFTYP(L) .EQ. 'HK0') THEN
               NHKL(L)=4
            ELSE IF (REFTYP(L) .EQ. 'HHL') THEN
               NHKL(L)=5
*           ELSE IF (REFTYP(L) .EQ. 'H-HL') THEN
*              NHKL(L)=6
            ELSE
               CALL JOBEND('BAD REFLECTION TYPE: '//REFTYP(L))
            END IF
            DO 21 ICOND=1,7
C*             CONDITIONS FOR POSSIBLE REFLECTIONS
C*             END OF CONDITIONS: 'ENDCON'
               READ(5,'(A)') LINE
               LCON(ICOND,L)=LINE
               IF (LINE(1:6) .EQ. 'ENDCON') GO TO 3
               CALL POSREF(COL,ICH(1,1,ICOND,L),NCON(ICOND,L))
   21       CONTINUE
    3       NLINE(L)=ICOND-1
         END IF
 
         CALL INTTBL(VNS(L),L,NSPGR,NSET,LAUEG,NCENTR,NSYM,SPGR,LSPSYM,
     &   NSSYM,SYM,LINNSS,NLNSS)
   22 CONTINUE
C
      DO 27 L=1,NPHASE
         IF(NPHASE.GT.1) THEN
            WRITE(6,'(//11X,A,I1,A,A)') 'PHASE #',L,': ',PHNAME(L)
         ELSE
            WRITE(6,'(/)')
         ENDIF
         IF(NSET(L) .EQ. 1) THEN
            FSSET=')'
         ELSE
            WRITE(FSSET,'(A,I1,A)') ', SETTING #',NSET(L),')'
         ENDIF
         WRITE(6,'(11X,5A,I4,A)')
     &   'SPACE GROUP: ',SPGR(L),' (VOL. ',VNS(L)(1:1),',',NSPGR(L),
     &   FSSET
         WRITE(6,277) CRYSYS(LAUEG(L))
  277    FORMAT(11X,'CRYSTAL SYSTEM AND LAUE-SYMMETRY CLASS: ',A)
         IF (LSPSYM(L) .EQ. 1) THEN
            WRITE(6,'(11X,A)') 'SPECIAL SYMMETRY CONDITIONS'
            DO 25 I=1,NLINE(L)
               IF (I .EQ. 1) THEN
                  WRITE(6,'(13X,3A)') REFTYP(L),': ',LCON(I,L)
               ELSE
                  WRITE(6,'(19X,A)') LCON(I,L)
               END IF
   25       CONTINUE
         ELSE IF (LSPSYM(L) .EQ. 2) THEN
            WRITE(6,'(11X,A,I3/11X,A,I2/11X,A)') 'LAUEG  =',LAUEG(L),
     &      'NCENTR =',NCENTR(L),'NON-STANDARD SYMMETRY CONDITIONS'
            WRITE(6,'(13X,A)') (LINNSS(J),J=1,NLNSS)
         END IF
         IF (LSPSYM(L) .EQ. 2 .OR. NPRINT .EQ. 2) THEN
            IF(NCENTR(L).EQ.1) THEN
               WRITE(6,280)
            ELSE
               WRITE(6,285)
            ENDIF
            DO 26 J=1,NSYM(L)
               WRITE(6,290) (SYM(KK,J,L),KK=1,3)
   26       CONTINUE
         END IF
   27 CONTINUE
  280 FORMAT(' ',10X,'COORDINATES OF EQUIVALENT POSITIONS EXCLUDING THOS
     &E GENERATED BY LATTICE CENTERING')
  285 FORMAT(' ',10X,'COORDINATES OF EQUIVALENT POSITIONS')
  290 FORMAT(' ',12X,3(A10,3X))
 
C     KPHB(L): PARAMETER NUMBER FOR THE SCALE FACTOR OF THE L'TH PHASE
C     KPHE(L): PARAMETER NUMBER FOR THE LAST STRUCTURE-FACTOR
C              PARAMETER OF THE L'TH PHASE
      DO 30 L=1,NPHASE
         IF (L .EQ. 1) THEN
            KPHB(L)=8
         ELSE
            KPHB(L)=KPHE(L-1)+1
         END IF
         NPARL=0
         DO 29 J=1,NSITE(L)
            NPARL=NPARL+NPSITE(J,L)
   29    CONTINUE
         KPHE(L)=KPHB(L)+NPARL+15
         IF (LMAG(L) .EQ. 1) THEN
            IF (LAUEG(L) .EQ. 5) THEN
               KPHE(L)=KPHE(L)+3
            ELSE IF (LAUEG(L) .LE. 13) THEN
               KPHE(L)=KPHE(L)+1
            END IF
         END IF
   30 CONTINUE
      NTERMS=KPHE(NPHASE)
      IF(NTERMS.GT.NT) CALL JOBEND('THE NUMBER OF PARAMETERS HAS REACHED
     & THE MEXIMUM NUMBER.')
C
      CALL MLAT(COEF)
      CALL RDPARA(NRFN,NCNSTR,NTERMS,A,ID,AOUT,IDSAVE,IR,
     &NMODE,FIRST,NRANGE)
C
      DO 32 L=1,NPHASE
C        THE VALUE OF NQ IS REFERRED TO IN SUBROUTINE SF
         IF(INDIV(L).EQ.1 .AND. NCENTR(L).EQ.0) THEN
            NQ(L)=1
         ELSEIF(INDIV(L).EQ.1 .AND. NCENTR(L).EQ.1) THEN
            NQ(L)=2
         ELSEIF(INDIV(L).EQ.0 .AND. NCENTR(L).EQ.0) THEN
            NQ(L)=3
         ELSEIF(INDIV(L).EQ.0 .AND. NCENTR(L).EQ.1) THEN
            NQ(L)=4
         ENDIF
   32 CONTINUE
C
      CALL PARAM(ANAME,ISONUM,A,ID,NMODE,NTERMS)
      CALL ACONV(NPHASE,LMAG,A,KPHB,KPHE,LAUEG)
      CALL CCTENS(A)
C
C     PRINT OUT DIRECT AND RECIPROCAL CELL CONSTANTS
      IF(NPRINT.GE.1) CALL PRUCC
C
      IF(NCNSTR.NE.0) THEN
         WRITE(6,'(//11X,A)') 'LINEAR CONSTRAINTS'
C*       LINEAR CONSTRAINTS
C*       END OF CONSTRAINTS: 'ENDLIN'
         DO 35 I=1,NCNSTR
            READ(5,'(A)') LINE
            WRITE(6,'(13X,A)') LINE
            CALL LINCON(COL,NTERMS)
   35    CONTINUE
         READ(5,'(A)') LINE
         IF (LINE(1:6) .NE. 'ENDLIN') THEN
            CALL JOBEND('MISSING ''ENDLIN'' LINE')
         END IF
      ENDIF
      CALL SETPAR(A)
C
      CALL SYMOP(A)
      IF(NPRINT.NE.0) THEN
         CALL EQPOS(NPHASE,PHNAME,NSITE,ISONUM,ANAME,NOAT,NSYM,IDSYM,
     &   NCENTR,IFAC,COEF,SYM,NSSYM)
         CALL COMPOS(A,SIGMAA,0,ANAME,INDIV,COEF,AW)
      END IF
C
C*    PREFERRED ORIENTATION
C     NPROR=0: DO NOT CORRECT PREFERRED ORIENTATION (ENTER ONLY '/')
C     NPROR=1: PLATY CRYSTALS
C     NPROR=2: NEEDLE CRYSTALS
C     (HP, KP, LP): PREFERRED-ORIENTATION VECTOR
C     WHEN PREFERRED ORIENTATION IS NEGLIGIBLE, NPROR IS SET TO 0.
C     THE PREFERRED-ORIENTATION VECTOR, (HP)A* + (KP)B* + (LP)C*, IS
C     PERPENDICULAR TO THE (HP KP LP) PLANE.
C     THE DIRECTION OF THE VECTOR CORRESPONDS TO THE NORMAL TO THE
C     PLATE CRYSTALLITES OR TO THE NEEDLE AXIS IN NEEDLE CRYSTALS.
      DO 50 L=1,NPHASE
         NPROR(L)=0
         HP(L)=0
         KP(L)=0
         LP(L)=1
         READ(5,*) NPROR(L),HP(L),KP(L),LP(L)
         IF (NPROR(L) .NE. 0) THEN
            WRITE(6,450) PHNAME(L),NPROR(L),HP(L),KP(L),LP(L)
         ELSE
            WRITE(6,450) PHNAME(L),0
         END IF
         IF(P(NPO1X).NE.0.0 .OR. P(NPO2X).NE.0.0 .OR. (NMODE.LE.1 .AND.
     &   LD(NPO1X).NE.0) .OR. (NMODE.LE.1 .AND. LD(NPO2X).NE.0)) THEN
*           PREFERRED ORIENTATION SHOULD BE CORRECTED
            IF (NPROR(L) .EQ. 0) THEN
               CALL JOBEND('NPROR FOR THIS PHASE SHOULD BE 1 OR 2.')
            ELSE IF (NPROR(L) .LT. 0 .OR. NPROR(L) .GT. 2) THEN
               WRITE(6,'(//11X,A,I2)') 'NPROR OUT OF RANGE: ',NPROR(L)
               CALL JOBEND(' ')
            ELSE
*              NEUTRON DIFFRACTION, CYLINDRICAL CONTAINER
               IF (NPROR(L) .EQ. 1 .AND. NBEAM .EQ. 0) THEN
                  NPROR(L)=2
               END IF
            ENDIF
         ENDIF
   50 CONTINUE
  450 FORMAT(//11X,'PREFERRED ORIENTATION IN ',A/13X,'NPROR =',I2,:,5X,
     &'PREFERRED-ORIENTATION VECTOR: (',I2,',',I2,',',I2,')')
C
      IF(NMODE.LT.2) THEN
C*       EXCLUDED REGIONS (NEXC=1)
C        DEGEXC(1,J): LOWER LIMIT, DEGEXC(2,J): UPPER LIMIT
C*       END OF REGION: 'ENDRANGE'
C        NSKIP: NUMBER OF SKIPPED REGIONS
         IF(NEXC.EQ.1) THEN
            DO 56 J=1,50
               READ(5,'(A80)') LINE
               IF(LINE(1:8).EQ.'ENDRANGE') GO TO 4
               BACKSPACE 5
               READ(5,*) (DEGEXC(MM,J),MM=1,2)
   56       CONTINUE
            CALL JOBEND('THE NUMBER OF EXCLUDED REGIONS HAS REACHED '//
     &      'THE MAXIMUM VALUE.')
    4       NSKIP=J-1
            WRITE(6,480) ((DEGEXC(MM,J),MM=1,2),J=1,NSKIP)
         ENDIF
C
C        READ STEP-SCANNED INTENSITY DATA RECORDED ON DISK
         CALL RDINT(NP,NTOTAL,THINIT,STEP,NEXC,NSKIP,DEGEXC,NSTEP,
     &   DEG,XINT)
      ENDIF
  480 FORMAT(//11X,'EXCLUDED REGIONS IN THE DATA'/(13X,F6.2,'-',F6.2))
C
      IF(NRANGE.EQ.1) THEN
C*       BACKGROUND SPECIFICATION (NRANGE=1)
C        X: ARRAY OF TWO-THETA (PLACE '/' AFTER THE LAST VALUE)
         DO 62 J=1,100
            X(J)=-1.0
   62    CONTINUE
         READ(5,*) (X(J),J=1,100)
         IF (X(100) .GT. 0.0) THEN
            CALL JOBEND('THE NUMBER OF BACKGROUND SPECIFICATIONS HAS '//
     &      'REACHED THE MAXIMUM VALUE.')
         END IF
         DO 65 J=1,100
            IF (X(J) .LT. 0.0) GO TO 5
            X(J)=X(J)*RD
   65    CONTINUE
    5    NBG=J-1
         CALL SMINT(X,Y,DEG,XINT,NBG,NSTEP)
         WRITE(6,560) (X(J)/RD,J=1,NBG)
         OPEN(UNIT=10,ACCESS='SEQUENTIAL',
     &   FORM='UNFORMATTED',STATUS='SCRATCH')
         WRITE(10) (DEG(J),XINT(J),BG(J),J=1,NSTEP)
         REWIND 10
      ENDIF
  560 FORMAT(//11X,'TWO-THETA SPECIFIED BY USER TO EVALUATE BACKGROUND.'
     &/(' ',9X,10F9.2))
C
C*    RANGE OF TWO-THETA (NMODE=2,3)
C     REFLECTIONS BETWEEN DEG1 AND DEG2 ARE CALCULATED
      IF(NMODE.GE.2) THEN
         READ(5,*) DEG1,DEG2
         DEG1=DEG1*RD
         DEG2=DEG2*RD
         IF (NMODE .EQ. 3) THEN
C           STEP: STEP INTERVAL
*BUG FIXED ON 1986.7.21
            STEP=0.015*RD
            NSTEP=(DEG2-DEG1)/STEP+1
            IF (NSTEP .GT. NP-2) THEN
               NSTEP=NP-2
               STEP=(DEG2-DEG1)/(NSTEP-1)
            END IF
         END IF
      ELSE
         DEG1=DEG(1)
         DEG2=DEG(NSTEP)
      ENDIF
C     COEFFICIENTS FOR THE NORMALIZATION OF TWO-THETA
      FT1=2.0/(DEG2-DEG1)
      FT2=-0.5*(DEG1+DEG2)
      WRITE(6,570) DEG1*RD2,DEG2*RD2
  570 FORMAT(//11X,'2O(MIN) =',11X,'2O(MAX) ='/'+'11X,'-',7X,F6.2,
     &6X,'-',7X,F7.2)
      IF(DEG1.LT.3.0*RD .OR. DEG2.LT.3.0*RD .OR. DEG1.GT.180.0*RD .OR.
     &   DEG2.GT.180.0*RD .OR. DEG2.LE.DEG1)
     &   CALL JOBEND('BAD DIFFRACTION ANGLE(S).')
      IF(NMODE.NE.2) WRITE(6,590) STEP*RD2,NSTEP
  590 FORMAT(' ',10X,'STEP =',F6.3,5X,'NSTEP =',I5)
      IF(NMODE.NE.2 .AND. NRANGE.EQ.2) THEN
         DO 67 J=1,NSTEP
            IF(NMODE.EQ.3) DEG(J)=DEG1+STEP*(J-1)
            BG(J)=FT1*(DEG(J)+FT2)
   67    CONTINUE
      ENDIF
C
      IF(NMODE.NE.2) THEN
C*       PROFILE PARAMETERS (NMODE<>2)
C        ALL DATA POINTS FARTHER THAN PC*FWHM FROM THE NEAREST BRAGG
C        POSITION ARE IGNORED.
C        CSTB: CONSTANT INTRODUCED INTO THE EQUATION FOR CALCULATING
C              H.K**2 IN ORDER TO STABILIZE CONVERSION
C        RLIM: PEAKS BELOW THIS ANGLE ARE CORRECTED FOR ASYMMETRY
         PC=7.0
         CSTB=0.6
         RLIM=40.0
         READ(5,*) PC,CSTB,RLIM
         WRITE(6,'(11X,A,F5.2,A,5X,A,F6.3,5X,A,F5.1)')
     &   'CUT-OFF = ',PC,' * FWHM','CSTB =',CSTB,'RLIM =',RLIM
         RLIM=RLIM*RD
*MODIFIED ON 1988.10.27
         IF (RLIM .LE. DEG1) CALL JOBEND('RLIM SHOULD BE GREATER THAN'//
     &   ' THE LOWEST DIFFRACTION ANGLE.')
*MODIFICATION END
C        INCREASE DEG2 SO THAT SOME REFLECTIONS WHOSE DIFFRACTION
C        ANGLES ARE SLIGHTLY HIGHER THAN DEG2 ARE INCLUDED
         CALL FWHM(A,1,IDPOS)
         IF (IDPOS .EQ. -1) THEN
            CALL JOBEND('FWHM CANNOT BE CALCULATED FROM U, V, AND W.')
         END IF
         TNTERM=TAN(DEG2/2.0)-CSTB
         ANGMAX=RD2*(DEG2+PC2(1)*SQRT((A(9)*TNTERM+A(10))*TNTERM+A(11)))
      ELSE
         ANGMAX=RD2*DEG2
      ENDIF
      ANGMIN=RD2*DEG1
      CALL GENREF(A,NSPGR)
      IDZP=0
      CALL UPDATE(YPEAK,A,IDPOS,0)
      IF(IDPOS.EQ.-1) THEN
         CALL JOBEND('FWHM CANNOT BE CALCULATED FROM U, V, AND W.')
      ELSE IF (IDPOS.EQ.0) THEN
         CALL JOBEND('D SPACINGS CANNOT BE CALCULATED FROM THE LATTICE '
     &   //'CONSTANTS.')
      END IF
      IF(NMODE.EQ.2 .OR. (NMODE.EQ.3 .AND. NPRINT.GE.1) .OR.
     &(NMODE.LE.1 .AND. NPRINT.EQ.2)) THEN
         WRITE(6,630)
         CALL RFLCTN(YPEAK,COEF,0)
      ENDIF
  630 FORMAT(///7X,'*** SUMMARY OF POSSIBLE REFLECTIONS (BASED ON THE US
     &ER-SUPPLIED PARAMETERS) ***'/)
      IF(NMODE .EQ. 3) THEN
C        CALCULATE INTENSITIES FROM PROFILE AND STRUCTURE PARAMETERS
         DO 80 J=1,NSTEP
            YFIT(J)=CALINT(DEG,J,A,YPEAK)
   80    CONTINUE
         IF (LOUTS .EQ. 1) THEN
*           NMODE=3
            FACFIG=1.0
C*          SCALE FACTOR FOR THE PLOTTER OUTPUT
            READ(5,*) FACFIG
            CALL SIMLTN(YFIT,DEG,NSTEP,TITLE,FACFIG)
         ELSE IF (LOUTS .EQ. -1) THEN
            CALL SIMDAT(YFIT,NSTEP,TITLE,DEG,STEP,NREFL,PEAK)
         END IF
      ENDIF
      IF(NMODE.GE.2) THEN
         CLOSE(UNIT=5,STATUS='KEEP')
         CALL JOBEND(' ')
      ENDIF
C
C*    CONTROL DATA FOR THE CONJUGATE DIRECTION METHOD (NLESQ=1)
C     MITER: MAXIMUM NUMBER OF ITERATIONS
C     STEP2: THE INITIAL STEP SIZE
C     ACC:   THE REQUIRED ACCURACY IN THE FUNCTION AND VECTOR VALUES
C     NC:    TOTAL NUMBER OF NONLINEAR CONSTRAINTS
C     TK:    PENALTY PARAMETER (WEIGHT IMPOSED ON THE SUM OF VIOLATED
C            CONSTRAINTS
C
C*    CONTROL DATA FOR NONLINEAR LEAST-SQUARES FITTING USING PARTIAL
C     DERIVATIVES (NLESQ=2,3)
C     NAUTO=0: REFINE VARIABLE PARAMETERS SIMULTANEOUSLY
C     NAUTO=1: REFINE VARIABLE PARAMATERS SUCCESSIVELY
C     NAUTO=2: REFINE VARIABLE PARAMATERS SUCCESSIVELY AND CHECK THE
C              RESULTING PARAMETERS BY POWELL'S METHOD
C       NCYCL: MAXIMUM NUMBER OF ITERATIONS
C        CONV: IF (S(N-1)-S(N))/S(N) <= CONV NCONV TIMES IN SUCCESSION,
C              FINISH THE REFINEMENT (NC=0) OR GO TO THE NEXT REFINEMENT
C              STAGE IN WHICH A LARGER VALUE OF TK IS USED (NC>0).  IN
C              THE ABOVE FORMULA, S DENOTES THE OBJECTIVE FUNCTION.
C          NC: TOTAL NUMBER OF NONLINEAR CONSTRAINTS
C          TK: INITIAL VALUE OF THE PENALTY PARAMETER
C        FINC: TK(K) = FINC*TK(K-1)
C
C     LALPHA=0: THE COEFFICIENT MATRIX HAS NOT BEEN CALCULATED
C     LALPHA=1: THE COEFFICIENT MATRIX HAS ALREADY BEEN CALCULATED
C     IDCYCL=0: SUBROUTINE CURFIT IS CALLED TO CALCULATE STANDARD
C               DEVIAIONS OF PARAMETERS
C     IDCYCL=1: SUBROUTINE CURFIT IS CALLED TO REFINE THE VALUES OF
C               PARAMETERS
C
      MITER=4
      STEP2=0.03
      ACC=1.0E-4
      NC=0
      TK=0.0
      NAUTO=0
      NCYCL=15
      CONV=1.0E-4
      NCONV=2
      FINC=20.0
      LALPHA=0
      ISCALE=0
      IDIF=0
      FACFIG=1.0
      INC=0
      IF(NLESQ.EQ.1) THEN
         READ(5,*) MITER,STEP2,ACC,NC,TK
C*       INCREMENT OF THE Y-AXIS LINE IN LINE PRINTER PLOT
         IF(NPRINT.EQ.2) READ(5,*,END=660) ISCALE,IDIF
C*       SCALE FACTOR FOR THE PLOTTER OUTPUT
         IF(NMODE.EQ.1) READ(5,*,END=670) FACFIG,INC
         CALL CONDIR(NTERMS,NSTEP,A,DEG,XINT,YFIT,YPEAK)
C        STANDARD DEVIATIONS OF PARAMETERS ARE CALCULATED
         NLESQ=3
         NCYCL=1
         NC=0
         IDCYCL=0
         CALL MARGAU(NCYCL,NTERMS,NSTEP,NPTS,A,DEG,XINT,YFIT,YPEAK,
     &   SIGMAA)
      ELSE
         READ(5,*) NAUTO,NCYCL,CONV,NCONV,NC,TK,FINC
         IF(NAUTO.NE.0) THEN
            CALL RDREF(IPAR,NPAR,NCHNG,ID)
C*          CONDITIONS OF THE CONJUGATE DIRECTION METHOD
            IF(NAUTO.EQ.2) READ(5,*) MITER,STEP2,ACC
         ENDIF
C*       INCREMENT OF THE Y-AXIS LINE IN LINE PRINTER PLOT
         IF(NPRINT.EQ.2) THEN
            READ(5,*,END=660) ISCALE,IDIF
         END IF
C        FACTOR LINE
C*       SCALE FACTOR FOR THE PLOTTER OUTPUT
         IF(NMODE.EQ.1) THEN
            READ(5,*,END=670) FACFIG,INC
         END IF
         IF (NCYCL .GT. 0) THEN
            IDCYCL=1
            CALL MARGAU(NCYCL,NTERMS,NSTEP,NPTS,A,DEG,XINT,YFIT,YPEAK,
     &      SIGMAA)
            LALPHA=1
         ELSE
            LALPHA=0
         END IF
         IF(NAUTO.EQ.2) THEN
C           CHECK THE CONVERGENCE TO THE GLOBAL MINIMUM
            NLESQ=1
            CALL CONDIR(NTERMS,NSTEP,A,DEG,XINT,YFIT,YPEAK)
            LALPHA=0
         ENDIF
C        STANDARD DEVIATIONS OF PARAMETERS ARE CALCULATED
         NLESQ=3
         NCYCL=1
         NC=0
         NAUTO=0
         IDCYCL=0
         CALL MARGAU(NCYCL,NTERMS,NSTEP,NPTS,A,DEG,XINT,YFIT,YPEAK,
     &   SIGMAA)
      ENDIF
      CLOSE(UNIT=10,STATUS='DELETE')
C     PRINT OUT A TABLE OF INDICES, RELATIVE INTENSITIES, PEAK
C     POSITIONS, AND SO ON
*MODIFIED ON 1988.10.25
*     IF (NPRINT .GE. 1) CALL COMPOS(A,ANAME,INDIV,COEF,AW)
      CALL COMPOS(A,SIGMAA,1,ANAME,INDIV,COEF,AW)
*MIDIFICATION END
      WRITE(6,650)
  650 FORMAT('1'/7X,'*** SUMMARY OF POSSIBLE REFLECTIONS (BASED ON THE R
     &EFINED PARAMETERS) ***'/)
      CALL RFLCTN(YPEAK,COEF,1)
CORRECTED ON 1989.3.10
C     IF(NPRINT.EQ.2) CALL LIST2(G,IDSAVE,ID,DEG,XINT,YFIT,NTERMS,
C    &NRFN,NPTS,ISCALE,IDIF)
      IF (NPRINT .EQ. 2 .OR. LFLAG(4) .EQ. 1 .OR. LFLAG(5) .EQ. 1) THEN
         CALL LIST2(G,ID,DEG,XINT,YFIT,NTERMS,NRFN,NPTS,ISCALE,IDIF,
     &   NPRINT,LFLAG)
      END IF
 
C     RECORD RESULTS OF RIETVELD REFINEMENT
      IF (NMODE .EQ. -1) THEN
         CALL OUT20(DEG,XINT,YFIT,BG,PEAK,NPTS,STEP,NREFL,TITLE)
      END IF
      IF (NDA .GT. 0) THEN
         CALL MKFLOR(A,G,PHNAME(NDA),SIGMAA,NTERMS,COEF)
      END IF
      IF(NMODE.EQ.1)
     &CALL PLOTRA(YFIT,XINT,DEG,NPTS,TITLE,A,YPEAK,X,Y,NBG,FACFIG,INC)
      IF (NAUTO .EQ. 0 .AND. NUPDT .EQ. 1 .AND. IDCYCL .EQ. 0) THEN
         CALL OVERWR(A,SIGMAA,NTERMS)
      END IF
      CLOSE(UNIT=5,STATUS='KEEP')
      CALL JOBEND(' ')
  660 CALL JOBEND('MISSING ISCALE AND IDIF')
  670 CALL JOBEND('MISSING INC')
      END
 
************************************************************************
 
      SUBROUTINE ASFDC(NREAL,IDREAL,ANAME,ANAME2,AW,NBEAM,AA,BB,C,DC,
     &  DELTF1,DELTF2,NTARG,NPRINT)
*     SEARCH THE ASFDC DATABASE
C     AA(N,KATOM), BB(N,KATOM), AND C(KATOM): COEFFICIENTS FOR ANALYTIC
C     APPROXIMATIONS OF SCATTERING FACTORS
C     DELTF1: REAL DISPERSION TERM
C     DELTF2: IMAGINARY DISPERSION TERM
C     'INTERNATIONAL TABLES FOR X-RAY CRYSTALLOGRAPHY,' VOL. IV (1974).
      PARAMETER (NA=7)
      INTEGER IDREAL(*)
      REAL AW(*),AA(4,NA),BB(4,NA),C(*),DC(2,5),DELTF1(*),DELTF2(*)
      CHARACTER*5 DNAME,ANAME(*),ANAME2(*)
 
      IREAL=1
*SUN (CHANGE THE FILENAME TO AN APPROPRIATE ONE)
*     OPEN(UNIT=2,FILE='/USR2/IZUMI/DATABASE/ASFDC',STATUS='OLD')
*VAX
      OPEN(UNIT=2,FILE='ASFDC.DAT',STATUS='OLD',READONLY)
      REWIND 2
      DO 50 J=1,211
         READ(2,'(A5)') DNAME
         DO 40 JJ=1,NREAL
            IF (IDREAL(JJ) .EQ. 0 .AND. DNAME .EQ. ANAME2(JJ)) THEN
               BACKSPACE(UNIT=2)
               READ(2,'(9X,F10.0)') AW(JJ)
               IF(NBEAM.GE.1) THEN
                  READ(2,*) (AA(N,JJ),BB(N,JJ),N=1,4),C(JJ)
                  READ(2,*) ((DC(MM,NN),MM=1,2),NN=1,5)
                  IF(NBEAM.EQ.1) THEN
                     DELTF1(JJ)=DC(1,NTARG)
                     DELTF2(JJ)=DC(2,NTARG)
                  ENDIF
               ELSE
                  READ(2,*) (AA(N,JJ),BB(N,JJ),N=1,4),DUM1,C(JJ)
                  READ(2,*) ((DC(MM,NN),MM=1,2),NN=1,5)
                  DO 30 N=1,4
                     AA(N,JJ)=0.0
                     BB(N,JJ)=0.0
   30             CONTINUE
                  DELTF1(JJ)=0.0
                  DELTF2(JJ)=0.0
               ENDIF
               IDREAL(JJ)=1
               IREAL=IREAL+1
               IF(IREAL.GT.NREAL) GO TO 3
               GO TO 50
            ENDIF
   40    CONTINUE
C        SKIP TWO LINES
         READ(2,'()')
         READ(2,'()')
   50 CONTINUE
      WRITE(6,'(//11X,A)') 'WRONG CHEMICAL SYMBOL(S)'
      DO 60 J=1,NREAL
         IF(IDREAL(J).EQ.0) WRITE(6,'(13X,A5)') ANAME(J)
   60 CONTINUE
      CALL JOBEND(' ')
    3 IF(NPRINT.NE.0) THEN
         IF(NBEAM.EQ.1) THEN
            WRITE(6,150) (JJ,ANAME(JJ),(AA(N,JJ),
     &      BB(N,JJ),N=1,4),C(JJ),DELTF1(JJ),DELTF2(JJ),JJ=1,NREAL)
         ELSE
            WRITE(6,'(//11X,A//11X,A/(11X,I2,3X,A5,3X,F6.3))')
     &      'SCATTERING LENGTHS','NO.  ATOM     B/FM',
     &      (JJ,ANAME(JJ),C(JJ),JJ=1,NREAL)
         ENDIF
      ENDIF
  150 FORMAT(//' ',10X,'COEFFICIENTS FOR ANALYTIC APPROXIMATIONS OF SCAT
     &TERING FACTORS AND DISPERSION TERMS'//10X,'NO. ATOM',4X,
     &'A1',9X,'B1',9X,'A2',9X,'B2',9X,'A3',9X,'B3',9X,'A4',9X,'B4',9X,
     &'C',7X,'DELTF1  DELTF2'/(10X,I2,1X,A5,F10.6,8F11.6,2F8.3))
      END
 
************************************************************************
 
      SUBROUTINE FLSITE(L,NOAT,INDIV,LISO,NPSITE,MAGATM,NSITE,LMAG,
     &  NATOM,ISONUM)
*     DETERMINE LISO, LMAG, AND ISONUM
      PARAMETER (NAP=36,NPH=2)
      INTEGER NOAT(NAP,NPH),INDIV(*),LISO(NAP,NPH),NPSITE(NAP,NPH),
     &  MAGATM(*),NSITE(*),LMAG(*),ISONUM(NAP,NPH)
 
      DO 20 J=1,NAP
C        LISO=0: OVERALL TEMPERATURE FACTOR
C        LISO=1: INDIVIDUAL ISOTROPIC TEMPERATURE FACTOR
C        IISO=6: INDIVIDUAL ANISOTROPIC TEMPERATURE FACTOR
         IF (NOAT(J,L) .EQ. 0) THEN
            GO TO 2
         ELSE IF (NOAT(J,L) .GT. 0) THEN
            IF (INDIV(L) .EQ. 1) THEN
               LISO(J,L)=1
            ELSE
               LISO(J,L)=0
            END IF
         ELSE
            LISO(J,L)=6
            NOAT(J,L)=-NOAT(J,L)
         END IF
C        NPSITE: STRUCTURE-FACTOR PARAMETERS PER SITE
         NPSITE(J,L)=4+LISO(J,L)+MAGATM(NOAT(J,L))
         IF (NOAT(J,L) .EQ. 0) GO TO 2
   20 CONTINUE
C     NSITE: NUMBER OF ATOMS IN ASYMMETRIC UNIT
    2 NSITE(L)=J-1
 
C     LMAG=0: NONMAGNETIC MATERIAL
C     LMAG=1: MAGNETIC MATERIAL
      LMAG(L)=0
      DO 30 J=1,NSITE(L)
         IF (MAGATM(NOAT(J,L)) .EQ. 1) THEN
            LMAG(L)=1
            GO TO 4
         END IF
   30 CONTINUE
 
C     ISONUM: ARRAY TO ASSIGN A SERIES OF NEMBERS FOR EACH CHEMICAL
C             SPECIES
    4 DO 70 J=1,NSITE(L)
         IF(NOAT(J,L).LT.1 .OR. NOAT(J,L).GT.NATOM) THEN
            WRITE(6,'(//11X,A,I2)') 'ATOMIC NUMBER OUT OF RANGE: ',
     &      NOAT(J,L)
            CALL JOBEND(' ')
         ENDIF
         KK=1
         DO 40 JJ=1,J-1
            IF (NOAT(J,L) .EQ. NOAT(JJ,L)) KK=KK+1
   40    CONTINUE
         ISONUM(J,L)=KK
         IF(KK.EQ.1) THEN
            DO 50 JJ=J+1,NSITE(L)
               IF(NOAT(J,L).EQ.NOAT(JJ,L)) GO TO 70
   50       CONTINUE
C           A SERIES NUMBER IS NOT ASSIGNED
            ISONUM(J,L)=0
         ENDIF
   70 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE RDREF(IPAR,NPAR,NCHNG,ID)
*     READ REFINABLE-PARAMETER NUMBERS
      PARAMETER (NR=65)
      INTEGER IPAR(NR,10),NPAR(*),ID(*)
      CHARACTER*80 LINE
 
C*    REFINABLE-PARAMETERS LINES (NAUTO=1 OR 2)
C     IPAR: NUMBERS FOR RFINABLE PARAMETERS IN THIS CYCLE
C*    END OF REFINABLE PARAMETERS: 'ENDREF'
      DO 30 JJ=1,10
         READ(5,'(A80)',IOSTAT=IOS) LINE
         IF (IOS .LT. 0) THEN
            CALL JOBEND('PLACE ENDREF LINE]')
         ELSE IF (LINE(1:6) .EQ. 'ENDREF') THEN
            GO TO 2
         END IF
         BACKSPACE 5
         READ(5,*) (IPAR(J,JJ),J=1,NR)
         DO 20 J=1,NR
            IF(IPAR(J,JJ).EQ.0) THEN
               NPAR(JJ)=J-1
               GO TO 30
            ENDIF
   20    CONTINUE
C        NPAR: NUMBER OF PARAMETERS REFINED IN THIS CYCLE
         NPAR(JJ)=NR
   30 CONTINUE
CORRECTED ON 1988.10.27 (IPAR IS CLEARED IN BLOCKDATA CLEAR)
      READ(5,'(A80)',IOSTAT=IOS) LINE
      IF (IOS .LT. 0) THEN
         CALL JOBEND('PLACE ENDREF LINE]')
      ELSE IF (LINE(1:6) .NE. 'ENDREF') THEN
         CALL JOBEND('NUMBER OF TIMES FOR VARYING REFINABLE '//
     &   'PARAMETERS SUCCESSIVELY IS TOO LARGE.')
      END IF
CORRECTION END
    2 NCHNG=JJ-1
      DO 60 JJ=1,NCHNG
         DO 50 J=1,NPAR(JJ)
            IF(ID(IPAR(J,JJ)).NE.1) THEN
               WRITE(6,200) IPAR(J,JJ)
               CALL JOBEND(' ')
            ENDIF
   50    CONTINUE
   60 CONTINUE
  200 FORMAT(//11X,'A CONSTANT PARAMETER WAS REGARDED AS A VARIABLE ONE.
     &  PARAMETER NUMBER: ',I3)
      END
 
************************************************************************
 
      SUBROUTINE RDPARA(NRFN,NCNSTR,NTERMS,A,ID,AOUT,IDSAVE,IR,
     &NMODE,FIRST,NRANGE)
      PARAMETER (NR=65,NCS=50)
      REAL A(*),FIRST(*),AOUT(*)
      INTEGER ID(*),IR(*),IDSAVE(*)
      CHARACTER LINE*80
C**   PARAMETER AND CONDITIONS OF REFINEMENT
C     (1) GLOBAL PARAMETERS
C              A(1): ZERO-POINT SHIFT OF THE COUNTER
C         A(2)-A(7): SIX BACKGROUND PARAMETERS
C     (2) PHASE-DEPENDENT PARAMETERS
C         J IS THE NUMBER USED AS THE DUMMY ARGUMENT IN STATEMENT
C         FUNCTIONS P AND LP
C         P(J)=A(KPHB(L)+J)
C         LP(J)=KPHB(L)+J
C         WHERE L DENOTES THE PHASE NUMBER.
C      J   NAME
C      0   SCALE FACTOR
C      1   U
C      2   V
C      3   W
C      4   ASYMMETRY PARAMETER
C      5   GAUSSIAN FRACTION
C      6   FWHM(GAUSS)/FWHM(LORENTZ)
C      7   PREFERRED-ORIENTATION PARAMETER 1
C      8   PREFERRED-ORIENTATION PARAMETER 2
C      9   A --> (A*)**2
C     10   B --> (B*)**2
C     11   C --> (C*)**2
C     12   ALPHA --> (B*)(C*)COS(ALPHA*)
C     13   BETA  --> (C*)(A*)COS(BETA*)
C     14   GAMMA --> (A*)(B*)COS(GAMMA*)
C     15   OVERALL THERMAL PARAMETER
C     16-  STRUCTURE-FACTOR PARAMETERS
C
C     ORDER OF STRUCTURE-FACTOR PARAMETERS
C        OCCUPATION FACTOR
C        FRACTIONAL COORDINATES (X, Y, Z)
C        ISOTROPIC OR ANISOTROPIC THERMAL PARAMETER(S)
C        MAGNETIC MOMENT IN BOHR MAGNETON, MU
C     PHI(S) ARE ADDED AT THE TAIL OF STRUCTURE-FACTOR PARAMETERS
C     IF MAGNETIC SCATTERING IS OBSERVED
C     COORDINATES ARE GIVEN FOR ONE POSITION ONLY FOR EACH SET OF
C     SYMMETRY-RELATED POSITIONS
C
C     ID(LL)=0:  THIS PARAMETER IS FIXED
C     ID(LL)=-1: THIS PARAMETER IS CONSTRAINED
C     ID(LL)=1:  THIS PARAMETER IS REFINED
C     ID(LL)=2:  THIS PARAMETER IS REFINED, AND THE STEP IN POWELL'S
C                METHOD IS GIVEN
C     IR: REFINABLE-PARAMETER NUMBER
C     NRFN: NUMBER OF REFINABLE PARAMETERS
C
      NRFN=0
      NCNSTR=0
      DO 30 LL=1,NTERMS
C        DEFAULT VALUES OF A AND ID
         A(LL)=0.0
         ID(LL)=0
         READ(5,'(A80)') LINE
         IF(LINE(1:7).EQ.'ENDPARA') THEN
            CALL JOBEND('THE NUMBER OF PARAMETERS IS NOT CONSISTENT '
     &      //'WITH THE NUMBER OF ATOMS IN ASYMMETRIC UNIT(S).')
         ELSEIF(NMODE.LT.2) THEN
            BACKSPACE 5
            READ(5,*) A(LL),ID(LL)
            IF(ID(LL).EQ.2) THEN
               BACKSPACE 5
               NRFN=NRFN+1
               READ(5,*) A(LL),ID(LL),FIRST(NRFN)
               ID(LL)=1
               IR(LL)=NRFN
            ELSEIF(ID(LL).NE.0 .AND. ID(LL).NE.1 .AND. ID(LL).NE.-1)
     &      THEN
               WRITE(6,'(//11X,A,I2)') 'BAD ID VALUE: ',ID(LL)
               CALL JOBEND(' ')
            ELSEIF(NRFN.EQ.NR) THEN
               CALL JOBEND('THE NUMBER OF REFINABLE PARAMETERS HAS '//
     &         'REACHED THE MAXIMUM VALUE.')
            ELSEIF(ID(LL).EQ.-1) THEN
               NCNSTR=NCNSTR+1
               IF(NCNSTR.GT.NCS) CALL JOBEND('THE NUMBER OF LINEAR '//
     &         'CONSTRAINTS HAS REACHED THE MAXIMUM VALUE.')
            ELSEIF(ID(LL).EQ.1) THEN
               NRFN=NRFN+1
               IR(LL)=NRFN
               FIRST(NRFN)=0.0
            ENDIF
            IDSAVE(LL)=ID(LL)
         ELSE
            BACKSPACE 5
            READ(5,*) A(LL)
         ENDIF
         AOUT(LL)=A(LL)
   30 CONTINUE
C**   END OF PARAMETER LINE: 'ENDPARA'
      READ(5,'(A80)') LINE
      IF(LINE(1:7).NE.'ENDPARA') CALL JOBEND('NUMBER OF PARAMETERS IS NO
     &T CONSISTENT WITH THE NUMBER OF ATOMS IN ASYMMETRIC UNIT(S).')
      IF(NRFN.GT.NR)
     &CALL JOBEND('NUMBER OF REFINABLE PARAMETERS IS TOO LARGE.')
      IF (NMODE .LE. 1) THEN
         DO 40 J=2,7
            IF (NRANGE .EQ. 1 .AND. ID(J) .EQ. 1) THEN
               CALL JOBEND('BACKGROUND PARAMETERS SHOULD NOT BE REFINED'
     &         //' WHEN NRANGE IS 1.')
            END IF
   40    CONTINUE
      END IF
      END
 
************************************************************************
 
      SUBROUTINE ACONV(NPHASE,LMAG,A,KPHB,KPHE,LAUEG)
*     CONVERT PARAMETER VALUES
      INTEGER LMAG(*),KPHB(*),KPHE(*),LAUEG(*)
      REAL A(*)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      DATA RD/0.01745329/
      P(J)=A(KPHB(L)+J)
 
C     DEG ==> RAD (ZERO-POINT SHIFT)
      A(1)=A(1)*RD
      DO 30 L=1,NPHASE
C        DEG ==> RAD (SCALE FACTOR)
         A(KPHB(L))=P(NSFX)*RD
C        DEG**2 ==> RAD**2 (U,V,W)
         DO 33 J=1,3
            A(KPHB(L)+J)=P(J)*RD**2
   33    CONTINUE
C        DEG**(-2) ==> RAD**(-2) (ASYMMETRY PARAMETER)
         A(KPHB(L)+4)=P(4)/RD**2
         IF (LMAG(L) .EQ. 1) THEN
C           DEG ==> RAD (PHI)
            IF (LAUEG(L) .EQ. 5) THEN
               A(KPHE(L)-2)=A(KPHE(L)-2)*RD
               A(KPHE(L)-1)=A(KPHE(L)-1)*RD
            END IF
            A(KPHE(L))=A(KPHE(L))*RD
         END IF
   30 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE RFLCTN(YPEAK,COEF,LLIST)
C     PRINT OUT PHASE #, INDICES, INTENSITIES, BRAGG ANGLES, FWHM'S,
C     MULTIPLICITIES, AND STRUCTURE FACTORS
      INTEGER H,SECSET,ISET(44)
      INTEGER R,RX,RY,RZ
      PARAMETER (NB=2000,NPH=2,NA=7,NAP=36,NT=220,NS=48)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      DIMENSION YPEAK(*),COEF(NPH)
      CHARACTER*9 FWHM
*SUN
*     CHARACTER*50 FILE21
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /B/ U(NB),NREFL
      COMMON /CC/ APR(NT)
      COMMON /DERPR/ OBSI(NB),CALCI(NB),DUMMY(NB)
      COMMON /FRDA/ NFR,NDA
      COMMON /G/ I
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /IS/ ISET,SECSET
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /MAGNE/ FMAG(NA,NB),SFRMAG(NB),SFIMAG(NB),Q2(NB)
      COMMON /O/ NMODE
      COMMON /ORDER/ IPOINT(NB)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      COMMON /SFRI/ SFR(NB),SFI(NB),OTF(NB)
      COMMON /T/ FF(NB)
      COMMON /WL/ NBEAM,XLMD,XLMDH,XLMD2H,R12
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
      DATA RD2/57.29578/
      P(J)=APR(KPHB(NFR)+J)
 
      YMAX=0.0
      DO 15 I=1,NREFL
         IF(LLIST.EQ.0 .AND. YPEAK(I).GT.YMAX) YMAX=YPEAK(I)
         IF(LLIST.EQ.1 .AND. OBSI(I).GT.YMAX) YMAX=OBSI(I)
   15 CONTINUE
      IF(LLIST.EQ.0) THEN
         WRITE(6,100)
      ELSE
         WRITE(6,200)
      ENDIF
  100 FORMAT(/12X,'NO.',3X,'PHASE',3X,'H',4X,'K',4X,'L',4X,'CODE',
     &6X,'2O',9X,'D',7X,'ICAL',2X,'!F(NUCL)! !F(MAGN)!',4X,
     &'POF',5X,'FWHM',4X,'M'/'+',51X,'-')
  200 FORMAT(/12X,'NO.',3X,'PHASE',3X,'H',4X,'K',4X,'L',4X,'CODE',
     &6X,'2O',9X,'D',7X,'IOBS',5X,'ICAL',2X,'!F(NUCL)! !F(MAGN)!',4X,
     &'POF',5X,'FWHM',4X,'M'/'+',51X,'-')
C     OBSI AND CALCI ARE CALCULATED IN SUBROUTINE RFACTR
      IF (NFR .GT. 0) THEN
*        RECORD LENGTH OF UNIT #21 = 100
         OPEN(UNIT=21)
*SUN
*        CALL GETARG(4,FILE21)
*SUN
*        OPEN(UNIT=21,FILE=FILE21)
         REWIND 21
         WRITE(21,'(6G14.6)') P(NAX),P(NBX),P(NCX),
     &   P(NALPX),P(NBETX),P(NGAMX)
         WRITE(21,'(I5)') NSYM(NFR)
         DO 17 JJ=1,NSYM(NFR)
            WRITE(21,'(3(3I3,1P,G14.6))')
     &      ((R(I,J,JJ,NFR),J=1,3),T(I,JJ,NFR),I=1,3)
   17    CONTINUE
      END IF
      DO 20 J=1,NREFL
         I=IPOINT(J)
         FMAGN=0.0
         IF (NQ(NOPH(I)) .GE. 3) THEN
            FNUCL=COEF(NOPH(I))*SQRT(OTF(I)*(SFR(I)**2+SFI(I)**2))
            IF (NFR .EQ. NOPH(I)) THEN
               FREAL=COEF(NOPH(I))*SQRT(OTF(I))*SFR(I)
               FIMAG=COEF(NOPH(I))*SQRT(OTF(I))*SFI(I)
            END IF
            IF (LMAG(NOPH(I)) .EQ. 1) THEN
               FMAGN=COEF(NOPH(I))*SQRT(7.266087*Q2(I)*OTF(I)*
     &         (SFRMAG(I)**2+SFIMAG(I)**2))
            END IF
         ELSE
            FNUCL=COEF(NOPH(I))*SQRT(SFR(I)**2+SFI(I)**2)
            IF (NFR .EQ. NOPH(I)) THEN
               FREAL=COEF(NOPH(I))*SFR(I)
               FIMAG=COEF(NOPH(I))*SFI(I)
            END IF
            IF (LMAG(NOPH(I)) .EQ. 1) THEN
               FMAGN=COEF(NOPH(I))*SQRT(7.266087*Q2(I)*
     &         (SFRMAG(I)**2+SFIMAG(I)**2))
            END IF
         END IF
         IF(L12(I).EQ.0) THEN
            LLL=1
            M=NINT(U(I))
         ELSE
            LLL=2
            M=NINT(U(I)/R12)
         ENDIF
         IF(NMODE.EQ.2) THEN
            FWHM='     -'
         ELSE
            WRITE(FWHM,'(F9.4)') W1(I)*PC2(NOPH(I))/PC*RD2
         ENDIF
         IF(LLIST.EQ.0) THEN
            WRITE(6,300) J,NOPH(I),H(I),K(I),L(I),LLL,PEAK(I)*RD2,D(I),
     &      NINT(YPEAK(I)/YMAX*100000.0),FNUCL,FMAGN,PROR1(I),FWHM,M
         ELSE
            WRITE(6,400) J,NOPH(I),H(I),K(I),L(I),LLL,
     &      PEAK(I)*RD2,D(I),NINT(OBSI(I)/YMAX*100000.0),NINT(CALCI(I)
     &      /YMAX*100000.0),FNUCL,FMAGN,PROR1(I),FWHM,M
            IF (NFR .EQ. NOPH(I) .AND. LLL .EQ. 1) THEN
               WRITE(21,'(3I5,1P,6G14.6)') H(I),K(I),L(I),SQRT(RLV2(I)),
     &         FNUCL,FNUCL*SQRT(OBSI(I)/CALCI(I)),FREAL/FNUCL,
     &         FIMAG/FNUCL,FNUCL*SQRT(OBSI(I)/CALCI(I))-FNUCL
            END IF
         ENDIF
   20 CONTINUE
      IF (NFR .NE. 0) THEN
         CLOSE(UNIT=21)
      END IF
  300 FORMAT(' ',9X,I4,6X,I1,3X,I3,2X,I3,2X,
     &I3,I6,5X,F7.3,3X,F8.5,I9,2F10.4,3X,F5.3,A,I5)
  400 FORMAT(' ',9X,I4,6X,I1,3X,I3,2X,I3,2X,
     &I3,I6,5X,F7.3,3X,F8.5,2I9,2F10.4,3X,F5.3,A,I5)
      END
 
************************************************************************
 
      FUNCTION PRFL(A,SP1,TN,WW)
C     PROFILE SHAPE FUNCTION
      INTEGER H
      PARAMETER (NB=2000,NPH=2,NAP=36)
      DIMENSION A(*)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /DP/ DLT1,CF1,FPV,COMA(NPH),DFLP(NB),DHDT(NB),DAA(NB)
     &  ,BUNSHI,PR2,PR3,CF2,APV(NB),DIFF,CUVW(NB),CAP(NB),CGE(NB),CS(NB)
      COMMON /G/ I
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /WL/ NBEAM,XLMD,XLMDH,XLMD2H,R
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
      P(J)=A(KPHB(NOPH(I))+J)
C     C1=-4*LN(2)
      DATA C1,C2/-2.772589,4.0/
C
C     CF1:  ASYMMETRIC CORRECTION
C     FPV:  MODIFIED PSEUDO-VOIGT FUNCTION
C     APV:  NORMALIZATION FACTOR
 
      DLT1=SP1*SP1
C     ASYMMETRIC FUNCTION
      IF(PEAK(I).LT.RLIM) THEN
         CF2=-SIGN(DLT1/TN,SP1)
         CF1=1.0+P(4)*CF2
      ELSE
         CF1=1.0
      ENDIF
C
      PR1=DLT1/WW
      PR2=EXP(C1*PR1)
      PR3=1.0+C2*P(6)**2*PR1
      DIFF=1.0-P(5)
      FPV=P(5)*PR2+DIFF/PR3
      BUNSHI=CF1*FPV
      PRFL=APV(I)*BUNSHI
      END
 
************************************************************************
 
      SUBROUTINE SF(A,RX,RY,RZ,HT,NSITE,NSYM,IDSYM)
C     STRUCTURE FACTOR OF THE I'TH REFLECTION
      PARAMETER (NS=48,NB=2000,NAP=36,NA=7,NT=220,NPH=2)
      PARAMETER (TWOPI=6.283185)
      INTEGER H,RX(NS),RY(NS),RZ(NS),IDSYM(NS,NAP)
      REAL A(*),HT(NS)
      COMMON /A/ H(NB),IK(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /G/ I
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /HALF/ IFAC(NAP,NPH)
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /MAGNE/ FMAG(NA,NB),SFRMAG(NB),SFIMAG(NB),Q2(NB)
      COMMON /MAGSC/ MAGATM(NA),RLV(20,NA),AMPMAG(20,NA),NPAIR(NA)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /S/ F(NA,NB),NATOM
      COMMON /SFRI/ SFR(NB),SFI(NB),OTF(NB)
      COMMON /SITE/ NOAT(NAP,NPH)
      COMMON /T/ FF(NB)
      COMMON /U/ DELTF1(NA),DELTF2(NA)
C
      N=NOPH(I)
      IG=KPHB(N)+NG1X
C        NOAT: NUMBER WHICH REPRESENTS THE KIND OF THE ATOM
C       A(IG): OCCUPATION FACTOR, G
C     A(IG+1): X
C     A(IG+2): Y
C     A(IG+3): Z
C
C     ISOTROPIC THERMAL VIBRATION
C     A(IG+4): ISOTROPIC THERMAL PARAMETER, B
C     A(IG+5): MAGNETIC MOMENT IN BOHR MAGNETON, MU
C
C     ANISOTROPIC THERMAL VIBRATION
C     A(IG+4)-A(IG+9): ANISOTROPIC THERMAL PARAMETERS, BETA(I,J)
C     A(IG+10): MAGNETIC MOMENT IN BOHR MAGNETON, MU
C
C     SFR(I): REAL PART OF THE STRUCTURE FACTOR
C     SFI(I): IMAGINARY PART OF THE STRUNCTURE FACTOR
C     SFRMAG(I): REAL PART OF THE MAGNETIC STRUCTURE FACTOR
C     SFIMAG(I): IMAGINARY PART OF THE MAGNETIC STRUCTURE FACTOR
      SFR(I)=0.0
      SFI(I)=0.0
      SFRMAG(I)=0.0
      SFIMAG(I)=0.0
      DO 50 J=1,NSITE
         FR=F(NOAT(J,N),I)
         FI=DELTF2(NOAT(J,N))
         LM=MAGATM(NOAT(J,N))
         FM=FMAG(NOAT(J,N),I)
         IF (LISO(J,N) .EQ. 6) GO TO 2
 
*        ISOTROPIC TEMPERATURE FACTOR
         SC=0.0
         SS=0.0
         DO 20 K=1,NSYM
            IF (IDSYM(K,J) .EQ. 0) GO TO 20
C           ARG: 2*PI*(HX+KY+LZ)
            ARG=TWOPI*(RX(K)*A(IG+1)+RY(K)*A(IG+2)+RZ(K)*A(IG+3)+HT(K))
            SC=SC+COS(ARG)
            IF (NCENTR(N) .EQ. 0) SS=SS+SIN(ARG)
   20    CONTINUE
         IF (IFAC(J,N) .EQ. 1) SC=0.5*SC
C
C        NQ=1: NONCENTROSYMMETRIC, INDIVIDUAL TEMPERATURE FACTOR
C        NQ=2: CENTROSYMMETRIC, INDIVIDUAL TEMPERATURE FACTOR
C        NQ=3: NONCENTROSYMMETRIC, OVERALL TEMPERATURE FACTOR
C        NQ=4: CENTROSYMMETRIC, OVERALL TEMPERATURE FACTOR
 
         IMU=IG+LISO(J,N)+4
         IF (NQ(N) .EQ. 1) THEN
            TISO=EXP(-A(IG+4)*RLV2(I))
            SFR(I)=SFR(I)+A(IG)*TISO*(FR*SC-FI*SS)
            SFI(I)=SFI(I)+A(IG)*TISO*(FR*SS+FI*SC)
            IF (LM .EQ. 1) THEN
               SFRMAG(I)=SFRMAG(I)+A(IMU)*A(IG)*TISO*FM*SC
               SFIMAG(I)=SFIMAG(I)+A(IMU)*A(IG)*TISO*FM*SS
            END IF
         ELSE IF (NQ(N) .EQ. 2) THEN
            TISO=EXP(-A(IG+4)*RLV2(I))
            SFR(I)=SFR(I)+A(IG)*TISO*FR*SC
            SFI(I)=SFI(I)+A(IG)*TISO*FI*SC
            IF (LM .EQ. 1) THEN
               SFRMAG(I)=SFRMAG(I)+A(IMU)*A(IG)*TISO*FM*SC
            END IF
         ELSE IF(NQ(N) .EQ. 3) THEN
            SFR(I)=SFR(I)+A(IG)*(FR*SC-FI*SS)
            SFI(I)=SFI(I)+A(IG)*(FR*SS+FI*SC)
            IF (LM .EQ. 1) THEN
               SFRMAG(I)=SFRMAG(I)+A(IMU)*A(IG)*FM*SC
               SFIMAG(I)=SFIMAG(I)+A(IMU)*A(IG)*FM*SS
            END IF
         ELSE
            SFR(I)=SFR(I)+A(IG)*FR*SC
            SFI(I)=SFI(I)+A(IG)*FI*SC
            IF (LM .EQ. 1) THEN
               SFRMAG(I)=SFRMAG(I)+A(IMU)*A(IG)*FM*SC
            END IF
         END IF
         GO TO 9
 
*        ANISOTROPIC TEMPERATURE FACTOR
    2    CONTINUE
         SP=0.0
         SQ=0.0
         DO 30 K=1,NSYM
            IF (IDSYM(K,J) .EQ. 0) GO TO 30
C           ARG: 2*PI*(HX+KY+LZ)
            ARG=TWOPI*(RX(K)*A(IG+1)+RY(K)*A(IG+2)+RZ(K)*A(IG+3)+HT(K))
            TANISO=RX(K)**2*A(IG+4)+RY(K)**2*A(IG+5)+RZ(K)**2*
     &      A(IG+6)+2.0*(RX(K)*RY(K)*A(IG+7)+RX(K)*RZ(K)*A(IG+8)
     &      +RY(K)*RZ(K)*A(IG+9))
            TANISO=EXP(-TANISO)
            SP=SP+TANISO*COS(ARG)
            IF (NCENTR(N) .EQ. 0) SQ=SQ+TANISO*SIN(ARG)
   30    CONTINUE
 
         IF (NCENTR(N) .EQ. 0) THEN
            SFR(I)=SFR(I)+A(IG)*(FR*SP-FI*SQ)
            SFI(I)=SFI(I)+A(IG)*(FR*SQ+FI*SP)
            IF (LM .EQ. 1) THEN
               SFRMAG(I)=SFRMAG(I)+A(IG+10)*A(IG)*FM*SP
               SFIMAG(I)=SFIMAG(I)+A(IG+10)*A(IG)*FM*SQ
            END IF
         ELSE
            IF (IFAC(J,N) .EQ. 1) SP=0.5*SP
            SFR(I)=SFR(I)+A(IG)*FR*SP
            SFI(I)=SFI(I)+A(IG)*FI*SP
            IF (LM .EQ. 1) THEN
               SFRMAG(I)=SFRMAG(I)+A(IG+10)*A(IG)*FM*SP
            END IF
         END IF
 
    9    IG=IG+NPSITE(J,N)
   50 CONTINUE
C
C     FF(I): !F!**2 OF THE I'TH REFLECTION
      FF(I)=SFR(I)**2+SFI(I)**2
      IF (LMAG(N) .EQ. 1) THEN
         CALL QSQR(N,A(IG))
         FF(I)=FF(I)+7.266087*Q2(I)*(SFRMAG(I)**2+SFIMAG(I)**2)
      ENDIF
C
      IF(NQ(N).GE.3) THEN
C        OTF: OVERALL TEMPERATURE FACTOR
         OTF(I)=EXP(-2.0*A(KPHB(N)+NOTX)*RLV2(I))
         FF(I)=OTF(I)*FF(I)
      ENDIF
      END
 
************************************************************************
 
      SUBROUTINE CURFIT(X,Y,NSTEP,NPTS,NTERMS,A,AMIN,FLAMDA,
     &  FLAMDC,FLAMDP,DAMP,IFAIL,YFIT,CHISQ1,CHISQR,CSMIN,YPEAK,ICYCLE,
     &  LDM,NFNEV)
C     NONLINEAR LEAST-SQUARES FITTING BY MARQUARDT'S METHOD AND
C     GAUSS-NEWTON METHOD
      PARAMETER (NB=2000,NR=65,NSF=50,NT=220,NPH=2,NOD=NR*(NR+1)/2)
      PARAMETER (NAP=36)
      SAVE ALPHA,AD
      DOUBLE PRECISION G(NOD),ALPHA(NOD),BETA(NR),DELTAB(NR),AD(NR)
      DIMENSION X(*),Y(*),A(*),AMIN(*),YFIT(*),
     &  B(NT),D(NT),YPEAK(*),DERIV(NR),DSTFAC(NSF,NB),ISFP(NT)
*FACOM, HITAC, ACOS, AND VAX
      INTEGER JSAVE(NR)
      COMMON /ALP/ LALPHA
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /NONLIN/ NLESQ,NAUTO,IDCYCL,NCHNG,NPAR(10),IPAR(NR,10)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /TWO/ G,FIRST(NR)
C
      IF(IDCYCL.EQ.0 .AND. LALPHA.EQ.1) THEN
         DO 10 J=1,NRFN
            ALPHA(J*(J+1)/2)=AD(J)
   10    CONTINUE
         GO TO 3
      ENDIF
C     NFNEV: NUMBER OF FUNCTION EVALUATIONS IN THIS CYCLE
      NFNEV=0
      CALL DERSP(A,YPEAK,DSTFAC,ISFP)
C
C     ALPHA: LOWER TRIANGLE OF THE COEFFICIENT MATRIX
C     BETA: RIGHT-HAND SIDE OF THE NORMAL EQUATION
C     1/Y(I):  WEIGHT
      DO 15 J=1,NRFN
         BETA(J)=0.0D0
*FACOM, HITAC, ACOS, AND VAX
         JSAVE(J)=(J-1)*J/2
   15 CONTINUE
      DO 20 J=1,NRFN*(NRFN+1)/2
         ALPHA(J)=0.0D0
   20 CONTINUE
      DO 50 I=1,NPTS
         CALL FDERIV(I,X,A,DERIV,DSTFAC,ISFP)
         DELTAY = Y(I) - YFIT(I)
*SUN
*        JK=0
         DO 46 J=1,NRFN
*SUN
*           TEMP=DERIV(J)/Y(I)
*FACOM, HITAC, ACOS, AND VAX
            BETA(J) = BETA(J) + DERIV(J)/Y(I)*DELTAY
*SUN
*           BETA(J) = BETA(J) + TEMP*DELTAY
            DO 45 K=1,J
*SUN
*              JK=JK+1
*FACOM, HITAC, ACOS, AND VAX
               ALPHA(K+JSAVE(J)) = ALPHA(K+JSAVE(J)) +
*FACOM, HITAC, ACOS, AND VAX
     &         DERIV(J)/Y(I)*DERIV(K)
*SUN
*              ALPHA(JK) = ALPHA(JK) + TEMP*DERIV(K)
   45       CONTINUE
   46    CONTINUE
   50 CONTINUE
C
C     INVERT ARRAY ALPHA TO CALCULATE STANDARD DEVIATIONS OF PARAMETERS
    3 IF(IDCYCL.EQ.0) THEN
C        INVERSION OF THE POSITIVE DEFINITE MATRIX
         CALL CHLSK(NRFN,ALPHA,G,0.0D0)
         CALL MATINV(G,NRFN)
         RETURN
      ENDIF
C     CONTRIBUTION OF THE PENALTY FUNCTION TO ARRAYS ALPHA AND BETA
      IF(NC.GT.0) CALL PENFN(ALPHA,BETA,A,NTERMS)
C
C     PACK ARRAY A
      CALL PACK(A,D,NTERMS)
C     STORE COEFFICIENTS OF FLAMDA, THAT IS, DIAGONAL TERMS OF THE
C     COEFFICIENT MATRIX
      DO 60 J=1,NRFN
         AD(J)=ALPHA(J*(J+1)/2)
   60 CONTINUE
C
    4 IF(NLESQ.EQ.2) THEN
C        GRADIENT-EXPANSION ALGORITHM.
         DO 70 J=1,NRFN
            ALPHA(J*(J+1)/2)=AD(J)*(1.0+FLAMDA)
   70    CONTINUE
      ENDIF
C     CHOLESKY DECOMPOSITION
      CALL CHLSK(NRFN,ALPHA,G,0.0D0)
C     SOLVE SIMULTANEOUS LINEAR EQUATIONS
      CALL SOLVE(NRFN,G,DELTAB,BETA)
C
      IF(NLESQ.EQ.2) THEN
         CALL RSSE(A,B,DELTAB,D,X,Y,YFIT,YPEAK,AMIN,NPTS,NSTEP,
     &   NTERMS,CSMIN,CHISQR,1.0,IDPOS,IFAIL,NFNEV,FLAMDA,FLAMDP)
         IF(NAUTO.EQ.0 .OR. CHISQ1.LT.CHISQR .OR. (NAUTO.EQ.1 .AND.
     &   ICYCLE.GE.NCHNG+1)) CALL LAMBDA(DELTAB,BETA,AD,G,FLAMDA,
     &   FLAMDC,IDPOS,LDM,CHISQ1,CHISQR)
         IF(LDM.EQ.1) THEN
            WRITE(6,'(//11X,A,I2/11X,A)') 'CYCLE #',
     &      ICYCLE,'TOO LARGE MARQUARDT PARAMETER'
         ELSEIF(CHISQ1.LT.CHISQR) THEN
            GO TO 4
         ENDIF
      ELSE
C        DAMP: VARIABLE DAMPING (RELAXATION) FACTOR
         DAMP=MIN(1.0,2.0*DAMP)
    6    CALL RSSE(A,B,DELTAB,D,X,Y,YFIT,YPEAK,AMIN,NPTS,NSTEP,
     &   NTERMS,CSMIN,CHISQR,DAMP,IDPOS,IFAIL,NFNEV,FLAMDA,FLAMDP)
         IF(IDPOS.NE.1 .OR. CHISQ1.LT.CHISQR) THEN
            IF(DAMP.LE.2.0**(-5)) THEN
               WRITE(6,150) ICYCLE
               IFAIL=IFAIL+1
               LDM=1
               IF(IFAIL.GE.2) WRITE(6,200) ICYCLE,IFAIL
            ELSE
C              REDUCE THE DAMPING FACTOR AND CREATE A NEW SET OF
C              PARAMETERS
               DAMP=DAMP*0.5
               GO TO 6
            ENDIF
         ENDIF
      ENDIF
  150 FORMAT(//11X,'CYCLE #',I2/11X,'FAILURE.  THE OBJECTIVE FUNCTION DO
     &ES NOT DECREASE IN THIS CYCLE.')
  200 FORMAT(//11X,'CYCLE #',I2/11X,'THE NUMBER OF FAILURES HAS REACHED
     &THE MAXIMUM VALUE (',I1,').')
C
C     COPY THE NEW VALUES OF PARAMETERS
      DO 90 J=1,NTERMS
         A(J)=B(J)
   90 CONTINUE
      END
 
************************************************************************
 
      FUNCTION AOFFN(X,Y,YFIT,NPTS,NSTEP,YPEAK,A,IDHKL,IDPOS)
C     UPDATE INDICES AND FWHM AND CALCULATE THE VALUE OF THE AUGMENTED
C     OBJECTIVE FUNCTION USING NEW PARAMETERS
      PARAMETER (NP=5050,NPH=2,NAP=36)
      DOUBLE PRECISION CHISQ
      DIMENSION X(*),Y(*),YFIT(*),YPEAK(*),A(*)
      COMMON /C/ BG(NP)
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /RLS/ NRANGE
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
      IDPOS=1
      IF(NRANGE.EQ.1) THEN
         REWIND 10
         READ(10) (X(J),Y(J),BG(J),J=1,NSTEP)
      ENDIF
      IF(IDHKL.EQ.1) CALL UPDATE(YPEAK,A,IDPOS,1)
      IF(IDPOS.NE.1) THEN
         AOFFN=1.7E38
         RETURN
      ENDIF
      CALL IGNORE(NSTEP,NPTS,X,Y)
      CHISQ=0.0D0
      DO 15 J=1,NPTS
         YFIT(J)=CALINT(X,J,A,YPEAK)
         CHISQ=CHISQ+(Y(J)-YFIT(J))**2/Y(J)
   15 CONTINUE
C
C     PENALTY FUNCTION
      SUMPEN=0.0
      DO 20 J=1,NC
         SUMPEN=SUMPEN+TK*(CON(J,A))**2
   20 CONTINUE
      AOFFN=CHISQ+SUMPEN
      END
 
************************************************************************
 
      SUBROUTINE FDERIV(K,DEG,A,DERIV,DSTFAC,ISFP)
C     PARTIAL DERIVATIVES WITH RESPECT TO PROFILE AND STRUCTURE
C     PARAMETERS
      PARAMETER (NP=5050,NB=2000,NT=220,NR=65,NSF=50,NPH=2,NAP=36)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      INTEGER H
      DIMENSION DEG(*),A(*),DERIV(*),DSTFAC(NSF,NB),ISFP(*)
      COMMON /A/ H(NB),IK(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /B/ U(NB),NREFL
      COMMON /C/ BG(NP)
      COMMON /DERPR/ POP2(NB),COMPO(NB),GAUSS(NB)
      COMMON /DP/ DLT1,CF1,FPV,COMA(NPH),DFLP(NB),DHDT(NB),DAA(NB)
     &  ,BUNSHI,PR2,PR3,CF2,APV(NB),DIFF,CUVW(NB),CAP(NB),CGE(NB),CS(NB)
      COMMON /G/ I
      COMMON /I/ RDEG(2,NB)
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /L/ DEG1,DEG2
      COMMON /ORDER/ IPOINT(NB)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /RLS/ NRANGE
      COMMON /T/ FF(NB)
      COMMON /UCC/ IDPEAK(NPH),IDSF(NPH),IDPRF(NPH),IDZP
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
      SAVE ISTART
      LP(J)=KPHB(NOPH(I))+J
      LD(J)=ID(LP(J))
      LR(J)=IR(LP(J))
*MODIFIED ON 1988.8.17 (3 LINES ADDED)
*     P(J)=A(LP(J))
*     C = (PI/2)**2
*     DATA C/2.467401/
*MODIFICATION END
C
C     RESET ARRAY DERIV
      DO 10 J=1,NRFN
         DERIV(J)=0.0
   10 CONTINUE
      X=DEG(K)
C     NUMERICAL PARTIAL DERIVATIVES OF BACKGROUND PARAMETERS
      IF(NRANGE.EQ.2) THEN
         IF(ID(2).EQ.1) DERIV(IR(2))=1.0
         IF(ID(3).EQ.1) DERIV(IR(3))=BG(K)
         IF(ID(4).EQ.1) DERIV(IR(4))=BG(K)**2
         IF(ID(5).EQ.1) DERIV(IR(5))=BG(K)**3
         IF(ID(6).EQ.1) DERIV(IR(6))=BG(K)**4
         IF(ID(7).EQ.1) DERIV(IR(7))=BG(K)**5
      ENDIF
C
      IF(K.EQ.1) ISTART=1
      DO 70 J0=ISTART,NREFL
         I=IPOINT(J0)
         IF(X.GT.RDEG(2,I)) THEN
            ISTART=J0+1
            GO TO 70
         ELSEIF(X.LT.RDEG(1,I)) THEN
            RETURN
         ENDIF
C        PROFILE FUNCTION OF THE I'TH REFLECTION AT DEG(K)
         SP1=X-PEAK(I)
         PRFIK=PRFL(A,SP1,TN1(I),WW1(I))
C
C        SCALE FACTOR
         IF(LD(NSFX).EQ.1) DERIV(LR(NSFX))=DERIV(LR(NSFX))+PRFIK*CS(I)
C
C        PARAMETERS CONTAINED IN PROFILE SHAPE FUNCTIONS
         CALL DERPF(A,DERIV,TN1(I)-CSTB)
C
         IF(LD(NPO1X).EQ.1 .OR. LD(NPO2X).EQ.1) THEN
            CPO=PRFIK*COMPO(I)
*MODIFIED ON 1988.10.17 (YAMAMOTO'S PREFERRED-ORIENTATION FUNCTION)
C           PREFERRED-ORIENTATION PARAMETER 1
            IF(LD(NPO1X).EQ.1) DERIV(LR(NPO1X))=
     &      DERIV(LR(NPO1X))+CPO*(1.-GAUSS(I))
*           IF(LD(NPO1X).EQ.1) DERIV(LR(NPO1X))=DERIV(LR(NPO1X))+CPO*
*    &      (1.0 - P(NPO2X)*C/(1.0 - EXP(-P(NPO2X)*C))*GAUSS(I))
C           PREFERRED-ORIENTATION PARAMETER 2
            IF(LD(NPO2X).EQ.1) DERIV(LR(NPO2X))=
     &      DERIV(LR(NPO2X))+CPO*POP2(I)
*           IF(LD(NPO2X).EQ.1) DERIV(LR(NPO2X))=DERIV(LR(NPO2X))+CPO*
*    &      (1.0 - P(NPO1X))*GAUSS(I)*(C*(1.0 - P(NPO2X)*POP2(I))/
*    &      (1.0 - EXP(-P(NPO2X)*C)) - P(NPO2X)*C*C*EXP(-P(NPO2X)*C)/
*    &      (1.0 - EXP(-P(NPO2X)*C))**2)
*MODIFICATION END
         ENDIF
C
C        ZERO-POINT SHIFT AND CELL CONSTANTS
         IF(ID(1).EQ.1 .OR. IDPEAK(NOPH(I)).EQ.1)
     &   CALL ZPCC(A,DERIV,SP1,WW1(I),W1(I),PRFIK)
C
         IF(IDSF(NOPH(I)).EQ.1) THEN
C           OVERALL THERMAL PARAMETER AND STRUCTURE PARAMETERS
            DO 40 J=LP(NOTX),KPHE(NOPH(I))
               IF(ID(J).EQ.1) DERIV(IR(J))=DERIV(IR(J))+PRFIK*
     &         DSTFAC(ISFP(J),I)
   40       CONTINUE
         ENDIF
   70 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE DERPF(A,DERIV,TN2)
C     CALCULATE PARTIAL DERIVATIVES WITH RESPECT TO PROFILE PARAMETERS
C     FOR THE I'TH REFLECTION
      INTEGER H
      LOGICAL VARCON
      PARAMETER (NT=220,NB=2000,NPH=2,NAP=36)
      DIMENSION A(*),DERIV(*)
      COMMON /A/ H(NB),K(NB),L0(NB),L12(NB),NOPH(NB)
      COMMON /COMPF/ PF1(NB),PF2(NB),PF3(NB),PF4(NB)
      COMMON /DP/ DLT1,CF1,FPV,COMA(NPH),DFLP(NB),DHDT(NB),DAA(NB)
     &  ,BUNSHI,PR2,PR3,CF2,APV(NB),DIFF,CUVW(NB),CAP(NB),CGE(NB),CS(NB)
      COMMON /G/ I
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /UCC/ IDPEAK(NPH),IDSF(NPH),IDPRF(NPH),IDZP
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
      LP(J)=KPHB(NOPH(I))+J
      P(J)=A(LP(J))
      LD(J)=ID(LP(J))
      LR(J)=IR(LP(J))
C     ARRAYS FOR CONSTRAINED PARAMETERS
      LR2(J)=IR(KPHB(1)+J)
C     VARCON(J)=.TRUE.: THIS PROFILE PARAMETER IS CONSTRAINED AND
C     VARIABLE
      VARCON(J)=LD(J) .EQ. -1 .AND. ID(J+8) .EQ. 1
C
C     C1=4*LN(2)
      DATA C1,C2/2.772589,4.0/
C
C     PARTIAL DERIVATIVES WITH RESPECT TO U, V, AND W
      IF(IDPRF(NOPH(I)).EQ.1) THEN
         V=PF1(I)*CF1*DLT1*(P(5)*PR2*C1+
     &   DIFF*C2*(P(6)/PR3)**2)-BUNSHI*COMA(NOPH(I))
         DPDH=V*APV(I)**2
         COMUVW=CUVW(I)*DPDH
*        WHEN PROFILE PARAMETERS OF THE MINOR PHASES ARE CONSTRAINED,
*        THEY ARE REGARDED AS HAVING THE SAME VALUES WITH THE PROFILE
*        PARAMETERS OF THE 1ST PHASE
         IF (LD(1) .EQ. 1) THEN
            DERIV(LR(1))=DERIV(LR(1))+COMUVW*TN2*TN2
         ELSE IF (VARCON(1)) THEN
            DERIV(LR2(1))=DERIV(LR2(1))+COMUVW*TN2*TN2
         END IF
         IF (LD(2) .EQ. 1) THEN
            DERIV(LR(2))=DERIV(LR(2))+COMUVW*TN2
         ELSE IF (VARCON(2)) THEN
            DERIV(LR2(2))=DERIV(LR2(2))+COMUVW*TN2
         END IF
         IF (LD(3) .EQ. 1) THEN
            DERIV(LR(3))=DERIV(LR(3))+COMUVW
         ELSE IF (VARCON(3)) THEN
            DERIV(LR2(3))=DERIV(LR2(3))+COMUVW
         END IF
      ENDIF
C
C     PARTIAL DERIVATIVES WITH RESPECT TO THE ASYMMETRIC PARAMETER
      IF (LD(4) .EQ. 1 .AND. PEAK(I) .LT. RLIM) THEN
         DERIV(LR(4))=DERIV(LR(4))+CAP(I)*CF2*FPV
      ELSE IF (VARCON(4) .AND. PEAK(I) .LT. RLIM) THEN
         DERIV(LR2(4))=DERIV(LR2(4))+CAP(I)*CF2*FPV
      END IF
C
C     PARTIAL DERIVATIVES WITH RESPECT TO GAUSSIAN FRACTION AND
C     HK(GAUSS)/HK(LORENTZ)
      IF (LD(5) .EQ. 1) THEN
         Q1=CF1*(PR2-1.0/PR3)/APV(I)-BUNSHI*PF2(I)
         DERIV(LR(5))=DERIV(LR(5))+CGE(I)*Q1
      ELSE IF (VARCON(5)) THEN
         Q1=CF1*(PR2-1.0/PR3)/APV(I)-BUNSHI*PF2(I)
         DERIV(LR2(5))=DERIV(LR2(5))+CGE(I)*Q1
      ENDIF
      IF (LD(6) .EQ. 1) THEN
         Q2=PF3(I)*(-CF1/PR3**2*DLT1)+BUNSHI*PF4(I)
         DERIV(LR(6))=DERIV(LR(6))+CGE(I)*Q2*DIFF
      ELSE IF (VARCON(6)) THEN
         Q2=PF3(I)*(-CF1/PR3**2*DLT1)+BUNSHI*PF4(I)
         DERIV(LR2(6))=DERIV(LR2(6))+CGE(I)*Q2*DIFF
      ENDIF
      END
 
************************************************************************
 
      SUBROUTINE ZPCC(A,DERIV,SP1,WW,W,PRFIK)
C     DERIVATIVES WITH RESPECT TO THE ZERO-POINT SHIFT AND CELL CONSTS.
C     THE STRUCTURE FACTOR AND PREFERRED-ORIENTATION FUNCTION ARE
C     ASSUMED TO BE CONSTANT EVEN IF THE BRAGG ANGLE IS SHIFTED
C     TO A SMALL EXTENT.
      INTEGER H
      PARAMETER (NB=2000,NT=220,NPH=2,NAP=36)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      DIMENSION A(*),DERIV(*)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /COMCC/ CC1(NB),CC2(NB),CC3(NB),CC4(NB),CC5(NB),CC6(NB),
     &  CZP(NB)
      COMMON /DP/ DLT1,CF1,FPV,COMA(NPH),DFLP(NB),DHDT(NB),DAA(NB)
     &  ,BUNSHI,PR2,PR3,CF2,APV(NB),DIFF,CUVW(NB),CAP(NB),CGE(NB),CS(NB)
      COMMON /G/ I
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      DATA C1,C2/2.772589,4.0/
      LP(J)=KPHB(NOPH(I))+J
      P(J)=A(LP(J))
      LD(J)=ID(LP(J))
      LR(J)=IR(LP(J))
 
C     DERIVATIVE OF THE ASYMMETRY CORRECTION WITH RESPECT TO THETA
      DA=P(4)*SIGN(1.0,SP1)*SP1*(4.0/TN1(I)+SP1/SIN(TH(I))**2)
      F1=2.0*SP1/(W*WW)*(2.0*W+DHDT(I)*SP1)
      F2=C1*P(5)*PR2
C     DERIVATIVE OF THE PROFILE SHAPE FUNCTION WITH RESPECT TO THETA
      DG=F1*(F2+C2*DIFF*(P(6)/PR3)**2)
C     DERIVATIVE OF THE THETA-DEPENDENT FUNCTION WITH RESPECT TO THETA
      DTDT=PRFIK*DFLP(I)+FLP(I)*(APV(I)*FPV*DA+CF1*(DAA(I)*FPV+APV(I)
     &  *DG))
      IF(ID(1).EQ.1) DERIV(1)=DERIV(1)+CZP(I)*DTDT
      IF(LD(NAX).EQ.1) DERIV(LR(NAX))=DERIV(LR(NAX))+DTDT*CC1(I)
      IF(LD(NBX).EQ.1) DERIV(LR(NBX))=DERIV(LR(NBX))+DTDT*CC2(I)
      IF(LD(NCX).EQ.1) DERIV(LR(NCX))=DERIV(LR(NCX))+DTDT*CC3(I)
      IF(LD(NALPX).EQ.1) DERIV(LR(NALPX))=DERIV(LR(NALPX))+DTDT*CC4(I)
      IF(LD(NBETX).EQ.1) DERIV(LR(NBETX))=DERIV(LR(NBETX))+DTDT*CC5(I)
      IF(LD(NGAMX).EQ.1) DERIV(LR(NGAMX))=DERIV(LR(NGAMX))+DTDT*CC6(I)
      END
 
************************************************************************
 
      SUBROUTINE CHLSK(N,A,G,EPS)
C     CHOLESKI DECOMPOSITION
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(*),G(*)
      IF(A(1).LE.EPS) GO TO 100
      G(1)=SQRT(A(1))
      DO 10 I=2,N
         I1=I*(I-1)/2+1
         G(I1)=A(I1)/G(1)
   10 CONTINUE
      DO 60 J=2,N
         JJ=J*(J-1)/2
         SUM=A(JJ+J)
         JMINUS=J-1
         DO 20 K=1,JMINUS
            SUM=SUM-G(JJ+K)**2
   20    CONTINUE
         IF(SUM.LE.EPS) GO TO 100
         G(JJ+J)=SQRT(SUM)
         IF(J.EQ.N) GO TO 60
         JPLUS=J+1
         DO 50 I=JPLUS,N
            II=I*(I-1)/2
            SUM=A(II+J)
            DO 40 K=1,JMINUS
               SUM=SUM-G(II+K)*G(JJ+K)
   40       CONTINUE
            G(II+J)=SUM/G(JJ+J)
   50    CONTINUE
   60 CONTINUE
      RETURN
  100 CALL JOBEND('THE COEFFICIENT MATRIX IS NOT POSITIVE DEFINITE.')
      END
 
************************************************************************
 
      FUNCTION CALINT(DEG,K,A,YPEAK)
C     SUMMATION OF THE CONTRIBUTIONS FROM NEIGHBORING BRAGG REFLECTIONS
      PARAMETER (NP=5050,NB=2000,NPH=2,NAP=36)
      INTEGER H
      DIMENSION A(*),DEG(*),YPEAK(*)
      COMMON /A/ H(NB),IK(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /B/ U(NB),NREFL
      COMMON /C/ BG(NP)
      COMMON /G/ I
      COMMON /I/ RDEG(2,NB)
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /L/ DEG1,DEG2
      COMMON /ORDER/ IPOINT(NB)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /RLS/ NRANGE
      COMMON /T/ FF(NB)
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
C     THE NUMBER OF THE STARTING REFLECTION IS SAVED IN VARIABLE ISTART.
      SAVE ISTART
 
C     CALCULATE THE BACKGROUND CORRECTION
      IF(NRANGE.EQ.2) THEN
         CALINT=((((A(7)*BG(K)+A(6))*BG(K)+A(5))*BG(K)+A(4))
     &   *BG(K)+A(3))*BG(K)+A(2)
      ELSE
         CALINT=BG(K)
      ENDIF
      IF(K.EQ.1) ISTART=1
      DO 10 J=ISTART,NREFL
         I=IPOINT(J)
         IF(DEG(K).GT.RDEG(2,I)) THEN
            ISTART=J+1
         ELSEIF(DEG(K).LT.RDEG(1,I)) THEN
            RETURN
         ELSE
            CALINT=CALINT+YPEAK(I)*PRFL(A,DEG(K)-PEAK(I),TN1(I),WW1(I))
         ENDIF
   10 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE RSSE(A,B,DELTAB,D,X,Y,YFIT,YPEAK,AMIN,NPTS,NSTEP,
     &NTERMS,CSMIN,CHISQR,DAMP,IDPOS,IFAIL,NFNEV,FLAMDA,FLAMDP)
C     UPDATE PARAMETERS AND CALCULATE NEW CHI-SQUARE
      PARAMETER (NT=220)
      DOUBLE PRECISION DELTAB(*)
      DIMENSION A(*),B(*),D(*),X(*),Y(*),YFIT(*),YPEAK(*),AMIN(*)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      DO 10 J=1,NRFN
C        COPY PACKED ARRAY A INTO ARRAY B
         B(J)=A(J)
C        ALTER PARAMETERS
         B(J)=B(J)+DAMP*DELTAB(J)
   10 CONTINUE
      CALL UNPACK(B,D,NTERMS)
C
C     CALCULATE CHISQR USING NEW PARAMETERS
      CHISQR=AOFFN(X,Y,YFIT,NPTS,NSTEP,YPEAK,B,1,IDPOS)
      NFNEV=NFNEV+1
C     FLAMDP: MARQUARDT PARAMETER ADOPTED IN THE PRESENT CYCLE
      FLAMDP=FLAMDA
      IF(CHISQR.LT.CSMIN) THEN
         CSMIN=CHISQR
         DO 82 J=1,NTERMS
            AMIN(J)=B(J)
   82    CONTINUE
         IFAIL=0
      ENDIF
      END
 
************************************************************************
 
      SUBROUTINE SOLVE(N,G,X,B)
C     SOLVE CONSISTENT SETS OF EQUATIONS WHOSE COEFFICIENT MATRICES
C     ARE SYMMETRIC AND NON-NEGATIVE DEFINITE
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION G(*),X(*),B(*)
      X(1)=B(1)/G(1)
      DO 20 I=2,N
         S=B(I)
         II=I*(I-1)/2
         IMINUS=I-1
         DO 10 J=1,IMINUS
            S=S-G(II+J)*X(J)
   10    CONTINUE
         X(I)=S/G(II+I)
   20 CONTINUE
      X(N)=X(N)/G(N*(N+1)/2)
      DO 40 IBACK=2,N
         I=N+1-IBACK
         S=X(I)
         IPLUS=I+1
         JI=I*(I+3)/2
         DO 30 J=IPLUS,N
            S=S-G(JI)*X(J)
            JI=JI+J
   30    CONTINUE
         X(I)=S/G(I*(I+1)/2)
   40 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE LAMBDA(DELTAB,BETA,AD,G,FLAMDA,FLAMDC,IDPOS,LDM,
     &CHISQ1,CHISQR)
C     FLETCHER'S ALGORITHM FOR DETERMINING FLAMDA
      PARAMETER (NT=220)
      DOUBLE PRECISION DELTAB(*),BETA(*),AD(*),G(*)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
C     CALCULATE PREDICTED DECREASE IN CHI-SQUARE ASSUMING LINEARITY
      PRED=0.0
      DO 10 J=1,NRFN
         PRED=PRED+DELTAB(J)*(BETA(J)+FLAMDA*DELTAB(J)*AD(J))
   10 CONTINUE
      IF(PRED.LE.0.0) THEN
         R1=0.5
      ELSE
         R1=(CHISQ1-CHISQR)/PRED
      ENDIF
      IF(R1.GT.0.75 .AND. FLAMDA.NE.0.0) THEN
         FLAMDA=0.5*FLAMDA
         IF(FLAMDA.LT.FLAMDC) FLAMDA=0.0
      ELSEIF(R1.LT.0.25) THEN
         IF(IDPOS.EQ.1) THEN
            U=MAX(2.0,MIN(2.0-R1,10.0))
         ELSE
            U=10.0
         ENDIF
         IF(FLAMDA.EQ.0.0) THEN
C           CALCULATE THE SUM OF THE DIAGONAL TERMS OF THE INVERSE
C           OF THE COEFFICIENT MATRIX
            CALL MATINV(G,NRFN)
            TRACE=0.0
            DO 20 J=1,NRFN
               TRACE=TRACE+G(J*(J+1)/2)*AD(J)
   20       CONTINUE
            FLAMDC=1.0/TRACE
            FLAMDA=FLAMDC
            U=U*0.5
         ENDIF
         FLAMDA=FLAMDA*U
         IF(FLAMDA.GT.1E4) LDM=1
      ENDIF
      END
 
************************************************************************
 
      SUBROUTINE MATINV(M,N)
C     INVERSION OF MATRIX M WHICH HAS BEEN DECOMPOSED BY THE
C     CHOLESKY METHOD
      DOUBLE PRECISION M(*),AM
      I0=0
      DO 30 I=1,N
      I0=I0+I-1
      J0=I0-I+1
      DO 31 J=I,N
      AM=0.0D0
      IF(J.EQ.I) AM=1.0D0
      J0=J0+J-1
      KI=I0+1
      DO 31 K=I,J
      JK=J0+K
      KI=KI+K-1
      IF(K.NE.J) AM=AM-M(JK)*M(KI)
 31   IF(K.EQ.J) M(KI)=AM/M(JK)
 30   CONTINUE
C     INVERSION OF MATRIX M
      IJ=0
      I0=0
      DO 40 I=1,N
      I0=I0+I-1
      DO 40 J=1,I
      AM=0.0D0
      K0=I0-I+1
      DO 41 K=I,N
      K0=K0+K-1
      KI=K0+I
      KJ=K0+J
 41   AM=AM+M(KI)*M(KJ)
      IJ=IJ+1
 40   M(IJ)=AM
      END
 
************************************************************************
 
      SUBROUTINE DERSP(A,YPEAK,DSTFAC,ISFP)
C     CALCULATE ARRAYS USED FOR THE CALCULATION OF PARTIAL DERIVATIVES
C     OF PARAMETERS.
      INTEGER R,RX,RY,RZ,H
      PARAMETER (NB=2000,NR=65,NSF=50,NT=220,NCS=50,NPH=2,NAP=36,NS=48)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      DIMENSION A(*),YPEAK(*),DSTFAC(NSF,NB),ISFP(*),DPARA(NT)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /B/ U(NB),NREFL
      COMMON /CNSTR/ C1(NCS),C2(10,NCS),IN(10,NCS),NCNPAR(NCS),
     &  NACNS(NCS),NCNSTR
      COMMON /COMCC/ CC1(NB),CC2(NB),CC3(NB),CC4(NB),CC5(NB),CC6(NB),
     &  CZP(NB)
      COMMON /COMPF/ PF1(NB),PF2(NB),PF3(NB),PF4(NB)
      COMMON /DERPR/ POP2(NB),COMPO(NB),GAUSS(NB)
      COMMON /DP/ DLT1,CF1,FPV,COMA(NPH),DFLP(NB),DHDT(NB),DAA(NB)
     &  ,BUNSHI,PR2,PR3,CF2,APV(NB),DIFF,CUVW(NB),CAP(NB),CGE(NB),CS(NB)
      COMMON /G/ I
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      COMMON /SFRI/ SFR(NB),SFI(NB),OTF(NB)
      COMMON /T/ FF(NB)
      COMMON /MC/ CTHM
      COMMON /UCC/ IDPEAK(NPH),IDSF(NPH),IDPRF(NPH),IDZP
      COMMON /WL/ NBEAM,XLMD,XLMDH,XLMD2H,R12
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
      DATA C5,C6/1.064467,1.570796/
      LP(J)=KPHB(NOPH(I))+J
      P(J)=A(LP(J))
      LD(J)=ID(LP(J))
C     ASSIGN NUMBERS FOR REFINABLE STRUCTURE-FACTOR PARAMETERS TO
C     ARRAY ISFP
      IS=0
      DO 20 J=1,NPHASE
         DO 10 JJ=KPHB(J)+NOTX,KPHE(J)
            IF(ID(JJ).EQ.1) THEN
               IS=IS+1
               IF(IS.GT.NSF) CALL JOBEND('NSF IS TOO SMALL.')
               ISFP(JJ)=IS
            ENDIF
   10    CONTINUE
   20 CONTINUE
C
      DO 60 I=1,NREFL
         IF(LD(NSFX).EQ.1) CS(I)=YPEAK(I)/P(NSFX)
C        CALCULATE ARRAYS USED IN SUBROUTINE DERPF
         IF(IDPRF(NOPH(I)).EQ.1) THEN
            CUVW(I)=YPEAK(I)/W1(I)*0.5
            PF1(I)=2.0/(WW1(I)*W1(I))/APV(I)
         ENDIF
         IF(LD(4) .NE. 0) CAP(I)=YPEAK(I)*APV(I)
         IF(LD(5) .NE.0 .OR. LD(6) .NE. 0) THEN
            CGE(I)=YPEAK(I)/(COMA(NOPH(I))*W1(I))**2
            IF(LD(5) .NE. 0) PF2(I)=W1(I)*(C5-C6/P(6))
            IF(LD(6) .NE. 0) THEN
               PF3(I)=8.0*P(6)/(WW1(I)*APV(I))
               PF4(I)=C6*W1(I)/P(6)**2
            ENDIF
         ENDIF
         IF(LD(NPO1X).EQ.1 .OR. LD(NPO2X).EQ.1) THEN
            COMPO(I)=YPEAK(I)/PROR1(I)
            IF(LD(NPO2X).EQ.1) THEN
               IF(L12(I).EQ.0) THEN
*MODIFIED ON 1988.10.17 (POP2(I) ==> COMMENT FOR YAMAMOTO'S FUNCTION
                  POP2(I)=(P(NPO1X)-1.0)*GAUSS(I)*POP2(I)
               ELSE
*MODIFIED ON 1988.10.17
                  POP2(I)=POP2(L12(I))
               ENDIF
            ENDIF
         ENDIF
C
         IF(IDPEAK(NOPH(I)).EQ.1 .OR. ID(1).EQ.1) THEN
C           DERIVATIVE OF THE LORENTZ AND POLARIZATION FACTOR WITH
C           RESPECT TO THETA
            IF(NBEAM.EQ.1) THEN
               CC=CTHM*COS(PEAK(I))
               ST=SIN(TH(I))
               DFLP(I)=(TN1(I)**2-2.0)*(1.0+CC*COS(PEAK(I)))/ST**2-8.*CC
               DFLP(I)=DFLP(I)/ST
            ELSE
               DFLP(I)=(TN1(I)**2-2.0)/(SIN(TH(I)))**3
            ENDIF
C           DERIVATIVE OF THE FWHM WITH RESPECT TO THETA
            DHDT(I)=(P(1)*(TN1(I)-CSTB)+0.5*P(2))/(W1(I)*COS(TH(I))**2)
C           DERIVATIVE OF THE NORMALIZATION FACTOR WITH RESPECT TO THETA
            DAA(I)=-DHDT(I)*APV(I)/W1(I)
C           COMMON PART OF THE DERIVATIVE OF Y(CALC) WITH RESPECT TO
C           ZERO-POINT SHIFT AND METRIC TENSORS
            CZP(I)=YPEAK(I)/FLP(I)
            CT=CZP(I)*D(I)**2*TN1(I)
            CZP(I)=0.5*CZP(I)
            IL=LAUEG(NOPH(I))
            IF(LD(NAX).EQ.1) THEN
               IF(IL.GE.14 .OR. IL.EQ.8 .OR. IL.EQ.10) THEN
                  CC1(I)=CT*0.5*(H(I)**2+K(I)**2+L(I)**2)
               ELSEIF(IL.EQ.6 .OR. IL.EQ.7) THEN
                  CC1(I)=CT*0.5*(H(I)**2+K(I)**2)
               ELSEIF(IL.EQ.9 .OR. IL.EQ.11 .OR. IL.EQ.12 .OR.
     &         IL.EQ.13) THEN
                  CC1(I)=CT*0.5*(H(I)**2+K(I)**2+H(I)*K(I))
               ELSE
                  CC1(I)=CT*0.5*H(I)**2
               ENDIF
            ENDIF
            IF(LD(NBX).EQ.1) CC2(I)=CT*0.5*K(I)**2
            IF(LD(NCX).EQ.1) CC3(I)=CT*0.5*L(I)**2
            IF(LD(NALPX).EQ.1) THEN
               IF(IL.EQ.8 .OR. IL.EQ.10) THEN
                  CC4(I)=CT*(K(I)*L(I)+L(I)*H(I)+H(I)*K(I))
               ELSE
                  CC4(I)=CT*K(I)*L(I)
               ENDIF
            ENDIF
            IF(LD(NBETX).EQ.1) CC5(I)=CT*H(I)*L(I)
            IF(LD(NGAMX).EQ.1) CC6(I)=CT*H(I)*K(I)
         ENDIF
C
C        DSTFAC: PARTIAL DERIVATIVES OF YPEAK(I) WITH RESPECT TO
C                STRUCTURE PARAMETERS
         IF(IDSF(NOPH(I)).EQ.0) GO TO 60
         IF(LD(NOTX).EQ.1) DSTFAC(ISFP(LP(NOTX)),I)=
     &   -2.0*RLV2(I)*YPEAK(I)
         IF (L12(I) .EQ. 0) THEN
            CALL ANALD(A,DPARA,RX(1,I),RY(1,I),RZ(1,I),HT(1,I),
     &      NSITE(NOPH(I)),NSYM(NOPH(I)),IDSYM(1,1,NOPH(I)))
         END IF
         DO 50 J=LP(NG1X),KPHE(NOPH(I))
            IF(ID(J).NE.1) GO TO 50
            IF(L12(I).EQ.0) THEN
               TEMP=DPARA(J)
C              CONTRIBUTION OF THE CONSTRAINED PARAMETERS
               DO 40 J2=1,NCNSTR
                  DO 30 J3=1,NCNPAR(J2)
                     IF(IN(J3,J2).EQ.J)
     &               TEMP=TEMP+C2(J3,J2)*DPARA(NACNS(J2))
   30             CONTINUE
   40          CONTINUE
               IF(R12.GT.0.0) THEN
                  DSTFAC(ISFP(J),I)=TEMP/FF(I)
               ELSE
                  DSTFAC(ISFP(J),I)=TEMP/FF(I)*YPEAK(I)
               ENDIF
               IF(NQ(NOPH(I)).GE.3) DSTFAC(ISFP(J),I)=
     &         DSTFAC(ISFP(J),I)*OTF(I)
            ELSE
               DSTFAC(ISFP(J),I)=DSTFAC(ISFP(J),L12(I))*YPEAK(I)
C              DSTFAC FOR THE K-ALPHA1 PEAK IS ALSO CALCULATED
               DSTFAC(ISFP(J),L12(I))=DSTFAC(ISFP(J),L12(I))*
     &         YPEAK(L12(I))
            ENDIF
   50    CONTINUE
   60 CONTINUE
      END
 
************************************************************************
 
*]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]
*FACOM (WARNING FOR THE OSIV/X8 FSP OPERATING SYSTEM)                  *
*     SUBROUTINE ANALD MAY CAUSE ERRORS WHEN THE OPTIMIZATION LEVEL    *
*     IS 3 OWING TO SOME BUGS OF THE FORTRAN 77 COMPILER.  IF YOU      *
*     ENCOUNTER SUCH A TROUBLE, YOU MUST COMPILE ONLY THIS SUBROUTINE  *
*     AT AN OPTIMIZATION LEVEL OF 2.                                   *
*]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]
 
      SUBROUTINE ANALD(A,DPARA,RX,RY,RZ,HT,NSITE,NSYM,IDSYM)
C     ANALYTICAL PARTIAL DERIVATIVES OF !F!**2 WITH RESPECT TO
C     OCCUPATION FACTORS, INDIVIDUAL TEMPERATURE FACTORS AND FRACTIONAL
C     COORDINATES
C     'JIKKEN KAGAKU KOHZA,' VOL. 6, MARUZEN, TOKYO (1977), P. 202.
      PARAMETER (NS=48,NB=2000,NAP=36,NA=7,NT=220,NPH=2)
      PARAMETER (C1=14.53217,TWOPI=6.283185)
      INTEGER H,RX(NS),RY(NS),RZ(NS),IDSYM(NS,NAP)
      REAL A(*),DPARA(*),SUM(20),HT(NS)
      COMMON /A/ H(NB),IK(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /G/ I
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /HALF/ IFAC(NAP,NPH)
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /MAGNE/ FMAG(NA,NB),SFRMAG(NB),SFIMAG(NB),Q2(NB)
      COMMON /MAGSC/ MAGATM(NA),RLV(20,NA),AMPMAG(20,NA),NPAIR(NA)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /S/ F(NA,NB),NATOM
      COMMON /SITE/ NOAT(NAP,NPH)
      COMMON /SFRI/ SFR(NB),SFI(NB),OTF(NB)
      COMMON /U/ DELTF1(NA),DELTF2(NA)
 
      N=NOPH(I)
      IG=KPHB(N)+NG1X
      DO 80 J=1,NSITE
         FR=F(NOAT(J,N),I)
         FI=DELTF2(NOAT(J,N))
         LM=MAGATM(NOAT(J,N))
         FM=FMAG(NOAT(J,N),I)
         DO 10 K=IG,IG+NPSITE(J,N)-1
            IF (ID(K) .NE. 0) GO TO 1
   10    CONTINUE
         GO TO 9
 
    1    IF (LISO(J,N) .EQ. 6) GO TO 2
*        ISOTROPIC TEMPERATURE FACTOR
         IX=IG+1
         IY=IG+2
         IZ=IG+3
         IB=IG+4
         IMU=IG+LISO(J,N)+4
         SC=0.0
         SS=0.0
         SHCX=0.0
         SHCY=0.0
         SHCZ=0.0
         SHSX=0.0
         SHSY=0.0
         SHSZ=0.0
         IF (LISO(J,N) .EQ. 1 .AND. ID(IB) .NE. 0) THEN
            IDIB=1
         ELSE
            IDIB=0
         END IF
C        NCENTR=0: NONCENTROSYMMETRIC; NCENTR=1: CENTROSYMMETRIC
         DO 20 K=1,NSYM
            IF(IDSYM(K,J).EQ.0) GO TO 20
            ARG=TWOPI*
     &      (RX(K)*A(IX)+RY(K)*A(IY)+RZ(K)*A(IZ)+HT(K))
            IF (ID(IG) .NE. 0 .OR. IDIB .NE. 0 .OR.
     &      (LM .EQ. 1 .AND. ID(IMU) .NE. 0)) THEN
               SC=SC+COS(ARG)
               IF (NCENTR(N) .EQ. 0) SS=SS+SIN(ARG)
            END IF
            IF(ID(IX).NE.0) THEN
               SHSX=SHSX+RX(K)*SIN(ARG)
               IF(NCENTR(N).EQ.0) SHCX=SHCX+RX(K)*COS(ARG)
            ENDIF
            IF(ID(IY).NE.0) THEN
               SHSY=SHSY+RY(K)*SIN(ARG)
               IF(NCENTR(N).EQ.0) SHCY=SHCY+RY(K)*COS(ARG)
            ENDIF
            IF(ID(IZ).NE.0) THEN
               SHSZ=SHSZ+RZ(K)*SIN(ARG)
               IF(NCENTR(N).EQ.0) SHCZ=SHCZ+RZ(K)*COS(ARG)
            ENDIF
   20    CONTINUE
 
         IF (ID(IG) .NE. 0 .OR. IDIB .NE. 0) THEN
            A1=FR*SC
            B1=FI*SC
            IF(NCENTR(N).EQ.0) THEN
               A1=A1-FI*SS
               B1=B1+FR*SS
            ENDIF
            IF (ID(IG) .NE. 0) THEN
               DPARA(IG)=2.0*(A1*SFR(I)+B1*SFI(I))
               IF (LM .EQ. 1) THEN
                  DPARA(IG)=DPARA(IG)+C1*Q2(I)*A(IMU)*FM*
     &            (SC*SFRMAG(I)+SS*SFIMAG(I))
               END IF
            END IF
            IF (IDIB .NE. 0) THEN
               DA=-A(IG)*RLV2(I)*A1
               DB=-A(IG)*RLV2(I)*B1
               DPARA(IB)=2.0*(DA*SFR(I)+DB*SFI(I))
               IF (LM .EQ. 1) THEN
                  DPARA(IB)=DPARA(IB)-C1*Q2(I)*A(IMU)*A(IG)*RLV2(I)*FM*
     &            (SC*SFRMAG(I)+SS*SFIMAG(I))
               END IF
            END IF
         END IF
         IF (ID(IX) .NE. 0) THEN
            A2X=FR*SHSX
            B2X=-FI*SHSX
            IF(NCENTR(N).EQ.0) THEN
               A2X=A2X+FI*SHCX
               B2X=B2X+FR*SHCX
            ENDIF
            DA=-TWOPI*A(IG)*A2X
            DB=TWOPI*A(IG)*B2X
            DPARA(IX)=2.0*(DA*SFR(I)+DB*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IX)=DPARA(IX)+C1*Q2(I)*TWOPI*A(IMU)*A(IG)*FM*
     &         (-SHSX*SFRMAG(I)+SHCX*SFIMAG(I))
            END IF
         END IF
         IF (ID(IY) .NE. 0) THEN
            A2Y=FR*SHSY
            B2Y=-FI*SHSY
            IF(NCENTR(N).EQ.0) THEN
               A2Y=A2Y+FI*SHCY
               B2Y=B2Y+FR*SHCY
            ENDIF
            DA=-TWOPI*A(IG)*A2Y
            DB=TWOPI*A(IG)*B2Y
            DPARA(IY)=2.0*(DA*SFR(I)+DB*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IY)=DPARA(IY)+C1*Q2(I)*TWOPI*A(IMU)*A(IG)*FM*
     &         (-SHSY*SFRMAG(I)+SHCY*SFIMAG(I))
            END IF
         END IF
         IF (ID(IZ) .NE. 0) THEN
            A2Z=FR*SHSZ
            B2Z=-FI*SHSZ
            IF(NCENTR(N).EQ.0) THEN
               A2Z=A2Z+FI*SHCZ
               B2Z=B2Z+FR*SHCZ
            ENDIF
            DA=-TWOPI*A(IG)*A2Z
            DB=TWOPI*A(IG)*B2Z
            DPARA(IZ)=2.0*(DA*SFR(I)+DB*SFI(I))
            IF (LM .EQ. 1) THEN
*                              IY ==> IZ
*                              ]]
               DPARA(IZ)=DPARA(IZ)+C1*Q2(I)*TWOPI*A(IMU)*A(IG)*FM*
     &         (-SHSZ*SFRMAG(I)+SHCZ*SFIMAG(I))
            END IF
         END IF
         IF (LM .EQ. 1 .AND. ID(IMU) .NE. 0) THEN
            DPARA(IMU)=C1*Q2(I)*A(IG)*FM*(SC*SFRMAG(I)+SS*SFIMAG(I))
         END IF
 
         DO 55 K=IG,IG+NPSITE(J,N)-1
            IF (ID(K) .NE. 0) THEN
C              MULTIPLY INDIVIDUAL TEMPERATURE FACTOR
               IF (NQ(N) .LE. 2) DPARA(K)=EXP(-A(IB)*RLV2(I))*DPARA(K)
               IF (IFAC(J,N) .EQ. 1) DPARA(K)=0.5*DPARA(K)
            END IF
   55    CONTINUE
         GO TO 9
C
    2    CONTINUE
*        ANISOTROPIC TEMPERATURE FACTOR
C         P: TANISO(SJH) * C(SJH), Q: TANISO(SJH) * S(SJH)
C         SUM(1): SIGMA P
C         SUM(2): SIGMA Q
C         SUM(3): SIGMA HS*Q
C         SUM(4): SIGMA HS*P
C         SUM(5): SIGMA KS*Q
C         SUM(6): SIGMA KS*P
C         SUM(7): SIGMA LS*Q
C         SUM(8): SIGMA LS*P
C         SUM(9): SIGMA HS**2*P
C        SUM(10): SIGMA HS**2*Q
C        SUM(11): SIGMA KS**2*P
C        SUM(12): SIGMA KS**2*Q
C        SUM(13): SIGMA LS**2*P
C        SUM(14): SIGMA LS**2*Q
C        SUM(15): SIGMA HS*KS*P
C        SUM(16): SIGMA HS*KS*Q
C        SUM(17): SIGMA HS*LS*P
C        SUM(18): SIGMA HS*LS*Q
C        SUM(19): SIGMA KS*LS*P
C        SUM(20): SIGMA KS*LS*Q
         DO 60 JJ=1,20
            SUM(JJ)=0.0
   60    CONTINUE
         DO 65 K=1,NSYM
            IF (IDSYM(K,J) .EQ. 0) GO TO 65
            ARG=TWOPI*
     &      (RX(K)*A(IG+1)+RY(K)*A(IG+2)+RZ(K)*A(IG+3)+HT(K))
            TANISO=RX(K)**2*A(IG+4)+RY(K)**2*A(IG+5)+RZ(K)**2*
     &      A(IG+6)+2.0*(RX(K)*RY(K)*A(IG+7)+RX(K)*RZ(K)*A(IG+8)
     &      +RY(K)*RZ(K)*A(IG+9))
            TANISO=EXP(-TANISO)
            P=TANISO*COS(ARG)
            Q=TANISO*SIN(ARG)
            IF (ID(IG) .NE. 0) THEN
               SUM(1)=SUM(1)+P
               IF (NCENTR(N) .EQ. 0) SUM(2)=SUM(2)+Q
            ENDIF
            IF (ID(IG+1) .NE. 0) THEN
               SUM(3)=SUM(3)+RX(K)*Q
               IF (NCENTR(N) .EQ. 0) SUM(4)=SUM(4)+RX(K)*P
            ENDIF
            IF (ID(IG+2) .NE. 0) THEN
               SUM(5)=SUM(5)+RY(K)*Q
               IF (NCENTR(N) .EQ. 0) SUM(6)=SUM(6)+RY(K)*P
            ENDIF
            IF (ID(IG+3) .NE. 0) THEN
               SUM(7)=SUM(7)+RZ(K)*Q
               IF (NCENTR(N) .EQ. 0) SUM(8)=SUM(8)+RZ(K)*P
            ENDIF
            IF (ID(IG+4) .NE. 0) THEN
               SUM(9)=SUM(9)+RX(K)**2*P
               IF (NCENTR(N) .EQ. 0) SUM(10)=SUM(10)+RX(K)**2*Q
            END IF
            IF (ID(IG+5) .NE. 0) THEN
               SUM(11)=SUM(11)+RY(K)**2*P
               IF (NCENTR(N) .EQ. 0) SUM(12)=SUM(12)+RY(K)**2*Q
            END IF
            IF (ID(IG+6) .NE. 0) THEN
               SUM(13)=SUM(13)+RZ(K)**2*P
               IF (NCENTR(N) .EQ. 0) SUM(14)=SUM(14)+RZ(K)**2*Q
            END IF
            IF (ID(IG+7) .NE. 0) THEN
               SUM(15)=SUM(15)+RX(K)*RY(K)*P
               IF (NCENTR(N) .EQ. 0) SUM(16)=SUM(16)+RX(K)*RY(K)*Q
            END IF
            IF (ID(IG+8) .NE. 0) THEN
               SUM(17)=SUM(17)+RX(K)*RZ(K)*P
               IF (NCENTR(N) .EQ. 0) SUM(18)=SUM(18)+RX(K)*RZ(K)*Q
            END IF
            IF (ID(IG+9) .NE. 0) THEN
               SUM(19)=SUM(19)+RY(K)*RZ(K)*P
               IF (NCENTR(N) .EQ. 0) SUM(20)=SUM(20)+RY(K)*RZ(K)*Q
            END IF
   65    CONTINUE
 
         IF (ID(IG) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADG=FR*SUM(1)-FI*SUM(2)
               DBDG=FR*SUM(2)+FI*SUM(1)
            ELSE
               DADG=FR*SUM(1)
               DBDG=FI*SUM(1)
            END IF
            DPARA(IG)=2.0*(DADG*SFR(I)+DBDG*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG)=DPARA(IG)+C1*Q2(I)*A(IG+10)*FM*
     &         (SUM(1)*SFRMAG(I)+SUM(2)*SFIMAG(I))
            END IF
         END IF
         IF (ID(IG+1) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADX=-TWOPI*A(IG)*(FR*SUM(3)+FI*SUM(4))
               DBDX=TWOPI*A(IG)*(FR*SUM(4)-FI*SUM(3))
            ELSE
               DADX=-TWOPI*A(IG)*FR*SUM(3)
               DBDX=-TWOPI*A(IG)*FI*SUM(3)
            END IF
            DPARA(IG+1)=2.0*(DADX*SFR(I)+DBDX*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG+1)=DPARA(IG+1)+C1*Q2(I)*TWOPI*A(IG+10)*A(IG)*FM*
     &         (-SUM(3)*SFRMAG(I)+SUM(4)*SFIMAG(I))
            END IF
         END IF
         IF (ID(IG+2) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADY=-TWOPI*A(IG)*(FR*SUM(5)+FI*SUM(6))
               DBDY=TWOPI*A(IG)*(FR*SUM(6)-FI*SUM(5))
            ELSE
               DADY=-TWOPI*A(IG)*FR*SUM(5)
               DBDY=-TWOPI*A(IG)*FI*SUM(5)
            END IF
            DPARA(IG+2)=2.0*(DADY*SFR(I)+DBDY*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG+2)=DPARA(IG+2)+C1*Q2(I)*TWOPI*A(IG+10)*A(IG)*FM*
     &         (-SUM(5)*SFRMAG(I)+SUM(6)*SFIMAG(I))
            END IF
         END IF
         IF (ID(IG+3) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADZ=-TWOPI*A(IG)*(FR*SUM(7)+FI*SUM(8))
               DBDZ=TWOPI*A(IG)*(FR*SUM(8)-FI*SUM(7))
            ELSE
               DADZ=-TWOPI*A(IG)*FR*SUM(7)
               DBDZ=-TWOPI*A(IG)*FI*SUM(7)
            END IF
            DPARA(IG+3)=2.0*(DADZ*SFR(I)+DBDZ*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG+3)=DPARA(IG+3)+C1*Q2(I)*TWOPI*A(IG+10)*A(IG)*FM*
     &         (-SUM(7)*SFRMAG(I)+SUM(8)*SFIMAG(I))
            END IF
         END IF
         IF (ID(IG+4) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADB11=-A(IG)*(FR*SUM(9)-FI*SUM(10))
               DBDB11=-A(IG)*(FR*SUM(10)+FI*SUM(9))
            ELSE
               DADB11=-A(IG)*FR*SUM(9)
               DBDB11=-A(IG)*FI*SUM(9)
            END IF
            DPARA(IG+4)=2.0*(DADB11*SFR(I)+DBDB11*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG+4)=DPARA(IG+4)-C1*Q2(I)*A(IG+10)*A(IG)*FM*
     &         (SUM(9)*SFRMAG(I)+SUM(10)*SFIMAG(I))
            END IF
         END IF
         IF (ID(IG+5) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADB22=-A(IG)*(FR*SUM(11)-FI*SUM(12))
               DBDB22=-A(IG)*(FR*SUM(12)+FI*SUM(11))
            ELSE
               DADB22=-A(IG)*FR*SUM(11)
               DBDB22=-A(IG)*FI*SUM(11)
            END IF
            DPARA(IG+5)=2.0*(DADB22*SFR(I)+DBDB22*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG+5)=DPARA(IG+5)-C1*Q2(I)*A(IG+10)*A(IG)*FM*
     &         (SUM(11)*SFRMAG(I)+SUM(12)*SFIMAG(I))
            END IF
         END IF
         IF (ID(IG+6) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADB33=-A(IG)*(FR*SUM(13)-FI*SUM(14))
               DBDB33=-A(IG)*(FR*SUM(14)+FI*SUM(13))
            ELSE
               DADB33=-A(IG)*FR*SUM(13)
               DBDB33=-A(IG)*FI*SUM(13)
            END IF
            DPARA(IG+6)=2.0*(DADB33*SFR(I)+DBDB33*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG+6)=DPARA(IG+6)-C1*Q2(I)*A(IG+10)*A(IG)*FM*
     &         (SUM(13)*SFRMAG(I)+SUM(14)*SFIMAG(I))
            END IF
         END IF
         IF (ID(IG+7) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADB12=-2.0*A(IG)*(FR*SUM(15)-FI*SUM(16))
               DBDB12=-2.0*A(IG)*(FR*SUM(16)+FI*SUM(15))
            ELSE
               DADB12=-2.0*A(IG)*FR*SUM(15)
               DBDB12=-2.0*A(IG)*FI*SUM(15)
            END IF
            DPARA(IG+7)=2.0*(DADB12*SFR(I)+DBDB12*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG+7)=DPARA(IG+7)-C1*Q2(I)*2.0*A(IG+10)*A(IG)*FM*
     &         (SUM(15)*SFRMAG(I)+SUM(16)*SFIMAG(I))
            END IF
         END IF
         IF (ID(IG+8) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADB13=-2.0*A(IG)*(FR*SUM(17)-FI*SUM(18))
               DBDB13=-2.0*A(IG)*(FR*SUM(18)+FI*SUM(17))
            ELSE
               DADB13=-2.0*A(IG)*FR*SUM(17)
               DBDB13=-2.0*A(IG)*FI*SUM(17)
            END IF
            DPARA(IG+8)=2.0*(DADB13*SFR(I)+DBDB13*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG+8)=DPARA(IG+8)-C1*Q2(I)*2.0*A(IG+10)*A(IG)*FM*
     &         (SUM(17)*SFRMAG(I)+SUM(18)*SFIMAG(I))
            END IF
         END IF
         IF (ID(IG+9) .NE. 0) THEN
            IF (NCENTR(N) .EQ. 0) THEN
               DADB23=-2.0*A(IG)*(FR*SUM(19)-FI*SUM(20))
               DBDB23=-2.0*A(IG)*(FR*SUM(20)+FI*SUM(19))
            ELSE
               DADB23=-2.0*A(IG)*FR*SUM(19)
               DBDB23=-2.0*A(IG)*FI*SUM(19)
            END IF
            DPARA(IG+9)=2.0*(DADB23*SFR(I)+DBDB23*SFI(I))
            IF (LM .EQ. 1) THEN
               DPARA(IG+9)=DPARA(IG+9)-C1*Q2(I)*2.0*A(IG+10)*A(IG)*FM*
     &         (SUM(19)*SFRMAG(I)+SUM(20)*SFIMAG(I))
            END IF
         END IF
         IF (LM .EQ. 1 .AND. ID(IG+10) .NE. 0) THEN
            DPARA(IG+10)=C1*Q2(I)*A(IG)*FM*
     &      (SUM(1)*SFRMAG(I)+SUM(2)*SFIMAG(I))
         END IF
         IF (IFAC(J,N) .EQ. 1) THEN
            DO 70 K=IG,IG+NPSITE(J,N)-1
               IF (ID(K) .NE. 0) DPARA(K)=0.5*DPARA(K)
   70       CONTINUE
         END IF
 
    9    IG=IG+NPSITE(J,N)
   80 CONTINUE
      IF (LMAG(N) .EQ. 1) CALL DERPHI(A,DPARA,N,IG)
      END
 
************************************************************************
 
      SUBROUTINE INTTBL(VNS,L,NSPGR,NSET,LAUEG,NCENTR,NSYM,SPGR,LSPSYM,
     &  NSSYM,SYM,LINNSS,NLNSS)
*     READ INFORMATION ABOUT SPACE GROUP
      PARAMETER (NS=48,NPH=2)
      INTEGER NSPGR(*),NSET(*),LAUEG(*),NCENTR(*),NSYM(*),LSPSYM(*),
     &  NSSYM(14,NPH)
*FACOM, HITAC, VAX, AND SUN
      CHARACTER VNS*7,FORM(3)*4,SPGR(*)*10,COORD*20,
*ACOS
*     CHARACTER VNS*7,FORM(3)*4,VNS1*7,SPGR(*)*10,COORD*20,
     &  SYM(3,NS,NPH)*10,LINNSS(*)*40,LINE*80
      DATA FORM/'(I1)','(I2)','(I3)'/
 
C        LAUEG: LAUE GROUP NUMBER
C              LAUEG= 1  TRICLINIC (-1)   1/2
C                   = 2  MONOCLINIC-1 (2/M) A-AXIS   1/4
C                   = 3  MONOCLINIC-2 (2/M) B-AXIS   1/4
C                   = 4  MONOCLINIC-3 (2/M) C-AXIS   1/4
C                   = 5  ORTHORHOMBIC (MMM)   1/8
C                   = 6  TETRAGONAL-1 (4/M)   1/8
C                   = 7  TETRAGONAL-2 (4/MMM)   1/16
C                   = 8  TRIGONAL-1  RHOMBOHEDRAL LATTICE (-3)   1/6
C                   = 9  TRIGONAL-2  HEXAGONAL LATTICE (-3)   1/6
C                   =10  TRIGONAL-3  RHOMBOHEDRAL LATTICE (-3M)   1/12
C                   =11  TRIGONAL-4  HEXAGONAL LATTICE (-3M)   1/12
C                   =12  HEXAGONAL-1 (6/M)   1/12
C                   =13  HEXAGONAL-2 (6/MMM)   1/24
C                   =14  CUBIC-1 (M3)   1/24
C                   =15  CUBIC-2 (M3M)   1/48
C     NCENTR=0: LACKING A CENTER OF SYMMETRY
C     NCENTR=1: POSSESSING A CENTER OF SYMMETRY
C         NSYM: NUMBER OF EQUIVALENT COORDINATES
C         SPGR: NAME OF THE SPACE GROUP
 
*     VNS: VOL.#-SPACE GROUP #-SETTING # (E.G., 'A-123-2', 'I-56')
      IF (VNS(1:1) .NE. 'I' .AND. VNS(1:1) .NE. 'A') THEN
         CALL JOBEND('WRONG VOLUME NAME IN: '//VNS)
      ELSE IF (VNS(2:2) .NE. '-') THEN
         CALL JOBEND('INVALID DELIMITER IN: '//VNS)
      END IF
      MINUS=INDEX(VNS(3:),'-')
      IF (MINUS .NE. 0) THEN
*FACOM, HITAC, VAX, AND SUN
         READ(VNS(3:),FORM(MINUS-1)) NSPGR(L)
*ACOS
*        VNS1=VNS(3:)
*ACOS
*        READ(VNS1,FORM(MINUS-1)) NSPGR(L)
         READ(VNS(MINUS+3:),'(I1)') NSET(L)
      ELSE
         DO 20 I=3,7
            IF (VNS(I:I) .EQ. ' ') GO TO 2
   20    CONTINUE
    2    READ(VNS(3:I-1),FORM(I-3)) NSPGR(L)
         NSET(L)=1
      END IF
      IF(NSPGR(L) .LT. 1 .OR. NSPGR(L) .GT. 230)
     &CALL JOBEND('NUMBER OF SPACE GROUP OUT OF RANGE.')
      IF (VNS(1:1) .EQ. 'I') THEN
         NFILE=1
*SUN (CHANGE THE FILENAME TO AN APPROPRIATE ONE)
*        OPEN(UNIT=NFILE,FILE='/USR2/IZUMI/DATABASE/SPGRI',
*    &   STATUS='OLD')
*VAX
         OPEN(UNIT=NFILE,FILE='SPGRI.DAT',STATUS='OLD',READONLY)
      ELSE
         NFILE=11
*SUN (CHANGE THE FILENAME TO AN APPROPRIATE ONE)
*        OPEN(UNIT=NFILE,FILE='/USR2/IZUMI/DATABASE/SPGRA',
*    &   STATUS='OLD')
*VAX
         OPEN(UNIT=NFILE,FILE='SPGRA.DAT',STATUS='OLD',READONLY)
      END IF
      REWIND NFILE
    4 READ(NFILE,'(5I3,3X,A)',IOSTAT=IOS)
     &NSPGR1,NSET1,LAUEG(L),NCENTR(L),NSYM(L),SPGR(L)
      IF (IOS .LT. 0) THEN
         CLOSE(UNIT=NFILE,STATUS='KEEP')
         CALL JOBEND('BAD SPACE GROUP SPECIFICATION: '//VNS)
      ELSE IF (NSPGR(L) .NE. NSPGR1 .OR. NSET(L) .NE. NSET1) THEN
         DO 40 J=1,NSYM(L)+1
            READ(NFILE,'()')
   40    CONTINUE
         GO TO 4
      END IF
      IF (NSYM(L) .GT. NS) THEN
         CALL JOBEND('TOO SMALL NS VALUE')
      ELSE IF (LSPSYM(L) .LE. 1) THEN
         READ(NFILE,'(14I2)') (NSSYM(I,L),I=1,14)
         DO 50 J=1,NSYM(L)
            READ(NFILE,'(A20)') COORD
            CALL DECODE(COORD,SYM(1,1,L),J,L)
   50    CONTINUE
      ELSE IF (LSPSYM(L) .EQ. 2) THEN
         READ(5,*) NCENTR(L),SPGR(L)
         DO 55 J=1,14
            NSSYM(J,L)=0
   55    CONTINUE
         DO 60 J=1,14
            READ(5,'(A)') LINNSS(J)
            IF (LINNSS(J)(1:6) .EQ. 'ENDNSS') GO TO 6
            CALL NSCONV(LINNSS(J),NSSYM(1,L))
   60    CONTINUE
         READ(5,'(A)') LINE
         IF (LINE(1:6) .NE. 'ENDNSS') CALL JOBEND
     &   ('TOO MANY NON-STANDARD SYMMETRY LINES')
    6    NLNSS=J-1
         DO 70 J=1,NS
            READ(5,'(A)') LINE
            IF (LINE(1:8) .EQ. 'ENDCOORD') GO TO 7
            READ(LINE,'(A20)') COORD
            CALL DECODE(COORD,SYM(1,1,L),J,L)
   70    CONTINUE
    7    NSYM(L)=J-1
      ELSE
         CALL JOBEND('BAD LSPSYM VALUE')
      END IF
      IF (LAUEG(L) .EQ. 8 .OR. LAUEG(L) .EQ. 10) NSSYM(7,L)=21
      END
 
************************************************************************
 
      SUBROUTINE PARAM(ANAME,ISONUM,A,ID,NMODE,NTERMS)
C     ASSIGN REMARKS ON PARAMETERS
      PARAMETER (NT=220,NR=65,NA=7,NAP=36,NPH=2,NS=48,NB=2000)
      CHARACTER INTCHR*4,ANAME(*)*5,PARNAM*48,PHNAME*25
CORRECTED ON 1988.12.2
      INTEGER ISONUM(NAP,NPH),ID(*),R,RX,RY,RZ
CORRECTION END
      REAL A(*)
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /MAGSC/ MAGATM(NA),RLV(20,NA),AMPMAG(20,NA),NPAIR(NA)
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      COMMON /SITE/ NOAT(NAP,NPH)
      LP(J)=KPHB(L)+J
C
      PARNAM(1)='ZERO-POINT SHIFT OF THE COUNTER'
      PARNAM(2)='BACKGROUND PARAMETER 0'
      PARNAM(3)='BACKGROUND PARAMETER 1'
      PARNAM(4)='BACKGROUND PARAMETER 2'
      PARNAM(5)='BACKGROUND PARAMETER 3'
      PARNAM(6)='BACKGROUND PARAMETER 4'
      PARNAM(7)='BACKGROUND PARAMETER 5'
      DO 20 L=1,NPHASE
         PARNAM(LP(NSFX))='SCALE FACTOR'
         PARNAM(LP(1))='FWHM PARAMETER 1 (U)'
         PARNAM(LP(2))='FWHM PARAMETER 2 (V)'
         PARNAM(LP(3))='FWHM PARAMETER 3 (W)'
         PARNAM(LP(4))='ASYMMETRY PARAMETER'
         PARNAM(LP(5))='GAUSSIAN FRACTION'
         PARNAM(LP(6))='FWHM(GAUSS)/FWHM(LORENTZ)'
         PARNAM(LP(NPO1X))='PREFERRED-ORIENTATION PARAMETER 1'
         PARNAM(LP(NPO2X))='PREFERRED-ORIENTATION PARAMETER 2'
         PARNAM(LP(NAX))='A'
         PARNAM(LP(NBX))='B'
         PARNAM(LP(NCX))='C'
         PARNAM(LP(NALPX))='ALPHA'
         PARNAM(LP(NBETX))='BETA'
         PARNAM(LP(NGAMX))='GAMMA'
         PARNAM(LP(NOTX))='OVERALL THERMAL PARAMETER'
         LL=LP(NG1X)
         DO 10 KK=1,NSITE(L)
            IF(ISONUM(KK,L).NE.0) THEN
               PARNAM(LL)=ANAME(NOAT(KK,L))//INTCHR(ISONUM(KK,L))//
     &         '  OCCUPATION FACTOR'
            ELSE
               PARNAM(LL)=ANAME(NOAT(KK,L))//'      OCCUPATION FACTOR'
            ENDIF
            PARNAM(LL+1)='           FRACTIONAL COORDINATE, X'
            PARNAM(LL+2)='           FRACTIONAL COORDINATE, Y'
            PARNAM(LL+3)='           FRACTIONAL COORDINATE, Z'
            IF (LISO(KK,L) .EQ. 1) THEN
               PARNAM(LL+4)='           ISOTROPIC THERMAL PARAMETER'
               NEXT=LL+5
            ELSE IF (LISO(KK,L) .EQ. 6) THEN
               PARNAM(LL+4)='           ANISOTROPIC THERMAL PARAMETER, '
     &         //'BETA11'
               PARNAM(LL+5)='           ANISOTROPIC THERMAL PARAMETER, '
     &         //'BETA22'
               PARNAM(LL+6)='           ANISOTROPIC THERMAL PARAMETER, '
     &         //'BETA33'
               PARNAM(LL+7)='           ANISOTROPIC THERMAL PARAMETER, '
     &         //'BETA12'
               PARNAM(LL+8)='           ANISOTROPIC THERMAL PARAMETER, '
     &         //'BETA13'
               PARNAM(LL+9)='           ANISOTROPIC THERMAL PARAMETER, '
     &         //'BETA23'
               NEXT=LL+10
            ELSE
               NEXT=LL+4
            END IF
            IF (MAGATM(NOAT(KK,L)) .EQ. 1) THEN
               PARNAM(NEXT)='           MAGNETIC MOMENT, MU'
            END IF
            LL=LL+NPSITE(KK,L)
   10    CONTINUE
         IF (LMAG(L) .EQ. 1) THEN
            IF (LAUEG(L) .EQ. 5) THEN
               PARNAM(KPHE(L)-2)='           PHI(A)'
               PARNAM(KPHE(L)-1)='           PHI(B)'
               PARNAM(KPHE(L))='           PHI(C)'
            ELSE IF (LAUEG(L) .LE. 13) THEN
               PARNAM(KPHE(L))='           PHI'
            END IF
         END IF
   20 CONTINUE
      WRITE(6,320)
  320 FORMAT(//11X,'INFORMATION ON PROFILE AND STRUCTURE PARAMETERS')
      IF(NMODE.GE.2) THEN
         WRITE(6,322) (J,A(J),PARNAM(J),J=1,NTERMS)
  322    FORMAT(/12X,'NO.',6X,'A'/(' ',10X,I3,2X,1P,G13.6,6X,A))
      ELSE
         WRITE(6,325) (J,A(J),ID(J),PARNAM(J),J=1,NTERMS)
  325    FORMAT(/12X,'NO.',6X,'A',12X,'ID'/
     &   (' ',10X,I3,2X,1P,G13.6,5X,I2,6X,A))
      ENDIF
      END
 
************************************************************************
 
      SUBROUTINE NSCONV(LINE,NSSYM)
C     CONVERT A REFLECTION TYPE AND A REFLECTION CONDITION INTO AN
C     ELEMENT OF ARRAY NSSYM
      CHARACTER LINE*40,REFTYP*3,CONDTN*14,RTITLE(14)*3,CTITLE(28)*14
      INTEGER NSSYM(*)
      DATA RTITLE/
     &'00L','0K0','0KL','H00','H0L','HK0','HKL','0KK','HH0',
     &'HHL','H0H','HKK','HKH','HHH'/
      DATA CTITLE/
     &'H=2N','K=2N','L=2N','K+L=2N','H+L=2N','H+K=2N',
     &'H,K,L ODD/EVEN','K+L=4N','H+L=4N','H+K=4N','2H+L=2N',
     &'2H+L=4N','H+K+L=2N','-H+K+L=3N','H-K+L=3N',
     &'H=4N','K=4N','L=3N','L=4N','L=6N','!H!>=!K!>=!L!',
     &'2H+K=2N','2H+K=4N','H+2K=2N',
     &'H+2K=4N','H=2N,K=2N','K=2N,L=2N','H=2N,L=2N'/
 
      DO 10 I=40,1,-1
         IF (LINE(I:I) .NE. ' ') GO TO 1
   10 CONTINUE
    1 NEND=I
      REFTYP=' '
      IP=0
      DO 20 I=1,NEND
         IF (LINE(I:I) .EQ. ':') THEN
            GO TO 2
         ELSE IF (LINE(I:I) .NE. ' ') THEN
            IP=IP+1
            IF (IP .GE. 4) CALL JOBEND('BAD REFLECTION TYPE')
            REFTYP(IP:IP)=LINE(I:I)
         END IF
   20 CONTINUE
      CALL JOBEND
     &('MISSING A COLON IN A NON-STANDARD SYMMETRY CONDITION')
    2 CONDTN=' '
      IP=1
      DO 30 J=I+1,NEND
         IF (LINE(J:J) .NE. ' ') THEN
            CONDTN(IP:IP)=LINE(J:J)
            IP=IP+1
         END IF
   30 CONTINUE
      DO 40 I=1,14
         IF (REFTYP .EQ. RTITLE(I)) GO TO 5
   40 CONTINUE
      CALL JOBEND('BAD REFLECTION TYPE: '//REFTYP)
    5 DO 50 J=1,28
         IF (CONDTN .EQ. CTITLE(J)) GO TO 6
   50 CONTINUE
      CALL JOBEND('BAD REFLECTION CONDITION: '//CONDTN)
    6 NSSYM(I)=J
      END
 
************************************************************************
 
      SUBROUTINE EQPOS(NPHASE,PHNAME,NSITE,ISONUM,ANAME,NOAT,NSYM,IDSYM,
     &  NCENTR,IFAC,COEF,SYM,NSSYM)
*     PRINT OUT EQUIVALENT POSITIONS FOR EACH SITE
      PARAMETER(NPH=2,NAP=36,NS=48)
      INTEGER NSITE(*),ISONUM(NAP,NPH),NOAT(NAP,NPH),NSYM(*),
     &  IDSYM(NS,NAP,NPH),NCENTR(*),IFAC(NAP,NPH),NSSYM(14,NPH)
      REAL COEF(*)
      CHARACTER PHNAME(*)*25,ANAME(*)*5,SYM(3,NS,NPH)*10,CHAR4*4,
     &  INTCHR*4,XYZ(3)*10
 
      DO 70 L=1,NPHASE
         WRITE(6,'(//11X,A,A)')
     &   'EQUIVALENT POSITIONS FOR EACH SITE IN ',PHNAME(L)
         NCON=NSSYM(7,L)
         IF (NCON .EQ. 4) THEN
*           A LATTICE
            WRITE(6,'(13X,A/)') '(0,0,0)+  (0,1/2,1/2)+'
         ELSE IF (NCON .EQ. 5) THEN
*           B LATTICE
            WRITE(6,'(13X,A/)') '(0,0,0)+  (1/2,0,1/2)+'
         ELSE IF (NCON .EQ. 6) THEN
*           C LATTICE
            WRITE(6,'(13X,A/)') '(0,0,0)+  (1/2,1/2,0)+'
         ELSE IF (NCON .EQ. 13) THEN
*           I LATTICE
            WRITE(6,'(13X,A/)') '(0,0,0)+  (1/2,1/2,1/2)+'
         ELSE IF (NCON .EQ. 7) THEN
*           F LATTICE
            WRITE(6,'(13X,A/)') '(0,0,0)+  (0,1/2,1/2)+  (1/2,0,1/2)+'//
     &      '  (1/2,1/2,0)'
         ELSE IF (NCON .EQ. 14) THEN
*           RHOMBOHEDRALLY CENTERED (OBVERSE SETTING)
            WRITE(6,'(13X,A/)') '(0,0,0)+  (2/3,1/3,1/3)+  '//
     &      '(1/3,2/3,2/3)+'
         ELSE IF (NCON .EQ. 15) THEN
*           RHOMBOHEDRALLY CENTERED (REVERSE SETTING)
            WRITE(6,'(13X,A/)') '(0,0,0)+  (1/3,2/3,1/3)+  '//
     &      '(2/3,1/3,2/3)+'
         END IF
 
         DO 60 J=1,NSITE(L)
            IF(ISONUM(J,L).NE.0) THEN
               CHAR4=INTCHR(ISONUM(J,L))
               WRITE(6,350) ANAME(NOAT(J,L)),CHAR4
            ELSE
               WRITE(6,350) ANAME(NOAT(J,L))
            ENDIF
            NPOS=0
            DO 20 JJ=1,NSYM(L)
               IF(IDSYM(JJ,J,L).EQ.1) NPOS=NPOS+1
   20       CONTINUE
            IF (NCENTR(L) .EQ. 1) THEN
               WRITE(6,370) IFAC(J,L),IFAC(J,L)*NINT(COEF(L))*NPOS/2
            ELSE
               WRITE(6,375) NINT(COEF(L))*NPOS
            ENDIF
            DO 25 JJ=1,NSYM(L)
               IF(IDSYM(JJ,J,L).EQ.1) WRITE(6,'(21X,3(A10,3X))')
     &         (SYM(LL,JJ,L),LL=1,3)
   25       CONTINUE
            IF (NCENTR(L) .EQ. 1 .AND. IFAC(J,L) .EQ. 2) THEN
               DO 30 JJ=1,NSYM(L)
                  IF (IDSYM(JJ,J,L) .EQ. 1) THEN
                     XYZ(1)=SYM(1,JJ,L)
                     XYZ(2)=SYM(2,JJ,L)
                     XYZ(3)=SYM(3,JJ,L)
                     CALL MINUS(XYZ)
                  END IF
   30          CONTINUE
            END IF
   60    CONTINUE
   70 CONTINUE
  350 FORMAT(' ',12X,A5,A4)
  370 FORMAT('+',26X,'FACTOR =',I2,5X,'NEQ =',I4)
  375 FORMAT('+',26X,'NEQ =',I4)
      END
 
************************************************************************
 
      SUBROUTINE MINUS(XYZ)
*     PRINT OUT INVERTED COORDINATES IN A CETROSYMMETRIC SPACE GROUP
      CHARACTER*10 XYZ(3),TEMP(3)
 
      DO 50 I=1,3
         TEMP(I)=' '
         IP=1
         J=1
    1    CONTINUE
            IF (XYZ(I)(J:J) .EQ. ' ') THEN
*              DO NOTHING
            ELSE IF (XYZ(I)(J:J) .EQ. '-' .AND. IP .EQ. 1) THEN
               K=J+1
               DO 20 J=K,10
                  IF (XYZ(I)(J:J) .NE. ' ') GO TO 3
   20          CONTINUE
    3          TEMP(I)(1:1)=XYZ(I)(J:J)
               IP=2
            ELSE IF (XYZ(I)(J:J) .NE. '+' .AND. IP .EQ. 1) THEN
               TEMP(I)(1:1)='-'
               TEMP(I)(2:2)=XYZ(I)(J:J)
               IP=3
            ELSE
               IF (XYZ(I)(J:J) .EQ. '-') THEN
                  TEMP(I)(IP:IP)='+'
               ELSE IF (XYZ(I)(J:J) .EQ. '+') THEN
                  TEMP(I)(IP:IP)='-'
               ELSE
                  TEMP(I)(IP:IP)=XYZ(I)(J:J)
               END IF
               IP=IP+1
            END IF
            J=J+1
         IF (J .LE. 10 .AND. IP .LE. 10) GO TO 1
   50 CONTINUE
      WRITE(6,'(21X,3(A,3X))') (TEMP(J),J=1,3)
      END
 
************************************************************************
 
      SUBROUTINE COMPOS(A,SIGMAA,LSIG,ANAME,INDIV,COEF,AW)
*     PRINT OUT THE NUMBER OF ATOMS IN THE UNIT CELL AND THERMAL
*     PARAMETERS OF ALL SITES
      PARAMETER (NB=2000,NP=5050,NT=220,NS=48,NAP=36,NPH=2)
*     2*PI**2 = 19.73921
      PARAMETER (C=19.73921)
      REAL A(*),SIGMAA(*),COEF(*),G1(3,3),GG1(3,3),BETA(3,3),B,AW(*)
      REAL SIGBET(6)
      INTEGER INDIV(*),R,RX,RY,RZ,LCAL(NAP),IG(NAP)
      CHARACTER ANAME(*)*5,PARNAM*48,PHNAME*25,LINE*126
*MODIFIED ON 1988.10.25
      COMMON /FRDA/ NFR,NDA
      COMMON /MULT/ SM(NAP)
*MODIFICATION END
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /HALF/ IFAC(NAP,NPH)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      COMMON /SITE/ NOAT(NAP,NPH)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      ITB(I,J)=NINT(1.0E6*BETA(I,J))
      ITU(I,J)=NINT(1.0E6*BETA(I,J)/(C*SQRT(GG(I,L)*GG(J,L))))
      ISU(J1,J2,J3)=NINT(SIGBET(J1)/(C*SQRT(GG(J2,L)*GG(J3,L))))
 
      DO 80 L=1,NPHASE
         WRITE(6,'(//11X,2A)') 'NUMBER AND WEIGHT OF EACH SPECIES IN '//
     &   'THE UNIT CELL, AND DENSITY FOR ',PHNAME(L)
         WRITE(6,'(/13X,A)') 'ATOM       N     *    AT.WT.  /  '//
     &   '6.02214E23  =     WT.'
         DO 10 J=1,NSITE(L)
            LCAL(J)=0
*           DETERMINE THE PARAMETER NUMBERS OF OCCUPATION FACTORS
            IF (J .EQ. 1) THEN
               IG(J)=KPHB(L)+NG1X
            ELSE
               IG(J)=IG(J-1)+NPSITE(J-1,L)
            END IF
   10    CONTINUE
         SUMAW=0.0
         DO 50 IPOINT=1,NSITE(L)
            IF (LCAL(IPOINT) .EQ. 1) GO TO 50
            X=0.0
            DO 30 J=IPOINT,NSITE(L)
               IF (LCAL(J) .EQ. 0 .AND.
     &         ABS(NOAT(J,L)) .EQ. ABS(NOAT(IPOINT,L))) THEN
                  NPOS=0
                  DO 20 JJ=1,NSYM(L)
                     IF (IDSYM(JJ,J,L) .EQ. 1) NPOS=NPOS+1
   20             CONTINUE
                  IF (NCENTR(L) .EQ. 1) THEN
                     X=X+A(IG(J))*IFAC(J,L)*COEF(L)*NPOS/2
*MODIFIED ON 1988.10.25
                     IF (L .EQ. NDA)
     &                  SM(J)=0.5*A(IG(J))*IFAC(J,L)*NPOS/NSYM(L)
*MODIFICATION END
                  ELSE
                     X=X+A(IG(J))*COEF(L)*NPOS
*MODIFIED ON 1988.10.25
                     IF (L .EQ. NDA) SM(J)=A(IG(J))*NPOS/NSYM(L)
*MODIFICATION END
                  END IF
                  LCAL(J)=1
               END IF
   30       CONTINUE
            WRITE(6,'(13X,A,F11.5,F13.5,15X,1P,E15.6,A)')
     &      ANAME(ABS(NOAT(IPOINT,L))),X,AW(ABS(NOAT(IPOINT,L))),
     &      X*AW(ABS(NOAT(IPOINT,L)))/6.022136E23,' G'
            SUMAW=SUMAW+AW(ABS(NOAT(IPOINT,L)))*X
   50    CONTINUE
         WRITE(6,'(13X,61A)') ('-',JJ=1,61)
         SUMAW=SUMAW/6.022136E23
         WRITE(6,'(52X,A,1P,E13.6,A)') 'TOTAL =',SUMAW,' G'
         CALL INVERS(GG(1,L),G(1,L),DET)
*        VOL: UNIT CELL VOLUMN/CM**3; D: DENSITY/G CM-3
         VOL=SQRT(DET)*1.0E-24
         WRITE(6,'(13X,A,1P,E13.6,A,1P,E13.6,A,0P,F9.6,A)')
     &   'D = TOTAL/V =',SUMAW,' /',VOL,' = ',SUMAW/VOL,' G/CM**3'
 
         IF (INDIV(L) .EQ. 1) THEN
            WRITE(6,'(//11X,2A)') 'BETA*10**6, U*10**6/ANGSTROM**2, '//
     &      'AND BEQ/ANGSTROM**2 IN ',PHNAME(L)
            WRITE(6,'(/24X,A)') 'BETA11  BETA22  BETA33  BETA12'//
     &      '  BETA13  BETA23     U11     U22     U33     '//
     &      'U12     U13     U23    BEQ'
            G1(1,1)=G(1,L)
            G1(2,2)=G(2,L)
            G1(3,3)=G(3,L)
            G1(2,3)=G(4,L)
            G1(1,3)=G(5,L)
            G1(1,2)=G(6,L)
            GG1(1,1)=GG(1,L)
            GG1(2,2)=GG(2,L)
            GG1(3,3)=GG(3,L)
            GG1(2,3)=GG(4,L)
            GG1(1,3)=GG(5,L)
            GG1(1,2)=GG(6,L)
            DO 75 J=1,NSITE(L)
               IF (LISO(J,L) .EQ. 6) THEN
                  BETA(1,1)=A(IG(J)+4)
                  BETA(2,2)=A(IG(J)+5)
                  BETA(3,3)=A(IG(J)+6)
                  BETA(1,2)=A(IG(J)+7)
                  BETA(1,3)=A(IG(J)+8)
                  BETA(2,3)=A(IG(J)+9)
                  CALL TOB(G1,BETA,B)
                  IF (LSIG .EQ. 1) THEN
                     DO 55 I=1,6
                        SIGBET(I)=SIGMAA(IG(J)+I+3)*1.0E6
   55                CONTINUE
                     SIGB=0.0
                  END IF
               ELSE
                  B=A(IG(J)+4)
                  CALL TOBETA(GG1,B,BETA)
                  IF (LSIG .EQ. 1) THEN
                     DO 60 I=1,6
                        SIGBET(I)=0.0
   60                CONTINUE
                     SIGB=SIGMAA(IG(J)+4)
                  END IF
               END IF
               WRITE(6,'(13X,A,12I8,F8.3)') PARNAM(IG(J))(1:9),
     &         ITB(1,1),ITB(2,2),ITB(3,3),ITB(1,2),ITB(1,3),ITB(2,3),
     &         ITU(1,1),ITU(2,2),ITU(3,3),ITU(1,2),ITU(1,3),ITU(2,3),B
               IF (LSIG .EQ. 1) THEN
                  WRITE(LINE,'(22X,12I8,F8.3)') (NINT(SIGBET(I)),I=1,6),
     &            (ISU(I,I,I),I=1,3),ISU(4,1,2),ISU(5,1,3),ISU(6,2,3),
     &            SIGB
                  DO 65 I=23,111,8
                     IF (LINE(I:I+7) .EQ. '       0') THEN
                        LINE(I+7:I+7)='-'
                     END IF
   65             CONTINUE
                  IF (SIGB .EQ. 0.0) LINE(119:126)='       -'
                  WRITE(6,'(A)') LINE
               END IF
   75       CONTINUE
         END IF
   80 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE TOB(G,BETA,B)
*     G: METRIC TENSOR(INPUT)
*     BETA: ANISOTROPIC THERMAL PARAMETERS (INPUT)
*     B: ISOTROPIC THERMAL PARAMETER (OUTPUT)
      REAL G(3,3),BETA(3,3),B
 
      B=0.0
      DO 20 J=1,3
         DO 10 I=1,J
            B=B+BETA(I,J)*G(I,J)
   10    CONTINUE
   20 CONTINUE
      B=1.333333*B
      END
 
************************************************************************
 
      SUBROUTINE TOBETA(GG,B,BETA)
*     GG: METRIC TENSORS OF THE RECIPROCAL CELL (INPUT)
*     B: ISOTROPIC THERMAL PARAMETER (INPUT)
*     BETA: ANISOTROPIC THERMAL PARAMETERS (OUTPUT)
      REAL GG(3,3),B,BETA(3,3)
 
      C=0.25*B
      BETA(1,1)=C*GG(1,1)
      BETA(2,2)=C*GG(2,2)
      BETA(3,3)=C*GG(3,3)
      BETA(2,3)=C*GG(2,3)
      BETA(1,3)=C*GG(1,3)
      BETA(1,2)=C*GG(1,2)
      END
 
************************************************************************
 
      SUBROUTINE LINCON(COL1,NTERMS)
C     DECODE A LINE IN WHICH A LINEAR CONSTRAINT IS DESCRIBED
      PARAMETER (NT=220,NCS=50)
      CHARACTER COL1(80)*1,LINE*80,COL(80)*1,FORM1*11,FORM2*8,CH(13)*1
      EQUIVALENCE (LINE,COL(1))
      COMMON /CNSTR/ C1(NCS),C2(10,NCS),IN(10,NCS),NCNPAR(NCS),
     &  NACNS(NCS),NCNSTR
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      DATA CH/'0','1','2','3','4','5','6','7','8','9','.','-','+'/
C
C     COPY COL1 INTO COL, REMOVING ' ' IN A LINE
      IP=1
      DO 12 I=1,80
         IF (COL1(I) .NE. ' ') THEN
            COL(IP)=COL1(I)
            IP=IP+1
         END IF
   12 CONTINUE
      LENGTH=IP-1
      IF (COL(1) .NE. 'A') CALL JOBEND('INVALID LINEAR CONSTRAINT')
C
C     LEFT-HAND SIDE OF THE EQUATION
      DO 20 ICOL=1,LENGTH
         IF (COL(ICOL) .EQ. '(') THEN
            IB=ICOL
         ELSE IF (COL(ICOL) .EQ. ')') THEN
            IE=ICOL
            GO TO 3
         END IF
   20 CONTINUE
    3 WRITE(FORM2,100) IB,IE-IB-1
  100 FORMAT('(',I2,'X,I',I1,')')
      READ(LINE,FORM2) NLEFT
C     ICON: CONSTRAINT NUMBER
      ICON=0
      DO 25 J=1,NTERMS
         IF (ID(J) .EQ. -1) THEN
            ICON=ICON+1
            IF (J .EQ. NLEFT) GO TO 4
         END IF
   25 CONTINUE
      CALL JOBEND('CHECK THE LEFT HAND SIDE OF THE LINEAR CONSTRAINT.')
    4 NACNS(ICON)=NLEFT
      C1(ICON)=0.0
      DO 27 I=1,10
         C2(I,ICON)=1.0
   27 CONTINUE
C
C     LOUT=0: THE TOP OF A NUMBER HAS BEEN ENCOUNTERED
C     LOUT=1: A NUMBER HAS NOT YET BEEN ENCOUNTERED OR HAS BEEN
C             STORED IN ARRAY C1, C2, OR IN
      LOUT=1
      IA=1
      IB=IE+2
 
C     RIGHT-HAND SIDE OF THE EQUATION
C     LINEAR CONSTRAINT: A(NACNS(J))=C1(J)+C2(1,J)*A(IN(1,J))+C2(2,J)*
C                        A(IN(2,J))+ .....
C     PARAMETERS CONTAINED IN THE ABOVE FORMULA MUST BE STRUCTURE-FACTOR
C     PARAMETERS.
C     THE ABOVE EQUALITY CONSTRAINT IS USED IN SUBROUTINE SETPAR
C     NCNSTR: NUMBER OF CONSTRAINTS
C     NCNPAR: NUMBER OF PARAMETERS CONTAINED IN THE RIGHT SIDE OF THE
C             EQUALITY CONSTRAINT
      DO 70 ICOL=IB,LENGTH
         IF (COL(ICOL) .EQ. ')') THEN
            IE=ICOL
            WRITE(FORM2,100) IB-1,IE-IB
            READ(LINE,FORM2) IN(IA,ICON)
            IA=IA+1
            LOUT=1
         ELSE IF (COL(ICOL) .EQ. '*') THEN
            IE=ICOL
            WRITE(FORM1,110) IB-1,IE-IB
  110       FORMAT('(',I2,'X,F',I2,'.0)')
            READ(LINE,FORM1) C2(IA,ICON)
            LOUT=1
         ELSE IF ((COL(ICOL) .EQ. '+' .OR. COL(ICOL) .EQ. '-') .AND.
     &   COL(ICOL-1) .NE. 'E') THEN
            IF (LOUT .EQ. 1) THEN
               IB=ICOL
               LOUT=0
            ELSE
               IE=ICOL
               WRITE(FORM1,110) IB-1,IE-IB
               READ(LINE,FORM1) C1(ICON)
               IB=ICOL
            END IF
*FIXED AT 1986.6.3
         ELSE IF (COL(ICOL) .EQ. 'A' .AND. LOUT .EQ. 0 .AND.
     &   COL(IB) .EQ. '+') THEN
            C2(IA,ICON)=+1.0
            LOUT=1
         ELSE IF (COL(ICOL) .EQ. 'A' .AND. LOUT .EQ. 0 .AND.
     &   COL(IB) .EQ. '-') THEN
            C2(IA,ICON)=-1.0
            LOUT=1
         ELSE IF (ICOL .EQ. LENGTH) THEN
            IF (LOUT .EQ. 0) THEN
               WRITE(FORM1,110) IB-1,ICOL-IB+1
               READ(LINE,FORM1) C1(ICON)
            END IF
            GO TO 9
         ELSE
            DO 30 J=1,13
               IF (COL(ICOL) .EQ. CH(J)) THEN
                  LP=J
                  GO TO 5
               END IF
   30       CONTINUE
            LP=0
    5       IF (LP .GT. 0 .AND. LOUT .EQ. 1) THEN
               IB=ICOL
               LOUT=0
            END IF
         END IF
   70 CONTINUE
    9 NCNPAR(ICON)=IA-1
      END
 
************************************************************************
 
      SUBROUTINE SIMDAT(YFIT,NSTEP,TITLE,DEG,STEP,NREFL,PEAK)
*     RECORD SIMULATION DATA
      REAL YFIT(*),DEG(*),PEAK(*)
      CHARACTER*80 TITLE
*SUN
*     CHARACTER*50 FILE20
      DATA RD2/57.29578/
 
*     NMODE=-3
C     NORMALIZATION OF INTENSITIES
      YMAX=YFIT(1)
      DO 15 J=2,NSTEP
         IF(YFIT(J).GT.YMAX) YMAX=YFIT(J)
   15 CONTINUE
      DO 25 J=1,NSTEP
         YFIT(J)=YFIT(J)*100000.0/YMAX
   25 CONTINUE
*     UNIT 20 --- RECORD LENGTH = 140
*SUN
*     CALL GETARG(3,FILE20)
*SUN
*     OPEN(UNIT=20,FILE=FILE20)
      REWIND 20
      WRITE(20,'(A80)') TITLE
      WRITE(20,'(I5,F10.3,F10.7,I5)') NSTEP,DEG(1)*RD2,
     &STEP*RD2,NREFL
      WRITE(20,'(20I7)') (NINT(YFIT(J)),J=1,NSTEP)
      WRITE(20,'(17F8.3)') (PEAK(J)*RD2,J=1,NREFL)
      END
 
************************************************************************
 
      SUBROUTINE OUT20(DEG,XINT,YFIT,BG,PEAK,NPTS,STEP,NREFL,TITLE)
*     RECORD THE RESULTS OF RIETVELD ANALYSIS
      REAL DEG(*),XINT(*),YFIT(*),BG(*),PEAK(*)
      INTEGER ISTART(100),IEND(100)
      CHARACTER TITLE*80
*SUN
*     CHARACTER*50 FILE20
      DATA RD,RD2/0.01745329,57.29578/
 
      NBLOCK=1
      ISTART(1)=1
    1 CONTINUE
      DO 15 J=ISTART(NBLOCK)+1,NPTS
         IF (ABS(DEG(J)-DEG(J-1)-STEP) .GT. 0.01*RD) THEN
            IEND(NBLOCK)=J-1
            NBLOCK=NBLOCK+1
            ISTART(NBLOCK)=J
            GO TO 1
         END IF
   15 CONTINUE
      IEND(NBLOCK)=NPTS
*     UNIT 20 --- RECORD LENGTH = 140
*FACOM, HITAC, AND ACOS
*     OPEN(UNIT=20)
*SUN
*     CALL GETARG(3,FILE20)
*SUN
*     OPEN(UNIT=20,FILE=FILE20)
*VAX
      OPEN(UNIT=20,STATUS='UNKNOWN')
      WRITE(20,'(A)') TITLE
C     NREFL: NUMBER OF REFLECTIONS; NBLOCK: NUMBER OF BLOCKS IN WHICH
C     THE STEP WIDTH IS FIXED
      WRITE(20,'(I6,F10.3,I6)') NBLOCK,STEP*RD2,NREFL
      DO 30 I=1,NBLOCK
C        WRITE NUMBER OF DATA IN EACH BLOCK
         WRITE(20,'(I5,F10.3)') IEND(I)-ISTART(I)+1,
     &   DEG(ISTART(I))*RD2
         WRITE(20,'(7(2I7,I6:))') (NINT(XINT(J)),NINT(YFIT(J)),
     &   NINT(BG(J)),J=ISTART(I),IEND(I))
   30 CONTINUE
      WRITE(20,'(17F8.3)') (PEAK(J)*RD2,J=1,NREFL)
      CLOSE(UNIT=20)
      END
 
************************************************************************
 
      SUBROUTINE APRNTD(A,NTERMS)
C     PRINTED VALUES OF ARRAY A
      PARAMETER (NT=220,NPH=2,NAP=36)
      DIMENSION A(*)
      COMMON /CC/ APR(NT)
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      DATA RD,RD2/0.0174532925,57.29578/
      LP(J)=KPHB(L)+J
      Z(J1,J2,J3)=ACOS(G(J1,L)/(APR(LP(J2))*APR(LP(J3))))*RD2
C
C     ZERO-POINT SHIFT
      APR(1)=A(1)*RD2
      DO 10 J=2,NTERMS
         APR(J)=A(J)
   10 CONTINUE
      DO 20 L=1,NPHASE
C        RAD ==> DEG (SCALE FACTOR)
         APR(LP(NSFX))=A(LP(NSFX))*RD2
C        RAD**2 ==> DEG**2 (U,V,W)
         APR(LP(1))=A(LP(1))/RD**2
         APR(LP(2))=A(LP(2))/RD**2
         APR(LP(3))=A(LP(3))/RD**2
C        RAD**(-2) ==> DEG**(-2) (ASYMMETRY PARAMETER)
         APR(LP(4))=A(LP(4))*RD**2
C        LATTICE CONSTANTS
         APR(LP(NAX))=SQRT(G(1,L))
         APR(LP(NBX))=SQRT(G(2,L))
         APR(LP(NCX))=SQRT(G(3,L))
         APR(LP(NALPX))=Z(4,NBX,NCX)
         APR(LP(NBETX))=Z(5,NCX,NAX)
         APR(LP(NGAMX))=Z(6,NAX,NBX)
         IF (LMAG(L) .EQ. 1) THEN
C           RAD ==> DEG (PHI)
            IF (LAUEG(L) .EQ. 5) THEN
               APR(KPHE(L)-2)=A(KPHE(L)-2)*RD2
               APR(KPHE(L)-1)=A(KPHE(L)-1)*RD2
            END IF
            APR(KPHE(L))=A(KPHE(L))*RD2
         END IF
   20 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE CCTENS(A)
C     CONVERT THE DIRECT UNIT CELL CONSTANTS INTO THE METRIC TENSORS
      PARAMETER (NPH=2,NAP=36)
      DIMENSION A(*)
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      DATA RD/0.0174532925/
      LP(J)=KPHB(L)+J
      P(J)=A(LP(J))
 
      DO 10 L=1,NPHASE
         G(1,L)=P(NAX)**2
         G(2,L)=P(NBX)**2
         G(3,L)=P(NCX)**2
         G(4,L)=P(NBX)*P(NCX)*COS(P(NALPX)*RD)
         G(5,L)=P(NCX)*P(NAX)*COS(P(NBETX)*RD)
         G(6,L)=P(NAX)*P(NBX)*COS(P(NGAMX)*RD)
         CALL INVERS(GG(1,L),G(1,L),DET)
         A(LP(NAX))=GG(1,L)
         A(LP(NBX))=GG(2,L)
         A(LP(NCX))=GG(3,L)
         A(LP(NALPX))=GG(4,L)
         A(LP(NBETX))=GG(5,L)
         A(LP(NGAMX))=GG(6,L)
   10 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE SYMOP(A)
C     EXAMINE WHETHER OR NOT EACH SYMMETRY OPERATION IS NECESSARY
      INTEGER R,RX,RY,RZ
      LOGICAL OVR
      PARAMETER (NB=2000,NS=48,NAP=36,NT=220,NPH=2)
      DIMENSION A(*),XYZ(3,NS)
      COMMON /EXC/ LSPSYM(NPH),NSSYM(14,NPH)
      COMMON /FLAG/ LFLAG(10)
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /HALF/ IFAC(NAP,NPH)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /RT/ TV(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      DELTA(I)=ABS(XYZ(I,L1)-XYZ(I,L2))-0.001
*     IF AN INVERTED POSITION OVERLAPS WITH ANOTHER EQUIVALENT POSITION,
*     OVR(I) BECOMES .TRUE.
*     SPECIAL CARE IS TAKEN FOR 1/2 BECAUSE 1/2 IS EQUIVALENT TO -1/2.
      OVR(I) = ABS(XYZ(I,L1)+XYZ(I,L2)) .LT. 0.001 .OR.
     &         (ABS(XYZ(I,L1)-0.5) .LT. 0.0001 .AND.
     &          ABS(XYZ(I,L2)-0.5) .LT. 0.0001)
 
      DO 70 L=1,NPHASE
         NCON=NSSYM(7,L)
C        IDSYM=0: THIS SYMMETRY OPERATION IS SKIPPED
C        IDSYM=1: THIS SYMMETRY OPERATION IS NOT SKIPPED
C        A(IX):   X
C        A(IX+1): Y
C        A(IX+2): Z
C        EACH COORDINATE, THAT IS, XYZ(1,JJ), XYZ(2,JJ), XYZ(3,JJ) ARE
C        NORMALIZED AS -1/2<XYZ<1/2
         IX=KPHB(L)+NG1X+1
         DO 60 J=1,NSITE(L)
            IFAC(J,L)=2
            DO 30 JJ=1,NSYM(L)
               IDSYM(JJ,J,L)=1
               IF (LFLAG(1) .EQ. 0) THEN
                  DO 20 K=1,3
                     XYZ(K,JJ)=R(K,1,JJ,L)*A(IX)+R(K,2,JJ,L)*A(IX+1)+
     &               R(K,3,JJ,L)*A(IX+2)+TV(K,JJ,L)
                     XYZ(K,JJ)=XNORM(XYZ(K,JJ))
   20             CONTINUE
               END IF
   30       CONTINUE
            IF (LFLAG(1) .EQ. 1) GO TO 60
C           WHEN TWO POINTS HAVE APPROXIMATELY THE SAME FRACTIONAL
C           COORDINATES, THE POINTS WITH HIGHER SYMMETRY # IS SKIPPED.
            DO 50 L1=1,NSYM(L)
               DO 40 L2=L1+1,NSYM(L)
                  IF(IDSYM(L2,J,L).EQ.0) GO TO 40
                  IF(DELTA(1).LT.0.0 .AND.
     &            DELTA(2).LT.0.0 .AND. DELTA(3).LT.0.0) THEN
                     IDSYM(L2,J,L)=0
                  ELSE IF (NCENTR(L) .EQ. 1 .AND. OVR(1) .AND.
     &            OVR(2) .AND. OVR(3)) THEN
                     IDSYM(L2,J,L)=0
                  ELSE IF(NCON .EQ. 0 .OR. NCON .EQ. 21) THEN
C                    DO NOTHING FOR THE PRIMITIVE LATTICE
                  ELSE
C                    COMPLEX LATTICE
                     IDSYM(L2,J,L)=ICOINC(XYZ(1,L1),XYZ(2,L1),XYZ(3,L1),
     &               XYZ(1,L2),XYZ(2,L2),XYZ(3,L2),NCON)
*                    CHECK WHETHER OR NOT INVERTED AND TRANSLATED
*                    POSITIONS OVERLAP WITH (X1,Y1,Z1)
                     IF (NCENTR(L) .EQ. 1 .AND. IDSYM(L2,J,L) .EQ. 1)
     &               THEN
                        IDSYM(L2,J,L)=ICOINC(XYZ(1,L1),XYZ(2,L1),
     &                  XYZ(3,L1),-XYZ(1,L2),-XYZ(2,L2),-XYZ(3,L2),NCON)
                     END IF
                  ENDIF
   40          CONTINUE
   50       CONTINUE
            IF(NCENTR(L).EQ.1) CALL INVRSN(XYZ,L,J,NCON)
C           NEXT SITES
            IX=IX+NPSITE(J,L)
   60    CONTINUE
   70 CONTINUE
      END
 
************************************************************************
 
      INTEGER FUNCTION ICOINC(X1,Y1,Z1,X2,Y2,Z2,NCON)
C     ICOINC=0: TRANSLATED POSITIONS OVERLAPS WITH (X1,Y1,Z1)
      ICOINC=1
      IF(NCON .EQ. 13) THEN
C        BODY CENTERED
         ICOINC=IOVRLP(X1,Y1,Z1,X2+0.5,Y2+0.5,Z2+0.5)
      ELSEIF(NCON .EQ. 4) THEN
C        A-FACE CENTERED
         ICOINC=IOVRLP(X1,Y1,Z1,X2,Y2+0.5,Z2+0.5)
      ELSEIF(NCON .EQ. 5) THEN
C        B-FACE CENTERED
         ICOINC=IOVRLP(X1,Y1,Z1,X2+0.5,Y2,Z2+0.5)
      ELSEIF(NCON .EQ. 6) THEN
C        C-FACE CENTERED
         ICOINC=IOVRLP(X1,Y1,Z1,X2+0.5,Y2+0.5,Z2)
      ELSEIF(NCON .EQ. 7) THEN
C        ALL-FACE CENTERED
         ICOINC=IOVRLP(X1,Y1,Z1,X2,Y2+0.5,Z2+0.5)
         IF(ICOINC.EQ.0) RETURN
         ICOINC=IOVRLP(X1,Y1,Z1,X2+0.5,Y2,Z2+0.5)
         IF(ICOINC.EQ.0) RETURN
         ICOINC=IOVRLP(X1,Y1,Z1,X2+0.5,Y2+0.5,Z2)
      ELSEIF(NCON .EQ. 14 .OR. NCON .EQ. 15) THEN
C        RHOMBOHEDRALLY CENTERED (HEXAGONAL AXES)
         ICOINC=IOVRLP(X1,Y1,Z1,X2+0.6666667,Y2+0.3333333,Z2+0.3333333)
         IF(ICOINC.EQ.0) RETURN
         ICOINC=IOVRLP(X1,Y1,Z1,X2+0.3333333,Y2+0.6666667,Z2+0.6666667)
      ENDIF
      END
 
************************************************************************
 
      INTEGER FUNCTION IOVRLP(X1,Y1,Z1,X,Y,Z)
C     IOVRLP=0: THE TWO POINTS OVERLAP WITH EACH OTHER
      DELTA(A,B)=ABS(A-XNORM(B))-0.001
      IOVRLP=1
      IF(DELTA(X1,X).LT.0.0 .AND. DELTA(Y1,Y).LT.0.0 .AND.
     &  DELTA(Z1,Z).LT.0.0) IOVRLP=0
      END
 
************************************************************************
 
      FUNCTION XNORM(X)
      IF (X .LT. -0.49999) THEN
         XNORM=X+1.0
      ELSE IF (X .GT. 0.50001) THEN
         XNORM=X-1.0
      ELSE
         XNORM=X
      ENDIF
      END
 
************************************************************************
 
      SUBROUTINE INVRSN(XYZ,L,J,NCON)
C     EXAMINE WHETHER OR NOT (-X,-Y,-Z) COINCIDES WITH OTHER EQUIVALENT
C     POSITIONS
      INTEGER R,RX,RY,RZ
      PARAMETER (NB=2000,NS=48,NAP=36,NT=220,NPH=2)
      DIMENSION XYZ(3,NS)
      COMMON /HALF/ IFAC(NAP,NPH)
      COMMON /RT/ TV(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      DELTA(I)=ABS(XYZ(I,K)-XNORM(-XYZ(I,1)))-0.001
 
C     IFAC=1: THE OCCUPATION FACTOR IS MULTIPLIED BY 0.5 IF X,Y,Z
C             COINCIDES WITH -X,-Y,-Z.
      DO 20 K=1,NSYM(L)
         IF(IDSYM(K,J,L).EQ.0) GO TO 20
         IF(DELTA(1).LT.0.0 .AND.
     &   DELTA(2).LT.0.0 .AND. DELTA(3).LT.0.0) THEN
            IFAC(J,L)=1
            RETURN
         ELSE IF (NCON .EQ. 0 .OR. NCON .EQ. 21) THEN
C           DO NOTHING FOR THE PRIMITIVE LATTICE
         ELSE IF (ICOINC(XYZ(1,1),XYZ(2,1),XYZ(3,1),-XYZ(1,K),-XYZ(2,K),
     &   -XYZ(3,K),NCON).EQ.0) THEN
            IFAC(J,L)=1
            RETURN
         ENDIF
   20 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE SMINT(X,Y,DEG,XINT,NBG,NSTEP)
      PARAMETER (NP=5050)
      COMMON /C/BG(NP)
      DIMENSION X(*),Y(*),DEG(*),XINT(*)
C     SMOOTHING USING FIVE POINTS
      DO 20 J=1,NBG
         DO 10 MM=3,NSTEP-2
            IF(ABS(DEG(MM)-X(J)).LT.2.0D-5) GO TO 1
   10    CONTINUE
         WRITE(6,100) X(J)
  100    FORMAT(//11X,'A BAD TWO-THETA VALUE WAS SPECIFIED: ',F6.2)
         CALL JOBEND(' ')
    1    Y(J)=(-3.0*XINT(MM-2)+12.0*XINT(MM-1)+17.0*XINT(MM)+
     &   12.0*XINT(MM+1)-3.0*XINT(MM+2))/35.0
   20 CONTINUE
C     LAGRANGE INTERPOLATION
      DO 30 J=1,NSTEP
         NFP=4
         CALL INTERP(X,Y,NBG,NFP,DEG(J),G)
         BG(J)=G
   30 CONTINUE
      END
 
************************************************************************
 
      CHARACTER*4 FUNCTION INTCHR(J)
C     CONVERT AN INTEGER INTO FOUR CHARACTERS
      INTCHR='    '
      IF(J.GE.0 .AND. J.LE.9) THEN
         WRITE(INTCHR,'(A,I1,A)') '(',J,')'
      ELSEIF(J.GE.10) THEN
         WRITE(INTCHR,'(A,I2,A)') '(',J,')'
      ENDIF
      END
 
************************************************************************
 
      SUBROUTINE INTERP(X,Y,NPTS,NTERMS,XIN,YOUT)
C     INTERPOLATE BETWEEN DATA POINTS TO EVALUATE A FUNCTION
      DIMENSION X(*),Y(*),DELTA(10),A(10)
   11 DO 19 I=1,NPTS
      IF(XIN-X(I)) 13,17,19
   13 I1=I-NTERMS/2
      IF(I1) 15,15,21
   15 I1=1
      GO TO 21
   17 YOUT=Y(I)
   18 GO TO 61
   19 CONTINUE
      I1=NPTS-NTERMS+1
   21 I2=I1+NTERMS-1
      IF(NPTS-I2) 23,31,31
   23 I2=NPTS
      I1=I2-NTERMS+1
   25 IF(I1) 26,26,31
   26 I1=1
   27 NTERMS=I2-I1+1
   31 DENOM=X(I1+1)-X(I1)
      DELTAX=(XIN-X(I1))/DENOM
      DO 35 I=1,NTERMS
      IX=I1+I-1
   35 DELTA(I)=(X(IX)-X(I1))/DENOM
   40 A(1)=Y(I1)
   41 DO 50 K=2,NTERMS
      PROD=1.0
      SUM=0.0
      IMAX=K-1
      IXMAX=I1+IMAX
      DO 49 I=1,IMAX
      J=K-I
      PROD=PROD*(DELTA(K)-DELTA(J))
   49 SUM=SUM-A(J)/PROD
   50 A(K)=SUM+Y(IXMAX)/PROD
   51 SUM=A(1)
      DO 57 J=2,NTERMS
      PROD=1.
      IMAX=J-1
      DO 56 I=1,IMAX
   56 PROD=PROD*(DELTAX-DELTA(I))
   57 SUM=SUM+A(J)*PROD
   60 YOUT=SUM
   61 END
 
************************************************************************
 
      SUBROUTINE JOBEND(MESSAG)
      CHARACTER*(*) MESSAG
*ACOS
*     REAL NSEC*8
*ACOS
*     INTEGER SEC
*VAX
      INTEGER LIB\STAT_TIMER
*VAX
      DIMENSION IT(2)
*VAX
      COMMON /VAX/ IVX
C     PRINT OUT THE CPU TIME AND END OF JOB MESSAGE
      IF(MESSAG(1:1).NE.' ') WRITE(6,'(//11X,A)') MESSAG
      WRITE(6,'(///7X,A//)') '*** END OF JOB ***'
*FACOM, ACOS, AND SUN
*     CALL CLOCK(NSEC)
*ACOS
*     SEC=NSEC
*HITAC
*     CALL CLOCK(SEC,4)
*VAX
      I=LIB\STAT_TIMER(2,IT,IVX)
*VAX
      NSEC=INT(0.01*(FLOAT(IT(1))+0.5))
*VAX
      I=LIB\STAT_TIMER(5,K,IVX)
*FACOM AND SUN
*     WRITE(6,200) NSEC/60, MOD(NSEC,60)
*HITAC
*     WRITE(6,200) INT(SEC/60.0),NINT(MOD(SEC,60.0))
*ACOS
*     WRITE(6,200) SEC/60, MOD(SEC,60)
*VAX
      WRITE(6,200) NSEC/60, MOD(NSEC,60),K
*FACOM, HITAC AND ACOS
* 200 FORMAT(' ',10X,'CPU TIME =',I4,' MIN  ',I2,' S'//
*VAX
  200 FORMAT(' ',10X,'CPU TIME =',I4,' MIN  ',I2,' S',10X,
*VAX
     &  'PAGE FAULTS =',I9//
*SUN
CORRECTED ON 1988.8.2
* 200 FORMAT(' ',10X,'ELAPSED TIME =',I4,' MIN  ',I2,' S'//
     &' ',10X,'--- RIETAN.  COPYLEFT (C) 1989, BY F. IZUMI.  ALL RIGHTS
     &RELEASED. ---')
      STOP
      END
 
************************************************************************
 
      SUBROUTINE TENSOR(A)
C     STORE THE METRIC TENSORS
      PARAMETER (NB=2000,NPH=2,NAP=36)
      DIMENSION A(*)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      P(J)=A(KPHB(L)+J)
 
      DO 10 L=1,NPHASE
         GG(1,L)=P(NAX)
         GG(2,L)=P(NBX)
         GG(3,L)=P(NCX)
         GG(4,L)=P(NALPX)
         GG(5,L)=P(NBETX)
         GG(6,L)=P(NGAMX)
         CALL INVERS(G(1,L),GG(1,L),DET)
   10 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE PRUCC
C     PRINT OUT RECIPROCAL UNIT CELL CONSTANTS
      CHARACTER PARNAM*48,PHNAME*25
      PARAMETER (NT=220,NPH=2,NAP=36)
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      Z2(J,X,Y)=ACOS(GG(J,L)/(X*Y))*57.29578
 
      DO 10 L=1,NPHASE
         CALL INVERS(GG(1,L),G(1,L),DET)
         A2=SQRT(GG(1,L))
         B2=SQRT(GG(2,L))
         C2=SQRT(GG(3,L))
         ALPHA2=Z2(4,B2,C2)
         BETA2=Z2(5,C2,A2)
         GAMMA2=Z2(6,B2,A2)
         WRITE(6,100) PHNAME(L),A2,B2,C2,ALPHA2,BETA2,GAMMA2,
     &   1.0/SQRT(DET),SQRT(DET)
   10 CONTINUE
  100 FORMAT(//11X,'DIMENSIONS OF THE RECIPROCAL CELL FOR '
     &,A/13X,'A* =',F8.5,5X,'B* =',F8.5,5X,'C* =',F8.5,5X,
     &'ALPHA* = ',F7.3,5X,'BETA* = ',F7.3,5X,'GAMMA* = ',F7.3/
     &13X,'V* =',1P,G14.6,5X,'(V =',1P,G14.6,')')
      END
 
************************************************************************
 
      SUBROUTINE DECODE(COORD,SYM,N,L)
C     CONVERT THREE CHARACTER DATA INTO A ROTATION MATRIX (R) AND
C     A TRANSLATION VECTOR (T)
      PARAMETER (NB=2000,NS=48,NAP=36,NPH=2)
      INTEGER R,RX,RY,RZ
      CHARACTER CHAR*1,SYM(3,NS)*10,COORD*20,XYZ(3)*1
      DIMENSION IX(3)
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      DATA (XYZ(J),J=1,3)/'X','Y','Z'/
 
      I1=INDEX(COORD,',')
      DO 10 J=I1+2,19
         READ(COORD(J:J),'(A1)') CHAR
         IF(CHAR.EQ.',') THEN
            I2=J
            GO TO 1
         ENDIF
   10 CONTINUE
    1 SYM(1,N)=COORD(1:I1-1)
      SYM(2,N)=COORD(I1+1:I2-1)
      SYM(3,N)=COORD(I2+1:20)
C
      DO 30 J=1,3
         T(J,N,L)=0.0
         DO 20 K=1,3
            R(J,K,N,L)=0
   20    CONTINUE
C
C        ROTATION MATRIX
         DO 25 JJ=1,3
            IX(JJ)=INDEX(SYM(J,N),XYZ(JJ))
            IF(IX(JJ).GT.0) THEN
               IF(IX(JJ).EQ.1) THEN
                  R(J,JJ,N,L)=1
               ELSE
                  IF(SYM(J,N)(IX(JJ)-1:IX(JJ)-1).EQ.'+') THEN
                     R(J,JJ,N,L)=1
                  ELSE
                     R(J,JJ,N,L)=-1
                  ENDIF
               ENDIF
            ENDIF
   25    CONTINUE
C
C        TRANSLATION VECTOR
         IT=INDEX(SYM(J,N),'/')
         IF(IT.GT.0) THEN
            READ(SYM(J,N)(IT-1:IT-1),'(I1)') N1
            READ(SYM(J,N)(IT+1:IT+1),'(I1)') N2
            T(J,N,L)=FLOAT(N1)/FLOAT(N2)
            IF(IT.NE.2 .AND. SYM(J,N)(IT-2:IT-2).EQ.'-')
     &      T(J,N,L)=-T(J,N,L)
         ENDIF
   30 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE CONDIR(NTERMS,NSTEP,A,DEG,XINT,YFIT,YPEAK)
C     NONLINEAR LEAST-SQUARES FITTING BY POWELL'S CONJUGATE DIRECTION
C     METHOD
      CHARACTER PARNAM*48,PHNAME*25
      PARAMETER (NT=220,NCS=50,NR=65,NPH=2)
      DIMENSION A(*),DEG(*),XINT(*),YFIT(*),YPEAK(*),B(NT)
      COMMON /CNSTR/ C1(NCS),C2(10,NCS),IN(10,NCS),NCNPAR(NCS),
     &  NACNS(NCS),NCNSTR
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /NUML/ NUPDT
      COMMON /ONE/ Y(NR),S(NR),FX,FY
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /POW/ MITER,STEP,ACC
      COMMON /PRLV/ NPRINT
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /RLS/ NRANGE
      COMMON /THREE/ N,NFUNCT,NDRV,ITER,INDIC,IPRINT
      COMMON /TWO/ DIRECT(NR,NR),BEFORE(NR),FIRST(NR)
      WRITE(6,100)
  100 FORMAT(///7X,'*** NONLINEAR LEAST-SQUARES FITTING BY THE CONJUGATE
     & DIRECTION METHOD ***'/)
      WRITE(6,130) MITER,STEP,ACC
  130 FORMAT(/11X,'MITER =',I2,5X,'STEP = ',F5.3,5X,'ACC = ',1P,E9.3)
      IF(NC.NE.0) WRITE(6,150) NC,TK
  150 FORMAT(11X,'NC =',I3,5X,'T(0) =',1P,G13.6/)
      LCOUNT=0
      DO 10 J=1,NTERMS
         IF(ID(J).EQ.1 .AND. FIRST(IR(J)).NE.0.0) THEN
            IF(LCOUNT.EQ.0) THEN
               WRITE(6,'(/11X,A)') 'STEP(S) SPECIFIED BY USER'
               LCOUNT=1
            ENDIF
            WRITE(6,'(13X,A,I3,A,F7.4)') 'STEP(',J,') =',FIRST(IR(J))
         ENDIF
   10 CONTINUE
      CALL PACK(A,B,NTERMS)
      N=NRFN
      NFUNCT=0
      NDRV=0
      INDIC=2
      IPRINT=NPRINT
      CALL MINI(YFIT,B,XINT,DEG,YPEAK,NTERMS,NSTEP,A)
      CALL UNPACK(A,B,NTERMS)
      CALL UPDATE(YPEAK,A,IDPOS,1)
      END
 
************************************************************************
 
      SUBROUTINE MARGAU(NCYCL,NTERMS,NSTEP,NPTS,A,DEG,XINT,YFIT,YPEAK,
     &  SIGMAA)
C     NONLINEAR LEAST-SQUARES FITTING BY THE GAUSS-NEWTON METHOD OR
C     THE MODIFIED MARQUARDT METHOD
      CHARACTER PARNAM*48,PHNAME*25,INTCHR*4,CHAR4*4
      DOUBLE PRECISION G
      PARAMETER (NA=7,NB=2000,NT=220,NR=65,NPH=2,NAP=36,NOD=NR*(NR+1)/2)
      DIMENSION A(*),DEG(*),XINT(*),SIGMAA(NT),YFIT(*),YPEAK(*),
     &  AMIN(NT),ASAVE(NT),DELTA(NT)
      COMMON /A/ IH(NB),IK(NB),IL(NB),L12(NB),NOPH(NB)
      COMMON /B/ U(NB),NREFL
      COMMON /CC/ APR(NT)
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /G/ I
      COMMON /NONLIN/ NLESQ,NAUTO,IDCYCL,NCHNG,NPAR(10),IPAR(NR,10)
      COMMON /NUML/ NUPDT
      COMMON /OLD/ AOLD(NT),AOUT(NT)
      COMMON /ORDER/ IPOINT(NB)
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PRLV/ NPRINT
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /RLS/ NRANGE
      COMMON /S/ F(NA,NB),NATOM
      COMMON /TWO/ G(NOD),AD(NR)
      COMMON /WL/ NBEAM,XLMD,XLMDH,XLMD2H,R12
      DATA DELTA/NT*0.0/
 
      IF(IDCYCL.EQ.0) THEN
         WRITE(6,100)
      ELSEIF(NLESQ.EQ.2) THEN
         WRITE(6,110)
      ELSEIF(NLESQ.EQ.3) THEN
         WRITE(6,120)
      ENDIF
  100 FORMAT(1H1/7X,'*** R FACTORS AND STANDARD DEVIATIONS OF PARAMETERS
     & ***'//)
  110 FORMAT(///7X,'*** NONLINEAR LEAST-SQUARES FITTING BY MARQUARDT''S
     &METHOD ***'//)
  120 FORMAT(///7X,'*** NONLINEAR LEAST-SQUARES FITTING BY THE GAUSS-NEW
     &TON METHOD ***'//)
      IF(IDCYCL.EQ.1) THEN
         WRITE(6,'(11X,A,I2,5X,A,I3,5X,A,1P,E9.3,5X,A,I2)')
     &   'NAUTO =',NAUTO,'NCYCL =',NCYCL,'CONV = ',CONV,'NCONV =',NCONV
         IF(NC.NE.0) WRITE(6,135) NC,TK,FINC
  135    FORMAT(11X,'NC =',I3,5X,'T(0) =',1P,G13.6,5X,'FINC =',G13.6)
         IF(NAUTO.NE.0) THEN
            WRITE(6,137)
            DO 10 JJ=1,NCHNG
               WRITE(6,138) JJ,(IPAR(J,JJ),J=1,NPAR(JJ))
   10       CONTINUE
         ENDIF
C        AMIN: ARRAY STORING PARAMETERS WHICH GIVE THE LOWEST VALUE OF
C              CHISQR
         DO 15 J=1,NTERMS
            AMIN(J)=A(J)
   15    CONTINUE
      ENDIF
  137 FORMAT(//11X,'NUMBERS FOR VARIABLE PARAMETERS IN PREPARATORY CYCLE
     &S')
  138 FORMAT(' ',12X,'CYCLE #',I2,':',20I4,:,/' ',22X,20I4)
C
C        LTK: FLAG TO INDICATE THE ALTERATION OF THE PENALTY PARAMETER
C         IT: COUNTER FOR THE ALTERATION OF THE PENALTY PARAMETER
C        LDM: FLAG TO INDICATE THAT THE DAMPING FACTOR OR MARQUARDT
C             PARAMETER HAS REACHED THE LIMIT VALUE
C      IFAIL: NUMBER OF FAILURE IN THE GAUSS-NEWTON METHOD
C     FLAMDA: MARQUARDT PARAMETER
C       DAMP: DAMPING FACTOR
C      ICONV: INCREASED BY 1 IF RELDEC <= CONV
      LTK=0
      IT=0
      LDM=0
      IFAIL=0
      FLAMDA=0.0
      DAMP=1.0
      ICONV=0
C
C     IREFUC: COUNTER TO INDICATE THE NUMBER OF CYCLES IN WHICH LATTICE
C             PARAMETERS ARE REFINED
      IREFUC=0
      DO 60 ICYCLE=1,NCYCL
         IF(NAUTO.NE.0 .AND. ICYCLE.LE.NCHNG+1)
     &   CALL REFPAR(ICYCLE,NTERMS)
C        SAVE THE CURRENT VALUES OF ARRAY A (USED IN SUBROUTINE CHKCNV)
         DO 30 J=1,NTERMS
            ASAVE(J)=A(J)
   30    CONTINUE
C
         IF(LTK.EQ.1) THEN
            SUMP1=FACTOR*SUMPEN
            CHISQ1=CHISQR-SUMPEN+SUMP1
            CSMIN=CHISQ1
C           RESET LTK
            LTK=0
         ELSEIF(ICYCLE.EQ.1) THEN
            CHISQ1=AOFFN(DEG,XINT,YFIT,NPTS,NSTEP,YPEAK,A,0,IDPOS)
            CHISQR=CHISQ1
            SUMP1=SUMPEN
            CSMIN=CHISQ1
            FLAMDC=0.0
         ELSE
            CHISQ1=CHISQR
            SUMP1=SUMPEN
         ENDIF
C
         CALL REFMG(ID,IREFUC)
         IF(NBEAM.NE.0 .AND. IREFUC.NE.0 .AND. MOD(IREFUC,4).EQ.0) THEN
            DO 38 I=1,NREFL
               IF(L12(I).EQ.0) THEN
                  CALL ASF
               ELSE
                  DO 37 JJ=1,NATOM
                     F(JJ,I)=F(JJ,L12(I))
   37             CONTINUE
               ENDIF
   38       CONTINUE
         ENDIF
         CALL CURFIT(DEG,XINT,NSTEP,NPTS,NTERMS,A,AMIN,
     &   FLAMDA,FLAMDC,FLAMDP,DAMP,IFAIL,YFIT,CHISQ1,CHISQR,CSMIN,
     &   YPEAK,ICYCLE,LDM,NFNEV)
         IF(LDM.EQ.1) GO TO 4
         IF(IDCYCL.EQ.1) THEN
            IF(ICYCLE.EQ.1) THEN
               WRITE(6,'(//11X,A)')
     &         'CALCULATION USING INITIAL PARAMETERS'
               IF(NC.GT.0) THEN
                  CHAR4=INTCHR(IT)
                  WRITE(6,140) CHISQ1,CHISQ1-SUMP1,SUMP1,CHAR4,TK
  140             FORMAT(' ',10X,'AOF =',1P,G13.6,5X,'OF =',
     &            1P,G13.6,5X,'PF =',1P,G13.6,5X,'T',A4,' =',G13.6)
               ELSE
                  WRITE(6,'(11X,A,1P,G13.6)') 'OF =',CHISQ1
               ENDIF
            ENDIF
            WRITE(6,'(//11X,A,I2)') 'CYCLE #',ICYCLE
            IF(NC.EQ.0) THEN
               WRITE(6,'(11X,A,I5,5X,A,1P,G13.6)')
     &         'NPTS =',NPTS,'OF =',CHISQR
            ELSE
               CHAR4=INTCHR(IT)
               WRITE(6,150) NPTS,CHISQR,CHISQR-SUMPEN,SUMPEN,CHAR4,TK
  150          FORMAT(11X,'NPTS =',I6,5X,'AOF =',1P,G13.6,5X,'OF =',
     &         G13.6,5X,'PF =',G13.6,5X,'T',A4,' =',G13.6)
            ENDIF
            IF(NPRINT.NE.0) THEN
               IF(NLESQ.EQ.2) THEN
                  WRITE(6,'(11X,A,I2,5X,A,1P,G9.3)')
     &            'NFNEV =',NFNEV,'LAMBDA = ',FLAMDP
               ELSE
                  WRITE(6,'(11X,A,F7.4,5X,A,I2)') 'DAMP =',DAMP,
     &            'NFNEV =',NFNEV
               ENDIF
            ENDIF
         ENDIF
         IF (NPRINT .GE. 1 .OR. IDCYCL .EQ. 0) THEN
CORRECTED ON 1989.3.18
            CALL APRNTD(A,NTERMS)
            IF (IDCYCL .EQ. 0) THEN
               CALL RFACTR(A,DEG,YPEAK,YFIT,XINT,NPTS,1)
               CALL STDEV(APR,SIGMAA,NTERMS,NPTS,CHISQR-SUMPEN)
CORRECTED ON 1989.4.5
CCCCC          IF (NLESQ .EQ. 1 .OR. NCYCL .EQ. 0) THEN
               IF (NLESQ .EQ. 1 .OR. NCYCL .EQ. 0 .OR. NPRINT .EQ. 0)
     &         THEN
CORRECTION END
                  WRITE(6,'(/12X,A,8X,A,12X,A)') 'NO.','A','SIGMA'
               ELSE
                  WRITE(6,'(/12X,A,8X,A,12X,A,6X,A)') 'NO.','A','SIGMA',
     &            'DELTA.A/SIGMA'
               END IF
            ELSE
               CALL RFACTR(A,DEG,YPEAK,YFIT,XINT,NPTS,0)
               WRITE(6,'(/12X,A)') 'NO.    A(OLD)    +   DELTA.A   '//
     &         '=  A(REFINED)    ID'
            END IF
CORRECTION END
C
            DO 50 JJ=1,NTERMS
               IF (IDCYCL .EQ. 0) THEN
CORRECTED ON 1989.4.5
CCCCC             IF (NLESQ .EQ. 1 .OR. NCYCL .EQ. 0) THEN
                  IF (NLESQ .EQ. 1 .OR. NCYCL .EQ. 0 .OR. NPRINT .EQ. 0)
     &            THEN
CORRECTION END
                     IF (ID(JJ) .EQ. 1) THEN
                        WRITE(6,200) JJ,APR(JJ),SIGMAA(JJ),PARNAM(JJ)
                     ELSE
                        WRITE(6,210) JJ,APR(JJ),PARNAM(JJ)
                     ENDIF
                  ELSE
                     IF (ID(JJ) .EQ. 1) THEN
                        WRITE(6,205) JJ,APR(JJ),SIGMAA(JJ),
     &                  ABS(DELTA(JJ))/SIGMAA(JJ),PARNAM(JJ)
                     ELSE
                        WRITE(6,215) JJ,APR(JJ),PARNAM(JJ)
                     END IF
                  END IF
               ELSE
                  IF (ID(JJ) .NE. 0 .OR. LATVAR(JJ) .EQ. 1) THEN
                     DELTA(JJ)=APR(JJ)-AOUT(JJ)
                  ELSE
                     DELTA(JJ)=0.0
                  ENDIF
C                 AOUT: THE VALUES OF ARRAY A IN THE PREVIOUS CYCLE
                  WRITE(6,220) JJ,AOUT(JJ),DELTA(JJ),APR(JJ),
     &            ID(JJ),PARNAM(JJ)
                  AOUT(JJ)=APR(JJ)
               ENDIF
   50       CONTINUE
         ENDIF
         IF(IDCYCL.EQ.0 .AND. NPRINT.GE.1) THEN
            CALL TENSOR(A)
            CALL PRUCC
         ENDIF
C
    4    IF (IDCYCL .EQ. 1 .AND. ICYCLE .GT. NCHNG+1) THEN
            CALL CHKCNV(IDCONV,A,ASAVE,CHISQ1,CHISQR,ICONV,NTERMS)
         END IF
         IF((NC.EQ.0 .OR. SUMP1.EQ.0.0 .OR. IFAIL.GE.2) .AND.
     &   (LDM.EQ.1 .OR. IDCONV.EQ.1)) THEN
            DO 52 J=1,NTERMS
               A(J)=AMIN(J)
   52       CONTINUE
            GO TO 6
         ELSEIF((NAUTO.NE.0 .AND. ICYCLE.LE.NCHNG) .OR. (IDCYCL.EQ.1
     &   .AND. SUMPEN.GT.0.0 .AND. (LDM.EQ.1 .OR. IDCONV.EQ.1))) THEN
            IF(LDM.EQ.1) THEN
               DO 55 JJ=1,NTERMS
                  A(JJ)=AMIN(JJ)
   55          CONTINUE
               LDM=0
            ENDIF
C           RESET THE MARQUARDT PARAMETER, DAMPING FACTOR, COUNTER OF
C           FAILURE
            FLAMDA=0.0
            DAMP=1.0
            IFAIL=0
            IF(NAUTO.NE.0 .AND. ICYCLE.LE.NCHNG) GO TO 60
C           INCREASE THE PENALTY PARAMETER
            IF(SUMPEN.GT.0.2*CHISQR) THEN
               FACTOR=MIN(FINC,1.5)
               IF(ICYCLE.EQ.1 .OR. FACTOR*SUMPEN.GT.0.8*CHISQR) THEN
                  WRITE(6,250)
                  GO TO 6
               ENDIF
            ELSE
               FACTOR=MIN(FINC,0.25*CHISQR/SUMPEN)
            ENDIF
            TK=FACTOR*TK
            IT=IT+1
            IF (TK .GT. 10E25) THEN
               WRITE(6,250)
               GO TO 6
            ENDIF
            LTK=1
         ENDIF
   60 CONTINUE
  200 FORMAT(' ',10X,I3,2X,2(1P,G13.6,2X),3X,A)
  205 FORMAT(' ',10X,I3,2X,3(1P,G13.6,2X),3X,A)
  210 FORMAT(' ',10X,I3,2X,1P,G13.6,20X,A)
CORRECTED ON 1989.1.7               50X
  215 FORMAT(' ',10X,I3,2X,1P,G13.6,35X,A)
  220 FORMAT(' ',10X,I3,2X,1P,3(G13.6,1X),I4,3X,A)
  250 FORMAT(//11X,'TOO LARGE PENALTY TERM.  STOP REFINING.')
    6 END
 
************************************************************************
 
      INTEGER FUNCTION LATVAR(JJ)
C     EXAMINE WHETHER OR NOT AT LEAST ONE OF THE LATTICE PARAMETERS
C     HAS BEEN REFINED
      PARAMETER (NPH=2,NT=220,NAP=36)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
 
      DO 50 L=1,NPHASE
         IF (JJ .GE. KPHB(L)+NAX .AND. JJ .LE. KPHB(L)+NGAMX) THEN
            DO 10 J=KPHB(L)+NAX,KPHB(L)+NGAMX
               IF (ID(J) .EQ. 1) THEN
                  LATVAR=1
                  RETURN
               END IF
   10       CONTINUE
         END IF
   50 CONTINUE
      LATVAR=0
      END
 
************************************************************************
 
      SUBROUTINE STDEV(APR,SIGMAA,NTERMS,NPTS,CHISQR)
C     CALCULATE STANDARD DEVIATIONS OF REFINABLE PARAMETERS
      PARAMETER (NB=2000,NT=220,NPH=2,NR=65,NAP=36,NOD=NR*(NR+1)/2)
      DOUBLE PRECISION G
      DIMENSION APR(*),SIGMAA(*)
      COMMON /B/ U(NB),NREFL
CORRECTED ON 1988.12.16
      COMMON /ERMAT/ SI2
CORRECTION END
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /TWO/ G(NOD),AD(NR)
      DATA RD/0.0174532925/
      LP(J)=KPHB(L)+J
      P(J)=APR(LP(J))
      LD(J)=ID(LP(J))
      R(J)=SIGMAA(LP(J))
C
      DO 10 J=1,NTERMS
         IF(ID(J).EQ.1) THEN
C           DIAGONAL ELEMENT OF THE INVERSE OF THE MAXTIX OF THE
C           NORMAL EQUATION
            SIGMAA(J)=G(IR(J)*(IR(J)+1)/2)
         ELSE
            SIGMAA(J)=0.0
         ENDIF
   10 CONTINUE
C
C     ADJUST RIETVELD E.S.D. TO PROVIDE COMPARABILITY WITH INTEGRATED
C     INTENSITY REFINEMENT
C     CF. H. G. SCOTT, J. APPL. CRYSTALLOGR., 16 159 (1983)
C     NPP: NUMBER OF PARAMETERS DESCRIBING THE PROFILE
C     NPC: NUMBER OF CRYSTAL STRUCTURE PARAMETERS
      SP2=CHISQR/(NPTS-NRFN)
      NPP=0
      DO 20 J=1,7
         IF(ID(J).EQ.1) THEN
            SIGMAA(J)=SQRT(SIGMAA(J)*SP2)
            NPP=NPP+1
         ENDIF
   20 CONTINUE
      IF(ID(1).EQ.1) SIGMAA(1)=SIGMAA(1)/RD
      DO 30 L=1,NPHASE
         DO 25 J=LP(NSFX),LP(NGAMX)
            IF(ID(J).EQ.1) THEN
               SIGMAA(J)=SQRT(SIGMAA(J)*SP2)
               NPP=NPP+1
            ENDIF
   25    CONTINUE
   30 CONTINUE
 
*     THE STANDARD DEVIATIONS OF STRUCTURE PARAMETERS ARE CALCULATED
*     ACCORDING TO THE PROCEDURE OF SCOTT (1983).
      NPC=NRFN-NPP
      SI2=1.0+(CHISQR-NPTS+NPP)/(NREFL-NPC)
CORRECTED ON 1989.3.17
      IF (SI2 .LT. 0.0) THEN
         WRITE(6,'(//11X,A/11X,A/11X,A//)')
     &   'THE SUM OF SQUARED RESIDUALS IS EXTRAORDINARILY SMALL.',
     &   'BACKGROUND IS TOO HIGH AND/OR OBSERVED INTENSITIES ARE TOO '//
     &   'LOW.','THE STANDARD DEVIATIONS OF STRUCTURAL PARAMETERS ARE '
     &   //'CALCULATED ACCORDING TO THE CONVENTIONAL METHOD.'
      END IF
      DO 50 L=1,NPHASE
         DO 45 J=LP(NOTX),KPHE(L)
            IF (ID(J) .EQ. 1 .AND. SI2 .GE. 0.0) THEN
               SIGMAA(J)=SQRT(SIGMAA(J)*SI2)
            ELSE IF (ID(J) .EQ. 1 .AND. SI2 .LT. 0.0) THEN
               SIGMAA(J)=SQRT(SIGMAA(J)*SP2)
            END IF
   45    CONTINUE
CORRECTION END
         IF (LMAG(L) .EQ. 1) THEN
            IF (LAUEG(L) .EQ. 5) THEN
               DO 47 J=KPHE(L)-2,KPHE(L)
                  IF (ID(J) .EQ. 1) SIGMAA(J)=SIGMAA(J)/RD
   47          CONTINUE
            ELSE
               IF (ID(KPHE(L)) .EQ. 1) SIGMAA(KPHE(L))=
     &         SIGMAA(KPHE(L))/RD
            END IF
         END IF
   50 CONTINUE
C
      DO 90 L=1,NPHASE
CORRECTED ON 1988.11.8
         CALL CPSIG(L,LAUEG,SIGMAA,KPHB)
CORRECTION END
C        COMPUTE STANDARD DEVIATIONS OF THE DIRECT UNIT CELL DIMENSIONS
         A=P(NAX)
         B=P(NBX)
         C=P(NCX)
         ALPHA=P(NALPX)*RD
         BETA=P(NBETX)*RD
         GAMMA=P(NGAMX)*RD
         S1=R(NAX)**2
         S2=R(NBX)**2
         S3=R(NCX)**2
         S4=R(NALPX)**2
         S5=R(NBETX)**2
         S6=R(NGAMX)**2
C        PROPAGATION OF THE ERROR
C        CF. C. H. KELSEY, MINERAL. MAG., 33, 809 (1964)
C        AND EQ. (5.3-82) IN T. SAKURAI, "XRAY-ANALYSIS OF CRYSTAL
C        CRYSTAL STRUCTURES," P. 233.
C
         IF(LD(NAX).EQ.1)
     &   SIGMAA(LP(NAX))=(0.5*A**3)**2*S1+(0.5*A*B**2*COS(GAMMA)
     &   **2)**2*S2+(0.5*A*C**2*COS(BETA)**2)**2*S3+(A*B*C*COS(BETA)
     &   *COS(GAMMA))**2*S4+(A**2*C*COS(BETA))**2*S5+(A**2*B*COS(GAMMA))
     &   **2*S6
         IF(LD(NBX).EQ.1)
     &   SIGMAA(LP(NBX))=(0.5*A**2*B*COS(GAMMA)**2)**2*S1+(0.5*B**3
     &   )**2*S2+(0.5*B*C**2*COS(ALPHA)**2)**2*S3+(B**2*C*COS(ALPHA)
     &   )**2*S4+(A*B*C*COS(ALPHA)*COS(GAMMA))**2*S5+(A*B**2*COS(GAMMA))
     &   **2*S6
         IF(LD(NCX).EQ.1)
     &   SIGMAA(LP(NCX))=(0.5*A**2*C*COS(BETA)**2)**2*S1+(0.5*B**2
     &   *C*COS(ALPHA)**2)**2*S2+(0.5*C**3)**2*S3+(B*C**2*COS(ALPHA)
     &   )**2*S4+(A*C**2*COS(BETA))**2*S5+(A*B*C*COS(ALPHA)*COS(BETA))**
     &   2*S6
         IF(LD(NALPX).EQ.1)
     &   SIGMAA(LP(NALPX))=(A**2*(2.0*COS(BETA)*COS(GAMMA)-COS(ALPHA)*
     &   (COS(BETA)**2+COS(GAMMA)**2))/(2.0*SIN(ALPHA)))**2*S1+
     &   (0.25*B**2*SIN(2.0*ALPHA))**2*S2+(0.25*C**2*SIN(2.0
     &   *ALPHA))**2*S3+(B*C*SIN(ALPHA))**2*S4+(A*C*SIN(ALPHA)
     &   *COS(GAMMA))**2*S5+(A*B*SIN(ALPHA)*COS(BETA))**2*S6
         IF(LD(NBETX).EQ.1)
     &   SIGMAA(LP(NBETX))=(0.25*A**2*SIN(2.0*BETA))**2*S1+(B**2*(2.0
     &   *COS(ALPHA)*COS(GAMMA)-COS(BETA)*(COS(ALPHA)**2+COS(GAMMA)
     &   **2))/(2.0*SIN(BETA)))**2*S2+(0.25*C**2*SIN(2.0*BETA))**2
     &   *S3+(B*C*SIN(BETA)*COS(GAMMA))**2*S4+(A*C*SIN(BETA))**2*S5+
     &   (A*B*SIN(BETA)*COS(ALPHA))**2*S6
         IF(LD(NGAMX).EQ.1)
     &   SIGMAA(LP(NGAMX))=(0.25*A**2*SIN(2.0*GAMMA))**2*S1+(0.25
     &   *B**2*SIN(2.0*BETA))**2*S2+(C**2*(2.0*COS(ALPHA)*COS(BETA)-
     &   COS(GAMMA)*(COS(ALPHA)**2+COS(BETA)**2))/(2.0*SIN(GAMMA))
     &   )**2*S3+(B*C*SIN(GAMMA)*COS(BETA))**2*S4+(A*C*SIN(GAMMA)
     &   *COS(ALPHA))**2*S5+(A*B*SIN(GAMMA))**2*S6
         DO 70 J=NAX,NCX
            IF(LD(J).EQ.1) SIGMAA(LP(J))=SQRT(SIGMAA(LP(J)))
   70    CONTINUE
C
*        SCALE FACTOR
         IF(LD(NSFX).EQ.1) SIGMAA(LP(NSFX))=SIGMAA(LP(NSFX))/RD
C        RAD**2 ==> DEG**2
         DO 75 J=1,3
            IF(LD(J).EQ.1) SIGMAA(LP(J))=SIGMAA(LP(J))/RD**2
   75    CONTINUE
C        RAD**(-2) ==> DEG**(-2)
         IF(LD(4).EQ.1) SIGMAA(LP(4))=SIGMAA(LP(4))*RD**2
C        RAD ==> DEG
         DO 80 J=NALPX,NGAMX
            IF(LD(J).EQ.1) SIGMAA(LP(J))=SQRT(SIGMAA(LP(J)))/RD
   80    CONTINUE
CORRECTED ON 1988.11.8
         CALL CPSIG(L,LAUEG,SIGMAA,KPHB)
CORRECTION END
   90 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE CPSIG(L,LAUEG,SIGMAA,KPHB)
*     COPY STANDARD DEVIAIONS OF LATTICE PARAMETERS OR ELEMENTS OF
*     THE METRIC TENSOR TO CONSTRAINED PARAMETERS
      INTEGER L,LAUEG(*),KPHB(*)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      REAL SIGMAA(*)
      LP(J)=KPHB(L)+J
      R(J)=SIGMAA(LP(J))
 
      IF(LAUEG(L).EQ.6 .OR. LAUEG(L).EQ.7 .OR. LAUEG(L).EQ.9 .OR.
     &LAUEG(L).EQ.11 .OR. LAUEG(L).EQ.12 .OR. LAUEG(L).EQ.13) THEN
         SIGMAA(LP(NBX))=R(NAX)
      ELSEIF(LAUEG(L).EQ.8 .OR. LAUEG(L).EQ.10) THEN
         SIGMAA(LP(NBX))=R(NAX)
         SIGMAA(LP(NCX))=R(NAX)
         SIGMAA(LP(NBETX))=R(NALPX)
         SIGMAA(LP(NGAMX))=R(NALPX)
      ELSEIF(LAUEG(L).GE.14) THEN
         SIGMAA(LP(NBX))=R(NAX)
         SIGMAA(LP(NCX))=R(NAX)
      END IF
      END
 
************************************************************************
 
      SUBROUTINE REFPOW(A,NTERMS)
C     EXAMINE WHETHER OR NOT A GROUP OF PARAMETERS ARE REFINED IN THE
C     CONJUGATE DIRECTION METHOD
      PARAMETER (NPH=2,NT=220,NAP=36)
      DIMENSION A(*)
      COMMON /OLD/ AOLD(NT),AOUT(NT)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /UCC/ IDPEAK(NPH),IDSF(NPH),IDPRF(NPH),IDZP
      LP(J)=KPHB(L)+J
 
      DO 40 L=1,NPHASE
         IDPEAK(L)=0
         IDSF(L)=0
         IDPRF(L)=0
         DO 10 J=LP(NAX),LP(NGAMX)
            IF(ID(J).EQ.1 .AND. A(J).NE.AOLD(J)) THEN
               IDPEAK(L)=1
               IDPRF(L)=1
               IDSF(L)=1
               GO TO 40
            ENDIF
   10    CONTINUE
         IF(ID(1).EQ.1 .AND. A(1).NE.AOLD(1)) THEN
            IDPRF(L)=1
         ELSE
            DO 20 J=LP(1),LP(3)
               IF(ID(J) .NE. 0 .AND. A(J) .NE. AOLD(J)) THEN
                  IDPRF(L)=1
                  GO TO 2
               ENDIF
   20       CONTINUE
         ENDIF
    2    DO 30 J=LP(NOTX),KPHE(L)
            IF(ID(J).EQ.1 .AND. A(J).NE.AOLD(J)) THEN
               IDSF(L)=1
               GO TO 40
            ENDIF
   30    CONTINUE
   40 CONTINUE
      A1=AOLD(1)
      DO 45 J=1,NTERMS
         AOLD(J)=A(J)
   45 CONTINUE
      IDZP=0
      IF(ID(1).NE.1) RETURN
      IF(A(1).EQ.A1) RETURN
      DO 50 L=1,NPHASE
         IF(IDPEAK(L).EQ.1) RETURN
   50 CONTINUE
      IDZP=1
      END
 
************************************************************************
 
      SUBROUTINE REFMG(ID,IREFUC)
C     EXAMINE WHETHER OR NOT A GROUP OF PARAMETERS ARE REFINED IN THE
C     GAUSS-NEWTON OR MARQUARDT METHOD
      PARAMETER (NPH=2,NAP=36)
      DIMENSION ID(*)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /UCC/ IDPEAK(NPH),IDSF(NPH),IDPRF(NPH),IDZP
      LP(J)=KPHB(L)+J
 
      IFIRST=IREFUC
      DO 40 L=1,NPHASE
         IDPEAK(L)=0
         IDSF(L)=0
         IDPRF(L)=0
         DO 10 J=LP(NAX),LP(NGAMX)
            IF(ID(J).EQ.1) THEN
               IDPEAK(L)=1
               IDPRF(L)=1
               IDSF(L)=1
               IF(IFIRST.EQ.IREFUC) IREFUC=IREFUC+1
               GO TO 40
            ENDIF
   10    CONTINUE
         IF(ID(1).EQ.1) THEN
            IDPRF(L)=1
         ELSE
            DO 20 J=LP(1),LP(3)
               IF(ID(J) .NE. 0) THEN
                  IDPRF(L)=1
                  GO TO 2
               ENDIF
   20       CONTINUE
         ENDIF
    2    DO 30 J=LP(NOTX),KPHE(L)
            IF(ID(J).EQ.1) THEN
               IDSF(L)=1
               GO TO 40
            ENDIF
   30    CONTINUE
   40 CONTINUE
      IDZP=0
      IF(ID(1).EQ.0) RETURN
      DO 50 L=1,NPHASE
         IF(IDPEAK(L).EQ.1) RETURN
   50 CONTINUE
      IDZP=1
      END
 
************************************************************************
 
      SUBROUTINE REFPAR(LL,NTERMS)
C     DETERMINE WHICH PARAMERTERS TO REFINE IN EACH CYCLE
      PARAMETER(NT=220,NR=65)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /NONLIN/ NLESQ,NAUTO,IDCYCL,NCHNG,NPAR(10),IPAR(NR,10)
      COMMON /RLS/ NRANGE
      NRFN=0
      IF(LL.EQ.NCHNG+1) THEN
         DO 10 J=1,NTERMS
            ID(J)=IDSAVE(J)
            IF(ID(J).EQ.1) THEN
               NRFN=NRFN+1
               IR(J)=NRFN
            ENDIF
   10    CONTINUE
      ELSE
         DO 20 J=1,NTERMS
            IF(IDSAVE(J).EQ.-1) THEN
               ID(J)=-1
            ELSEIF(IDSAVE(J).EQ.0) THEN
               ID(J)=0
            ELSE
               DO 15 JJ=1,NPAR(LL)
                  IF(J.EQ.IPAR(JJ,LL)) THEN
                     ID(J)=1
                     NRFN=NRFN+1
                     IR(J)=NRFN
                     GO TO 20
                  ENDIF
   15          CONTINUE
               ID(J)=0
            ENDIF
   20    CONTINUE
      ENDIF
      END
 
************************************************************************
 
      SUBROUTINE CHKCNV(IDCONV,A,ASAVE,CHISQ1,CHISQR,ICONV,NTERMS)
C     IDCONV=1: CONVERGED; IDCONV=0: NOT CONVERGED
      PARAMETER (NT=220,EPSR=1.0E-3)
      DIMENSION A(*),ASAVE(*)
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      IDCONV=0
      RELDEC=(CHISQ1-CHISQR)/CHISQR
      IF(RELDEC.LT.0.0 .OR. RELDEC.GT.CONV) THEN
         ICONV=0
         RETURN
      ELSE
         ICONV=ICONV+1
      ENDIF
      IF(ICONV.LT.NCONV) RETURN
      DX=0.0
      X=0.0
      DO 10 J=1,NTERMS
         IF(ID(J).EQ.1) THEN
            IF(ABS(A(J)-ASAVE(J)).GT.DX) DX=ABS(A(J)-ASAVE(J))
            IF(ABS(ASAVE(J)).GT.X) X=ABS(ASAVE(J))
         ENDIF
   10 CONTINUE
      IF(DX.LE.MAX(1.0,X)*EPSR) IDCONV=1
      END
 
************************************************************************
 
      SUBROUTINE IGNORE(NSTEP,NPTS,DEG,XINT)
C     IGNORE ALL DATA POINTS FARTHER THAN PC*FWHM FROM THE NEAREST
C     BRAGG PEAK
      PARAMETER (NB=2000,NP=5050)
      DIMENSION DEG(*),XINT(*)
      COMMON /B/ U(NB),NREFL
      COMMON /C/ BG(NP)
      COMMON /I/ RDEG(2,NB)
      COMMON /ORDER/ IPOINT(NB)
      COMMON /RLS/ NRANGE
C     NPTS: NUMBER OF INTENSITY DATA USED TO REFINE PARAMETERS
      IF(NRANGE.EQ.2) THEN
         NPTS=NSTEP
         RETURN
      ENDIF
C
C     PACK ARRAYS DEG, XINT, AND BG
      NPTS=1
      ISTART=1
      DO 30 K=1,NSTEP
         DO 20 J=ISTART,NREFL
            I=IPOINT(J)
            IF(DEG(K).GT.RDEG(2,I)) THEN
               ISTART=I+1
            ELSE
               IF(DEG(K).GE.RDEG(1,I)) THEN
                  DEG(NPTS)=DEG(K)
                  XINT(NPTS)=XINT(K)
                  BG(NPTS)=BG(K)
                  NPTS=NPTS+1
               ENDIF
               GO TO 30
            ENDIF
   20    CONTINUE
   30 CONTINUE
      NPTS=NPTS-1
      END
 
************************************************************************
 
      SUBROUTINE FWHM(A,IP,IDPOS)
C     NUMERICAL EVALUATION OF THE FWHM OF THE MODIFIED PSEUDO-VOIGT
C     FUNCTION
      PARAMETER (NPH=2,NAP=36)
      DIMENSION A(*)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
C     TOL: RELATIVE CONVERGENCE TOLERANCE
      DATA C1,C2,ITMAX,TOL/2.772589,4.0,25,0.0001/
      DATA X/0.5/
C     X: DELTA.2THETA.IK/FWHM(GAUSS)
      P(J)=A(KPHB(IP)+J)
      F(X)=P(5)*EXP(-C1*X*X)+(1.0-P(5))/(1.0+C2*P(6)*P(6)*X*X)-0.5
      DF(X)=-2.0*C1*P(5)*X*EXP(-C1*X*X)+2.0*C2*P(6)*P(6)*X*
     &  (P(5)-1.0)/(1.0+C2*P(6)*P(6)*X*X)**2
      IDPOS=1
      IF(P(5).LT.0.0 .OR. P(5).GT.1.0) THEN
CORRECTED ON 1989.3.11
         WRITE(6,'(//11X,A,I3,A)') 'PARAMETER #',KPHB(IP)+5,
     &   ' OUT OF RANGE.  GAMMA AND DELTA MAY HAVE TO BE FIXED.'
CORRECTION END
         IDPOS=-1
         RETURN
      ENDIF
C
C     FIND A ROOT OF AN EQUATION USING THE NEWTON-RAPHSON METHOD
C     X=0.5
      XOLD=X
      FX=F(X)
      DFX=DF(X)
      DO 10 I=1,ITMAX
         X=X-FX/DFX
         FX=F(X)
         DFX=DF(X)
         IF(ABS((X-XOLD)/X).LE.TOL) GO TO 1
         XOLD=X
   10 CONTINUE
    1 PC2(IP)=2.0*ABS(X)*PC
      END
 
************************************************************************
 
      SUBROUTINE INVERS(G1,G2,DET)
C     G2 === INVERT ===> G1
      DIMENSION G1(6),G2(6)
      A11=G2(1)
      A22=G2(2)
      A33=G2(3)
      A23=G2(4)
      A13=G2(5)
      A12=G2(6)
      DET=(A11*A33-A13*A13)*A22+(A12*A13-A11*A23)*A23+
     &    (A13*A23-A12*A33)*A12
      G1(1)=(A22*A33-A23*A23)/DET
      G1(2)=(A11*A33-A13*A13)/DET
      G1(3)=(A11*A22-A12*A12)/DET
      G1(4)=(A12*A13-A11*A23)/DET
      G1(5)=(A12*A23-A13*A22)/DET
      G1(6)=(A13*A23-A12*A33)/DET
      END
 
************************************************************************
 
      SUBROUTINE GENREF(AA,NSPGR)
C     GENERATE REFLECTIONS WHICH ARE LOCATED BETWEEN DEG1 AND DEG2
      PARAMETER (NS=48,NA=7,NB=2000,NPH=2,NAP=36)
      INTEGER SECSET,ISET(44),H,R,RX,RY,RZ
      REAL A,B,C,ALPHA,BETA,GAMMA,LAMBDA,ANGMAX,ANGMIN,X,Y,Z
      CHARACTER SPGR*10
      DIMENSION NSPGR(NPH),AA(*)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /B/ U(NB),NREFL
      COMMON /G/ I
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /INPT/ A,B,C,ALPHA,BETA,GAMMA,LAMBDA,ANGMAX,ANGMIN
      COMMON /IS/ ISET,SECSET
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /ORDER/ IPOINT(NB)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PHNO/ IP
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      COMMON /S/ F(NA,NB),NATOM
      COMMON /SG/ SPGR(NPH)
      COMMON /SGN/ NSG,NSC
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      COMMON /WL/ NBEAM,XLMD,XLMDH,XLMD2H,R12
      Z(J,X,Y)=ACOS(G(J,IP)/(X*Y))*57.29578
      NREFL=0
      DO 10 IP=1,NPHASE
         A=SQRT(G(1,IP))
         B=SQRT(G(2,IP))
         C=SQRT(G(3,IP))
         ALPHA=Z(4,B,C)
         BETA=Z(5,C,A)
         GAMMA=Z(6,B,A)
         NSG=ABS(NSPGR(IP))
*        IF(NSPGR(IP).LT.0) THEN
*           SECSET=2
*        ELSE
*           SECSET=0
*        ENDIF
         SECSET=0
         IF (LAUEG(IP) .EQ. 3) THEN
*           MONOCLINIC, B-AXIS UNIQUE
            SECSET=2
         ELSE IF (LAUEG(IP) .EQ. 9 .OR. LAUEG(IP) .EQ. 11) THEN
*          TRIGONAL(R LATTICE), HEXAGONAL SETTING
           IF (SPGR(IP)(1:1) .EQ. 'R') SECSET=2
         END IF
         CALL KDRREF
   10 CONTINUE
      IF(R12.GT.0.0 .AND. NREFL*2.GT.NB) CALL JOBEND
     &('NUMBER OF REFLECTIONS HAS REACHED THE MAXIMUM VALUE.')
      DO 15 I=1,NREFL
         L12(I)=0
         CALL BRANG(AA)
   15 CONTINUE
C     ARRAYS FOR ALPHA-2 PEAKS ARE INSERTED
      IF(R12.GT.0.0) THEN
         DO 35 J=NREFL,1,-1
            DO 17 I=2*J-1,2*J
               H(I)=H(J)
               K(I)=K(J)
               L(I)=L(J)
               NOPH(I)=NOPH(J)
               D(I)=D(J)
               RLV2(I)=RLV2(J)
               IF(MOD(I,2).EQ.0) THEN
                  U(I)=U(J)*R12
                  L12(I)=2
                  CALL FTHETA(AA)
               ELSE
                  U(I)=U(J)
                  L12(I)=0
                  PEAK(I)=PEAK(J)
                  TH(I)=TH(J)
                  TN1(I)=TN1(J)
                  FLP(I)=FLP(J)
               ENDIF
   17       CONTINUE
   35    CONTINUE
         NREFL=2*NREFL
      ENDIF
      CALL HEAP(PEAK,IPOINT,NREFL)
C     VARIOUS ARRAYS FOR REFLECTIONS ARE SORTED
      CALL ICOPY(H)
      CALL ICOPY(K)
      CALL ICOPY(L)
      CALL ICOPY(NOPH)
      CALL ICOPY(L12)
      CALL RCOPY(U)
      CALL RCOPY(D)
      CALL RCOPY(RLV2)
      CALL RCOPY(TH)
      CALL RCOPY(TN1)
      CALL RCOPY(FLP)
      DO 50 I=1,NREFL
         IPOINT(I)=I
         IF(L12(I).EQ.0) THEN
            CALL HRHT
            CALL ASF
         ELSE
            DO 40 J=I-1,1,-1
               IF(H(I).EQ.H(J) .AND. K(I).EQ.K(J) .AND. L(I).EQ.L(J)
     &         .AND. NOPH(I).EQ.NOPH(J)) THEN
C                 L12 FOR A K-ALPHA2 PEAK REPRESENTS THE NUMBER FOR
C                 THE CORRESPONDING K-ALPHA1 PEAK
                  L12(I)=J
                  DO 37 JJ=1,NSYM(NOPH(J))
                     RX(JJ,I)=RX(JJ,J)
                     RY(JJ,I)=RY(JJ,J)
                     RZ(JJ,I)=RZ(JJ,J)
                     HT(JJ,I)=HT(JJ,J)
   37             CONTINUE
                  DO 38 JJ=1,NATOM
                     F(JJ,I)=F(JJ,J)
   38             CONTINUE
                  GO TO 50
               ENDIF
   40       CONTINUE
         ENDIF
   50 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE HEAP(X,IPOINT,NX)
C     HEAP SORT
      DIMENSION X(*),IPOINT(*)
      KC=0
      KX=0
      KW=0
      DO 10 J=1,NX
      IPOINT(J)=J
   10 CONTINUE
      DO 400 NS=2,NX
      N=NS
      NW=N
      W=X(N)
      IW=IPOINT(N)
  200 CONTINUE
      ND=N
      N=N/2
      IF(N.EQ.0) GO TO 350
      KC=KC+1
      IF(W.LE.X(N)) GO TO 350
      KX=KX+1
      X(ND)=X(N)
      IPOINT(ND)=IPOINT(N)
      GO TO 200
  350 CONTINUE
      IF(NW.EQ.ND) GO TO 400
      KW=KW+1
      X(ND)=W
      IPOINT(ND)=IW
  400 CONTINUE
      DO 800 NS=NX,2,-1
      NW=NS
      KW=KW+2
      W=X(NS)
      IW=IPOINT(NS)
      X(NS)=X(1)
      IPOINT(NS)=IPOINT(1)
      N=1
  600 CONTINUE
      NH=N
      N=N*2
      IF(N.GE.NS) GO TO 750
      IF(N+1.GE.NS) GO TO 630
      KC=KC+1
      IF(X(N+1).GT.X(N)) N=N+1
  630 KC=KC+1
      IF(W.GT.X(N)) GO TO 750
      KX=KX+1
      X(NH)=X(N)
      IPOINT(NH)=IPOINT(N)
      GO TO 600
  750 CONTINUE
      IF(NW.EQ.NH) GO TO 800
      KW=KW+1
      X(NH)=W
      IPOINT(NH)=IW
  800 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE ICOPY(IX)
      DIMENSION IX(*)
      PARAMETER (NB=2000)
      COMMON /B/ U(NB),NREFL
      COMMON /BUFFER/ IBUF(NB)
      COMMON /ORDER/ IPOINT(NB)
      DO 10 I=1,NREFL
         IBUF(I)=IX(IPOINT(I))
   10 CONTINUE
      DO 20 I=1,NREFL
         IX(I)=IBUF(I)
   20 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE RCOPY(RX)
      DIMENSION RX(*)
      PARAMETER (NB=2000)
      COMMON /B/ U(NB),NREFL
      COMMON /BUFFER/ RBUF(NB)
      COMMON /ORDER/ IPOINT(NB)
      DO 10 I=1,NREFL
         RBUF(I)=RX(IPOINT(I))
   10 CONTINUE
      DO 20 I=1,NREFL
         RX(I)=RBUF(I)
   20 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE KDRREF
C     GENERATE UNIQUE REFLECTION SETS FOR ALL SPACE GROUPS
      PARAMETER (NB=2000,NGEN=2000,NPH=2)
      INTEGER SYMTAB(679),POINT(2,274),SYMCON(2,109),PTCON(2,48),
     &SCLASS(13),CHK(7),NSG,REFCON(14),NSYST,NTYPE,NSC,DEV,TOT,
     &NCO(32),IEX(32),NCOINC,IC,JND(NGEN),MULT,H,K,L,
     &HMAX,KMAX,LMAX,HMIN,KMIN,NOR,ICODE,IPUNCH,COITAB(5,14),SUB,
     &TEMREF(14),ISET(44),SECSET,REFREQ(14),RRT
      REAL*4 A,B,C,ALPHA,BETA,GAM,LAMBDA,ANGMIN,ANGMAX,DMIN,DMAX,
     &AA,BB,CC,CALPHA,CBETA,CGAMMA,DD(NGEN),
     &ANGLE,PATH,DELAY,TMIN,MIND,MINT,FACTOR
      CHARACTER*8 TITLE(10),CTITLE(2,28),RTITLE(2,14),SYSNAM(2,7)
      INTEGER*2 HH(NGEN),KK(NGEN),LL(NGEN)
      COMMON
     &/INPT/ A,B,C,ALPHA,BETA,GAM,LAMBDA,ANGMAX,ANGMIN
     &/PRT/ TITLE,CTITLE,RTITLE,SYSNAM
     &/SGN/ NSG,NSC
     &/CONDTN/ REFCON,NSYST
     &/TYP/ NTYPE
     &/TUF/ ANGLE,PATH,DELAY,TMIN,MIND
     &/CAL/ DMIN,DMAX,MINT,FACTOR
     &/ER/ TOT
     &/HEAD/ DEV,ICODE,IPUNCH
     &/TAB/ SYMTAB,POINT,SYMCON,PTCON,SCLASS,CHK
     &/COI/ NCO,IEX
     &/IDC/ NCOINC,MULT
     &/HKL/ H,K,L
     &/SORT/ DD,IC
     &/LP/ JND
     &/RR/ HH,KK,LL
     &/CIN/ AA,BB,CC,CALPHA,CBETA,CGAMMA
     &/GPAS/ HMAX,KMAX,LMAX,HMIN,KMIN
     &/CTAB/ COITAB
      COMMON
     &/CNOR/ NOR,SUB
     &/TMP/ TEMREF
     &/IS/ ISET,SECSET
     &/REQ/ REFREQ,RRT
      COMMON /EXC/ LSPSYM(NPH),NSSYM(14,NPH)
      COMMON /PHNO/ IP
*     IF (LSPSYM(IP) .LE. 1) THEN
*        NSC=0
*     ELSE
         NSC=1
*     END IF
      RRT=0
      DEV=2
      NOR=0
      SUB=0
      TOT=0
      CALL INPUT
      IF(TOT.EQ.1) CALL JOBEND(' ')
      CALL COND2
      CALL LIMITS
      CALL GENHKL
      DO 10 J=1,IC
         JND(J)=J
   10 CONTINUE
C     CALL EXCTES(DD,JND,IC)
      CALL OUTPUT(5)
      END
 
************************************************************************
 
      SUBROUTINE INPUT
      PARAMETER (NPH=2)
      INTEGER NSG,NSC,DEV,REFCON(14),NSYST,ICODE,IPUNCH,TOT,TEMREF(14),
     &SECSET,RRT,ISET(44),REFREQ(14)
      REAL*4 A,B,C,ALPHA,BETA,GAM,LAMBDA,ANGMAX,ANGMIN,
     &ANGLE,PATH,DELAY,TMIN,MIND
      CHARACTER*8 TITLE(10),CTITLE(2,28),RTITLE(2,14),SYSNAM(2,7)
      COMMON
     &/SGN/ NSG,NSC
     &/INPT/ A,B,C,ALPHA,BETA,GAM,LAMBDA,ANGMAX,ANGMIN
     &/HEAD/ DEV,ICODE,IPUNCH
     &/CONDTN/ REFCON,NSYST
     &/L/ DEG1,DEG2
     &/PRT/ TITLE,CTITLE,RTITLE,SYSNAM
     &/TOF/ ANGLE,PATH,DELAY,TMIN,MIND
     &/ER/ TOT
     &/TMP/ TEMREF
     &/IS/ ISET,SECSET
     &/REQ/ REFREQ,RRT
     &/WL/ NBEAM,XLMD,XLMDH,XLMD2H,R12
     &/EXC/ LSPSYM(NPH),NSSYM(14,NPH)
      COMMON /PHNO/ IP
C     CLEAR ARRAYS REFCON, TEMREF, AND REFREQ
      DO 200 I=1,14
         REFCON(I)=0
         TEMREF(I)=0
         REFREQ(I)=0
  200 CONTINUE
      IF(NSG.GE.1 .AND. NSG.LE.274) GO TO 2
      CALL ERROR(1)
      GO TO 10
    2 IF(NSC.EQ.0) GO TO 1
*     NSSYM HAS BEEN ASSIGNED VALUES REGARDLESS OF LSPSYM
*   2 IF(NSC.EQ.0) GO TO 12
      IF(NSC.EQ.1) GO TO 12
      IF(NSC.EQ.2) GO TO 9
      CALL ERROR(6)
      GO TO 10
   12 DO 1205 I=1,14
         REFCON(I)=NSSYM(I,IP)
 1205 CONTINUE
      DO 3 I=1,14
      IF(REFCON(I).GE.0 .AND. REFCON(I).LE.28) GO TO 3
      CALL ERROR(2)
      GO TO 10
    3 CONTINUE
      GO TO 1
    9 CONTINUE
      DO 11 I=1,14
      IF(TEMREF(I).GE.-1 .AND. TEMREF(I).LE.28) GO TO 11
      CALL ERROR(2)
      GO TO 10
   11 CONTINUE
    1 IF(RRT.EQ.0) GO TO 16
      IF(RRT.EQ.1) GO TO 17
      CALL ERROR(8)
      GO TO 10
   17 CONTINUE
   16 CONTINUE
      DEV=1
      IF(DEV.EQ.1) GO TO 7
      IF(DEV.EQ.2) GO TO 8
      CALL ERROR(3)
      GO TO 10
    8 CONTINUE
      GO TO 4
    7 LAMBDA=XLMD
    4 ICODE=1
      IPUNCH=0
      IF(ICODE.GE.1 .AND. ICODE.LE.3) GO TO 5
      CALL ERROR(4)
      GO TO 10
    5 IF(IPUNCH.GE.0 .AND. IPUNCH.LE.3) GO TO 6
      CALL ERROR(5)
      GO TO 10
    6 CONTINUE
      CALL OUTPUT(1)
      IF(SECSET.NE.2) GO TO 15
      DO 13 I=1,44
      IF(ISET(I).EQ.NSG) GO TO 14
   13 CONTINUE
      CALL ERROR(7)
      GO TO 10
   14 NSG=230+I
   15 CONTINUE
   10 END
 
************************************************************************
 
      SUBROUTINE COND2
      INTEGER SYMTAB(679),POINT(2,274),SYMCON(2,109),PTCON(2,48),
     &SCLASS(13),CHK(7),NSG,REFCON(14),NSYST,NTYPE,NSGC,CLASS,
     &COND(2,30),TEMP(7),SYMNUM,NSC,NCO(32),IEX(32),NCOINC,MULT,
     &TEMREF(14)
      COMMON
     &/TAB/ SYMTAB,POINT,SYMCON,PTCON,SCLASS,CHK
     &/SGN/ NSG,NSC
     &/CONDTN/ REFCON,NSYST
     &/TYP/ NTYPE
     &/COI/ NCO,IEX
     &/IDC/ NCOINC,MULT
     &/TMP/ TEMREF
      DO 1 I=1,13
      IF(NSG.LT.SCLASS(I)) GO TO 2
    1 CONTINUE
    2 CLASS=I-1
      NSGC=(NSG-SCLASS(I-1))+1
      NSGC=NSGC
      IF(NSC.EQ.1) GO TO 9
    5 DO 20 I=1,30
      DO 21 J=1,2
      COND(J,I)=0
   21 CONTINUE
   20 CONTINUE
      K=POINT(1,NSG)
      L=POINT(2,NSG)
      DO 6 I=1,L
      TEMP(I)=SYMTAB(K)
      K=K+1
    6 CONTINUE
      J=1
      DO 7 I=1,L
      SYMNUM=TEMP(I)
      MM=PTCON(1,SYMNUM)
      N=PTCON(2,SYMNUM)
      DO 8 II=1,N
      COND(1,J)=SYMCON(1,MM)
      COND(2,J)=SYMCON(2,MM)
      MM=MM+1
      J=J+1
    8 CONTINUE
    7 CONTINUE
      DO 16 I=1,14
      REFCON(I)=0
   16 CONTINUE
      DO 15 I=1,30
      IF(COND(2,I).EQ.0) GO TO 10
      REFCON(COND(2,I))=COND(1,I)
   15 CONTINUE
   10 IF(NSC.EQ.0) GO TO 9
    4 DO 3 I=1,14
      IF(TEMREF(I).EQ.-1) GO TO 3
      REFCON(I)=TEMREF(I)
    3 CONTINUE
    9 IF(CLASS.EQ.5) GO TO 105
      IF(CLASS.LE.7) GO TO 205
      IF(CLASS.GE.8 .AND. CLASS.LE.10) GO TO 305
      IF(CLASS.GE.11) GO TO 405
  105 DO 100 I=1,7
      IF(NSG.EQ.CHK(I)) GO TO 110
  100 CONTINUE
      NSYST=6
      GO TO 120
  110 NSYST=5
      GO TO 120
  205 NSYST=CLASS
      GO TO 120
  305 NSYST=CLASS-6
      GO TO 120
  405 NSYST=CLASS-5
  120 CONTINUE
      IF(NSYST.LE.4) GO TO 200
      IF(NSYST.EQ.5) GO TO 210
      IF(NSYST.GE.6) GO TO 220
  200 NTYPE=NSYST
      GO TO 240
  210 NTYPE=1
      GO TO 240
  220 NTYPE=NSYST-2
  240 CONTINUE
   17 CALL OUTPUT(2)
      DO 40 I=1,32
      IF(NSG.LE.NCO(I)) GO TO 41
   40 CONTINUE
   41 NCOINC=IEX(I)
      IF(NCOINC.EQ.0) GO TO 42
      CALL OUTPUT(4)
   42 CONTINUE
   18 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE ERROR(ERR)
      INTEGER ERR,TOT
      COMMON
     &/ER/ TOT
      TOT=1
      GO TO (1,2,3,4,5,6,7,8), ERR
      WRITE(6,100)
      GO TO 20
    1 WRITE(6,11)
      GO TO 20
    2 WRITE(6,12)
      GO TO 20
    3 WRITE(6,13)
      GO TO 20
    4 WRITE(6,14)
      GO TO 20
    5 WRITE(6,15)
      GO TO 20
    6 WRITE(6,16)
      GO TO 20
    7 WRITE(6,17)
      GO TO 20
    8 WRITE(6,18)
   11 FORMAT(//' ',10X,'ILLEGAL SPACE GROUP NO.')
   12 FORMAT(//' ',10X,'ILLEGAL CONDITIONS')
   13 FORMAT(//' ',10X,'ILLEGAL DATA TYPE')
   14 FORMAT(//' ',10X,'ILLEGAL NUCLEAR/MAGNETIC CODE')
   15 FORMAT(//' ',10X,'ILLEGAL OUTPUT CODE')
   16 FORMAT(//' ',10X,'ILLEGAL TEST FOR NON-STANDARD CONDITIONS')
   17 FORMAT(//' ',10X,'THERE IS NO ALTERNATIVE SETTING FOR THIS SPACE G
     &ROUP.'/' ',10X,'JOB ABANDONED.')
   18 FORMAT(//' ',10X,'ILLEGAL REFLECTION TYPE CONDITION')
  100 FORMAT(//' ',10X,'ERROR IN SYSTEM')
   20 END
 
************************************************************************
 
      SUBROUTINE LIMITS
      INTEGER NTYPE,HMAX,KMAX,LMAX,HMIN,KMIN,H,K,L,DEV,ICODE,IPUNCH
      REAL*4 A,B,C,ALPHA,BETA,GAM,LAMBDA,ANGMAX,ANGMIN,DMIN,DMAX,RAD,S,
     &VOL,AA,BB,CC,CALPHA,CBETA,CGAMMA,FACTOR,PATH,ANGLE,TMIN,DELAY,
     &MIND,MINT
      CHARACTER*8 TITLE(10),CTITLE(2,28),RTITLE(2,14),SYSNAM(2,7)
      COMMON
     &/INPT/ A,B,C,ALPHA,BETA,GAM,LAMBDA,ANGMAX,ANGMIN
     &/TYP/ NTYPE
     &/TOF/ ANGLE,PATH,DELAY,TMIN,MIND
     &/CAL/ DMIN,DMAX,MINT,FACTOR
     &/HEAD/ DEV,ICODE,IPUNCH
     &/PRT/ TITLE,CTITLE,RTITLE,SYSNAM
     &/HKL/ H,K,L
     &/CIN/ AA,BB,CC,CALPHA,CBETA,CGAMMA
     &/GPAS/ HMAX,KMAX,LMAX,HMIN,KMIN
      DATA RAD/0.0174532925/
      ALPHA=ALPHA*RAD
      BETA=BETA*RAD
      GAM=GAM*RAD
      S=(ALPHA+BETA+GAM)/2
      VOL=2*A*B*C*SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAM))
      AA=B*C*SIN(ALPHA)/VOL
      BB=C*A*SIN(BETA)/VOL
      CC=A*B*SIN(GAM)/VOL
      CALPHA=(COS(BETA)*COS(GAM)-COS(ALPHA))/(SIN(BETA)*SIN(GAM))
      CBETA=(COS(GAM)*COS(ALPHA)-COS(BETA))/(SIN(GAM)*SIN(ALPHA))
      CGAMMA=(COS(ALPHA)*COS(BETA)-COS(GAM))/(SIN(ALPHA)*SIN(BETA))
      IF(ABS(CALPHA).LT.0.001) CALPHA=0.
      IF(ABS(CBETA).LT.0.001) CBETA=0.
      IF(ABS(CGAMMA).LT.0.001) CGAMMA=0.
      IF(DEV.EQ.1) GO TO 1
      FACTOR=2*252.77*PATH*SIN(0.5*ANGLE*RAD)
      DMIN=(TMIN+DELAY)/FACTOR
      IF(DMIN.LT.MIND) DMIN=MIND
      MINT=DMIN*FACTOR-DELAY
      DMAX=1000
      GO TO 2
    1 DMIN=LAMBDA/(2.0*SIN(0.5*ANGMAX*RAD))
      DMAX=LAMBDA/(2.0*SIN(0.5*ANGMIN*RAD))
    2 CALL OUTPUT(3)
      HMAX=INT(A/DMIN)
      KMAX=INT(B/DMIN)
      LMAX=INT(C/DMIN)
      HMIN=0
      KMIN=0
      H=1
      K=0
      L=0
      IF(NTYPE-2) 5,6,10
    5 KMIN=-KMAX
    6 HMIN=-HMAX
   10 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE GENHKL
      PARAMETER (NB=2000,NGEN=2000)
      INTEGER IC,HMIN,MAXH,MINH,KMAX,KMIN,LMAX,NTYPE,REFCON(14),NSYST,
     &H,K,L,HMAX,IH,IK,IL,RT,NSG,NSC,REFREQ(14),RRT
      INTEGER*2 HH(NGEN),KK(NGEN),LL(NGEN)
      REAL*4 QMAX,DMIN,DMAX,AA,BB,CC,CALPHA,CBETA,CGAMMA,HA,HB,HC,ZAP,
     &AH,BK,CL,Q,D,DD(NGEN),MINT,FACTOR,MINM,MAXM
      COMMON
     &/SGN/ NSG,NSC
     &/CAL/ DMIN,DMAX,MINT,FACTOR
     &/TYP/ NTYPE
     &/CONDTN/ REFCON,NSYST
     &/HKL/ H,K,L
     &/CIN/ AA,BB,CC,CALPHA,CBETA,CGAMMA
     &/SORT/ DD,IC
     &/RR/ HH,KK,LL
     &/GPAS/ HMAX,KMAX,LMAX,HMIN,KMIN
     &/REQ/ REFREQ,RRT
      SAVE NTOTAL
      DATA NTOTAL/0/
 
      IC=1
  194 QMAX=1/DMIN
      HA=AA**2
      HB=2*AA*(K*BB*CGAMMA+L*CC*CBETA)
      HC=(K*BB)**2+(L*CC)**2+2*K*L*BB*CC*CALPHA-QMAX**2
      ZAP=(HB**2-4*HA*HC)
      IF(ZAP.LT.0.0) GO TO 116
 2750 MAXM=(-HB+SQRT(ZAP))/(2*HA)
      MINM=(-HB-SQRT(ZAP))/(2*HA)
      IF(MAXM.LT.0) MAXM=MAXM-1
      IF(MINM.GT.0) MINM=MINM+1
      MAXH=MAXM
      MINH=MINM
      IF(H.GT.MAXH) GO TO 117
 2950 IF(NTYPE.GT.2) GO TO 206
      IF(K.EQ.0 .AND. L.EQ.0) GO TO 206
  205 H=MINH
  206 CONTINUE
      IF(NSYST.NE.2) GO TO 208
      IF(NSG.GT.230) GO TO 207
      IF(K.EQ.0 .AND. H.LT.0) GO TO 122
      GO TO 208
  207 IF(L.EQ.0 .AND. H.LT.0) GO TO 122
  208 IF(NSYST.NE.7) GO TO 40
      IH=H
      IK=K
      IL=L
      H=IABS(IH)
      K=IABS(IK)
      L=IABS(IL)
 
*----------------- CHECK ALL THE SPECIAL SUBSETS --------------------
   40 DO 120 LOOP=1,14
      RT=LOOP
      IF (LOOP .EQ. 1 .AND. H .EQ. 0 .AND. K .EQ. 0) THEN
      ELSE IF (LOOP .EQ. 2 .AND. H .EQ. 0 .AND. L .EQ. 0) THEN
      ELSE IF (LOOP .EQ. 3 .AND. H .EQ. 0) THEN
      ELSE IF (LOOP .EQ. 4 .AND. K .EQ. 0 .AND. L .EQ. 0) THEN
      ELSE IF (LOOP .EQ. 5 .AND. K .EQ. 0) THEN
      ELSE IF (LOOP .EQ. 6 .AND. L .EQ. 0) THEN
      ELSE IF (LOOP .EQ. 7) THEN
      ELSE IF (LOOP .EQ. 8 .AND. H .EQ. 0 .AND. K .EQ. L) THEN
      ELSE IF (LOOP .EQ. 9 .AND. H .EQ. K .AND. L .EQ. 0) THEN
      ELSE IF (LOOP .EQ. 10 .AND. H .EQ. K) THEN
      ELSE IF (LOOP .EQ. 11 .AND. H .EQ. L .AND. K .EQ. 0) THEN
      ELSE IF (LOOP .EQ. 12 .AND. K .EQ. L) THEN
      ELSE IF (LOOP .EQ. 13 .AND. H .EQ. L) THEN
      ELSE IF (LOOP .EQ. 14 .AND. H .EQ. K .AND. K .EQ. L) THEN
      ELSE
         GO TO 120
      END IF
C     IF(H.EQ.K .AND. H.EQ.L) GO TO 41
C     RT=0
C     IF(L.NE.0) RT=RT+1
C     IF(K.NE.0) RT=RT+2
C     IF(H.NE.0) RT=RT+4
C     IF(H.EQ.K .AND. H.NE.0) RT=RT+3
C     IF(H.EQ.L .AND. H.NE.0) RT=RT+6
C     IF(L.EQ.K .AND. L.NE.0) RT=RT+5
C     GO TO 42
C  41 RT=14
   42 CONTINUE
      IF(NSYST.NE.7) GO TO 43
      H=IH
      K=IK
      L=IL
   43 CONTINUE
      J=RT
      IF(REFREQ(J).NE.0) GO TO 122
      J=7
   44 II=REFCON(J)
      IF(II.EQ.0) GO TO 51
   31 GO TO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,
     &23,24,25,26,27,28),  II
    1 IF(MOD(H,2).EQ.0) GO TO 51
      GO TO 122
    2 IF(MOD(K,2).EQ.0) GO TO 51
      GO TO 122
    3 IF(MOD(L,2).EQ.0) GO TO 51
      GO TO 122
    4 IF(MOD(K+L,2).EQ.0) GO TO 51
      GO TO 122
    5 IF(MOD(H+L,2).EQ.0) GO TO 51
      GO TO 122
    6 IF(MOD(H+K,2).EQ.0) GO TO 51
      GO TO 122
    7 IF(MOD(H,2).EQ.0 .AND. MOD(K,2).EQ.0 .AND. MOD(L,2).EQ.0 .OR.
     &MOD(H,2).NE.0 .AND. MOD(K,2).NE.0 .AND. MOD(L,2).NE.0) GO TO 51
      GO TO 122
    8 IF(MOD(K+L,4).EQ.0) GO TO 51
      GO TO 122
    9 IF(MOD(H+L,4).EQ.0) GO TO 51
      GO TO 122
   10 IF(MOD(H+K,4).EQ.0) GO TO 51
      GO TO 122
   11 IF(MOD(2*H+L,2).EQ.0) GO TO 51
      GO TO 122
   12 IF(MOD(2*H+L,4).EQ.0) GO TO 51
      GO TO 122
   13 IF(MOD(H+K+L,2).EQ.0) GO TO 51
      GO TO 122
   14 IF(MOD(-H+K+L,3).EQ.0) GO TO 51
      IF(NSYST.EQ.6) GO TO 51
      GO TO 122
   15 IF(MOD(H-K+L,3).EQ.0) GO TO 51
      IF(NSYST.EQ.6) GO TO 51
      GO TO 122
   16 IF(MOD(H,4).EQ.0) GO TO 51
      GO TO 122
   17 IF(MOD(K,4).EQ.0) GO TO 51
      GO TO 122
   18 IF(MOD(L,3).EQ.0) GO TO 51
      GO TO 122
   19 IF(MOD(L,4).EQ.0) GO TO 51
      GO TO 122
   20 IF(MOD(L,6).EQ.0) GO TO 51
      GO TO 122
   21 IF(IABS(H).GE.IABS(K) .AND. IABS(K).GE.IABS(L)) GO TO 29
      GO TO 122
   22 IF(MOD(2*H+K,2).EQ.0) GO TO 51
      GO TO 122
   23 IF(MOD(2*H+K,4).EQ.0) GO TO 51
      GO TO 122
   24 IF(MOD(H+2*K,2).EQ.0) GO TO 51
      GO TO 122
   25 IF(MOD(H+2*K,4).EQ.0) GO TO 51
      GO TO 122
   26 IF(MOD(H,2).EQ.0 .AND. MOD(K,2).EQ.0) GO TO 51
      GO TO 122
   27 IF(MOD(K,2).EQ.0 .AND. MOD(L,2).EQ.0) GO TO 51
      GO TO 122
   28 IF(MOD(H,2).EQ.0 .AND. MOD(L,2).EQ.0) GO TO 51
      GO TO 122
   29 IF(K+L.EQ.0 .AND. H.LT.0) GO TO 122
      IF(H+K.EQ.0 .AND. K.LT.0) GO TO 122
   51 IF(J.NE.7) GO TO 120
      IF(RT.EQ.7) GO TO 120
      J=RT
      GO TO 44
  120 CONTINUE
*-----------------------------------------------------------------------
  119 AH=AA*H
      BK=BB*K
      CL=CC*L
      Q=SQRT(AH*AH+BK*BK+CL*CL+2*AH*BK*CGAMMA+2*BK*CL*CALPHA
     &+2*CL*AH*CBETA)
      D=1./Q
      IF (D .GT. DMAX .OR. D .LT. DMIN) GO TO 122
  121 IF(NTOTAL+IC .GT. NGEN) THEN
         CALL JOBEND('THE VALUE OF NGEN (NB) IS TOO SMALL.')
      ENDIF
      HH(IC)=H
      KK(IC)=K
      LL(IC)=L
      DD(IC)=D
      IC=IC+1
 
  122 H=H+1
      IF(MAXH-H) 116,206,206
  116 K=K+1
      IF(KMAX-K) 117,114,114
  117 L=L+1
      IF(LMAX-L) 196,113,113
  113 IF(NTYPE.EQ.5) GO TO 108
  107 K=KMIN
  114 IF(NTYPE.EQ.4 .OR. NTYPE.EQ.5) GO TO 109
      H=HMIN
      GO TO 110
  108 K=L
  109 H=K
  110 CONTINUE
      GO TO 194
  196 CONTINUE
      IC=IC-1
      NTOTAL=NTOTAL+IC
      END
 
************************************************************************
 
      SUBROUTINE OUTPUT(IND)
      PARAMETER (NB=2000,NGEN=2000,NT=220,NPH=2)
      INTEGER NSG,REFCON(14),NSYST,IND,NSC,DEV,NCOINC,IC,
     &JND(NGEN),MULT,NOR,ICODE,IPUNCH,SUB,H,K,L,SECSET,ISET(44),
     &RRT,REFREQ(14)
      REAL*4 A,B,C,ALPHA,BETA,GAM,LAMBDA,ANGMAX,ANGMIN,DMIN,DMAX,
     &DD(NGEN),X,STHE,ATHE2,RAD,RH,RK,RL,ANGLE,PATH,MINT,TIME,
     &DELAY,TMIN,MIND,FACTOR,AA,BB,CC,CALPHA,CBETA,CGAMMA
      CHARACTER*8 TITLE(10),CTITLE(2,28),RTITLE(2,14),SYSNAM(2,7)
      CHARACTER PARNAM*48,PHNAME*25
      INTEGER*2 HH(NGEN),KK(NGEN),LL(NGEN)
      LOGICAL SET(28)
      COMMON
     &/A/ IH(NB),IK(NB),IL(NB),L12(NB),NOPH(NB)
     &/B/ U(NB),NREFL
     &/INPT/ A,B,C,ALPHA,BETA,GAM,LAMBDA,ANGMAX,ANGMIN
     &/EXC/ LSPSYM(NPH),NSSYM(14,NPH)
     &/SGN/ NSG,NSC
     &/CONDTN/ REFCON,NSYST
     &/TOF/ ANGLE,PATH,DELAY,TMIN,MIND
     &/CAL/ DMIN,DMAX,MINT,FACTOR
     &/PRT/ TITLE,CTITLE,RTITLE,SYSNAM
     &/HEAD/ DEV,ICODE,IPUNCH
      COMMON
     &/IDC/ NCOINC,MULT
     &/SORT/ DD,IC
     &/LP/ JND
     &/RR/ HH,KK,LL
     &/CNOR/ NOR,SUB
     &/CIN/ AA,BB,CC,CALPHA,CBETA,CGAMMA
     &/IS/ ISET,SECSET
     &/REFNO/ IREFL
     &/REQ/ REFREQ,RRT
     &/PRLV/ NPRINT
     &/PHNO/ IP
     &/PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /CONHKL/ NHKL(NPH),ICH(5,3,7,NPH),NCON(7,NPH),NLINE(NPH)
      DATA RAD/0.0174532925/
      IREFL=NREFL+1
      GO TO (21,22,23,28,29), IND
   21 CONTINUE
   56 CONTINUE
      GO TO 24
   22 IF(NPRINT.EQ.2) WRITE(6,3007) PHNAME(IP)
 3007 FORMAT(//11X,'SYMMETRY CONDITIONS IN ',A)
      DO 1 I=1,28
      SET(I)=.FALSE.
    1 CONTINUE
      IF(REFCON(7).EQ.0 .OR. REFCON(7).EQ.21) GO TO 53
      GO TO 52
   53 IF(NPRINT.EQ.2) WRITE(6,205)
      GO TO 55
   52 DO 50 J=1,28
      IF(REFCON(7).EQ.J) GO TO 51
      GO TO 50
   51 IF(NPRINT.EQ.2) WRITE(6,203) CTITLE(1,J),CTITLE(2,J)
   50 CONTINUE
      IF(NPRINT.EQ.2) WRITE(6,206) RTITLE(1,7),RTITLE(2,7)
   55 DO 100 J=1,28
      DO 200 I=1,14
      IF(I.EQ.7) GO TO 200
      IF(REFCON(I).EQ.J) GO TO 201
      GO TO 200
  201 IF(SET(J)) GO TO 202
      SET(J)=.TRUE.
      IF(NPRINT.EQ.2) THEN
         WRITE(6,203) CTITLE(1,J),CTITLE(2,J)
         WRITE(6,206) RTITLE(1,I),RTITLE(2,I)
      ENDIF
      GO TO 200
  202 IF(NPRINT.EQ.2) WRITE(6,204) RTITLE(1,I),RTITLE(2,I)
  200 CONTINUE
  100 CONTINUE
  203 FORMAT(' ',12X,2A8)
  204 FORMAT(' ',30X,2A8)
  205 FORMAT(' ',12X,'NO LATTICE ABSENCES')
  206 FORMAT('+',30X,2A8)
      GO TO 24
   23 CONTINUE
      GO TO (25,26), DEV
   25 CONTINUE
      GO TO 27
   26 CONTINUE
   27 CONTINUE
      GO TO 24
   28 CONTINUE
      GO TO 24
   29 IF(DEV.EQ.1) GO TO 426
      DO 424 I=1,IC
      J=JND(I)
      TIME=DD(I)*FACTOR-DELAY
      TIME=TIME
      RH=HH(J)
      RK=KK(J)
      RL=LL(J)
      CALL SEMULT(RH,RK,RL,NSG,MULT)
      H=HH(J)
      K=KK(J)
      L=LL(J)
      IF(NSYST.EQ.6 .AND. (REFCON(7).EQ.14 .OR. REFCON(7).EQ.15)) GOTO 5
      GO TO 3
    5 IF(REFCON(7).EQ.14) GO TO 2
    7 IF(MOD(H-K+L,3).EQ.0) GO TO 3
      SUB=SUB+1
      GO TO 4
    2 IF(MOD(-H+K+L,3).EQ.0) GO TO 3
      SUB=SUB+1
      GO TO 4
    3 IF(LSPSYM(IP).NE.1 .OR. IPOS(H,K,L,NHKL(IP),ICH(1,1,1,IP),
     &NCON(1,IP),NLINE(IP)) .EQ. 1) THEN
         IH(IREFL)=H
         IK(IREFL)=K
         IL(IREFL)=L
         U(IREFL)=MULT
         NOPH(IREFL)=IP
         IREFL=IREFL+1
      ENDIF
      IF(IPUNCH.EQ.0) GO TO 4
      IF(IPUNCH.EQ.2) GO TO 425
      IF(IPUNCH.EQ.1) GO TO 4
  425 CONTINUE
    4 IF(H+K.EQ.0 .AND. NCOINC.NE.2) GO TO 31
      IF(NCOINC.EQ.0) GO TO 31
      CALL COINC(J)
   31 CONTINUE
  424 CONTINUE
      GO TO 427
  426 CONTINUE
      DO 421 I=1,IC
      J=JND(I)
      X=1./(2.*DD(I))
      STHE=X*LAMBDA
      ATHE2=2.0*ASIN(STHE)/RAD
      ATHE2=ATHE2
      RH=HH(J)
      RK=KK(J)
      RL=LL(J)
      CALL SEMULT(RH,RK,RL,NSG,MULT)
      H=HH(J)
      K=KK(J)
      L=LL(J)
      IF(NSYST.EQ.6 .AND. (REFCON(7).EQ.14 .OR. REFCON(7).EQ.15)) GO TO
     &16
      GO TO 14
   16 IF(REFCON(7).EQ.14) GO TO 13
   18 IF(MOD(H-K+L,3).EQ.0) GO TO 14
      SUB=SUB+1
      GO TO 15
   13 IF(MOD(-H+K+L,3).EQ.0) GO TO 14
      SUB=SUB+1
      GO TO 15
   14 IF(LSPSYM(IP).NE.1 .OR. IPOS(H,K,L,NHKL(IP),ICH(1,1,1,IP),
     &NCON(1,IP),NLINE(IP)) .EQ. 1) THEN
         IH(IREFL)=H
         IK(IREFL)=K
         IL(IREFL)=L
         U(IREFL)=MULT
         NOPH(IREFL)=IP
         IREFL=IREFL+1
      ENDIF
      IF(IPUNCH.EQ.0) GO TO 15
      IF(IPUNCH.EQ.2) GO TO 422
      IF(IPUNCH.EQ.1) GO TO 15
  422 CONTINUE
   15 IF(H+K.EQ.0 .AND. NCOINC.NE.2) GO TO 30
      IF(NCOINC.EQ.0) GO TO 30
      CALL COINC(J)
   30 CONTINUE
  421 CONTINUE
  427 IF(IPUNCH.EQ.0) GO TO 61
      IF(IPUNCH.EQ.2) GO TO 62
      IF(IPUNCH.EQ.1) GO TO 61
   62 CONTINUE
   61 NREFL=IREFL-1
   24 CONTINUE
   57 END
 
************************************************************************
 
      SUBROUTINE SEMULT(H,K,L,ISG,MULT)
      REAL*4 H,K,L,HH,KK,LL
      DIMENSION MSG(19),MULTM(14,14)
      DATA MSG/2,15,74,88,142,148,167,176,194,206,230,243,248,251,261,
     &263,268,270,274/
      DATA MULTM/2, 2, 2, 2, 2, 2, 2, 2, 2, 6, 6, 2, 6, 6,
     &           2, 2, 2, 4, 4, 6, 6, 6, 6, 6, 6, 2, 6, 6,
     &           2, 4, 4, 8, 8, 6, 6,12,12,12,24, 4, 6,12,
     &           2, 2, 2, 4, 4, 6, 6, 6, 6, 6, 6, 2, 6, 6,
     &           2, 4, 4, 8, 8, 6, 6,12,12,12,24, 2, 6,12,
     &           2, 2, 4, 4, 8, 6,12, 6,12,12,24, 4, 6,12,
     &           2, 4, 8, 8,16, 6,12,12,24,24,48, 4, 6,12,
     &           2, 4, 4, 8, 8, 6, 6,12,12,12,12, 4, 6, 6,
     &           2, 2, 4, 4, 4, 6, 6, 6, 6,12,12, 4, 6, 6,
     &           2, 4, 8, 8, 8, 6,12,12,12,24,24, 4, 6, 6,
     &           2, 4, 4, 8, 8, 6, 6,12,12,12,12, 2, 6, 6,
     &           2, 4, 8, 8,16, 6,12,12,24,24,24, 4, 6, 6,
     &           2, 4, 8, 8,16, 6,12,12,24,24,24, 4, 6, 6,
     &           2, 4, 8, 8, 8, 6,12,12,12, 8, 8, 4, 2, 2/
      IF(ISG.LT.195) GO TO 50
      IF(ISG.GT.230 .AND. ISG.LT.269) GO TO 50
      HH=H
      KK=K
      LL=L
      H=ABS(HH)
      K=ABS(KK)
      L=ABS(LL)
   50 IF(H.EQ.K .AND. H.EQ.L) GO TO 100
      J=0
      IF(L.NE.0.0) J=J+1
      IF(K.NE.0.0) J=J+2
      IF(H.NE.0.0) J=J+4
      IF(H.EQ.K .AND. H.NE.0.0) J=J+3
      IF(H.EQ.L .AND. H.NE.0.0) J=J+6
      IF(L.EQ.K .AND. L.NE.0.0) J=J+5
      GO TO 90
  100 J=14
   90 IF(ISG.LT.195) GO TO 200
      IF(ISG.GT.230 .AND. ISG.LT.269) GO TO 200
      H=HH
      K=KK
      L=LL
      IF(ISG.GT.270) GO TO 40
      IF(ISG.LT.206 .OR. ISG.GT.268) GO TO 70
   40 I=11
      GO TO 600
   70 I=10
      GO TO 600
  200 IF(ISG.LT.146 .OR. ISG.GT.167) GO TO 500
      NISG=ISG-145
      GO TO (2,4,2,5,1,5,1,5,1,3,1,5,1,5,3,3,5,5,1,1,3,3), NISG
    2 I=13
      GO TO 600
    3 I=14
      IF(H.NE.0.0 .AND. K.NE.0.0 .AND. L.NE.0.0) GO TO 600
      IF(ABS(H+K+L).LT.0.0005) I=13
      GO TO 600
    5 IF(J.EQ.3 .OR. J.EQ.5) GO TO 6
      IF(J.EQ.8 .OR. J.EQ.11) GO TO 6
      IF(J.EQ.10 .OR. J.EQ.14) J=5
      GO TO 1
    6 J=10
    1 I=7
      GO TO 800
    4 CONTINUE
  500 DO 300 I=1,19
      IF(MSG(I).GE.ISG) GO TO 400
  300 CONTINUE
  400 IF(I.GE.18) I=I-8
      IF(I.GE.13) I=I-10
  800 IF(I.NE.7) GO TO 700
      IF(ABS(H+K).LT.0.0005) GO TO 60
      IF(L.NE.0.0) GO TO 600
      IF(ABS(H+2*K).LT.0.0005) I=6
      IF(ABS(2*H+K).LT.0.0005) I=6
      GO TO 600
  700 IF(I.NE.9) GO TO 600
      IF(ABS(H+K).LT.0.0005) GO TO 80
      IF(ABS(H+2*K).LT.0.0005) I=8
      IF(ABS(2*H+K).LT.0.0005) I=8
      GO TO 600
   60 I=6
      GO TO 600
   80 I=8
  600 MULT=MULTM(I,J)
      END
 
************************************************************************
 
      SUBROUTINE COINC(J)
      PARAMETER (NB=2000,NGEN=2000)
      INTEGER NCOINC,IC,RT,COITAB(5,14),INDEX,NSG,H,K,L,IH,IK,IL,NSC,
     &NOR,MULT,REFCON(14),NSYST,DEV,ICODE,IPUNCH
      REAL*4 DD(NGEN)
      INTEGER*2 HH(NGEN),KK(NGEN),LL(NGEN)
      CHARACTER*8 TITLE(10),CTITLE(2,28),RTITLE(2,14),SYSNAM(2,7)
      COMMON
     &/IDC/ NCOINC,MULT
     &/RR/ HH,KK,LL
     &/SORT/ DD,IC
     &/CTAB/ COITAB
     &/SGN/ NSG,NSC
     &/CNOR/ NOR,SUB
     &/CONDTN/ REFCON,NSYST
     &/PRT/ TITLE,CTITLE,RTITLE,SYSNAM
     &/HEAD/ DEV,ICODE,IPUNCH
      H=HH(J)
      K=KK(J)
      L=LL(J)
      IF(NSYST.NE.7) GO TO 40
      IH=H
      IK=K
      IL=L
      H=IABS(IH)
      K=IABS(IK)
      L=IABS(IL)
   40 IF(H.EQ.K .AND. H.EQ.L) GO TO 41
      RT=0
      IF(L.NE.0) RT=RT+1
      IF(K.NE.0) RT=RT+2
      IF(H.NE.0) RT=RT+4
      IF(H.EQ.K .AND. H.NE.0) RT=RT+3
      IF(H.EQ.L .AND. H.NE.0) RT=RT+6
      IF(L.EQ.K .AND. L.NE.0) RT=RT+5
      GO TO 42
   41 RT=14
   42 CONTINUE
      IF(NSYST.NE.7) GO TO 43
      H=IH
      K=IK
      L=IL
   43 CONTINUE
      INDEX=COITAB(NCOINC,RT)
      IF(INDEX.EQ.0) GO TO 4
      GO TO (1,2,3), INDEX
    1 IH=K
      IK=H
      CALL COINC2(IH,IK,L)
      GO TO 4
    2 IH=-H
      IK=-K
      CALL COINC2(IH,IK,L)
      GO TO 4
    3 IH=K
      IK=H
      CALL COINC2(IH,IK,L)
      IH=-H
      IK=-K
      CALL COINC2(IH,IK,L)
      IH=-K
      IK=-H
      CALL COINC2(IH,IK,L)
    4 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE COINC2(H,K,L)
      PARAMETER (NB=2000,NGEN=2000,NPH=2)
      INTEGER H,K,L,NCOINC,MULT,DEV,ICODE,IPUNCH,NOR,IC,REFCON(14),
     &NSYST
      REAL*4 DD(NGEN)
      CHARACTER*8 TITLE(10),CTITLE(2,28),RTITLE(2,14),SYSNAM(2,7)
      COMMON
     &/A/ IH(NB),IK(NB),IL(NB),L12(NB),NOPH(NB)
     &/B/ U(NB),NREFL
     &/EXC/ LSPSYM(NPH),NSSYM(14,NPH)
     &/IDC/ NCOINC,MULT
     &/PRT/ TITLE,CTITLE,RTITLE,SYSNAM
     &/HEAD/ DEV,ICODE,IPUNCH
     &/CNOR/ NOR,SUB
     &/SORT/ DD,IC
     &/CONDTN/ REFCON,NSYST
     &/PHNO/ IP
     &/REFNO/ IREFL
      COMMON /CONHKL/ NHKL(NPH),ICH(5,3,7,NPH),NCON(7,NPH),NLINE(NPH)
      IF(NSYST.EQ.6 .AND. (REFCON(7).EQ.14 .OR. REFCON(7).EQ.15)) GO TO
     &20
      GO TO 3
   20 IF(REFCON(7).EQ.14) GO TO 2
      GO TO 7
    2 IF(MOD(-H+K+L,3).EQ.0) GO TO 3
      GO TO 24
    7 IF(MOD(H-K+L,3).EQ.0) GO TO 3
      GO TO 24
    3 IF(LSPSYM(IP).NE.1 .OR. IPOS(H,K,L,NHKL(IP),ICH(1,1,1,IP),
     &NCON(1,IP),NLINE(IP)) .EQ. 1) THEN
CORRECTED ON 1989.8.22
         IF (IREFL .GT. NB) CALL JOBEND
     &   ('NUMBER OF REFLECTIONS HAS REACHED THE MAXIMUM VALUE.')
CORRECTION END
         IH(IREFL)=H
         IK(IREFL)=K
         IL(IREFL)=L
         U(IREFL)=MULT
         NOPH(IREFL)=IP
         IREFL=IREFL+1
         NOR=NOR+1
      ENDIF
      IF(IPUNCH.EQ.0) GO TO 24
      IF(IPUNCH.EQ.2) GO TO 25
      IF(IPUNCH.EQ.1) GO TO 24
   25 CONTINUE
   24 END
 
************************************************************************
 
*MODIFIED ON 1988.10.27
      BLOCK DATA CLEAR
      PARAMETER (NR=65,NR2=10*NR)
      COMMON /NONLIN/ NLESQ,NAUTO,IDCYCL,NCHNG,NPAR(10),IPAR(NR,10)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      DATA IPAR/NR2*0.0/
*     NSFX: SCALE FACTOR
*     NPO1X: PREFERRED-ORIENTATION PARAMETER 1
*     NPO2X: PREFERRED-ORIENTATION PARAMETER 2
*     NAX: A
*     NBX: B
*     NCX: C
*     NALPX: ALPHA
*     NBETX: BETA
*     NGAMX: GAMMA
*     NOTX: OVERALL THERMAL PARAMETER
*     NG1X: OCCUPATION FACTOR OF THE 1ST SITE
      DATA NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,NOTX,NG1X/
     &  0,7,8,9,10,11,12,13,14,15,16/
      END
*MODIFICATION END
 
************************************************************************
 
      BLOCK DATA VINIT
      INTEGER TRIC(2),MONO1(21),ORTHO1(146),TET1(178),TRIG1(43),
     &HEX(53),CUBIC1(108),MONO2(21),ORTHO2(18),TET2(48),TRIG2(11),
     &CUBIC2(30),SYMTAB(679),POINT1(256),POINT2(256),POINT3(36),
     &POINT(2,274),SYMCON(2,109),PTCON(2,48),SCLASS(13),CHK(7),
     &NCO(32),IEX(32),COITAB(5,14),SECSET,ISET(44)
      CHARACTER*8 TITLE(10),CTITLE(2,28),RTITLE(2,14),SYSNAM(2,7)
      COMMON
     &/TAB/ SYMTAB,POINT,SYMCON,PTCON,SCLASS,CHK
     &/PRT/ TITLE,CTITLE,RTITLE,SYSNAM
     &/COI/ NCO,IEX
     &/CTAB/ COITAB
     &/IS/ ISET,SECSET
      EQUIVALENCE (TRIC(1),  SYMTAB(1)),
     &            (MONO1(1), SYMTAB(3)),
     &            (ORTHO1(1),SYMTAB(24)),
     &            (TET1(1),  SYMTAB(170)),
     &            (TRIG1(1), SYMTAB(348)),
     &            (HEX(1),   SYMTAB(391)),
     &            (CUBIC1(1),SYMTAB(444)),
     &            (MONO2(1), SYMTAB(552)),
     &            (ORTHO2(1),SYMTAB(573)),
     &            (TET2(1),  SYMTAB(591)),
     &            (TRIG2(1), SYMTAB(639)),
     &            (CUBIC2(1),SYMTAB(650)),
     &            (POINT1(1),POINT(1,1)),
     &            (POINT2(1),POINT(1,129)),
     &            (POINT3(1),POINT(1,257))
      DATA TRIC/
     & 1, 1/
      DATA MONO1/
     & 1, 1,44, 3, 1, 1,20, 3, 3,20, 1, 1,44, 3, 1,20, 1,20,
     &44, 3,20/
      DATA ORTHO1/
     & 1, 1,44, 1,41,43, 1,41,43,44, 4,44, 4, 5, 6, 6, 1, 1,
     &16, 1,12,16, 1,15, 1,12,15, 1,13,16, 1,17, 1,11,15, 1,
     &13,15, 1,13,17, 4, 4,16, 4,12,16, 2, 2,11, 2,15, 2,11,
     &15, 5, 5,14,18, 6, 6,11,15, 6,15, 1, 1,13,17,21, 1,12,
     &16, 1,11,15,21, 1,19, 1,13,17,19, 1,17,19, 1,12,16,19,
     & 1,11,15, 1,12,16,21, 1,11,16, 1,13,17, 1,21, 1,11,16,
     &21, 1,11,16,19, 1,13,19, 4,16, 4,16,19, 4, 4,12,16, 4,
     &19, 4,12,16,19, 5, 5,14,18,22, 6, 6,11,15, 6,11,16,19,
     & 6,19/
      DATA TET1/
     & 1, 1,46, 1,44, 1,46, 6, 6,46, 1, 6, 1, 1,44, 1,21, 1,
     &21,44, 6, 6,34,46, 1, 1,41,43, 1,46, 1,41,43,46, 1,44,
     & 1,41,43,44, 1,46, 1,41,43,46, 6, 6,46, 1, 1,11,15, 1,
     &12,16, 1,13,17, 1,12,16,23, 1,13,17,23, 1,23, 1,11,15,
     &23, 6, 6,12,16, 6,25, 6,12,16,25, 1, 1,23, 1,41,43, 1,
     &23,41,43, 1, 1,12,16, 1,11,15, 1,13,17, 6, 6,12,16, 6,
     & 6,25, 1, 1,12,16,23, 1,11,15,21, 1,13,17,23,21, 1,11,
     &15, 1,13,17,23, 1,21, 1,12,16,23,21, 1,23, 1,12,16, 1,
     &11,15,23,21, 1,13,17,21, 1,11,15,23, 1,13,17, 1,23,21,
     & 1,12,16,21, 6, 6,12,16, 6,25,34, 6,12,16,25,34/
      DATA TRIG1/
     & 1, 1,45, 1,45, 9, 1, 9, 1, 1, 1,45, 1,45, 1,45, 1,45,
     & 9, 1, 1, 1,12,16, 1,23, 9, 9,23,28,31, 1, 1,23, 1, 1,
     &12,16, 9, 9,23,28,31/
      DATA HEX/
     & 1, 1,47, 1,47, 1,45, 1,45, 1,44, 1, 1, 1,44, 1, 1,47,
     & 1,47, 1,45, 1,45, 1,44, 1, 1,12,16,23, 1,12,16, 1,23,
     & 1, 1,12,16, 1, 1,23, 1, 1,12,16,23, 1,12,16, 1,23/
      DATA CUBIC1/
     & 1, 5, 6, 1,41,43,44, 6,41,43,44, 1, 1,13,17,21, 5, 5,
     &14,18,22, 6, 1,11,16,19, 6,34,35,36, 1, 1,41,43,44, 5,
     & 5,42,48,46, 6, 1,42,48,46, 1,42,48,46, 6,42,48,46, 1,
     & 5, 6, 1,24,29,32, 5,23,28,31, 6,25,30,33, 1, 1,13,17,
     &21,24,29,32, 1,24,29,32, 1,13,17,21, 5, 5,23,28,31, 5,
     &14,18,22, 5,23,28,31,14,18,22, 6, 6,34,35,36,25,30,33/
      DATA MONO2/
     & 1, 1,43, 4, 1, 1,16, 4, 4,16, 1, 1,43, 4, 1,16, 1,16,
     &43, 4,16/
      DATA ORTHO2/
     & 1,13,17,21, 1,11,15,21, 1,21, 4,12,16,19, 5,14,18,22/
      DATA TET2/
     & 1,21, 1,21,44, 6,34,46, 1,11,15,21, 1,13,17,23,21, 1,
     &21, 1,12,16,23,21, 1,11,15,23,21, 1,13,17,21, 1,23,21,
     & 1,12,16,21, 6,25,19, 6,12,16,25,19/
      DATA TRIG2/
     & 7, 7, 7, 7, 7,12,16, 7, 7,12,16/
      DATA CUBIC2/
     & 1,13,17,21, 5,14,18,22, 1,13,17,21,24,29,32, 1,13,17,
     &21, 5,14,18,22, 5,23,28,31,14,18,22/
      DATA POINT1/
     &  1,  1,  2,  1,  3,  1,  4,  2,  6,  1,  7,  1,  8,  2, 10,  1,
     & 11,  2, 13,  1, 14,  2, 16,  1, 17,  2, 19,  3, 22,  2, 24,  1,
     & 25,  2, 27,  3, 30,  4, 34,  2, 36,  1, 37,  1, 38,  1, 39,  1,
     & 40,  1, 41,  2, 43,  3, 46,  2, 48,  3, 51,  3, 54,  2, 56,  3,
     & 59,  3, 62,  3, 65,  1, 66,  2, 68,  3, 71,  1, 72,  2, 74,  2,
     & 76,  3, 79,  1, 80,  3, 83,  1, 84,  3, 87,  2, 89,  1, 90,  4,
     & 94,  3, 97,  4,101,  2,103,  4,107,  3,110,  4,114,  3,117,  4,
     &121,  3,124,  3,127,  2,129,  4,133,  4,137,  3,140,  2,142,  3,
     &145,  1,146,  3,149,  2,151,  4,155,  1,156,  4,160,  1,161,  3,
     &164,  4,168,  2,170,  1,171,  2,173,  2,175,  2,177,  1,178,  2,
     &180,  1,181,  1,182,  1,183,  2,185,  2,187,  3,190,  1,191,  3,
     &194,  1,195,  3,198,  2,200,  4,204,  2,206,  4,210,  2,212,  4,
     &216,  1,217,  2,219,  1,220,  3,223,  3,226,  3,229,  4,233,  4,
     &237,  2,239,  4,243,  1,244,  3,247,  2,249,  4,253,  1,254,  2,
     &256,  3,259,  4,263,  1,264,  3,267,  3,270,  3,273,  1,274,  3,
     &277,  1,278,  2,280,  1,281,  4,285,  4,289,  5,294,  3,297,  4/
      DATA POINT2/
     &301,  2,303,  5,308,  2,310,  3,313,  5,318,  4,322,  4,326,  3,
     &329,  3,332,  4,336,  1,337,  3,340,  3,343,  5,348,  1,349,  2,
     &351,  2,353,  1,354,  1,355,  1,356,  1,357,  1,358,  2,360,  2,
     &362,  2,364,  2,366,  1,367,  1,368,  1,369,  3,372,  2,374,  1,
     &375,  4,379,  1,380,  2,382,  1,383,  3,386,  1,387,  4,391,  1,
     &392,  2,394,  2,396,  2,398,  2,400,  2,402,  1,403,  1,404,  2,
     &406,  1,407,  2,409,  2,411,  2,413,  2,415,  2,417,  1,418,  4,
     &422,  3,425,  2,427,  1,428,  3,431,  1,432,  2,434,  1,435,  4,
     &439,  3,442,  2,444,  1,445,  1,446,  1,447,  4,451,  4,455,  1,
     &456,  4,460,  1,461,  4,465,  1,466,  4,470,  4,474,  1,475,  4,
     &479,  1,480,  4,484,  1,485,  4,489,  4,493,  4,497,  1,498,  1,
     &499,  1,500,  4,504,  4,508,  4,512,  1,513,  7,520,  4,524,  4,
     &528,  1,529,  4,533,  4,537,  7,544,  1,545,  7,552,  1,553,  2,
     &555,  1,556,  1,557,  2,559,  1,560,  2,562,  1,563,  2,565,  1,
     &566,  2,568,  3,571,  2,573,  4,577,  4,581,  2,583,  4,587,  4,
     &591,  2,593,  3,596,  3,599,  4,603,  5,608,  2,610,  5,615,  5/
      DATA POINT3/
     &620,  4,624,  3,627,  4,631,  3,634,  5,639,  1,640,  1,641,  1,
     &642,  1,643,  3,646,  1,647,  3,650,  4,654,  4,658,  7,665,  4,
     &669,  4,673,  7/
      DATA SYMCON/
     & 0, 7, 4, 7, 5, 7, 6, 7, 7, 7,13, 7,14, 7,15, 7,21, 7,
     & 0, 0, 2, 3, 2, 8, 2, 2, 3, 3, 2, 8, 3, 1, 4, 3, 2, 2,
     & 3, 1, 8, 3,17, 2,19, 1, 2, 8, 1, 5, 1,11, 1, 4, 3, 5,
     & 1,11, 3, 1, 5, 5, 1, 4, 3, 1, 9, 5,16, 4,19, 1, 1,11,
     & 1, 6, 1, 9, 1, 4, 2, 6, 1, 9, 2, 2, 6, 6, 1, 4, 2, 2,
     &10, 6,16, 4,17, 2, 1, 9, 3,10, 3, 1, 1,14, 3,10, 3, 1,
     & 1,14,12,10,16,14,19, 1, 1, 9, 3,10, 3, 1, 1,14, 3, 5,
     & 1,11, 3, 1, 2,13, 2, 2, 1,14, 2,13, 2, 2, 1,14,23,13,
     &17, 2,16,14, 1,11, 1,12, 1, 4, 1,14, 1,12, 1, 4, 1,14,
     &25,12,16, 4,16,14, 2, 8,26, 6, 1, 9, 1, 4, 2, 2,27, 3,
     & 2, 8, 2, 2, 3, 1,28, 5, 1,11, 1, 4, 3, 1, 0, 0, 0, 0,
     & 0, 0, 0, 0, 1, 4,16, 4, 2, 2, 3, 1,18, 1,19, 1,20, 1,
     &17, 2/
      DATA PTCON/
     &  1,  1,  2,  1,  3,  1,  4,  1,  5,  1,  6,  1,  7,  1,  8,  1,
     &  9,  1, 10,  1, 11,  3, 14,  3, 17,  3, 20,  4, 24,  3, 27,  3,
     & 30,  3, 33,  4, 37,  3, 40,  3, 43,  3, 46,  4, 50,  3, 53,  3,
     & 56,  4, 60,  3, 63,  3, 66,  3, 69,  3, 72,  4, 76,  3, 79,  3,
     & 82,  4, 86,  4, 90,  4, 94,  4, 98,  1, 99,  1,100,  1,101,  1,
     &102,  1,103,  1,104,  1,105,  1,106,  1,107,  1,108,  1,109,  1/
      DATA SCLASS/1,3,16,75,143,168,195,231,244,249,262,269,275/
      DATA CHK/146,148,155,160,161,166,167/
      DATA CTITLE/
     &'H=2N;   ','        ','K=2N;   ','        ','L=2N;   ','        ',
     &'K+L=2N; ','        ','H+L=2N; ','        ','H+K=2N; ','        ',
     &'H,K,L OD','D/EVEN; ','K+L=4N; ','        ','H+L=4N; ','        ',
     &'H+K=4N; ','        ','2H+L=2N;','        ','2H+L=4N;','        ',
     &'H+K+L=2N',';       ','-H+K+L=3','N;      ','H-K+L=3N',';       ',
     &'H=4N;   ','        ','K=4N;   ','        ','L=3N;   ','        ',
     &'L=4N;   ','        ','L=6N;   ','        ','!H!>=!K!','>=!L!;  ',
     &'2H+K=2N;','        ','2H+K=4N;','        ','H+2K=2N;','        ',
     &'H+2K=4N;','        ','H=2N,K=2','N;      ','K=2N,L=2','N;      ',
     &'H=2N,L=2','N;      '/
      DATA RTITLE/
     &'00L;    ','        ','0K0;    ','        ','0KL;    ','        ',
     &'H00;    ','        ','H0L;    ','        ','HK0;    ','        ',
     &'ALL REFL','ECTIONS;','0KK;    ','        ','HH0;    ','        ',
     &'HHL;    ','        ','H0H;    ','        ','HKK;    ','        ',
     &'HKH;    ','        ','HHH;    ','        '/
      DATA SYSNAM/
     &'TRICLINI','C       ','MONOCLIN','IC      ','ORTHORHO','MBIC    ',
     &'TETRAGON','AL      ','RHOMBOHE','DRAL    ','HEXAGONA','L       ',
     &'CUBIC   ','        '/
      DATA NCO/74,88,142,145,146,147,148,149,150,151,152,153,154,
     &155,156,157,158,159,161,163,165,167,176,194,206,248,251,261,
     &263,268,270,274/
      DATA IEX/0,1,0,2,4,2,4,5,3,5,3,5,3,0,3,5,3,5,0,5,3,0,1,0,4,
     &0,1,0,2,3,4,0/
      DATA COITAB/0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,
     &1,0,1,1,0,1,0,1,3,1,1,2,0,0,1,0,0,0,0,0,0,0,0,2,0,0,2,0,0,
     &1,0,0,1,3,1,0,2,1,3,1,0,2,0,2,0,0,2/
      DATA ISET/3,4,5,6,7,8,9,10,11,12,13,14,15,48,50,59,68,70,85,86,88,
     &125,126,129,130,133,134,137,138,141,142,146,148,155,160,161,166,
     &167,201,203,222,224,227,228/
      END
 
************************************************************************
 
      SUBROUTINE POSREF(COL,IC,NCON)
C     DETERMINE THE COEFFICIENTS IN EQUATIONS
C     (C1)H+(C2)K+(C3)L=(C4)N+(C5); .....
C     UP TO THREE EQUATIONS MAY BE INPUT.  THEY ARE SEPARATED BY ','
C     OR ';'
C     IC(I,J): I SCANS COEFFICIENTS C1 - C5
C              J SCANS EQUATIONS (RELATED BY 'AND')
      CHARACTER COL(80)*1,CH(14)*1
      INTEGER IC(5,3),NCON,NUM,SIGN
      DATA CH/'H','K','L','N','0','1','2','3','4','5','6','7','8','9'/
C
      DO 20 J=1,3
         DO 10 I=1,5
            IC(I,J)=0
   10    CONTINUE
   20 CONTINUE
      J=1
C     LOUT=0:  AN INTEGER HAS BEEN ENCOUNTERED
C     LOUT=1:  AN INTEGER HAS NOT YET BEEN ENCOUNTERED OR HAS BEEN
C              STORED IN ARRAY IC
      LOUT=1
      SIGN=1
      NUM=1
      DO 50 ICOL=1,80
         IF (COL(ICOL) .EQ. '-') THEN
            SIGN=-1
         ELSE IF (COL(ICOL) .NE. ' ') THEN
            DO 25 I=1,14
               IF (COL(ICOL) .EQ. CH(I)) THEN
                  LP=I
                  GO TO 1
               END IF
   25       CONTINUE
            LP=0
    1       IF (LP .GT. 0 .AND. LP .LE. 4) THEN
               IC(LP,J)=SIGN*NUM
               LOUT=1
               SIGN=1
               NUM=1
            ELSE IF (LP .GE. 5) THEN
               NUM=LP-5
               LOUT=0
            ELSE IF (COL(ICOL) .EQ. ';' .OR. COL(ICOL) .EQ. ',') THEN
               IF (LOUT .EQ. 0) IC(5,J)=SIGN*NUM
               LOUT=1
               SIGN=1
               NUM=1
               J=J+1
            END IF
         END IF
   50 CONTINUE
      IF (LOUT .EQ. 0) IC(5,J)=SIGN*NUM
      NCON=J
      END
 
************************************************************************
 
      INTEGER FUNCTION IPOS(H,K,L,NHKL,ICH,NCON,NLINE)
      INTEGER H,K,L,ICH(5,3,7),NCON(7)
 
      IPOS=1
      IF (NHKL .EQ. 2 .AND. H .NE. 0) THEN
         RETURN
      ELSE IF (NHKL .EQ. 3 .AND. K .NE. 0) THEN
         RETURN
      ELSE IF (NHKL .EQ. 4 .AND. L .NE. 0) THEN
         RETURN
      ELSE IF (NHKL .EQ. 5 .AND. H .NE. K) THEN
         RETURN
*     ELSE IF (NHKL .EQ. 6 .AND. H .NE. -H) THEN
*        RETURN
      END IF
 
      DO 50 J=1,NLINE
         DO 40 I=1,NCON(J)
            IF (ICH(4,I,J) .NE. 0 .AND. MOD(ICH(1,I,J)*H + ICH(2,I,J)
     &      *K + ICH(3,I,J)*L - ICH(5,I,J), ICH(4,I,J)) .EQ. 0) THEN
C              DO NOTHING
            ELSE IF (ICH(4,I,J) .EQ. 0 .AND. ICH(1,I,J)*H + ICH(2,I,J)
     &      *K + ICH(3,I,J)*L .EQ. ICH(5,I,J)) THEN
C              DO NOTHING
            ELSE
               GO TO 50
            END IF
   40    CONTINUE
         RETURN
   50 CONTINUE
      IPOS=0
      END
 
************************************************************************
 
      SUBROUTINE HRHT
C     HS AND H*TS
C     'JIKKEN KAGAKU KOHZA,' VOL. 6, MARUZEN, TOKYO (1977), P. 60.
      INTEGER H,R,RX,RY,RZ
      PARAMETER (NB=2000,NS=48,NAP=36,NPH=2)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /G/ I
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      IP=NOPH(I)
      DO 10 J=1,NSYM(IP)
         RX(J,I)=H(I)*R(1,1,J,IP)+K(I)*R(2,1,J,IP)+L(I)*R(3,1,J,IP)
         RY(J,I)=H(I)*R(1,2,J,IP)+K(I)*R(2,2,J,IP)+L(I)*R(3,2,J,IP)
         RZ(J,I)=H(I)*R(1,3,J,IP)+K(I)*R(2,3,J,IP)+L(I)*R(3,3,J,IP)
         HT(J,I)=H(I)*T(1,J,IP)+K(I)*T(2,J,IP)+L(I)*T(3,J,IP)
   10 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE UPDATE(YPEAK,A,IDPOS,ID1ST)
C     UPDATE VARIOUS ARRAYS SUCH AS FWHM AND PEAK POSITIONS
      PARAMETER (NB=2000,NS=48,NAP=36,NT=220,NCS=50,NA=7,NPH=2)
      INTEGER H,HP,R,RX,RY,RZ
      DIMENSION A(*),YPEAK(*)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /B/ U(NB),NREFL
      COMMON /BUFFER/ TEMP(NB)
      COMMON /DERPR/ POP2(NB),COMPO(NB),GAUSS(NB)
      COMMON /DP/ DLT1,CF1,FPV,COMA(NPH),DFLP(NB),DHDT(NB),DAA(NB)
     &  ,BUNSHI,PR2,PR3,CF2,APV(NB),DIFF,CUVW(NB),CAP(NB),CGE(NB),CS(NB)
      COMMON /G/ I
      COMMON /I/ RDEG(2,NB)
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
      COMMON /MAGNE/ FMAG(NA,NB),SFRMAG(NB),SFIMAG(NB),Q2(NB)
      COMMON /O/ NMODE
      COMMON /ORDER/ IPOINT(NB)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      COMMON /S/ F(NA,NB),NATOM
      COMMON /SFRI/ SFR(NB),SFI(NB),OTF(NB)
      COMMON /T/ FF(NB)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      COMMON /UCC/ IDPEAK(NPH),IDSF(NPH),IDPRF(NPH),IDZP
      COMMON /V/ NPROR(NPH),HP(NPH),KP(NPH),LP(NPH)
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
      DATA C5,C6/1.064467,1.570796/
      P(J)=A(KPHB(NOPH(I))+J)
      P2(J)=A(KPHB(IP)+J)
 
C     ID1ST=0: THIS SUBROUTINE IS CALLED FOR THE FIRST TIME
C     IDPEAK=1: CHANGE BRAGG POSITIONS
C     IDPRF=1: CHANGE U, V, OR W
C     IDSF=1: CHANGE STRUCTURE-FACTOR PARAMETER(S)
C     IDZP=1: DO'NT CHANGE CELL CONSTS BUT THE ZERO-POINT SHIFT
C     IDPOS=-1: FWHM CANNOT BE CALCULATED
C     IDPOS=0: BRAGG POSITIONS CANNOT BE CALCULATED
C     IDPOS=1: BRAGG POSITIONS AND PEAK SHAPE FUNCTION CAN BE CALCULATED
      IDPOS=1
      CALL SETPAR(A)
      CALL TENSOR(A)
      IDBR=0
      DO 10 IP=1,NPHASE
         IF(ID1ST.EQ.0) THEN
            IDPEAK(IP)=0
            IDPRF(IP)=1
            IDSF(IP)=1
         ENDIF
         IDBR=IDBR+IDPEAK(IP)
C        CPROR IS USED IN PROR
         IF(NPROR(IP).GE.1)
     &      CPROR(IP)=HP(IP)**2*GG(1,IP)+KP(IP)**2*GG(2,IP)+LP(IP)**2*
     &      GG(3,IP)+2.0*(KP(IP)*LP(IP)*GG(4,IP)+LP(IP)*HP(IP)*
     &      GG(5,IP)+HP(IP)*KP(IP)*GG(6,IP))
C        COMA IS USED IN PRFL AND DERPF
         IF (NMODE .NE. 2) THEN
            COMA(IP)=C5*P2(5)+C6*(1.0-P2(5))/P2(6)
            CALL FWHM(A,IP,IDPOS)
            IF(IDPOS.EQ.-1) RETURN
         END IF
   10 CONTINUE
C
C     CALCULATE VARIOUS QUANTITIES USING NEW INDICES
C     DO LOOPS 20 AND 30 ARE SEPARATED BECAUSE THE ORDER OF 2-THETA
C     MAY BE CHANGED AS A RESULT OF THE REFINEMENT OF LATTICE PARAMETERS
      DO 20 I=1,NREFL
         IF (IDPEAK(NOPH(I)) .EQ. 1 .OR. IDZP .EQ. 1) THEN
            CALL BRANG(A)
            IF (D(I) .EQ. 0.0) THEN
               IDPOS=0
               RETURN
            ENDIF
         END IF
         IF (NMODE .NE. 2 .AND.
     &   IDPRF(NOPH(I)) .EQ. 1 .OR. IDZP .EQ.1) THEN
C           STORE ARRAYS TO CALCULATE PROFILE FUNCTIONS
            TN2=TN1(I)-CSTB
            WW1(I)=(P(1)*TN2+P(2))*TN2+P(3)
            IF(WW1(I).LT.0.0) THEN
               IDPOS=-1
               RETURN
            ENDIF
            W1(I)=SQRT(WW1(I))
            APV(I)=1.0/(COMA(NOPH(I))*W1(I))
C           RDEG(1,I)-RDEG(2,I): REGION WHERE THE I-TH REFLECTION CAN
C           CONTRIBUTE TO SUMREF
            RANGE=PC2(NOPH(I))*W1(I)
            RDEG(1,I)=PEAK(I)-RANGE
            RDEG(2,I)=PEAK(I)+RANGE
         ENDIF
         IF (L12(I) .EQ. 0) THEN
            CALL PROR(A)
            IF (IDSF(NOPH(I)) .EQ. 1) THEN
               CALL SF(A,RX(1,I),RY(1,I),RZ(1,I),HT(1,I),
     &         NSITE(NOPH(I)),NSYM(NOPH(I)),IDSYM(1,1,NOPH(I)))
            END IF
         END IF
   20 CONTINUE
 
      DO 30 I=1,NREFL
         II=L12(I)
         IF (II .NE. 0) THEN
C           ARRAYS FOR ALPHA-2 PEAKS
            PROR1(I)=PROR1(II)
            POP2(I)=POP2(II)
            GAUSS(I)=GAUSS(II)
            IF (IDSF(NOPH(I)) .EQ. 1) THEN
               FF(I)=FF(II)
               SFR(I)=SFR(II)
               SFI(I)=SFI(II)
               OTF(I)=OTF(II)
            END IF
         END IF
         YPEAK(I)=P(0)*U(I)*FLP(I)*PROR1(I)*FF(I)
   30 CONTINUE
      IF (ID1ST .EQ. 0 .OR. IDZP .EQ. 1 .OR. IDBR .EQ. 0) RETURN
C
      DO 50 I=1,NREFL
         TEMP(I)=PEAK(I)
   50 CONTINUE
      CALL EXCTES(TEMP,IPOINT,NREFL)
      END
 
************************************************************************
 
      SUBROUTINE EXCTES(A,IPOINT,K)
C     TESTED EXCHANGE
      DIMENSION A(*),IPOINT(*)
      DO 10 I=1,K
         IPOINT(I)=I
   10 CONTINUE
    1 ISW=0
      DO 20 I=2,K
         IF(A(I-1).LE.A(I)) GO TO 20
         W=A(I)
         A(I)=A(I-1)
         A(I-1)=W
         IW=IPOINT(I)
         IPOINT(I)=IPOINT(I-1)
         IPOINT(I-1)=IW
         ISW=1
   20 CONTINUE
      IF(ISW.NE.0) GO TO 1
      END
 
************************************************************************
 
      SUBROUTINE MLAT(COEF)
      DIMENSION COEF(*)
      PARAMETER (NPH=2,NAP=36)
      COMMON /EXC/ LSPSYM(NPH),NSSYM(14,NPH)
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
 
      DO 10 IP=1,NPHASE
         NCON=NSSYM(7,IP)
         IF (NCON .EQ. 0 .OR. NCON .EQ. 21) THEN
*           P OR R LATTICE
            IF(NCENTR(IP).EQ.1) THEN
               COEF(IP)=2.0
            ELSE
               COEF(IP)=1.0
            ENDIF
         ELSE IF (NCON .EQ. 4 .OR. NCON .EQ. 5 .OR. NCON .EQ. 6 .OR.
     &   NCON .EQ. 13) THEN
*           A, B, C, OR I LATTICE
            IF(NCENTR(IP).EQ.1) THEN
               COEF(IP)=4.0
            ELSE
               COEF(IP)=2.0
            ENDIF
         ELSE IF (NCON .EQ. 7) THEN
*           F LATTICE
            IF(NCENTR(IP).EQ.1) THEN
               COEF(IP)=8.0
            ELSE
               COEF(IP)=4.0
            ENDIF
         ELSE IF (NCON .EQ. 14 .OR. NCON .EQ. 15) THEN
*           R LATTICE (HEXAGONAL SETTING)
            IF(NCENTR(IP).EQ.1) THEN
               COEF(IP)=6.0
            ELSE
               COEF(IP)=3.0
            ENDIF
         ENDIF
   10 CONTINUE
      END
 
************************************************************************
 
CORRECTED ON 1989.3.10
C     SUBROUTINE LIST2(G,ITEMP,ID,DEG,XINT,YFIT,NTERMS,NRFN,NPTS,
C    &  ISCALE,IDIF)
      SUBROUTINE LIST2(G,ID,DEG,XINT,YFIT,NTERMS,NRFN,NPTS,
     &  ISCALE,IDIF,NPRINT,LFLAG)
C     (1) LIST OF CORRELATION MATRIX
C     (2) LIST OF 2*THETA, Y(O), AND Y(C)
C     (3) LINE PRINTER PLOT OF Y(O), Y(C), AND Y(O)-Y(C)
      DOUBLE PRECISION G(*)
      CHARACTER*1 ISPACE,IDOT,ISTAR,IPLUS,IMINUS,IBAR,IOUT(150)
CORRECTED ON 1989.3.10
CC    DIMENSION ITEMP(*),ID(*),DEG(*),XINT(*),YFIT(*),KS(19),
CC   &  LABEL(12)
      PARAMETER (NT=220)
      DIMENSION ITEMP(NT),ID(*),DEG(*),XINT(*),YFIT(*),KS(19),
     &  LABEL(12),LFLAG(*)
      COMMON /L/ DEG1,DEG2
      COMMON /X/ STEP
      DATA RD2/57.29578/
      DATA ISPACE,IDOT,ISTAR,IPLUS,IMINUS,IBAR/' ','.','*','+','0','-'/
 
      IF (NPRINT .EQ. 2 .OR. LFLAG(4) .EQ. 1) THEN
C        CORRELATION MATRIX
         WRITE(6,'(//,11X,A)') 'CORRELATION MATRIX'
         L=1
         DO 12 J=1,NTERMS
            IF(ID(J).EQ.1) THEN
               ITEMP(L)=J
               L=L+1
            ENDIF
   12    CONTINUE
         IA=1
         LIM=19
    1    LIM=MIN0(NRFN,LIM)
         WRITE(6,100) (ITEMP(I),I=IA,LIM)
  100    FORMAT(//13X,19I6)
         DO 20 I=1,NRFN
            L=0
            DO 15 J=IA,LIM
               L=L+1
               IF(I.GE.J) THEN
                  KS(L)=NINT(100.0D0*G((I-1)*I/2+J)/SQRT(G((I-1)*I/2+I)*
     &            G((J-1)*J/2+J)))
               ELSE
                  KS(L)=NINT(100.0D0*G((J-1)*J/2+I)/SQRT(G((J-1)*J/2+J)*
     &            G((I-1)*I/2+I)))
               ENDIF
   15       CONTINUE
            WRITE(6,110) ITEMP(I),(KS(J),J=1,L)
   20    CONTINUE
  110    FORMAT(8X,I5,19I6)
         IF(LIM.LT.NRFN) THEN
            IA=LIM+1
            LIM=LIM+19
            GO TO 1
         ENDIF
      END IF
C
      IF (NPRINT .EQ. 2 .OR. LFLAG(5) .EQ. 1) THEN
C        LIST 2*THETA, Y(O), AND Y(C)
         NP=NPTS/300
         WRITE(6,120) (((DEG(300*N-360+60*I+J)*RD2,
     &   NINT(XINT(300*N-360+60*I+J)),NINT(YFIT(300*N-360+60*I+J)),
     &   I=1,5),J=1,60),N=1,NP)
  120    FORMAT(('1'/5X,5('  2O',6X,'YOBS',3X,'YCALC',4X)/'+',4X,
     &   5('   -',22X)/,60(3X,5(1X,F7.3,1X,2(I7,1X),1X),/)))
         NPTS2=NPTS-NP*300
         IF(NPTS2.EQ.0) RETURN
         NCOL=NPTS2/60
         WRITE(6,130)
  130    FORMAT('1'/5X,5('  2O',6X,'YOBS',3X,'YCALC',4X)/'+',4X,
     &   5('   -',22X))
         NLINES=NPTS2-NCOL*60
         IF(NLINES.NE.0) THEN
            NCOL1=NCOL+1
            NP=300*NP-60
            DO 30 J=1,NLINES
               WRITE(6,140) (DEG(NP+60*I+J)*RD2,NINT(XINT(NP+60*I+J)),
     &         NINT(YFIT(NP+60*I+J)),I=1,NCOL1)
   30       CONTINUE
  140       FORMAT(3X,5(1X,F7.3,1X,2(I7,1X),1X))
            NP=NP+NLINES
         ENDIF
         DO 35 J=1,60-NLINES
            WRITE(6,140) (DEG(NP+60*I+J)*RD2,NINT(XINT(NP+60*I+J)),
     &      NINT(YFIT(NP+60*I+J)),I=1,NCOL)
   35    CONTINUE
      END IF
C
      IF (NPRINT .EQ. 2 .OR. LFLAG(6) .EQ. 1) THEN
C        LINE PRINTER PLOT OF Y(O), Y(C), AND Y(O)-Y(C)
         IF (ISCALE .EQ. 0 .OR. IDIF .EQ. 0) THEN
            YMAX=0.0
            DO 36 J=1,NPTS
               IF (YFIT(J) .GT. YMAX) YMAX=YFIT(J)
   36       CONTINUE
            IF (ISCALE .EQ. 0) ISCALE=INT(YMAX/120.0+1.0)
            IF (IDIF .EQ. 0) IDIF=INT(YMAX/120.0+1.0)
         END IF
         DO 37 I=1,12
            LABEL(I)=10*I*ISCALE
   37    CONTINUE
         WRITE(6,150) LABEL
  150    FORMAT('1'//7X,12I10)
         DO 40 I=1,12
            LABEL(I)=-60*IDIF+10*I*IDIF
   40    CONTINUE
         WRITE(6,160) LABEL
  160    FORMAT(' ',6X,12I10)
         BEFORE=DEG(1)-STEP
         LL=0
         DO 60 I=1,NPTS
            TH=BEFORE+STEP
            IF(DEG(I).GT.TH+0.0001745329) THEN
               WRITE(6,'(/)')
               LL=0
            ENDIF
            DO 45 J=1,120
               IOUT(J)=ISPACE
   45       CONTINUE
            IOUT(1)=IDOT
            IOUT(61)=IDOT
            IOUT(120)=IDOT
            IY=INT(XINT(I))/ISCALE+2
            IY=MAX0(MIN0(IY,120),2)
            IOUT(IY-1)=IBAR
            IOUT(IY)=IPLUS
            IF(IY.LE.119) IOUT(IY+1)=IBAR
            IY=INT(YFIT(I))/ISCALE+2
            IY=MAX0(MIN0(IY,120),2)
            IOUT(IY)=IMINUS
            IY=INT(XINT(I)-YFIT(I))/IDIF+61
            IY=MAX0(MIN0(IY,120),2)
            IOUT(IY)=ISTAR
            IF(MOD(LL,10).EQ.0) THEN
               WRITE(6,170) (IOUT(J),J=1,113),DEG(I)*RD2,IOUT(120)
  170          FORMAT(7X,113A1,F6.2,A1)
            ELSE
               WRITE(6,'(7X,120A1)') (IOUT(J),J=1,120)
            ENDIF
            BEFORE=DEG(I)
            LL=LL+1
   60    CONTINUE
      END IF
      END
 
************************************************************************
 
      SUBROUTINE BRANG(A)
C     CALCULATE THE D SPACING FOR THE I'TH REFLECTION AND FUNCTIONS
C     AND THE FUNCTIONS OF D
C     PEAK: TWO-THETA
C       TH: THETA
C        D: D SPACING
C     RLV2: (SIN(THETA)/LAMBDA)**2
C      FLP: LORENTZ AND POLARIZATION FACTORS
      INTEGER H
      PARAMETER (NB=2000,NPH=2)
      DIMENSION A(*)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /G/ I
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /MC/ CTHM
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      COMMON /WL/ NBEAM,XLMD,XLMDH,XLMD2H,R
      N=NOPH(I)
      Z=H(I)**2*GG(1,N)+K(I)**2*GG(2,N)+L(I)**2*GG(3,N)+2.0*
     &  (K(I)*L(I)*GG(4,N)+L(I)*H(I)*GG(5,N)+H(I)*K(I)*GG(6,N))
      IF(Z.LE.0.0) THEN
         D(I)=0.0
         RETURN
      ENDIF
      D(I)=1.0/SQRT(Z)
      RLV2(I)=0.25*Z
C
      ENTRY FTHETA(A)
C     CALCULATE WAVELENGTH-DEPENDENT QUANTITIES
      IF(L12(I).EQ.0) THEN
         PEAK(I)=2.0*ASIN(XLMDH/D(I))+A(1)
      ELSE
         PEAK(I)=2.0*ASIN(XLMD2H/D(I))+A(1)
      ENDIF
      TH(I)=0.5*PEAK(I)
      TN1(I)=TAN(TH(I))
      IF(NBEAM.EQ.1) THEN
         FLP(I)=(1.0+CTHM*COS(PEAK(I))**2)/(SIN(TH(I))**2*COS(TH(I)))
      ELSE
         FLP(I)=1.0/(SIN(TH(I))**2*COS(TH(I)))
      ENDIF
      END
 
************************************************************************
 
      SUBROUTINE PROR(A)
C     PREFERRED-ORIENTATION CORRECTION OF THE I'TH REFLECTION
      INTEGER H,HP
      PARAMETER (NB=2000,NPH=2,NAP=36)
      DIMENSION A(*)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /DERPR/ POP2(NB),COMPO(NB),GAUSS(NB)
      COMMON /G/ I
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      COMMON /V/ NPROR(NPH),HP(NPH),KP(NPH),LP(NPH)
      DATA DEGR,PI/1.570796,3.141593/
*     MODIFIED ON 1988.10.17
*     C = (PI/2)**2
*     DATA C/2.467401/
      P(J)=A(KPHB(N)+J)
 
      N=NOPH(I)
      IF(NPROR(N).EQ.0) THEN
         PROR1(I)=1.0
         POP2(I)=0.0
         GAUSS(I)=1.0
         RETURN
      ENDIF
      APROR=H(I)*HP(N)*GG(1,N)+K(I)*KP(N)*GG(2,N)+L(I)*LP(N)*
     &  GG(3,N)+(K(I)*LP(N)+L(I)*KP(N))*GG(4,N)+(H(I)*LP(N)+
     &  L(I)*HP(N))*GG(5,N)+(H(I)*KP(N)+K(I)*HP(N))*GG(6,N)
C
C     PHI: ANGLE BETWEEN (HP)A* + (KP)B* +(LP)C* AND HA* + KB* +LC*
      TEMP=APROR*D(I)/SQRT(CPROR(N))
      IF (TEMP .GE. 1.0) THEN
         PHI=0.0
      ELSE
         PHI=ACOS(TEMP)
      END IF
      IF(PHI.GT.DEGR) PHI=PI-PHI
      IF(NPROR(N).EQ.2) PHI=DEGR-PHI
C     ARRAYS POP2 AND GAUSS ARE USED IN SUBROUTINE FDERIV TO CALCULATE
C     THE PARTIAL DERIVATIVES OF THE PREFERRED-ORIENTATION PARAMETERS
      POP2(I)=PHI**2
      GAUSS(I)=EXP(-P(NPO2X)*POP2(I))
C
C     PREFERRED-ORIENTATION FUNCTION CONTAINING TWO PARAMETERS
C     H. TORAYA AND F. MARUMO, MINERAL. J., 10, 211 (1981).
*MODIFIED ON 1988.10.17
      PROR1(I)=P(NPO1X)+(1.0-P(NPO1X))*GAUSS(I)
      END
 
************************************************************************
 
      SUBROUTINE ASF
C     ATOMIC SCATTERING FACTORS ARE CALCULATED FROM THE ANALYTIC
C     EXPRESSION
      PARAMETER (NB=2000,NA=7)
      COMMON /B/ U(NB),NREFL
      COMMON /E/ AA(4,NA),BB(4,NA),C(NA)
      COMMON /G/ I
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /MAGNE/ FMAG(NA,NB),SFRMAG(NB),SFIMAG(NB),Q2(NB)
      COMMON /MAGSC/ MAGATM(NA),RLV(20,NA),AMPMAG(20,NA),NPAIR(NA)
      COMMON /MIX/ FRCTN(5,10),MFRAC(5,10),NOFRAC(10),NMIX
      COMMON /S/ F(NA,NB),NATOM
      COMMON /U/ DELTF1(NA),DELTF2(NA)
      COMMON /WL/ NBEAM,XLMD,XLMDH,XLMD2H,R
 
C     ATOMIC SCATTERING FACTORS OF REAL SPECIES
C     RLV2: (SIN(THETA)/LAMBDA)**2
      DO 20 J=1,NATOM-NMIX
         IF(NBEAM.GE.1) THEN
            FJ=AA(1,J)*EXP(-BB(1,J)*RLV2(I))+AA(2,J)*EXP(-BB(2,J)*
     &      RLV2(I))+AA(3,J)*EXP(-BB(3,J)*RLV2(I))+AA(4,J)*
     &      EXP(-BB(4,J)*RLV2(I))+C(J)
            F(J,I)=FJ+DELTF1(J)
         ELSE
            F(J,I)=C(J)
         ENDIF
         IF (MAGATM(J) .EQ. 1) THEN
            NTERMS=2
            CALL INTERP(RLV(1,J),AMPMAG(1,J),NPAIR(J),NTERMS,
     &      SQRT(RLV2(I)),YOUT)
            FMAG(J,I)=YOUT
         END IF
   20 CONTINUE
      IF(NMIX.EQ.0) RETURN
C
C     NUCLEAR AND MAGNETIC FORM FACTORS OF VIRTUAL SPECIES
      KK=J
      DO 40 J=1,NMIX
         F(KK,I)=0.0
         FMAG(KK,I)=0.0
         DO 30 L=1,NOFRAC(J)
            F(KK,I)=F(KK,I)+F(MFRAC(L,J),I)*FRCTN(L,J)
            IF (MAGATM(MFRAC(L,J)) .EQ. 1) THEN
               FMAG(KK,I)=FMAG(KK,I)+FMAG(MFRAC(L,J),I)*FRCTN(L,J)
            END IF
   30    CONTINUE
         KK=KK+1
   40 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE QSQR(N,PHI)
C     CALCULATE <Q**2> FOR MAGNETIC MATERIALS
C     CF. G. SHIRANE, ACTA CRYSTALLOGR., 12 282 (1959).
      INTEGER H
      REAL PHI(*)
      PARAMETER (NB=2000,NPH=2,NA=7)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /G/ I
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /MAGNE/ FMAG(NA,NB),SFRMAG(NB),SFIMAG(NB),Q2(NB)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
 
      LN=LAUEG(N)
      IF (LN .GE. 14) THEN
         Q2(I) = 0.6666667
      ELSE IF (LN .EQ. 6 .OR. LN .EQ. 7) THEN
         Q2(I) = 1.0 - (0.5*(H(I)**2+K(I)**2)*GG(1,N)*SIN(PHI(1))**2 +
     &   L(I)**2*GG(3,N)*COS(PHI(1))**2)*D(I)**2
      ELSE IF (LN .EQ. 9 .OR. LN .EQ. 11 .OR. LN .EQ. 12 .OR.
     &LN .EQ. 13) THEN
         Q2(I) = 1.0 - (0.5*(H(I)**2+K(I)**2+H(I)*K(I))*GG(1,N)*
     &   SIN(PHI(1))**2 + L(I)**2*GG(3,N)*COS(PHI(1))**2)*D(I)**2
      ELSE IF (LN .EQ. 8 .OR. LN .EQ. 10) THEN
         NN=H(I)**2+K(I)**2+L(I)**2
         NR=H(I)*K(I)+K(I)*L(I)+L(I)*H(I)
         Q2(I) = 1.0 - (2*(NN-NR)*(GG(1,N)-GG(4,N))*SIN(PHI(1))**2 +
     &   (NN+2*NR)*(GG(1,N)+2.0*GG(4,N))*COS(PHI(1))**2)/3.0*D(I)**2
      ELSE IF (LN .EQ. 5) THEN
         Q2(I) = 1.0 - (H(I)**2*GG(1,N)*COS(PHI(1))**2+K(I)**2*GG(2,N)*
     &   COS(PHI(2))**2+L(I)*GG(3,N)*COS(PHI(3))**2)*D(I)**2
      ELSE
         Q2(I) = 0.0
      END IF
      END
 
************************************************************************
 
      SUBROUTINE DERPHI(A,DPARA,N,IPHI)
C     DERIVATIVES OF !F(MAG)!**2 WITH RESPECT TO PHI
      PARAMETER (NB=2000,NT=220,NPH=2,NA=7)
      INTEGER H
      REAL A(*),DPARA(*)
      COMMON /A/ H(NB),K(NB),L(NB),L12(NB),NOPH(NB)
      COMMON /G/ I
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /MAGNE/ FMAG(NA,NB),SFRMAG(NB),SFIMAG(NB),Q2(NB)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
 
      LN=LAUEG(N)
      IF (LN .GE. 14) RETURN
      COM=7.266087*(SFRMAG(I)**2+SFIMAG(I)**2)
      IF (LN .EQ. 5) THEN
C        ORTHORHOMBIC
         IF (ID(IPHI) .NE. 0) THEN
            DPARA(IPHI)=COM*H(I)**2*GG(1,N)*SIN(2*A(IPHI))*D(I)**2
         END IF
         IF (ID(IPHI+1) .NE. 0) THEN
            DPARA(IPHI+1)=COM*K(I)**2*GG(2,N)*SIN(2*A(IPHI+1))*D(I)**2
         END IF
         IF (ID(IPHI+2) .NE. 0) THEN
            DPARA(IPHI+2)=COM*L(I)**2*GG(3,N)*SIN(2*A(IPHI+2))*D(I)**2
         END IF
      ELSE IF (ID(IPHI) .NE. 0) THEN
         SINX=SIN(2.0*A(IPHI))
         IF (LN .EQ. 6 .OR. LN .EQ. 7) THEN
C           TETRAGONAL
            DPARA(IPHI)=-COM*(0.5*(H(I)**2+K(I)**2)*GG(1,N)*SINX-
     &      L(I)**2*GG(3,N)*SINX)*D(I)**2
         ELSE IF (LN .EQ. 9 .OR. LN .EQ. 11 .OR. LN .EQ. 12 .OR.
     &   LN .EQ. 13) THEN
C           HEXAGONAL
            DPARA(IPHI)=-COM*(0.5*(H(I)**2+K(I)**2+H(I)*K(I))*GG(1,N)*
     &      SINX-L(I)**2*GG(3,N)*SINX)*D(I)**2
         ELSE IF (LN .EQ. 8 .OR. LN .EQ. 10) THEN
C           RHOMBOHEDRAL
            NN=H(I)**2+K(I)**2+L(I)**2
            NR=H(I)*K(I)+K(I)*L(I)+L(I)*H(I)
            DPARA(IPHI)=-COM*(2.0*(NN-NR)*(GG(1,N)-GG(4,N))*SINX-
     &      (NN+2*NR)*(GG(1,N)+2.0*GG(3,N))*SINX)/3.0*D(I)**2
         END IF
      END IF
      END
 
************************************************************************
 
      SUBROUTINE PACK(A,C,NTERMS)
C     A: UNPACKED ARRAY ---> PACKED ARRAY
C     C: RESERVE UNPACKED ARRAY
      PARAMETER (NT=220)
      REAL A(*),C(*)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      DO 10 J=1,NTERMS
         C(J)=A(J)
         IF(ID(J).EQ.1) A(IR(J))=A(J)
   10 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE UNPACK(B,C,NTERMS)
C     B: PACKED ARRAY ---> UNPACKED ARRAY
C     C: RESERVE UNPACKED ARRAY
      PARAMETER (NT=220)
      REAL B(*),C(*)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      DO 10 J=1,NTERMS
         IF(ID(J).EQ.1) C(J)=B(IR(J))
   10 CONTINUE
      DO 20 J=1,NTERMS
         B(J)=C(J)
   20 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE PENFN(ALPHA,BETA,A,NTERMS)
C     CONTRIBUTION OF THE PENALTY FUNCTION IS ADDED TO ARRAYS ALPHA AND
C     BETA
      PARAMETER (NR=65,NT=220,NCS=50)
      DOUBLE PRECISION ALPHA,BETA
      DIMENSION ALPHA(*),BETA(*),A(*),DCNSTR(NR),DCPM(NT)
      COMMON /CNSTR/ C1(NCS),C2(10,NCS),IN(10,NCS),NCNPAR(NCS),
     &  NACNS(NCS),NCNSTR
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /NONLIN/ NLESQ,NAUTO,IDCYCL,NCHNG,NPAR(10),IPAR(NR,10)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      DO 80 I=1,NC
         FCNSTR=CON(I,A)
         IF(FCNSTR.EQ.0.0) GO TO 80
C        DCPM: DERIVATIVES OF CONSTRAINTS WITH RESPECT TO PARAMETERS
C        FOR WHICH ID(J)<>0.  CENTERED DIVIDED DIFFERENCES ARE USED.
         DO 10 J=1,NTERMS
            IF(ID(J).NE.0) THEN
               ASAVE=A(J)
               IF(ASAVE.EQ.0.0) THEN
                  DELTAA=0.002
               ELSE
                  DELTAA=ABS(ASAVE)*0.002
               ENDIF
               A(J)=ASAVE-DELTAA
               F1=CON(I,A)
               A(J)=ASAVE+DELTAA
               F2=CON(I,A)
               DCPM(J)=(F2-F1)/(DELTAA+DELTAA)
               A(J)=ASAVE
            ENDIF
   10    CONTINUE
C
C        DCNSTR: DERIVATIVES WITH RESPECT PARAMETERS FOR WHICH ID(J)=1
         DO 40 J=1,NTERMS
            IF(ID(J).EQ.1) THEN
               DCNSTR(IR(J))=DCPM(J)
               DO 30 J2=1,NCNSTR
                  DO 20 J3=1,NCNPAR(J2)
                     IF(IN(J3,J2).EQ.J) DCNSTR(IR(J))=DCNSTR(IR(J))+
     &               C2(J3,J2)*DCPM(NACNS(J2))
   20             CONTINUE
   30          CONTINUE
            ENDIF
   40    CONTINUE
         DO 60 J=1,NTERMS
            IF(ID(J).EQ.1) THEN
               IF(IDCYCL.EQ.1) BETA(IR(J))=BETA(IR(J))-TK*FCNSTR*
     &         DCNSTR(IR(J))
               DO 50 K=1,J
                  JK=(IR(J)-1)*IR(J)/2+IR(K)
                  IF(ID(K).EQ.1) ALPHA(JK)=ALPHA(JK)+
     &            TK*DCNSTR(IR(J))*DCNSTR(IR(K))
   50          CONTINUE
            ENDIF
   60    CONTINUE
   80 CONTINUE
      END
 
************************************************************************
 
      FUNCTION CON(J,A)
*     THIS FUNCTION RETURNS THE J'TH VIOLATED CONSTRAINTS.  EACH
*     CONSTRAINT IS FORMULATED BY USING THE CURRENT VALUES OF
*     PARAMETERS (A).  CELL CONSTANTS SHOULD NOT BE CONTAINED IN THESE
*     CONSTRAINTS.
*          FUNCTIONS DIS AND ANG SERVE TO OBTAIN THE VALUES
*     OF BOND DISTANCES AND ANGLES, RESPECTIVELY.  FOR EXAMPLE,
*     BOUNDARY CONDITIONS D0-EPS < D < D0+EPS ARE EXPRESSED BY USING
*     STATEMENT FUNCTION G, WHERE D IS THE BOND DISTANCE BETWEEN THE
*     TWO ATOMS WHOSE FRACTIONAL COORDINATES ARE (X1,Y1,Z1) AND
*     (X2,Y2,Z2), AND D0 IS THE EXPECTED BOND DISTANCE BETWEEN THEM.
 
*     IN THE PRESENT ANALYSIS DEALING WITH AMMONIOLEUCITE, 12 (SI,AL)-O
*     DISTANCES ARE ASSUMED TO BE 1.65 +/- 0.05 ANGSTROM.  IF THE BOND
*     DISTANCES ARE IN THIS RANGE, CON IS SET EQUAL TO ZERO.
*     CONSTRAINTS FOR BOND ANGLES CAN BE FORMULATED IN SIMILAR WAYS.
 
      REAL A(*)
      DATA D0,EPS/1.65,0.05/
      G(X1,Y1,Z1,X2,Y2,Z2)=MIN(0.0,EPS-ABS(DIS(X1,Y1,Z1,
     &  X2,Y2,Z2,1)-D0))
 
      IF (J .EQ. 1) THEN
         CON=G(A(25),A(26),A(27),A(40),A(41),A(42))
      ELSE IF (J .EQ. 2) THEN
         CON=G(A(25),A(26),A(27),0.25-A(41),0.25+A(40),0.25-A(42))
      ELSE IF (J .EQ. 3) THEN
         CON=G(A(25),A(26),A(27),A(45),A(46),A(47))
      ELSE IF (J .EQ. 4) THEN
         CON=G(A(25),A(26),A(27),0.75-A(56),0.25+A(55),0.25+A(57))
      ELSE IF (J .EQ. 5) THEN
         CON=G(A(30),A(31),A(32),A(45),A(46),A(47))
      ELSE IF (J .EQ. 6) THEN
         CON=G(A(30),A(31),A(32),A(50),A(51),A(52))
      ELSE IF (J .EQ. 7) THEN
         CON=G(A(30),A(31),A(32),A(55),A(56),A(57))
      ELSE IF (J .EQ. 8) THEN
         CON=G(A(30),A(31),A(32),A(60),A(61),A(62))
      ELSE IF (J .EQ. 9) THEN
         CON=G(A(35),A(36),A(37),0.75+A(51)-1.0,0.75-A(50),
     &   0.75+A(52)-1.0)
      ELSE IF (J .EQ. 10) THEN
         CON=G(A(35),A(36),A(37),A(60),A(61),A(62))
      ELSE IF (J .EQ. 11) THEN
         CON=G(A(35),A(36),A(37),A(65),A(66),A(67))
      ELSE IF (J .EQ. 12) THEN
         CON=G(A(35),A(36),A(37),0.75+A(66)-1.0,0.25-A(65)+1.0,
     &   0.25-A(67))
      END IF
      END
 
************************************************************************
 
      FUNCTION DIS(X1,Y1,Z1,X2,Y2,Z2,IP)
C     DIS: DISTANCE BETWEEN TWO ATOMS WHICH ARE LOCATED AT (X1,Y1,Z1)
C          AND (X2,Y2,Z2)
C     IP: PHASE NUMBER
C     THIS FUNCTION IS USED TO GIVE CONSTRAINTS IN SUBROUTINE CON
      PARAMETER (NPH=2)
      COMMON /TENS/ G(6,NPH),GG(6,NPH)
      DIS=G(1,IP)*(X1-X2)**2+G(2,IP)*(Y1-Y2)**2+G(3,IP)*(Z1-Z2)**2+
     &  2.0*(G(4,IP)*(Y1-Y2)*(Z1-Z2)+G(5,IP)*(Z1-Z2)*(X1-X2)+
     &  G(6,IP)*(X1-X2)*(Y1-Y2))
      DIS=SQRT(DIS)
      END
 
************************************************************************
 
      FUNCTION ANG(X2,Y2,Z2,X1,Y1,Z1,X3,Y3,Z3,IP)
C     ANG: BOND ANGLE (X2,Y2,Z2) - (X1,Y1,Z1) - (X3,Y3,Z3)
C     IP: PHASE NUMBER
      AA=DIS(X2,Y2,Z2,X3,Y3,Z3,IP)
      CC=DIS(X1,Y1,Z1,X2,Y2,Z2,IP)
      BB=DIS(X1,Y1,Z1,X3,Y3,Z3,IP)
      COSAA=(BB*BB+CC*CC-AA*AA)/(2.0*BB*CC)
      ANG=57.29578*ACOS(COSAA)
      END
 
************************************************************************
 
      SUBROUTINE MINI(YFIT,B,XINT,DEG,YPEAK,NTERMS,NSTEP,X)
C     POWELL'S ALGORITHM FOR UNCONSTRAINED OPTIMIZATION WITHOUT THE USE
C     OF DERIVATIVES (CONJUGATE DIRECTION METHOD)
C     M. J. D. POWELL, COMPUTER J., 7, 155 (1964).
      PARAMETER (NT=220,NR=65,NPH=2,NAP=36)
      DIMENSION YFIT(*),W(NR),SECND(NR),B(*),XINT(*),DEG(*),YPEAK(*),
     &  X(*)
      COMMON /NUML/ NUPDT
      COMMON /ONE/ Y(NR),S(NR),FX,FY
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /OLD/ AOLD(NT),AOUT(NT)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /POW/ MITER,STEP,ACC
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /TWO/ DIRECT(NR,NR),BEFORE(NR),FIRST(NR)
      COMMON /THREE/ N,NFUNCT,NDRV,ITER,INDIC,NPRINT
      EQUIVALENCE (W,SECND)
      ICONVG=1
      ITER=0
      NTRY=1
      N1=N-1
      DO 2 I=1,N
      DO 1 J=1,N
      DIRECT(J,I)=0.0
    1 CONTINUE
      IF(FIRST(I).EQ.0.0) THEN
         IF(X(I).EQ.0.0) THEN
            DIRECT(I,I)=STEP
         ELSE
            DIRECT(I,I)=ABS(X(I))*STEP
         ENDIF
      ELSE
         IF(X(I).EQ.0.0) THEN
            DIRECT(I,I)=FIRST(I)
         ELSE
            DIRECT(I,I)=ABS(X(I))*FIRST(I)
         ENDIF
      ENDIF
    2 CONTINUE
      STEP=1.0
      STEPA=STEP
  100 FX=AOFFN(DEG,XINT,YFIT,NPTS,NSTEP,YPEAK,B,0,IDPOS)
      NFUNCT=NFUNCT+1
      WRITE(6,'(/11X,A)') 'CALCULATION USING INITIAL PARAMETERS'
      IF(NC.GT.0) THEN
         WRITE(6,2010) FX,FX-SUMPEN,SUMPEN
 2010    FORMAT(' ',10X,'AOF =',1P,G13.6,4X,'OF =',1P,G13.6,4X,'PF =',
     &   1P,G13.6)
      ELSE
         WRITE(6,'(11X,A,1P,G13.6)') 'OF =',FX
      ENDIF
      DO 85 J=1,NTERMS
         AOLD(J)=B(J)
   85 CONTINUE
      GO TO 301
    3 ITER=ITER+1
      CALL PRPARA(YFIT,B,XINT,DEG,YPEAK,NTERMS,NPTS,NSTEP,X)
      IF(ITER.EQ.MITER) RETURN
  301 F1=FX
      DO 4 I=1,N
    4 BEFORE(I)=X(I)
      SUM=0.0
      DO 9 I=1,N
      DO 5 J=1,N
    5 S(J)=DIRECT(J,I)*STEP
      CALL SEARCH(YFIT,B,XINT,DEG,YPEAK,NTERMS,NSTEP,X)
      A=FX-FY
      IF(A-SUM) 7,7,6
    6 ISAVE=I
      SUM=A
    7 DO 8 J=1,N
    8 X(J)=Y(J)
    9 FX=FY
      F2=FX
      DO 10 I=1,N
   10 W(I)=2.0*X(I)-BEFORE(I)
      CALL FUN(YFIT,W,F3,B,XINT,DEG,YPEAK,NTERMS,NSTEP,*999)
  999 A=F3-F1
      IF(A) 11,19,19
   11 A=2.0*(F1-2.0*F2+F3)*((F1-F2-SUM)/A)**2
      IF(A-SUM) 12,19,19
   12 IF(ISAVE-N) 13,15,15
   13 DO 14 I=ISAVE,N1
      II=I+1
      DO 14 J=1,N
   14 DIRECT(J,I)=DIRECT(J,II)
   15 A=0.0
      DO 16 J=1,N
      DIRECT(J,N)=X(J)-BEFORE(J)
   16 A=DIRECT(J,N)**2+A
      A=1.0/SQRT(A)
      DO 17 J=1,N
      DIRECT(J,N)=DIRECT(J,N)*A
   17 S(J)=DIRECT(J,N)*STEP
      CALL SEARCH(YFIT,B,XINT,DEG,YPEAK,NTERMS,NSTEP,X)
      FX=FY
      DO 18 I=1,N
   18 X(I)=Y(I)
   19 CALL TEST(F1,FX,BEFORE,X,FLAG,N,ACC)
      IF(FLAG) 22,22,20
   20 IF(F1-FX) 121,120,120
  121 STEP=-0.4*SQRT(ABS(F1-FX))
      GO TO 123
  120 STEP=0.4*SQRT(F1-FX)
  123 IF(STEPA-STEP) 21,3,3
   21 STEP=STEPA
      GO TO 3
   22 GO TO (23,24), ICONVG
   23 RETURN
   24 GO TO (25,27), NTRY
   25 NTRY=2
      DO 26 I=1,N
      FIRST(I)=X(I)
   26 X(I)=X(I)+ACC*10.0
      FFIRST=FX
      GO TO 100
   27 FSECND=FX
      A=0.0
      DO 28 I=1,N
      SECND(I)=X(I)
      S(I)=FIRST(I)-SECND(I)
   28 A=A+S(I)**2
      IF(A) 23,23,29
   29 A=STEP/SQRT(A)
      DO 30 I=1,N
   30 S(I)=S(I)*A
      CALL SEARCH(YFIT,B,XINT,DEG,YPEAK,NTERMS,NSTEP,X)
      CALL TEST(FFIRST,FY,FIRST,Y,FLAG,N,ACC)
      IF(FLAG) 32,32,31
   31 CALL TEST(FSECND,FY,SECND,Y,FLAG,N,ACC)
      IF(FLAG) 32,32,34
   32 DO 33 I=1,N
   33 X(I)=Y(I)
      FX=FY
      RETURN
   34 A=A/STEP
      DO 35 I=1,N
      DIRECT(I,1)=(FIRST(I)-SECND(I))*A
   35 FIRST(I)=SECND(I)
      GO TO 3
      END
 
************************************************************************
 
      SUBROUTINE SEARCH(YFIT,B,XINT,DEG,YPEAK,NTERMS,NSTEP,X)
C     DSC-POWELL UNIDIMENSIONAL SEARCH
      PARAMETER (NR=65)
      DIMENSION YFIT(*),B(*),XINT(*),DEG(*),YPEAK(*),X(*)
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /ONE/ Y(NR),S(NR),FX,FY
      COMMON /THREE/ N,NFUNCT,NDRV,ITER,INDIC,NPRINT
      COMMON /TWO/ H(NR,NR),DELG(NR),GX(NR)
      IEXIT=0
      NTOL=0
      FTOL=.001
      FTOL2=FTOL/100.0
      FA=FX
      FB=FX
      FC=FX
      DA=0.0
      DB=0.0
      DC=0.0
      K=-2
      M=0
      STEP=1.0
      D=STEP
    1 DO 2 I=1,N
    2 Y(I)=X(I)+D*S(I)
      CALL FUN(YFIT,Y,F,B,XINT,DEG,YPEAK,NTERMS,NSTEP,*999)
      K=K+1
      IF(F-FA) 5,3,6
    3 DO 4 I=1,N
    4 Y(I)=X(I)+DA*S(I)
      FY=FA
      IF(NPRINT.EQ.2) WRITE(6,2100)
 2100 FORMAT(/11X,'SEARCH FAILED.  FUNCTION VALUE INDEPENDENT OF SEARCH
     &DIRECTION.')
      GO TO 326
    5 FC=FB
      FB=FA
      FA=F
      DC=DB
      DB=DA
      DA=D
      D=2.0*D+STEP
      GO TO 1
    6 IF(K) 7,8,9
    7 FB=F
      DB=D
      D=-D
      STEP=-STEP
      GO TO 1
    8 FC=FB
      FB=FA
      FA=F
      DC=DB
      DB=DA
      DA=D
      GO TO 21
    9 DC=DB
      DB=DA
      DA=D
      FC=FB
      FB=FA
      FA=F
   10 D=0.5*(DA+DB)
      DO 11 I=1,N
   11 Y(I)=X(I)+D*S(I)
      CALL FUN(YFIT,Y,F,B,XINT,DEG,YPEAK,NTERMS,NSTEP,*999)
   12 IF((DC-D)*(D-DB)) 15,13,18
   13 DO 14 I=1,N
   14 Y(I)=X(I)+DB*S(I)
      FY=FB
      IF(IEXIT.EQ.1) GO TO 32
      IF(NPRINT.EQ.2) WRITE(6,2200)
 2200 FORMAT(/11X,'SEARCH FAILED.  LOCATION OF MINIMUM LIMITED BY ROUNDI
     &NG.')
      GO TO 325
   15 IF(F-FB) 16,13,17
   16 FC=FB
      FB=F
      DC=DB
      DB=D
      GO TO 21
   17 FA=F
      DA=D
      GO TO 21
   18 IF(F-FB) 19,13,20
   19 FA=FB
      FB=F
      DA=DB
      DB=D
      GO TO 21
   20 FC=F
      DC=D
   21 A=FA*(DB-DC)+FB*(DC-DA)+FC*(DA-DB)
      IF(A) 22,30,22
   22 D=0.5*((DB*DB-DC*DC)*FA+(DC*DC-DA*DA)*FB+(DA*DA-DB*DB)*FC)/A
      IF((DA-D)*(D-DC)) 13,13,23
   23 DO 24 I=1,N
   24 Y(I)=X(I)+D*S(I)
      CALL FUN(YFIT,Y,F,B,XINT,DEG,YPEAK,NTERMS,NSTEP,*999)
      IF(ABS(FB)-FTOL2) 25,25,26
   25 A=1.0
      GO TO 27
   26 A=1.0/FB
   27 IF((ABS(FB-F)*A)-FTOL) 28,28,12
   28 IEXIT=1
      IF(F-FB) 29,13,13
   29 FY=F
      GO TO 32
   30 IF(M) 31,31,13
   31 M=M+1
      GO TO 10
   32 DO 99 I=1,N
      IF(Y(I).NE.X(I)) GO TO 325
   99 CONTINUE
      GO TO 33
  325 IF(NTOL.NE.0 .AND. NPRINT.EQ.2) WRITE(6,3000) NTOL
 3000 FORMAT(/11X,'TOLERANCE REDUCED ',I1,' TIME(S)')
  326 IF(FY.LT.FX) RETURN
      IF(S(1).NE.-GX(1) .OR. FY.LT.FX) RETURN
      IF(NPRINT.EQ.2) THEN
         WRITE(6,5100) ITER,NFUNCT,NDRV
         IF(NC.GT.0) THEN
            WRITE(6,5200) FY,FY-SUMPEN,SUMPEN
         ELSE
            WRITE(6,'(11X,A,1P,G13.6/)') 'OF =',FY
         ENDIF
      ENDIF
 5100 FORMAT(/11X,'SEARCH FAILED ON A GRADIENT STEP.  SEARCH TERMINATED.
     &'//11X,'ITER   =',I3,5X,'NFUNCT =',I4,5X,'NDRV   =',I3)
 5200 FORMAT(11X,'AOF =',1P,G13.6,4X,'OF =',G13.6,4X,'PF =',G13.6/)
      RETURN
   33 IF(NTOL.EQ.5) GO TO 34
      IEXIT=0
      NTOL=NTOL+1
      FTOL=FTOL/10.0
      GO TO 12
   34 IF(NPRINT.EQ.2) WRITE(6,2000)
 2000 FORMAT(/11X,'A POINT BETTER THAN THE ENTERING POINT CANNOT BE FOUN
     &D.')
      RETURN
  999 DO 91 I=1,N
         Y(I)=X(I)
   91 CONTINUE
      FY=FX
      END
 
************************************************************************
 
      SUBROUTINE TEST(FI,FF,RI,RF,FLAG,N,ACC)
      DIMENSION RI(*),RF(*)
      FLAG=2.0
      IF(ABS(FI)-ACC) 2,2,1
    1 IF(ABS((FI-FF)/FI)-ACC) 3,3,7
    2 IF(ABS(FI-FF)-ACC) 3,3,7
    3 DO 6 I=1,N
      IF(ABS(RI(I))-ACC) 5,5,4
    4 IF(ABS((RI(I)-RF(I))/RI(I))-ACC) 6,6,7
    5 IF(ABS(RI(I)-RF(I))-ACC) 6,6,7
    6 CONTINUE
      FLAG=-2.0
    7 END
 
************************************************************************
 
      SUBROUTINE FUN(YFIT,Z,FX,A,XINT,DEG,YPEAK,NTERMS,NSTEP,*)
C     FUNCTION TO BE MINIMIZED BY POWELL'S METHOD
      PARAMETER (NT=220,NPH=2)
      DIMENSION Z(*),A(*),XINT(*),DEG(*),YPEAK(*),YFIT(*)
      COMMON /OLD/ AOLD(NT),AOUT(NT)
      COMMON /THREE/ N,NFUNCT,NDRV,ITER,INDIC,NPRINT
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
C     COPY CURRENT VALUES OF VARIABLE PARAMETERS INTO ARRAY A
      IDSAME=1
      DO 10 J=1,NTERMS
         IF(ID(J).EQ.1) THEN
            A(J)=Z(IR(J))
            IF(A(J).NE.AOLD(J)) IDSAME=0
         ENDIF
   10 CONTINUE
      IF(IDSAME.EQ.1) RETURN 1
      CALL REFPOW(A,NTERMS)
C
      FX=AOFFN(DEG,XINT,YFIT,NPTS,NSTEP,YPEAK,A,1,IDPOS)
      NFUNCT=NFUNCT+1
      END
 
************************************************************************
 
      SUBROUTINE PRPARA(YFIT,A,XINT,DEG,YPEAK,NTERMS,NPTS,NSTEP,X)
C     PRINT THE CURRENT VALUES OF ARRAYS A AND ID
      CHARACTER PARNAM*48,PHNAME*25
      PARAMETER (NT=220,NR=65,NPH=2,NAP=36)
C     DIMENSION YFIT(*),A(*),XINT(*),DEG(*),YPEAK(*),X(*),IDLAT(10)
      DIMENSION YFIT(*),A(*),XINT(*),DEG(*),YPEAK(*),X(*)
      COMMON /CC/ APR(NT)
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /OLD/ AOLD(NT),AOUT(NT)
      COMMON /ONE/ Y(NR),S(NR),FX,FY
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /THREE/ N,NFUNCT,NDRV,ITER,INDIC,NPRINT
      COMMON /UCC/ IDPEAK(NPH),IDSF(NPH),IDPRF(NPH),IDZP
      DO 10 J=1,NTERMS
         IF(ID(J).EQ.1) A(J)=X(IR(J))
   10 CONTINUE
      DO 15 L=1,NPHASE
         IDPEAK(L)=1
         IDSF(L)=1
         IDPRF(L)=1
   15 CONTINUE
      IDZP=0
      FX=AOFFN(DEG,XINT,YFIT,NPTS,NSTEP,YPEAK,A,1,IDPOS)
C
      ENTRY PRFIN(A,NTERMS)
      WRITE(6,100) ITER,NFUNCT
  100 FORMAT(//' ',10X,'ITER   =',I3/' ',10X,'NFUNCT =',I4)
      IF(NC.GT.0) THEN
         WRITE(6,110) FX,FX-SUMPEN,SUMPEN
  110    FORMAT(' ',10X,'AOF    =',1P,G13.6,4X,'OF    =',1P,G13.6,4X,
     &   'PF    =',1P,G13.6)
      ELSE
         WRITE(6,'(11X,A,1P,G13.6)') 'OF     =',FX
      ENDIF
      CALL SETPAR(A)
      CALL RFACTR(A,DEG,YPEAK,YFIT,XINT,NPTS,0)
      IF(NPRINT.NE.0) THEN
         WRITE(6,'(/12X,A)') 'NO.    A(OLD)    +   DELTA.A   =  '//
     &   'A(REFINED)    ID'
         CALL APRNTD(A,NTERMS)
         DO 20 JJ=1,NTERMS
            IF(ID(JJ) .NE. 0 .OR. LATVAR(JJ) .EQ. 1) THEN
               DELTA=APR(JJ)-AOUT(JJ)
            ELSE
               DELTA=0.0
            ENDIF
            WRITE(6,220) JJ,AOUT(JJ),DELTA,APR(JJ),ID(JJ),PARNAM(JJ)
            AOUT(JJ)=APR(JJ)
   20    CONTINUE
      ENDIF
  220 FORMAT(11X,I3,2X,1P,3(G13.6,1X),I4,3X,A)
      END
 
************************************************************************
 
      SUBROUTINE SETPAR(A)
C     UPDATE THE METRIC TENSOR AND CONSTRAINED PARAMETERS
      DIMENSION A(*)
      PARAMETER (NT=220,NCS=50,NPH=2,NAP=36)
      COMMON /CNSTR/ C1(NCS),C2(10,NCS),IN(10,NCS),NCNPAR(NCS),
     &  NACNS(NCS),NCNSTR
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      LP(J)=KPHB(L)+J
      P(J)=A(LP(J))
 
      K=1
      DO 40 L=1,NPHASE
         IF(LAUEG(L).EQ.6 .OR. LAUEG(L).EQ.7) THEN
            A(LP(NBX))=P(NAX)
         ELSEIF(LAUEG(L).EQ.8 .OR. LAUEG(L).EQ.10) THEN
            A(LP(NBX))=P(NAX)
            A(LP(NCX))=P(NAX)
            A(LP(NBETX))=P(NALPX)
            A(LP(NGAMX))=P(NALPX)
         ELSEIF(LAUEG(L).EQ.9 .OR. LAUEG(L).EQ.11 .OR. LAUEG(L).EQ.12
     &   .OR. LAUEG(L).EQ.13) THEN
            A(LP(NBX))=P(NAX)
            A(LP(NGAMX))=0.5*P(NAX)
         ELSEIF(LAUEG(L).GE.14) THEN
            A(LP(NBX))=P(NAX)
            A(LP(NCX))=P(NAX)
         ENDIF
         DO 30 J=LP(1),KPHE(L)
            IF(ID(J).EQ.-1) THEN
               A(J)=C1(K)
               DO 20 MM=1,NCNPAR(K)
                  A(J)=A(J)+C2(MM,K)*A(IN(MM,K))
   20          CONTINUE
               K=K+1
            ENDIF
   30    CONTINUE
   40 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE OVERWR(A,SIGMAA,NTERMS)
C     UPDATE ARRAYS A AND ID IN INPUT FILE
      PARAMETER (NT=220,NCS=50,NPH=2)
      DIMENSION A(*),SIGMAA(*)
      CHARACTER PARNAM*48,PHNAME*25
      CHARACTER*80 LINE1(100),LINE2(100)
      COMMON /CC/ APR(NT)
      COMMON /FLAG/ LFLAG(10)
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
C
C     UPDATE THE INPUT FILE
      REWIND 5
      DO 10 J=1,1000
         READ(5,'(A)') LINE1(1)
         IF (LINE1(1)(1:7) .EQ. 'ENDPARA') GO TO 1
   10 CONTINUE
    1 NLINE1=J-NTERMS-1
C
      REWIND 5
      DO 20 J=1,NLINE1
         READ(5,'(A)') LINE1(J)
   20 CONTINUE
C     SKIP PARAMETER LINES
      DO 30 J=1,NTERMS+1
         READ(5,'(A)') LINE2(1)
   30 CONTINUE
      DO 35 J=1,100
         READ(5,'(A)',END=2) LINE2(J)
   35 CONTINUE
    2 NLINE2=J-1
C
      REWIND 5
      DO 37 J=1,NLINE1
         WRITE(5,'(A)') LINE1(J)
   37 CONTINUE
C     WRITE A AND ID
      CALL APRNTD(A,NTERMS)
      DO 40 J=1,NTERMS
         IF (LFLAG(2) .EQ. 0 .AND. LFLAG(3) .EQ. 0) THEN
            WRITE(5,'(1P,G14.6,I3)') APR(J),IDSAVE(J)
         ELSE IF (LFLAG(2) .EQ. 1 .AND. LFLAG(3) .EQ. 0) THEN
            WRITE(5,'(1P,G14.6,I3,A,A,A)')
     &      APR(J),IDSAVE(J),' ''',PARNAM(J),''''
         ELSE IF (LFLAG(2) .EQ. 0 .AND. LFLAG(3) .EQ. 1) THEN
            WRITE(5,'(1P,G14.6,I3,G14.6)') APR(J),IDSAVE(J),SIGMAA(J)
         ELSE IF (LFLAG(2) .EQ. 0 .AND. LFLAG(3) .EQ. 2) THEN
            WRITE(5,'(1P,G14.6,I3,I4)') APR(J),IDSAVE(J),J
         ELSE IF (PARNAM(J)(12:22) .EQ. 'ANISOTROPIC' .AND.
     &   LFLAG(3) .EQ. 1) THEN
            WRITE(5,'(1P,G14.6,I3,A,A,21X,A,G14.6)')
     &      APR(J),IDSAVE(J),' ''',PARNAM(J)(:11)//PARNAM(J)(43:48),
     &      '''',SIGMAA(J)
         ELSE IF (PARNAM(J)(12:22) .EQ. 'ANISOTROPIC' .AND.
     &   LFLAG(3) .EQ. 2) THEN
            WRITE(5,'(1P,G14.6,I3,A,A,21X,A,I4)')
     &      APR(J),IDSAVE(J),' ''',PARNAM(J)(:11)//PARNAM(J)(43:48),
     &      '''',J
         ELSE IF (LFLAG(3) .EQ. 1) THEN
            WRITE(5,'(1P,G14.6,I3,A,A,A,G14.6)')
     &      APR(J),IDSAVE(J),' ''',PARNAM(J)(:38),'''',SIGMAA(J)
         ELSE
            WRITE(5,'(1P,G14.6,I3,A,A,A,I4)')
     &      APR(J),IDSAVE(J),' ''',PARNAM(J)(:38),'''',J
         END IF
   40 CONTINUE
      WRITE(5,'(A)') 'ENDPARA'
      DO 50 J=1,NLINE2
         WRITE(5,'(A80)') LINE2(J)
   50 CONTINUE
      REWIND 5
      END
 
************************************************************************
 
      SUBROUTINE RFACTR(A,DEG,YPEAK,YFIT,XINT,NPTS,LRB)
C     RELIABILITY INDICES R.WP, R.P, AND R.B
      PARAMETER (NT=220,NB=2000,NP=5050,NPH=2,NAP=36)
      CHARACTER PARNAM*48,PHNAME*25
      DOUBLE PRECISION SUM1,SUM2,SUM3,SUMA(NPH),SUMB(NPH),SUMC(NPH),
     &  SUMD(NPH)
      DIMENSION A(*),DEG(*),YPEAK(*),YFIT(*),XINT(*)
      COMMON /A/ IH(NB),IK(NB),IL(NB),L12(NB),NOPH(NB)
      COMMON /B/ U(NB),NREFL
      COMMON /C/ BG(NP)
      COMMON /DERPR/ OBSI(NB),CALCI(NB),DUMMY(NB)
      COMMON /FL0/ NC,TK,CONV,NCONV,FINC,SUMPEN,SUMP1,FACTOR
      COMMON /G/ I
      COMMON /ORDER/ IPOINT(NB)
      COMMON /I/ RDEG(2,NB)
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /PR/ W1(NB),WW1(NB),TN1(NB),PROR1(NB),CPROR(NPH),FLP(NB)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /RLS/ NRANGE
      COMMON /Z/ PC,PC2(NPH),RLIM,CSTB
      SUM1=0.0D0
      SUM2=0.0D0
      SUM3=0.0D0
      DO 10 KK=1,NPTS
         DELTA=XINT(KK)-YFIT(KK)
         SUM1=SUM1+DELTA**2/XINT(KK)
         SUM2=SUM2+XINT(KK)
         SUM3=SUM3+ABS(DELTA)
   10 CONTINUE
      RWP=SQRT(SUM1/SUM2)
      RP=SUM3/SUM2
      RE=SQRT((NPTS-NRFN+NC)/SUM2)
      IF(LRB.EQ.0) THEN
         WRITE(6,100) RWP,RP,RE
  100    FORMAT(' ',10X,'R.WP =',2P,F6.2,5X,'R.P =',F6.2,
     &   5X,'R.E =',F6.2)
         RETURN
      ENDIF
      IF(NRANGE.EQ.2) THEN
         DO 15 J=1,NPTS
            BG(J)=((((A(7)*BG(J)+A(6))*BG(J)+A(5))*BG(J)+A(4))
     &      *BG(J)+A(3))*BG(J)+A(2)
   15    CONTINUE
      ENDIF
      ISTART=1
      DO 17 IPH=1,NPHASE
         SUMA(IPH)=0.0D0
         SUMB(IPH)=0.0D0
         SUMC(IPH)=0.0D0
         SUMD(IPH)=0.0D0
   17 CONTINUE
      DO 30 J=1,NREFL
         I=IPOINT(J)
         YCBK=0.0
         YCTOT=0.0
         CALCI(I)=0.0
         YOTOT=0.0
         DO 20 K=ISTART,NPTS
            IF (DEG(K) .GT. RDEG(2,I)) THEN
               GO TO 1
            ELSE IF (DEG(K) .GE. RDEG(1,I)) THEN
               YCBK=YCBK+BG(K)
               YCTOT=YCTOT+YFIT(K)
               CALCI(I)=CALCI(I)+YPEAK(I)*
     &         PRFL(A,DEG(K)-PEAK(I),TN1(I),WW1(I))
               YOTOT=YOTOT+XINT(K)
            ELSE
               ISTART=ISTART+1
            END IF
   20    CONTINUE
C        OBSI AND CALCI ARE USED IN SUBROUTINE RFLCTN
    1    IF (YOTOT-YCBK .GT. 0.0 .AND. YCTOT-YCBK .NE. 0.0) THEN
            OBSI(I)=(YOTOT-YCBK)*CALCI(I)/(YCTOT-YCBK)
         ELSE
            OBSI(I)=0.0
         END IF
         IF (OBSI(I) .GT. 0.0) THEN
            SUMA(NOPH(I))=SUMA(NOPH(I))+ABS(OBSI(I)-CALCI(I))
            SUMB(NOPH(I))=SUMB(NOPH(I))+OBSI(I)
            SUMC(NOPH(I))=SUMC(NOPH(I))+
     &                    ABS(SQRT(OBSI(I))-SQRT(CALCI(I)))
            SUMD(NOPH(I))=SUMD(NOPH(I))+SQRT(OBSI(I))
         END IF
   30 CONTINUE
      WRITE(6,180) RWP,RP,RE
  180 FORMAT(11X,'R.WP =',2P,F6.2,5X,'R.P =',F6.2,5X,'R.E =',F6.2)
      IF(NPHASE.EQ.1) THEN
         WRITE(6,200) SUMA(1)/SUMB(1),SUMC(1)/SUMD(1)
      ELSE
         WRITE(6,300) (PHNAME(IPH),SUMA(IPH)/SUMB(IPH),SUMC(IPH)/
     &   SUMD(IPH),IPH=1,NPHASE)
      ENDIF
  200 FORMAT(12X,'R.I =',2P,F6.2,5X,'R.F =',F6.2)
  300 FORMAT(/11X,A/11X,'R.I =',2P,F6.2,5X,'R.F =',F6.2)
      END
 
************************************************************************
 
*THIS SUBROUTINE WAS SEPARATED ON 1988.5.18
      SUBROUTINE RDINT(NP,NTOTAL,THINIT,STEP,NEXC,NSKIP,DEGEXC,NSTEP,
     &   DEG,XINT)
*     READ STEP-SCANNED INTENSITY DATA
*     (A) INPUT
*         NP: MAXIMUM DATA POINTS FOR XINT
*     (B) OUTPUT
*         NTOTAL: TOTAL NUMBER OF INTENSITY DATA
*         THINIT: MINIMUM TWO-THETA
*           STEP: STEP WIDTH
*           XINT: STEP-SCANNED INTENSITY DATA
      INTEGER NP,NTOTAL,NEXC,NSKIP,NSTEP
      REAL THINIT,STEP,DEGEXC(2,50),DEG(*),XINT(*)
      CHARACTER*80 LINE
*SUN
*     CHARACTER*50 FILE3*50
      DATA RD/0.01745329/
 
*FACOM, HITAC, AND ACOS
      OPEN(UNIT=3)
*SUN
*     CALL GETARG(2,FILE3)
*SUN
*     OPEN(UNIT=3,FILE=FILE3,STATUS='OLD')
*VAX
      OPEN(UNIT=3,FILE='XRAYINT.DAT',STATUS='OLD')
      REWIND 3
*     COMMENT LINE(S)
    1 READ(3,'(A)') LINE(1:1)
      IF (LINE(1:1) .NE. '*') THEN
         BACKSPACE (UNIT=3)
      ELSE
         GO TO 1
      END IF
      READ(3,*) NTOTAL,THINIT,STEP
      IF(NTOTAL.GT.NP-2) THEN
         WRITE(6,150) NP
         CALL JOBEND(' ')
      ENDIF
  150 FORMAT(//11X,'THE NUMBER OF STEP-SCAN DATA HAS EXTENDED THE MAXIMU
     &M VALUE (',I4,').')
      READ(3,*) (XINT(J),J=1,NTOTAL)
      CLOSE(UNIT=3,STATUS='KEEP')
 
      NSTEP=0
      DO 60 LL=1,NTOTAL
         X1=THINIT+(LL-1)*STEP
         IF(NEXC.EQ.1) THEN
            DO 50 J=1,NSKIP
               IF (X1 .GT. DEGEXC(1,J)-0.001 .AND. X1 .LT.
     &         DEGEXC(2,J)+0.001) GO TO 60
   50       CONTINUE
         ENDIF
         NSTEP=NSTEP+1
         DEG(NSTEP)=X1*RD
         XINT(NSTEP)=XINT(LL)
   60 CONTINUE
      STEP=STEP*RD
      END
 
************************************************************************
 
      SUBROUTINE MKFLOR(A,G,TITLE,SIGMAA,NTERMS,COEF)
*     MAKE A FILE FOR ORFFE
      PARAMETER (NT=220,NR=65,NAP=36,NPH=2,NS=48,NB=2000,NCS=50)
      PARAMETER (NOD=NR*(NR+1)/2,NSP=NAP*10)
      REAL A(*),SIGMAA(*),STPAR(NSP),PM(NOD),TV(3),COEF(*)
      DOUBLE PRECISION G(*)
      INTEGER IG(NAP),KI1(NSP),R,RX,RY,RZ,ROR(2,3),NEWNO(NT),NC(NT)
      CHARACTER TITLE*25,PARNAM*48,PHNAME*25,INSTR*72
*SUN
*     CHARACTER*50 FILE9
      COMMON /CC/ APR(NT)
      COMMON /CNSTR/ C1(NCS),C2(10,NCS),IN(10,NCS),NCNPAR(NCS),
     &  NACNS(NCS),NCNSTR
CORRECTED ON 1988.12.16
      COMMON /ERMAT/ SI2
CORRECTION END
      COMMON /EXC/ LSPSYM(NPH),NSSYM(14,NPH)
      COMMON /FRDA/ NFR,NDA
      COMMON /H/ NQ(NPH),NCENTR(NPH),LAUEG(NPH)
      COMMON /LTM/ LISO(NAP,NPH),LMAG(NPH)
*MODIFIED ON 1988.10.25
      COMMON /MULT/ SM(NAP)
      COMMON /PAR/ PARNAM(NT),PHNAME(NPH)
      COMMON /PARNO/ NSFX,NPO1X,NPO2X,NAX,NBX,NCX,NALPX,NBETX,NGAMX,
     &  NOTX,NG1X
      COMMON /PHASE/ NPHASE,KPHB(NPH),KPHE(NPH),NPSITE(NAP,NPH)
      COMMON /R/ ID(NT),IR(NT),IDSAVE(NT),NRFN
      COMMON /RT/ T(3,NS,NPH),HT(NS,NB),NSYM(NPH),NSITE(NPH),
     &  IDSYM(NS,NAP,NPH),R(3,3,NS,NPH),RX(NS,NB),RY(NS,NB),RZ(NS,NB)
      COMMON /SITE/ NOAT(NAP,NPH)
      LP(J)=KPHB(NDA)+J
      PS(J)=SIGMAA(LP(J))
 
*FACOM, HITAC, ACOS AND VAX
      OPEN(UNIT=9)
*SUN
*     CALL GETARG(5,FILE9)
*SUN
*     OPEN(UNIT=9,FILE=FILE9)
      REWIND 9
      WRITE(9,'(A)') TITLE
*     LAUE GROUP NUMBER, CENTROSYMMETRIC/NONCENTROSYMMETRIC,
*     STEP OF SYMMETRY OPERATIONS
*MODIFIED ON 1988.10.25
*     WRITE(9,'(3I5)') LAUEG(NDA),NCENTR(NDA),2*NINT(COEF(NDA))
      WRITE(9,'(4I5)') LAUEG(NDA),NCENTR(NDA),2*NINT(COEF(NDA)),
     &  NSSYM(7,NDA)
*MIDIFICATION END
*     NC(RIETAN PARAM. #) = (RIETAN SERIES # OF CONSTRAINTS)
      IPOINT=0
      DO 10 I=1,NTERMS
         IF (ID(I) .EQ. -1) THEN
            IPOINT=IPOINT+1
            NC(I)=IPOINT
         END IF
   10 CONTINUE
 
      DO 20 J=1,NSITE(NDA)
*        DETERMINE THE PARAMETER NUMBERS OF OCCUPATION FACTORS
         IF (J .EQ. 1) THEN
            IG(J)=LP(NG1X)
         ELSE
            IG(J)=IG(J-1)+NPSITE(J-1,NDA)
         END IF
*        NEWNO(RIETAN PARAM. #) = PARAM. # OF ORFFE
         DO 15 I=IG(J),IG(J)+LISO(J,NDA)+3
            NEWNO(I)=(J-1)*10+I-IG(J)+1
   15    CONTINUE
   20 CONTINUE
      NP=10*NSITE(NDA)
      DO 25 I=1,NP
         STPAR(I)=0.0
         KI1(I)=0
   25 CONTINUE
 
      DO 35 J=1,NSITE(NDA)
         DO 30 I=0,LISO(J,NDA)+3
*           STORE SUTRUCTURE PARAMETERS INCLUDING DUMMY ONES
            STPAR((J-1)*10+1+I)=A(IG(J)+I)
            IF (ID(IG(J)+I) .EQ. 1) THEN
               KI1((J-1)*10+1+I)=1
            ELSE IF (ID(IG(J)+I) .EQ. -1) THEN
               IC=NC(IG(J)+I)
*              WRITE CONSTRAINTS IMPOSED ON STRUCTURE PARAMETERS
               WRITE(9,'(2I5,1P,G14.6,10(1P,G14.6,I5:))')
     &         NEWNO(IG(J)+I),NCNPAR(IC),C1(IC),(C2(K,IC),
     &         NEWNO(IN(K,IC)),K=1,NCNPAR(IC))
            END IF
   30    CONTINUE
CORRECTED ON 1989.1.31
*        IF (LISO(J,NDA) .EQ. 0) STPAR(IPOINT+4)=A(LP(NOTX))
         IF (LISO(J,NDA) .EQ. 0) STPAR((J-1)*10+5)=A(LP(NOTX))
CORRECTION END
*MODIFIED ON 1988.10.25
*        G ==> OCCUPANCY * MULTIPLICITY / (NUMBER OF GENERAL EQUIVALENT
*              POSITIONS)
         STPAR((J-1)*10+1)=SM(J)
*MODIFICATION END
   35 CONTINUE
      WRITE(9,'(A)') 'ENDCON'
 
*     WRITE STRUCTURE PARAMETERS AND REFINEMENT IDENTIFIERS
      WRITE(9,'(I5)') NP
      DO 40 J=1,NSITE(NDA)
         WRITE(9,'(A,1X,10(1P,G14.6:))') PARNAM(IG(J))(1:9),
     &   (STPAR(K),K=(J-1)*10+1,(J-1)*10+1+MAX(4,LISO(J,NDA)+3))
   40 CONTINUE
      WRITE(9,'(150I1)') (KI1(J),J=1,NP)
 
*     WRITE THE VARIANCE-COVARIANCE MATRIX
      IPOINT=1
      DO 50 J=IG(1),IG(NSITE(NDA))+LISO(NSITE(NDA),NDA)+3
         IF (ID(J) .NE. 1) GO TO 50
         DO 45 K=J,IG(NSITE(NDA))+LISO(NSITE(NDA),NDA)+3
*           ARRAY ELEMENTS FOR REFINABLE STRUCTURE PARAMETERS ARE COPIED
*           CHI-SQUARE/(N-M) IS MULTIPLIED
            IF (ID(K) .EQ. 1 .AND.
     &      INDEX(PARNAM(K),'MAGNETIC MOMENT') .EQ. 0) THEN
CORRECTED ON 1988.12.16
               PM(IPOINT)=SI2*G(IR(K)*(IR(K)-1)/2+IR(J))
CORRECTION END
               IPOINT=IPOINT+1
            END IF
   45    CONTINUE
   50 CONTINUE
      NV=0
      DO 55 J=1,NP
         IF (KI1(J) .EQ. 1) NV=NV+1
   55 CONTINUE
      WRITE(9,'(I5)') NV
      WRITE(9,'(1P,10G14.6)') (PM(I),I=1,NV*(NV+1)/2)
 
*     A, B, C, COS(ALPHA), COS(BETA), COS(GAMMA) AND THEIR STAND. DEV.
      WRITE(9,'(1P,6G14.6/1P,6G14.6)')
     &(APR(LP(J)),J=NAX,NCX),(COS(APR(LP(J))*0.01745329),J=NALPX,NGAMX),
     &(PS(J),J=NAX,NCX),(PS(J)*SIN(PS(J)*0.01745329),J=NALPX,NGAMX)
 
*     WRITE SYMMETRY OPERATIONS
      DO 70 ISYM=1,NSYM(NDA)
         DO 65 I=1,3
            ROR(2,I)=0
            IPOINT=1
            DO 60 J=1,3
               IF (R(I,J,ISYM,NDA) .EQ. -1) THEN
                  ROR(IPOINT,I)=-J
                  IPOINT=IPOINT+1
               ELSE IF (R(I,J,ISYM,NDA) .EQ. 1) THEN
                  ROR(IPOINT,I)=J
                  IPOINT=IPOINT+1
               END IF
   60       CONTINUE
            TV(I)=T(I,ISYM,NDA)
   65    CONTINUE
         CALL WRSYOP(TV,ROR,NSSYM(7,NDA),ISYM-1)
         IF (NCENTR(NDA) .EQ. 1) THEN
            DO 68 I=1,3
*              INVERTED POSITION: -X, -Y, -Z
               TV(I)=-TV(I)
               ROR(1,I)=-ROR(1,I)
               ROR(2,I)=-ROR(2,I)
   68       CONTINUE
            CALL WRSYOP(TV,ROR,NSSYM(7,NDA),1)
         END IF
   70 CONTINUE
      WRITE(9,'(A)') 'ENDSYM'
 
*     WRITE ORFFE INSTRUCTIONS
   80 CONTINUE
         READ(5,'(A)',END=9) INSTR
CORRECTED ON 1988.7.7
C        IF (INSTR .EQ. 'ENDOR') GO TO 9
         IF (INSTR(1:5) .EQ. 'ENDOR') GO TO 9
*MODIFIED ON 1988.11.25
*        CORRECT THE WRONG NUMBER OF ATOMS IN THE PARAMETER LIST
         READ(INSTR,'(2I3)') NFUNC,NSITES
         IF ((NFUNC .EQ. 101 .OR. NFUNC .EQ. 201 .OR. NFUNC .EQ. 207
     &   .OR. NFUNC .EQ. 208 .OR. NFUNC .EQ. 209 .OR. NFUNC .EQ. 210
     &   .OR. NFUNC .EQ. 211) .AND. NSITES .NE. NSITE(NDA)) THEN
            WRITE(9,'(2I3,A)') NFUNC,NSITE(NDA),INSTR(7:)
         ELSE
            WRITE(9,'(A)') INSTR
         END IF
*MODIFICATION END
      GO TO 80
    9 END
 
************************************************************************
 
      SUBROUTINE WRSYOP(TV,ROR,NCON,LSYM)
*     WRITE SYMMETRY OPERATIONS COMPATIBLE WITH ORFLS AND ORFFE
      REAL TV(3)
      INTEGER ROR(2,3)
 
      IF (LSYM .EQ. 0) THEN
*        X, Y, Z IS SKIPPED; ONLY TRANSLATED POSITIONS ARE WRITTEN
         WRITE(9,'(3(F11.6,2I2))') (TV(I)+1.0,(ROR(J,I),J=1,2),I=1,3)
      ELSE
         CALL TVROR(TV(1),TV(2),TV(3),ROR)
      END IF
      IF (NCON .EQ. 13) THEN
*        BODY CENTERED
         CALL TVROR(TV(1)+0.5,TV(2)+0.5,TV(3)+0.5,ROR)
      ELSE IF (NCON .EQ. 4) THEN
*        A-FACE CENTERED
         CALL TVROR(TV(1),TV(2)+0.5,TV(3)+0.5,ROR)
      ELSE IF (NCON .EQ. 5) THEN
*        B-FACE CENTERED
         CALL TVROR(TV(1)+0.5,TV(2),TV(3)+0.5,ROR)
      ELSE IF (NCON .EQ. 6) THEN
*        C-FACE CENTERED
         CALL TVROR(TV(1)+0.5,TV(2)+0.5,TV(3),ROR)
      ELSE IF (NCON .EQ. 7) THEN
*        ALL-FACE CENTERED
         CALL TVROR(TV(1),TV(2)+0.5,TV(3)+0.5,ROR)
         CALL TVROR(TV(1)+0.5,TV(2),TV(3)+0.5,ROR)
         CALL TVROR(TV(1)+0.5,TV(2)+0.5,TV(3),ROR)
      ELSE IF (NCON .EQ. 14 .OR. NCON .EQ. 15) THEN
*        RHOMBOHEDRALLY CENTERED (HEXAGONAL AXES)
         CALL TVROR(TV(1)+0.6666667,TV(2)+0.3333333,TV(3)+0.3333333,ROR)
         CALL TVROR(TV(1)+0.3333333,TV(2)+0.6666667,TV(3)+0.6666667,ROR)
      END IF
      END
 
************************************************************************
 
      SUBROUTINE TVROR(TV1,TV2,TV3,ROR)
*     MAKE TV SMALL ENOUGH AND WRITE SYMMETRY OPERATION ON A FILE
      INTEGER ROR(2,3)
 
      WRITE(9,'(3(F11.6,2I2))') TV1,ROR(1,1),ROR(2,1),
     &   TV2,ROR(1,2),ROR(2,2),TV3,ROR(1,3),ROR(2,3)
      WRITE(9,'(3(F11.6,2I2))') TV1+1.0,ROR(1,1),ROR(2,1),
     &   TV2+1.0,ROR(1,2),ROR(2,2),TV3+1.0,ROR(1,3),ROR(2,3)
      END
 
************************************************************************
 
      SUBROUTINE PLOTRA(YFIT,XINT,DEG,NPTS,TITLE,A,YPEAK,XB,YB,NBG,
     &  FACFIG,INC)
C     PLOT RIETVELD REFINEMENT PATTERNS
      REAL*4 XLEN,X,Y
      PARAMETER (NB=2000,NP=5050)
      CHARACTER TITLE*80
*VAX
      CHARACTER*80 TITLE0
*VAX
      DIMENSION TITLE1(20)
      DIMENSION YFIT(*),XINT(*),DEG(*),A(*),DEGX(2),YPEAK(*),XB(*),YB(*)
*HITAC
*     INTEGER*2 ICHAR(2),IDY(2)
      COMMON /B/ U(NB),NREFL
      COMMON /C/ BG(NP)
      COMMON /FT/ FT1,FT2
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      COMMON /L/ DEG1,DEG2
      COMMON /RLS/ NRANGE
      COMMON /X/ STEP
*VAX
      EQUIVALENCE (TITLE0,TITLE1(1))
      DATA RD2,DD/57.29578,2.0/
*HITAC
*     DATA ICHAR/ZA3B2,ZA6C8/,IDY/ZA6A4,ZA3D9/
C     INITIALLIZATION
*FACOM
*     CALL PLOTS(10.0,7.0,16)
*SUN --- CALL STATEMENTS DESCRIBED BELOW SHOULD BE USED BY COMBINING
*        CALCOMP-COMPATIBLE SUBROUTINE PAKAGE CALCOMP.F, WHICH WAS
*        DEVELOPED BY A. YAMAMOTO AND CAN BE OBTAINED FROM F. IZUMI
*        UPON REQUEST.
*SUN (LASER WRITER)
*     CALL PLOTS(3.0,7.0,4)
*ACOS (OKAYAMA UNIVERSITY)
*     CALL XYOPEN(0,0.0,0.0,0.0,0.0,3)
*ACOS (NEC, FUNDAMENTAL RESEARCH LABORATORIES)
*     CALL PLOTS(DMY,DMY,16)
*ACOS (OKAYAMA UNIVERSITY)
*     CALL PLOTS('POWDER$',60.0)
*FACOM, ACOS, AND SUN
*     CALL FACTOR(FACFIG)
*ACOS (NEC, FUNDAMENTAL RESEARCH LABORATORIES)
*     CALL PLOT(10.0,7.0,-3)
*ACOS (OKAYAMA UNIVERSITY)
*     CALL PLOT(5.0,10.0,-3)
*FACOM AND ACOS
*     IF(FACFIG.GT.0.99999) CALL NEWPEN(2)
*SUN
*     CALL NEWPEN(2)
*HITAC
*     CALL DEVICE('XYPLOT  ',ILNK,ITRR,ITRNK,IDIAL)
*HITAC
*     CALL RWIND(0,0,2000*80,269*80)
*HITAC
*     CALL VSINI(0.0,0.0,200.0,26.9)
*HITAC
*     CALL PLOT(10.0,7.0,-3)
*HITAC
*     CALL FACTOR(FACFIG)
*HITAC
*     CALL NEWPEN(2)
*VAX --- CALL STATEMENTS DESCRIBED BELOW ARE EFFECTIVE FOR THE
         COMBINATION: PLOTTER = HP7550A AND PLOTTER OUTPUT SUBROUTINE
*        PACKAGE = HP-ISPP
*VAX
      CALL HPINIT(0,0,0,1,16)
*VAX
      CALL PLOT(2.0,6.0,-3)
*VAX
      CALL FACTOR(FACFIG)
*VAX
      CALL NEWPEN(2)
C
C     X-AXIS
      DEGL=DEG1*RD2
      DEGH=DEG2*RD2
      IF(MOD(INT(DEGL),10).LT.5) THEN
         FD=AINT(DEGL/10.0)*10.0
      ELSE
         FD=AINT(DEGL/10.0)*10.0+5.0
      ENDIF
      IF(MOD(INT(DEGH),10).LT.5) THEN
         ED=AINT(DEGH/10.0)*10.0+5.0
      ELSE
         ED=AINT(DEGH/10.0)*10.0+10.0
      ENDIF
      IDIV=NINT((ED-FD)/5.0)+1
      XLEN=(IDIV-1)*2.5
C
C     Y-AXIS
      IF(INC.LE.0) CALL MYSCL(YFIT,XINT,NPTS,INC)
      DY=INC/2
      CALL PLOT(0.0,-1.0,3)
      CALL PLOT(0.0,0.0,2)
*ACOS
*     CALL PLOT(0.0,0.0,3)
      CALL YAXIS(0.0,0.0,18.0,10,0,INC)
      MAXY=INC*9
      IF(MAXY.LT.10000) THEN
         XCOUNT=-2.1
      ELSEIF(MAXY.LT.100000) THEN
         XCOUNT=-2.45
      ELSE
         XCOUNT=-2.8
      ENDIF
      CALL SYMBOL(XCOUNT,7.85,0.42,'COUNTS',90.0,6)
*VAX
      WRITE(TITLE0,'(A80)') TITLE
*VAX
      CALL SYMBOL(1.0,18.2,0.56,TITLE1,0.0,65)
*FACOM, HITAC, ACOS, AND SUN
*     CALL SYMBOL(1.0,18.2,0.56,TITLE,0.0,80)
      CALL PLOT(0.0,18.0,3)
      CALL PLOT(XLEN,18.0,2)
      CALL PLOT(XLEN,-1.0,2)
C
C     K=1: RESET ISTART IN FUNCTION CALINT
      K=1
C     PLOT CALCULATED INTENSITIES
      DO 10 XX=DEG1,DEG2,1.75E-4
         X=(XX*RD2-FD)/DD
         DEGX(K)=XX
         IF(NRANGE.EQ.1) THEN
            NFP=4
            CALL INTERP(XB,YB,NBG,NFP,XX,G)
            BG(K)=G
         ELSE
            BG(K)=FT1*(XX+FT2)
         ENDIF
         Y=MIN(CALINT(DEGX,K,A,YPEAK)/DY,18.0)
         CALL PLOT(X,Y,4-K)
         IF(K.EQ.1) K=2
   10 CONTINUE
C
C     PLOT OBSERVED INTENSITIES
*VAX
      K=1
      DO 15 J=NPTS-1,1,-1
         X=(DEG(J+1)*RD2-FD)/DD
         Y=XINT(J+1)/DY
*FACOM, HITAC, AND ACOS (NEC, FUNDAMENTAL RESEARCH LABORATORIES)
*        CALL SYMBOL(X,Y,0.04,1,0.0,-1)
*ACOS (OKAYAMA UNIVERSITY)
*        CALL MARK(X,Y,0.04,1,0.0,-1)
*SUN
*        CALL SYMBOL(X,Y,0.04,'3',0.0,-1)
*VAX
         CALL SYMBOL(X,Y,0.04,K,0.0,-1)
   15 CONTINUE
C
C     PLOT REFLECTION MARKERS
*VAX
      K=13
      DO 20 J=1,NREFL
         X=(PEAK(J)*RD2-FD)/DD
         IF(X.GT.XLEN) GO TO 1
*FACOM, HITAC, AND ACOS (NEC, FUNDAMENTAL RESEARCH LABORATORIES)
*        CALL SYMBOL(X,-0.55,0.4,13,0.0,-1)
*ACOS (OKAYAMA UNIVERSITY)
*        CALL MARK(X,-0.55,0.4,13,0.0,-1)
*SUN
*        CALL SYMBOL(X,-0.55,0.4,'1',0.0,-1)
*VAX
         CALL SYMBOL(X,-0.55,0.4,K,0.0,-1)
   20 CONTINUE
C
C     PLOT THE DIFFERENCE BETWEEN THE OBSERVED AND CALCULATED POWDER
C     DIFFRACTION PATTERNS
*FACOM, ACOS, AND VAX
    1 CALL NEWPEN(1)
*HITAC AND SUN
*   1 CONTINUE
      CALL PLOT(0.0,-5.0,-3)
      CALL PLOT(0.0,2.0,2)
*ACOS
*     CALL PLOT(0.0,2.0,3)
      CALL SYMBOL(-0.5,1.825,0.35,'0',0.0,1)
      CALL PLOT(0.2,2.0,3)
      CALL PLOT(0.0,2.0,2)
      CALL PLOT(0.0,4.0,2)
      CALL PLOT(0.2,4.0,2)
C     WRITE DELTA.Y
*FACOM AND ACOS (NEC, FUNDAMENTAL RESEARCH LABORATORIES)
*     CALL SYMBOL(XCOUNT,1.58,0.42,52,90.0,0)
*ACOS (OKAYAMA UNIVERSITY)
*     CALL MARK(XCOUNT,1.58,0.42,52,90.0,0)
*SUN
*     CALL PLOT(XCOUNT,1.52,3)
*SUN
*     CALL NEWPEN(3)
*SUN
*     CALL PLOT(XCOUNT,1.88,2)
*SUN
*     CALL PLOT(XCOUNT-0.42,1.70,2)
*SUN
*     CALL PLOT(XCOUNT,1.52,2)
*SUN
*     CALL NEWPEN(2)
*SUN
*     CALL SYMBOL(XCOUNT,2.06,0.42,'Y',90.0,1)
*FACOM AND ACOS
*     CALL SYMBOL(XCOUNT,2.12,0.42,'Y',90.0,1)
*HITAC
*     CALL CHARAC(XCOUNT,1.58,0.42,IDY,90.0,2)
*VAX
      CALL SYMBOL(XCOUNT,1.58,0.42,'DY',90.0,2)
C     X-AXIS
      CALL XAXIS(0.0,0.0,XLEN,IDIV,NINT(FD),5)
C     PLOT TWO-THETA
*FACOM AND ACOS
*     CALL SYMBOL(XLEN/2.0-0.28,-1.3,0.42,'2',0.0,1)
*SUN
*     CALL SYMBOL(XLEN/2.0-0.37,-1.3,0.49,'2',0.0,1)
*FACOM AND ACOS (NEC, FUNDAMETAL RESEARCH LABORATORIES)
*     CALL SYMBOL(XLEN/2.0+0.08,-1.3,0.49,37,0.0,0)
*ACOS (OKAYAMA UNVERSITY)
*     CALL MARK(XLEN/2.0+0.08,-1.3,0.49,37,0.0,0)
*SUN
*     CALL SYMBOL(XLEN/2.0+0.08,-1.3,0.49,'0',0.0,1)
*SUN
*     CALL SYMBOL(XLEN/2.0+0.08,-1.25,0.49,'-',0.0,1)
*HITAC
*     CALL CHARAC(XLEN/2.0-0.28,-1.3,0.42,ICHAR,0.0,2)
*VAX
      CALL SYMBOL(XLEN/2.0-0.28,-1.3,0.49,'TWO-THETA',0.0,9)
      CALL PLOT(XLEN,0.0,3)
      CALL PLOT(XLEN,4.0,2)
      FY=-2.0*DY
*VAX
      K=1
      DO 30 J=NPTS,1,-1
         X=(DEG(J)*RD2-FD)/DD
         Y=(XINT(J)-YFIT(J)-FY)/DY
*FACOM, HITAC, AND ACOS (FUNDAMENTAL RESEARCH LABORATORIES)
*        IF(Y.GE.0) CALL SYMBOL(X,Y,0.04,1,0.0,-1)
*ACOS (OKAYAMA UNIVERSITY)
*        IF(Y.GE.0) CALL MARK(X,Y,0.04,1,0.0,-1)
*SUN
*        IF (Y .GE. 0) CALL SYMBOL(X,Y,0.04,'1',0.0,-1)
*VAX
         IF(Y.GE.0) CALL SYMBOL(X,Y,0.04,K,0.0,-1)
   30 CONTINUE
*FACOM AND SUN
*     CALL PLOTE('RIETANPLOT          ')
*HITAC
*     CALL VSTERM(IDUM,IDUM)
*HITAC
*     CALL GPSLTM
*ACOS (OKAYAMA UNIVERSITY)
*     CALL PLOTE
*ACOS (OKAYAMA UNIVERSITY)
*     CALL XYCLOS
*VAX
      CALL PLOT(0.0,0.0,999)
      END
 
************************************************************************
 
      SUBROUTINE MYSCL(YFIT,XINT,NPTS,INC)
C     DETERMINE THE SCALE OF Y-AXIS
      DIMENSION YFIT(*),XINT(*)
      YMAX=YFIT(1)
      DO 10 J=2,NPTS
         IF(YFIT(J).GT.YMAX) YMAX=YFIT(J)
   10 CONTINUE
      DO 20 J=1,NPTS
         IF(XINT(J).GT.YMAX) YMAX=XINT(J)
   20 CONTINUE
      IF(YMAX.GT.14400.0) THEN
         INC=(INT(YMAX/9000.0)+1)*1000
      ELSEIF(YMAX.GT.13500.0) THEN
         INC=1600
      ELSEIF(YMAX.GT.9000.0) THEN
         INC=1500
      ELSEIF(YMAX.LE.1800.0) THEN
         INC=200
      ELSE
         DO 30 J=8100,1800,-900
            IF(YMAX.GT.J) THEN
               INC=J/9+100
               GO TO 1
            ENDIF
   30    CONTINUE
      ENDIF
    1 END
 
************************************************************************
 
      SUBROUTINE SIMLTN(YFIT,DEG,NSTEP,TITLE,FACFIG)
C     OFF-LINE PLOT OF THE SIMULATION OF X-RAY POWDER PATTERNS
C     ARRAYS YFIT AND DEG HAVE CONVERTED INTO SINGLE-PRECISION ARRAYS
C     IN THE MAIN PROGRAM
      REAL*4 YFIT(*),DEG(*)
*HITAC
*     INTEGER*2 ICHAR(2)
      PARAMETER (NB=2000,NPH=2)
      CHARACTER TITLE*80
      COMMON /B/ U(NB),NREFL
      COMMON /J/ PEAK(NB),TH(NB),RLV2(NB),D(NB)
      DATA RD2/57.29578/
*HITAC
*     DATA ICHAR/ZA3B2,ZA6C8/
C     INITIALIZATION
*FACOM
*     CALL PLOTS(10.0,3.0,16)
*SUN (LASER WRITER)
*     CALL PLOTS(3.0,3.0,4)
*ACOS
*     CALL PLOTS(DMY,DMY,16)
*FACOM, ACOS, AND SUN
*     CALL FACTOR(FACFIG)
*FACOM AND ACOS
*     CALL NEWPEN(1)
*SUN
*     CALL NEWPEN(2)
*ACOS
*     CALL PLOT(10.0,3.0,-3)
*HITAC
*     CALL DEVICE('XYPLOT  ',ILNK,ITRR,ITRNK,IDIAL)
*HITAC
*     CALL RWIND(0,0,2000*80,269*80)
*HITAC
*     CALL VSINI(0.0,0.0,200.0,26.9)
*HITAC
*     CALL PLOT(10.0,3.0,-3)
*HITAC
*     CALL FACTOR(FACFIG)
*HITAC
*     CALL NEWPEN(2)
*VAX
      CALL HPINIT(0,0,0,1,16)
*VAX
      CALL PLOT(4.0,3.0,-3)
*VAX
      CALL FACTOR(FACFIG)
*VAX
      CALL NEWPEN(1)
C
C     NORMALIZATION OF INTENSITIES
      YMAX=YFIT(1)
      DO 20 J=2,NSTEP
         IF(YFIT(J).GT.YMAX) YMAX=YFIT(J)
   20 CONTINUE
      DO 30 J=1,NSTEP
         YFIT(J)=YFIT(J)*100.0/YMAX
         DEG(J)=DEG(J)*RD2
   30 CONTINUE
C
C     X-AXIS
      IFD=INT(DEG(1)+0.001)
      IF(MOD(IFD,2).NE.0) IFD=IFD-1
      FD=REAL(IFD)
CORRECTED ON 1988.8.8
      IED=INT(DEG(NSTEP))
      IF (FLOAT(IED) .LT. DEG(NSTEP)) THEN
         IED=IED+1
      END IF
CORRECTION END
      IF(MOD(IED,2).NE.0) IED=IED+1
      ED=REAL(IED)
      IDIV=NINT((ED-FD)/2.0)+1
      XLEN=(IDIV-1)*2.0
      CALL XAXIS(0.0,-1.0,XLEN,IDIV,NINT(FD),2)
*FACOM AND ACOS
*     CALL SYMBOL(XLEN/2.0-0.28,-2.3,0.42,'2',0.0,1)
*SUN
*     CALL SYMBOL(XLEN/2.0-0.42,-2.3,0.49,'2',0.0,1)
*FACOM AND ACOS (NEC, FUNDAMENTAL RESEARCH LABORATORIES)
*     CALL SYMBOL(XLEN/2.0+0.08,-2.3,0.49,37,0.0,0)
*ACOS (OKAYAMA UNIVERSITY)
*     CALL MARK(XLEN/2.0+0.08,-2.3,0.49,37,0.0,0)
*SUN
*     CALL SYMBOL(XLEN/2.0+0.08,-2.3,0.49,'0',0.0,1)
*SUN
*     CALL SYMBOL(XLEN/2.0+0.08,-2.25,0.49,'-',0.0,1)
*HITAC
*     CALL CHARAC(XLEN/2.0-0.28,-2.3,0.42,ICHAR,0.0,2)
*VAX
      CALL SYMBOL(XLEN/2.0-0.28,-2.3,0.49,'TWO-THETA',0.0,9)
      DEG(NSTEP+1)=FD
      DEG(NSTEP+2)=1.0
C
C     Y-AXIS
      CALL PLOT(0.0,-1.0,3)
      CALL PLOT(0.0,0.0,2)
      CALL YAXIS(0.0,0.0,20.0,11,0,10)
      CALL SYMBOL(-1.4,6.95,0.35,'RELATIVE INTENSITY',90.0,18)
      YFIT(NSTEP+1)=0.0
      YFIT(NSTEP+2)=5.0
C
      CALL SYMBOL(1.0,20.5,0.56,TITLE,0.0,80)
      CALL PLOT(0.0,20.0,3)
      CALL PLOT(XLEN,20.0,2)
      CALL PLOT(XLEN,-1.0,2)
C     PLOT CALCULATED INTENSITIES
      CALL LINE(DEG,YFIT,NSTEP,1,0,0)
C
C     PLOT REFLECTION MARKERS
*VAX
      K=13
      DO 40 J=1,NREFL
         X=PEAK(J)*RD2-FD
         IF(X.GT.XLEN) GO TO 1
*FACOM, HITAC, AND ACOS (NEC, FUNDAMENTAL RESEARCH LABORATORIES)
*        CALL SYMBOL(X,-0.45,0.4,13,0.0,-1)
*ACOS (OKAYAMA UNIVERSITY)
*        CALL MARK(X,-0.45,0.4,13,0.0,-1)
*SUN
*        CALL SYMBOL(X,-0.45,0.4,'13',0.0,-1)
*VAX
         CALL SYMBOL(X,-0.45,0.4,K,0.0,-1)
   40 CONTINUE
*FACOM AND SUN
*   1 CALL PLOTE('RIETANPLOT          ')
*HITAC
*   1 CALL VSTERM(IDUM,IDUM)
*HITAC
*     CALL GPSLTM
*ACOS (OKAYAMA UNIVERSITY)
*     CALL PLOTE
*ACOS (OKAYAMA UNIVERSITY)
*     CALL XYCLOS
*VAX
    1 CALL PLOT(0.0,0.0,999)
      END
 
************************************************************************
 
      SUBROUTINE XAXIS(XS,YS,XL,IDIV,INIT,INCR)
C     PLOT X-AXIS (INTEGER VALUES ARE PLOTTED)
C     (XS,YS): ORIGIN OF THE X-AXIS
C     XL:      LENGTH OF THE X-AXIS
C     IDIV:    NUMBER OF DIVISIONS
C     INIT:    INITIAL VALUE
C     INCR:    INCREMENT
      CHARACTER*4 VALUE
*VAX
      DIMENSION IVALUE(2)
*VAX
      EQUIVALENCE (VALUE,IVALUE(1))
      XINC=XL/(IDIV-1)
      DO 10 J=1,IDIV
         IJ=INIT+INCR*(J-1)
         WRITE(VALUE,'(I4)') IJ
CORRECTED ON 1988.8.8
         IF (IJ .GE. 100) THEN
*FACOM, HITAC, AND ACOS
*           CALL SYMBOL(XS+XINC*(J-1)-0.80,YS-0.5,0.35,VALUE,0.0,4)
*SUN
*           CALL SYMBOL(XS+XINC*(J-1)-0.89,YS-0.5,0.35,VALUE,0.0,4)
*VAX
            CALL SYMBOL(XS+XINC*(J-1)-0.94,YS-0.5,0.35,IVALUE,0.0,4)
         ELSE IF (IJ .GE. 10) THEN
*FACOM, HITAC, AND ACOS
a8           CALL SYMBOL(XS+XINC*(J-1)-0.97,YS-0.5,0.35,VALUE,0.0,4)
*SUN
*           CALL SYMBOL(XS+XINC*(J-1)-1.06,YS-0.5,0.35,VALUE,0.0,4)
*VAX
            CALL SYMBOL(XS+XINC*(J-1)-0.8,YS-0.5,0.35,IVALUE,0.0,4)
         ELSE
*FACOM, HITAC AND ACOS
*           CALL SYMBOL(XS+XINC*(J-1)-1.15,YS-0.5,0.35,VALUE,0.0,4)
*SUN
*           CALL SYMBOL(XS+XINC*(J-1)-1.24,YS-0.5,0.35,VALUE,0.0,4)
CORRECTION END
*VAX
            CALL SYMBOL(XS+XINC*(J-1)-0.65,YS-0.5,0.35,IVALUE,0.0,4)
         ENDIF
         CALL PLOT(XS+XINC*(J-1),YS+0.2,3)
         CALL PLOT(XS+XINC*(J-1),YS,2)
         IF(J.EQ.IDIV) RETURN
         CALL PLOT(XS+XINC*J,YS,2)
   10 CONTINUE
      END
 
************************************************************************
 
      SUBROUTINE YAXIS(XS,YS,YL,IDIV,INIT,INCR)
C     PLOT Y-AXIS (INTEGER VALUES ARE PLOTTED)
C     (XS,YS): ORIGIN OF THE Y-AXIS
C     YL:      LENGTH OF THE Y-AXIS
C     IDIV:    NUMBER OF DIVISIONS
C     INIT:    INITIAL VALUE
C     INCR:    INCREMENT
      CHARACTER*6 VALUE
*VAX
      DIMENSION IVALUE(2)
*VAX
      EQUIVALENCE (VALUE,IVALUE(1))
      YINC=YL/(IDIV-1)
      DO 10 J=1,IDIV
         WRITE(VALUE,'(I6)') INIT+INCR*(J-1)
*FACOM, HITAC, ACOS, AND SUN
*        CALL SYMBOL(XS-2.25,YS+YINC*(J-1)-0.175,0.35,VALUE,0.0,6)
*VAX
         CALL SYMBOL(XS-2.25,YS+YINC*(J-1)-0.175,0.35,IVALUE,0.0,6)
         CALL PLOT(XS+0.2,YS+YINC*(J-1),3)
         CALL PLOT(XS,YS+YINC*(J-1),2)
         IF(J.EQ.IDIV) RETURN
         CALL PLOT(XS,YS+YINC*J,2)
   10 CONTINUE
      END
 
